! ----------------------------------------------------------------------
      MODULE RandomStaff
             USE model_util, only:model_type
             implicit none
             real,    allocatable :: matcomb(:,:) ! matrice delle parole
             real,    allocatable :: imatcomb(:,:)! puntatore ai multipletti
             real,    allocatable :: clpcomb(:)   ! Lorentz-Polarizzazione

             real,  allocatable :: fom_mabs(:)
             real,  allocatable :: fom_alcomb(:)
             real,  allocatable :: fom_pscomb(:)
             real,  allocatable :: fom_pscomb_random(:)
             real,  allocatable :: fom_cphase(:)
             real,  allocatable :: fom_cfom(:)
             real,  allocatable :: fom_emap(:)
             real,  allocatable :: fom_geom(:,:)
             real,  allocatable :: fomrt_random(:,:)
             real,  allocatable :: erfom(:)

             real,  allocatable :: fomgeom_comb(:)
             real,  allocatable :: fomemap(:)
             real,  allocatable :: fomgeom(:)
             real,  allocatable :: fomcfom(:)
             real,  allocatable :: fompsi0(:)
             real,  allocatable :: fompr(:)
             real,  allocatable :: fomsr1(:)
             real,  allocatable :: fomsr1_pes(:)
             real,  allocatable :: fomsr2(:)
             real,  allocatable :: fomsr2_pes(:)

             real,  allocatable :: wt_random(:,:,:)
             real,  allocatable :: wt_random_fin(:,:)

             integer,  allocatable :: numdet(:)
             integer,  allocatable :: nset_del(:)
             integer,  allocatable :: nset_sost(:)
             integer,  allocatable :: indici_per_random(:,:)
             integer,  allocatable :: i_set_del(:)
             integer,  allocatable :: imod_del(:)

             integer,  allocatable :: indici_random(:,:,:)
             integer,  allocatable :: jpuntt_random(:,:)
             integer,  allocatable :: npunt_random(:)
             integer,  allocatable :: iphaz_random(:,:,:)
             integer,  allocatable :: iphaz_random_fin(:,:)

             real,  allocatable :: errsem(:,:)
             real,  allocatable :: errsem_pes(:,:)
             real,  allocatable :: errsem_tot(:,:)
             real,  allocatable :: errsem_pes_tot(:,:)
             integer,  allocatable :: irefsem(:)

             integer :: iprandom,iprandomax,icomatsav,ipdirsav, &
                        ipprandom,ippdirsav,iit_random,natsoldd,ichoice_volte,nvo, &
                        ichoice,ipdirfigure,numtrialrando,               &
                        numtrialrando_sav,nats_sav_rand
             integer :: i_ordino_DM,i_compare_map

             character(len=80)  :: fomfile

!             type(list_model_type), save :: listrand
             type(model_type), dimension(:), allocatable :: modelrand
      CONTAINS
!
      subroutine AllocaRandomStaff(iAction)
      dimension ierv(3)
      integer :: i,iAction,ierv,ierr
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      ierv=0
      ierr = 0

      if (iAction == 1) then
          IF (.NOT. ALLOCATED(matcomb)) ALLOCATE (matcomb(1:10000,1:1000), stat = ierv(1))

          IF (.NOT. ALLOCATED(imatcomb)) ALLOCATE (imatcomb(1:1000,1:2), stat = ierv(2))
          IF (.NOT. ALLOCATED(clpcomb))  ALLOCATE (clpcomb(1:3000), stat = ierv(3))

          ierr=0
          do i=1,3
            ierr=ierr+iabs(ierv(i))
          enddo
          if (ierr.ne.0) then
              write(0,*) 'RandomStaff Allocation Error'
              stop
          endif
          matcomb=0
          imatcomb=0
          clpcomb=0
      else
          IF (ALLOCATED(matcomb)) DEALLOCATE (matcomb,imatcomb,clpcomb,stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'RandomStaff DeAllocation Error'
              stop
          endif
      endif
!
      return
      end subroutine AllocaRandomStaff
!
      subroutine AllocaRandomStaff_fom(iAction)

      integer :: i,i_app,iAction,ierv,ierr

      dimension ierv(21)
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      i_app=20+(20*iprandomax)

      ierv=0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(fom_mabs))  ALLOCATE (fom_mabs(1:20), stat = ierv(1))
          IF (.NOT. ALLOCATED(fom_alcomb))  ALLOCATE (fom_alcomb(1:20), stat = ierv(2))
          IF (.NOT. ALLOCATED(fom_pscomb))  ALLOCATE (fom_pscomb(1:20), stat = ierv(3))
          IF (.NOT. ALLOCATED(fom_pscomb_random))  ALLOCATE (fom_pscomb_random(1:20), stat = ierv(4))
          IF (.NOT. ALLOCATED(fom_cphase))  ALLOCATE (fom_cphase(1:20), stat = ierv(5))
          IF (.NOT. ALLOCATED(fom_cfom))  ALLOCATE (fom_cfom(1:20), stat = ierv(6))
          IF (.NOT. ALLOCATED(fom_emap))  ALLOCATE (fom_emap(1:20), stat = ierv(7))
          IF (.NOT. ALLOCATED(fom_geom))  ALLOCATE (fom_geom(1:20+1,1:2), stat = ierv(8))

          IF (.NOT. ALLOCATED(fomgeom_comb))  ALLOCATE (fomgeom_comb(1:i_app), stat = ierv(9))
          IF (.NOT. ALLOCATED(fomemap))  ALLOCATE (fomemap(1:i_app), stat = ierv(10))
          IF (.NOT. ALLOCATED(fomgeom))  ALLOCATE (fomgeom(1:i_app), stat = ierv(11))
          IF (.NOT. ALLOCATED(fomcfom))  ALLOCATE (fomcfom(1:i_app), stat = ierv(12))
          IF (.NOT. ALLOCATED(fompsi0))  ALLOCATE (fompsi0(1:i_app), stat = ierv(13))
          IF (.NOT. ALLOCATED(fompr))  ALLOCATE (fompr(1:i_app), stat = ierv(14))
          IF (.NOT. ALLOCATED(fomsr1))  ALLOCATE (fomsr1(1:i_app), stat = ierv(15))
          IF (.NOT. ALLOCATED(fomsr1_pes))  ALLOCATE (fomsr1_pes(1:i_app), stat = ierv(16))
          IF (.NOT. ALLOCATED(fomsr2))  ALLOCATE (fomsr2(1:i_app), stat = ierv(17))
          IF (.NOT. ALLOCATED(fomsr2_pes))  ALLOCATE (fomsr2_pes(1:i_app), stat = ierv(18))

          IF (.NOT. ALLOCATED(numdet))  ALLOCATE (numdet(1:20), stat = ierv(19))
          IF (.NOT. ALLOCATED(erfom))  ALLOCATE (erfom(1:20), stat = ierv(20))
          IF (.NOT. ALLOCATED(imod_del))  ALLOCATE (imod_del(1:i_app), stat = ierv(21))
          ierr=0
          do i=1,21
            ierr=ierr+iabs(ierv(i))
          enddo
          if (ierr.ne.0) then
              write(0,*) 'RandomStaff_fom Allocation Error'
              stop
          endif
          fom_mabs=0
          fom_alcomb=0
          fom_pscomb=0
          fom_pscomb_random=0
          fom_cphase=0
          fom_cfom=0
          fom_emap=0
          fom_geom=0

          fomgeom_comb=0
          fomemap=0
          fomgeom=0
          fomcfom=0
          fompsi0=0
          fompr=0
          fomsr1=0
          fomsr1_pes=0
          fomsr2=0
          fomsr2_pes=0

          numdet=0
          erfom=0
          imod_del=0
      else
          IF (ALLOCATED(fom_mabs)) DEALLOCATE (fom_mabs,fom_alcomb,fom_pscomb,  &
          fom_pscomb_random,fom_cphase,fom_cfom,fom_emap,fom_geom,              &
          fomgeom_comb,fomemap,fomgeom,fomcfom,fompsi0,fompr,fomsr1,fomsr1_pes,fomsr2,     &
          fomsr2_pes,numdet,erfom,imod_del,stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'RandomStaff_fom DeAllocation Error'
              stop
          endif
      endif
      return
      end subroutine AllocaRandomStaff_fom
!
      subroutine AllocaRandomStaff_del(iAction)

      integer :: i,i_app,iAction,ierv,ierr

      dimension ierv(15)
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      i_app=20+(20*iprandomax)
      ierv=0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(nset_del))  ALLOCATE (nset_del(1:i_app), stat = ierv(1))
          IF (.NOT. ALLOCATED(nset_sost))  ALLOCATE (nset_sost(1:i_app), stat = ierv(2))
          IF (.NOT. ALLOCATED(i_set_del))  ALLOCATE (i_set_del(1:i_app), stat = ierv(3))
          IF (.NOT. ALLOCATED(indici_per_random))  ALLOCATE (indici_per_random(1:501,1:3), stat = ierv(4))

          IF (.NOT. ALLOCATED(indici_random))  ALLOCATE (indici_random(1:i_app,1:501,1:3), stat = ierv(5))
          IF (.NOT. ALLOCATED(jpuntt_random))  ALLOCATE (jpuntt_random(1:i_app,1:501), stat = ierv(6))
          IF (.NOT. ALLOCATED(npunt_random))  ALLOCATE (npunt_random(1:i_app), stat = ierv(7))
          IF (.NOT. ALLOCATED(iphaz_random))  ALLOCATE (iphaz_random(1:iprandomax+1,1:20,1:501), stat = ierv(8))
          IF (.NOT. ALLOCATED(iphaz_random_fin))  ALLOCATE (iphaz_random_fin(1:i_app,1:501), stat = ierv(8))
          IF (.NOT. ALLOCATED(wt_random))  ALLOCATE (wt_random(1:iprandomax+1,1:20,1:501), stat = ierv(9))
          IF (.NOT. ALLOCATED(wt_random_fin))  ALLOCATE (wt_random_fin(1:i_app,1:501), stat = ierv(9))

          IF (.NOT. ALLOCATED(errsem))  ALLOCATE (errsem(1:2,1:20), stat = ierv(10))
          IF (.NOT. ALLOCATED(errsem_pes))  ALLOCATE (errsem_pes(1:2,1:20), stat = ierv(11))
          IF (.NOT. ALLOCATED(errsem_tot))  ALLOCATE (errsem_tot(1:2,1:i_app), stat = ierv(12))
          IF (.NOT. ALLOCATED(errsem_pes_tot))  ALLOCATE (errsem_pes_tot(1:2,1:i_app), stat = ierv(13))
          IF (.NOT. ALLOCATED(irefsem))  ALLOCATE (irefsem(1:20), stat = ierv(14))
          IF (.NOT. ALLOCATED(fomrt_random))  ALLOCATE (fomrt_random(1:i_app,1:10), stat = ierv(15))
          ierr=0
          do i=1,15
            ierr=ierr+iabs(ierv(i))
          enddo
          if (ierr.ne.0) then
              write(0,*) 'RandomStaff_del Allocation Error'
              stop
          endif
          nset_del=0
          nset_sost=0
          i_set_del=0
          indici_per_random=0

          indici_random=0
          jpuntt_random=0
          npunt_random=0
          iphaz_random=0
          iphaz_random_fin=0
          wt_random=0
          wt_random_fin=0

          errsem=0
          errsem_pes=0
          errsem_tot=0
          errsem_pes_tot=0
          irefsem=0
          fomrt_random=0
      else
          IF (ALLOCATED(nset_del)) DEALLOCATE (nset_del,nset_sost,i_set_del,indici_per_random,  &
             indici_random,jpuntt_random,npunt_random,iphaz_random,iphaz_random_fin,wt_random,  &
             wt_random_fin,errsem,errsem_pes,errsem_tot,errsem_pes_tot,irefsem,fomrt_random, stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'RandomStaff_del DeAllocation Error'
              stop
          endif
      endif
      return
      end subroutine AllocaRandomStaff_del
      END MODULE RandomStaff
