#define REGROUP 1
 MODULE FSREFINEMENT
 USE progtype, only:ALLOCA,DEALLOCA,refine_condition_type,rparam_type  !!!!,model_type
 USE atom_basic, only: atom_type
 USE reflection_type_util, only:gref_type
 USE rrestr, only:restraint_type   !!!FIXME, constraint_type
 USE model_util, only: model_type
 USE constraints, only: constraint_type

 implicit none

 public  :: fsfourier,calcolaRwp,setgwei
!
 type(refine_condition_type) :: fscond
 integer                  :: npref        ! num. di rifessi usati per minimi quadrati
 integer                  :: ngr          ! num. di gruppi
 real                     :: sogover      ! soglia di overlapping
 real                     :: errefsmin    ! minimo rf ripartito
 real, allocatable        :: integg(:)     ! intensit� dei gruppi
 integer                  :: numoss       ! num. di osservazioni
 integer                  :: kcscal       ! 0/1 : non calcola / calcola scala prima della Fourier
 integer                  :: krip         ! 0/1 : applica / non applica ripartizione
 integer                  :: ncfs =0      ! numero seriale ciclo fourier
 integer                  :: typeref      ! tipo di affinamento (vedi icod in setreflections)
 integer                  :: ncyclestep   ! numero cicli per step                                      
 real, private            :: fracref      ! (0-1) frazione di riflessi da usare
 integer                  :: selcode      ! tipo di selezione del modello.1-errefsw;2-erref;3-Rwp
 real                     :: valsel       ! grandezza usata per la selezione del modello
 character(len=80)        :: strsel       ! stringa identificativa del modello selezionato
 type(atom_type), allocatable :: atb(:)       ! contiene il modello migliore
 type(atom_type), allocatable :: atbest(:)       ! contiene il modello migliore
 integer                  :: natb         ! il numero di atomi del modello migliore
 integer                  :: natbest      ! il numero di atomi del modello migliore
 real                     :: fsc
 real                     :: sogh
 real, allocatable        :: wprint(:)    ! peso per plot
 logical                  :: rwpopt       ! calcola e stampa Rwp ad ogni ciclo
 logical                  :: statopt      ! stampa statistiche varie
 real, allocatable        :: fobsold(:)
 real, allocatable        :: fcor(:)
 integer                  :: nmcicli      ! num. di macrocicli Affinamento/Fourier
 integer                  :: nresd,nresa
 logical                  :: fserr = .false.
 character(len=120)       :: fserr_msg = " "
 integer                  :: auto_complete
 real, dimension(3)       :: wqqsav
 integer, private         :: natold
 real                     :: errefsv
 real                     :: errefs
 real                     :: errefsv1
 real                     :: errefsw
 real                     :: errefsing
 real                     :: errepw
 real, allocatable, dimension(:,:) :: mapcor
 real, allocatable, dimension(:,:,:) :: mapdif
 type(gref_type), dimension(:), allocatable :: gref
 integer, parameter, private :: INTREF = 1
 integer, parameter, private :: GRUREF = 2
 integer, parameter, private :: FREF = 3
 integer, parameter, private :: GR_AND_REF = 4
 type(restraint_type), dimension(:), allocatable :: resvf
 real, dimension(3) :: wqqf
 type(constraint_type), dimension(:), allocatable :: constrv
 type(rparam_type) :: scalf
 logical :: kload12 = .FALSE.
 type(model_type), dimension(:), allocatable :: fsmodel
 integer                                     :: numfsmodel
 real, dimension(5)  :: corfscat
 integer             :: icorfscat=0


 CONTAINS

   subroutine fsinitlsq()

   USE RefinecomRef, only:noverl
   USE General  , only : nrefl,knw,celem,spacegr
   USE GENLSQ
   USE variables, only : atm,ref
   USE Atomi
   USE progtype
   USE atom_type_util
   USE reflection_type_util
   USE sinterface, only: fillatom
!
   character(len=69) :: string
   integer           :: i
   integer           :: ng
   real              :: scale
   real              :: errefvo
   integer           :: numosstrue
   integer           :: nparf
   real, allocatable :: ddf(:),inteo(:)
   logical           :: sverbose
!
!  Intestazione
   !do i=1,69
   !   string(i:i) = '*'
   !enddo
   !write(6,'(/5x,a69,//,23x,a28,//,5x,a69)')string,'Structure Model Optimization',string
   !write(6,'(/5x,69("*"),//,23x,a,//,5x,69("*"))')'Structure Model Optimization'
   write(6,'(/5x,69("*"),//,23x,"Structure Model Optimization",//,5x,69("*"))')
!
!  Inizializza variabili
   call fserr_init()
   call fsdefault()
   sverbose = index(fscond%sprint,'V') > 0
   scalf = rparam_type(val=1.0,rcod=1,str='scale')
   ncytot = 0
   sogh = 0.6
!
!  Salva gli F osservati   
   allocate(fobsold(nrefl))
   fobsold = ref(:nrefl)%fo
!
   call setall
!
!  Calcolo iniziale di fattori di struttura
!corr   if(nats.gt.0)call fcalcan(ref,atm(:nats))
   if(nats.gt.0)call sfcalc(ref,atm,spacegr,celem)
!
!  Ordina i riflessi e definisci il numero di riflessi da usare
   !ref%fo = ref%fv   ! se vuoi usare gli Fo veri
   call setreflections(nrefl,fra=fracref,icod=typeref)
!
   call Allocafuncls(ALLOCA,numoss)        ! alloca funcls e weilsq
!
!  Calcolo iniziale di scala
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1))
   call setweilsq()                        ! calcola pesi
!
   if (statopt) call statfsnew()
!!!!   call statfsnew()
!
!  Stampa erref e modello
   !if(nats.gt.0) call print_atoms(atm(:nats),title='Starting model')
   if(nats.gt.0)then
      call print_atoms(atm(:nats),title='Starting model')
!
      if (knw == 1) then
          call fillatom(atm)
          if (sverbose) then
              call to_coord(1)
          else
              call to_coord(0)
          endif
      endif
      call calcerrefs(npref,kcscal,scalf%val,1)
!
     if (statopt) then
       select case (typeref)
          case (INTREF)
             allocate(ddf(npref),inteo(npref))
             inteo(:) = ref(:npref)%m*ref(:npref)%lp(1)*ref(:npref)%fo**2
             ddf = ref(:npref)%m*ref(:npref)%lp(1)*(ref(:npref)%fo**2-scalf%val*ref(:npref)%fc**2)
             call wdfanalysis(inteo,real(weilsq),ddf,20)

          case (GRUREF)
             allocate(ddf(ngr))
             do ng=1,ngr
                 ddf(ng) = gref(ng)%Io - scalf%val*gref(ng)%Ic
             enddo
             call wdfanalysis(gref(:numoss)%Io,real(weilsq(:numoss)),ddf(:numoss),20)

          case (FREF)
             call wdfanalysis(ref(:npref)%fo,real(weilsq),ref(:npref)%fo-scalf%val*ref%fc,20)

       end select
     endif
!
     write(string,'(a5,f8.3)') ' R = ',errefs*100.0
     call PrintMess(string(1:13))
   endif
!
   if (sverbose) then
!
!      Stampa il numero di riflessi
       write(6,10)npref,nrefl,100.*npref/nrefl
10     format(/10x,'Nr. of reflections = ',i4,'/',i4,' (',f5.1,'%)')
!
!      Stampa il numero di clusters
       if (ngr /= 0) then
           write(6,20)ngr,size(gref),100.*ngr/size(gref)
20         format(10x,'Nr. of clusters    = ',i4,'/',i4,' (',f5.1,'%)')
       endif
!
!      Stampa rapporto osservazioni/parametri
       nparf = (nats*4)
       numosstrue=0
       do i=1,numoss
         if(weilsq(i)>0.0)numosstrue=numosstrue+1
       enddo
       write(6,70)real(numosstrue) / nparf, sum(weilsq**2) / nparf
70     format(10x,'Ratio obs./par.    = ',f7.2,' (',f7.2,')')
!
       if (knw == 1) then
!
!          Stampa erre tra F osservati e veri
           scale = sum(ref(:npref)%fv) / sum(ref(:npref)%fo)
           errefvo = sum(abs(ref(:npref)%fv-scale*ref(:npref)%fo)) / sum(ref(:npref)%fv)
           if (npref /= nrefl) then
               write(6,60)errefvo,npref
               scale = sum(ref(:nrefl)%fv) / sum(ref(:nrefl)%fo)
               errefvo = sum(abs(ref(:nrefl)%fv-scale*ref(:nrefl)%fo)) / sum(ref(:nrefl)%fv)
               write(6,60)errefvo,nrefl
           else
               write(6,61)errefvo
           endif
!
!          Stampa riflessi e clusters
           if (ngr == 0) then
!          write(6,48)
!          write(6,50)(i,ref(i)%hkl,ref(i)%fo*scale,ref(i)%fv,weilsq(i)**2,noverl(i),i=1,npref)
           else
               write(6,'(/,14x,a,/)')'Clusters                 Reflections'
               write(6,*)'        Intensity    Overlap.          h  k  l      Fo        Fv'
               ng = 0
               do i=1,npref
                if (noverl(i) /= 0) then
                    ng = ng + 1
!               write(6,30)ng,integ(ng),integv(ng),noverl(i),i,ref(i)%hkl,ref(i)%fo,ref(i)%fv
                else
!               write(6,40)i,ref(i)%hkl,ref(i)%fo,ref(i)%fv
                endif
              enddo
           endif
       endif
   endif
!
!30 format(2x,i4,')',2x,2es12.3,6x,i3,6x,'|',i4,')',3i3,2x,3(f10.3,2x))
!40 format(t49,'|',i4,')',3i3,2x,2(f10.3,2x))
!48 format(/,'     n.   h  k  l     Fobs     Ftrue      W             n.   h  k  l     Fobs     Ftrue      W',/, &
!            '     ----------------------------------------------     ----------------------------------------------')
!50 format(2(2x,i4,')',3i3,2x,3(f10.3,2x),i3))
60 format(10x,'RF (true-obs)      = ',f8.3,'(',i4,' reflections)')
61 format(10x,'RF (true-obs)      = ',f8.3)
!
   end subroutine fsinitlsq
!----------------------------------------------------------------------------------------------------
   subroutine fserr_init()
   fserr = .false.
   fserr_msg = " "
   end subroutine fserr_init   
!----------------------------------------------------------------------------------------------------
   subroutine fsdefault()
   USE refinecomref
   USE genlsq
   USE RIETV
!
!  definisci il default per l'affinamento
   call init_refine_cond(fscond)
!   
!  numero massimo di cicli
   fscond%maxcy = 100
!
!  opzioni di stampa
   fscond%sprint = 'S'     ! small print
   !fscond%sprint = 'V'     ! verbose print
!
!  Tipo di algoritmo di ottimizzazione: NL2SOL,LMDER,GAUNEW
   fscond%algo = NL2SOL   ! NL2SOL GAUNEW  LMDER
   !fscond%algo = LMDER  
!
!  Tipo di affinamento (vedi icod in setreflections per dettagli)
!  typeref = GR_AND_REF   !!!GR_AND_REF  !GRUREF  !!!INTREF   
   !typeref = GRUREF                                                   
   typeref = INTREF   
!
!  Frazione di riflessi da usare
   fracref = 1.0
!
!  Calcola e stampa Rwp ad ogni ciclo?
   rwpopt = .false.
!
!  Esegui statistiche varie
   statopt = .false.
!
!  Tipo di selezione per il modello migliore
   selcode = 2
!
   end subroutine fsdefault
!----------------------------------------------------------------------------------------------------
   subroutine fslsqexe(kevent)
   USE GENLSQ
   USE RRESTR, only:nrestraints
   USE constraints, only:reset_constraints 
   USE progtype
   USE variables, only:atm,ref
   USE atom_type_util
   USE General, only: knw,cell,spacegr,lo
   USE unit_cell
   USE compare_struct
   USE variables, only: cryst
!
   integer, intent(out) :: kevent
   integer              :: Nactot
   integer              :: stoplsq
   integer              :: numres
   real                 :: start_time, end_time
!
   call cpu_time(start_time)   ! inizializza il tempo di calcolo
   kevent = 0
!
   numres = nrestraints(resvf)
   if (size(funcls) /= numoss + numres) call Allocafuncls(ALLOCA,numoss+numres)
!
   if (auto_complete == 1) then                ! richiesto completamento della struttura
       call fscomplete(kevent)
   else                                           ! richiesto affinamento della struttura
       scalf%rcod = 1
!
       call setweilsq()
!
       if (.not.fscond%auto_stru) then                                        ! affinamento non automatico
           call reset_constraints(constrv)   ! corrado-temp
           call fsconta_parametri(Nactot)     !!!!!!,fscond)
           call AllocaLSQ(ALLOCA,Nactot,numoss+numres)
!
           call fsprerefine()
           call lsqsolve(fscond%algo,numoss+numres,Nactot,fscond%maxcy,fscond%eps,ffsgauss,ffslm,fscalcr,fscalcj, &
                         .TRUE.,kevent,stoplsq)
           call AllocaLSQ(DEALLOCA)
       else                                                             ! affinamento automatico
           call autofslsq(kevent)
       endif
!
   endif
!
   if(.not.fserr) then
      if (knw == 1 .and. scan(fscond%sprint,'SV') > 0) then
!corr         call fillatom(atm)
!corr         call to_coord(1)   !!! temp
         call to_coord_sir(-1,atm,ref,size(ref),set_cell_type(cell),spacegr,lo,cryst(1)%atpub)
      endif
      if (index(fscond%sprint,'V') > 0) then
          call cpu_time(end_time)               ! tempo di calcolo
          write(6,'(2x,a9,f6.3,a)')'CPU time:',(end_time-start_time)/60.0,'m'
      endif
   endif
!
   end subroutine fslsqexe
   
!----------------------------------------------------------------------------------------------------

   subroutine autofslsq(kevento,group)
   USE Atomi, only:nats
   USE RefinecomRef, only:kstager,kstagemax,rfcond
   USE GENLSQ
   USE RRESTR, only:nrestraints
   USE constraints, only:reset_constraints 
   USE Molcom, only:jscreen
   USE variables, only:atm,lconn
!corr   USE RIETV, only: setstagestru_new
   USE drawatoms
   USE molpnew
   USE strutil
   USE messagemod
   USE General, only: cell,spacegr,celem,neutro
   USE unit_cell
   USE setref
   USE sinterface, only: fillatom
!
   integer, intent(out), optional   :: kevento
   logical, intent(in), optional    :: group
   logical                          :: winact
   integer                          :: Nactot
   integer                          :: stoplsq
   integer, allocatable             :: vrem(:)
   integer                          :: numres
   integer                          :: kevent
   logical                          :: rgroup
   type(cell_type)                  :: cellt
   type(refinement_strategy_type)   :: fstrat
!
   if (present(group)) then
       rgroup = group
   else
#if defined(REGROUP) 
       rgroup = .true.
#else
       rgroup = .false.
#endif
   endif
   winact = .FALSE.
   kstagemax = 0
   kevent = 0
   numres = nrestraints(resvf)
   call reset_constraints(constrv)         ! reset constrv used by setstagestru, can contains constr from rietveld
   call fstrat%new()
   if (numres == 0) then
       call fsdefine_strategy(2,fstrat,atm,neutro)
   else
       call fsdefine_strategy(3,fstrat,atm,neutro)
   endif
   kstagemax = fstrat%get_num()
   cellt = set_cell_type(cell)
   do kstager=1,kstagemax
                          !call print_connect(atm%lab,legm=lconn,kpri=0)
      call setstagestru_new(rfcond,atm,lconn,cellt,spacegr,celem,constrv,fstrat%stages(kstager))
      call write_message('Step '//trim(i_to_s(kstager))//'/'//trim(i_to_s(kstagemax))//   &
                         '. Parameters: '//trim(fstrat%stages(kstager)%get_string()),pos=4)
      scalf%rcod = 1                     ! imponi affinamento scala
      do
         call reset_constraints(constrv)         ! corrado-temp
         call fsconta_parametri(Nactot)   !!!!!!,fscond)
         call AllocaLSQ(ALLOCA,Nactot,numoss+numres)
!
    !    winact = (codew == 0) .and. (kstager == kstagemax)
         call fsprerefine()
         call lsqsolve(fscond%algo,numoss+numres,Nactot,fscond%maxcy,fscond%eps,ffsgauss,ffslm,fscalcr,fscalcj,  &
                       winact,kevent,stoplsq)
         call AllocaLSQ(DEALLOCA)
         if (kevent > 0) exit
         if (stoplsq == 0) exit
!         write(6,*)'ALGO RIAVVIATO'
      enddo
!
!     Disegna
!!#if defined(REGROUP) 
!!      call create_connectivity(atm,iconn,check=.true.,move=.true.)
!!#else
!!      call create_connectivity(atm,iconn,check=.true.)
!!#endif
      if (rgroup) then
          call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.,move=.true.)
      else
          call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.)
      endif
      if (jscreen > 0) call draw_atoms(atm,lconn)
!!!! introdotta a luglio 2006 perche' si ottenevano risultati diversi con e senza grafica
      call fillatom(atm)
      if (kevent > 0) exit
   enddo
   allocate(vrem(nats))
   call check_distance(atm(:nats),vrem,kpr=0)
   call check_coord(atm(:nats),vrem)
   call remove_atoms(vrem)
   deallocate(vrem)
   if (present(kevento)) kevento = kevent
!
   end subroutine autofslsq

!----------------------------------------------------------------------

   subroutine fsdefine_strategy(codes,strategy,atom,radtype)
   USE setref
   integer, intent(in)                                    :: codes
   type(refinement_strategy_type), intent(inout)          :: strategy
   type(atom_type), dimension(:), allocatable, intent(in) :: atom
   integer, intent(in)                                    :: radtype
!   
   select case (codes)
      case (1)
        call strategy%add_stage('XYZ@SEQ',atom,radtype)
        call strategy%add_stage('XYZ',atom,radtype)
        call strategy%add_stage('B@SEQ',atom,radtype)
        call strategy%add_stage('B',atom,radtype)
        call strategy%add_stage('XYZB@SEQ',atom,radtype)
        call strategy%add_stage('XYZB',atom,radtype)
        !call strategy%prn(0)

      case (2)
        call strategy%add_stage('XYZ',atom,radtype)
        call strategy%add_stage('XYZB',atom,radtype)

      case (3)
        call strategy%add_stage('XYZB',atom,radtype)
   end select
!
   end subroutine fsdefine_strategy

!--------------------------------------------------------------------

   subroutine setstagestru_new(rfc,atom,legm,cell,spg,elem,constr,sstage)
   USE elements
   USE unit_cell
   USE atom_type_util
   USE setref
   USE spginfom
   USE connect_mod
   USE constraints
   USE arrayutil
   USE variables, only: cryst,dataset
!
   implicit none
   type(refine_condition_type), intent(in)                         :: rfc
   type(atom_type), dimension(:), allocatable, intent(inout)       :: atom
   type(bond_type), dimension(:), allocatable, intent(in)          :: legm
   type(cell_type), intent(inout)                                  :: cell
   type(spaceg_type), intent(in)                                   :: spg
   type(element_type), dimension(:), allocatable, intent(in)       :: elem
   type(constraint_type), dimension(:), allocatable, intent(inout) :: constr
   type(refinement_stage_type), intent(in)                         :: sstage
   logical                                                         :: riding_model
!
   call calcola_occ(atom,spg,cell)   ! coordinates are modified
!   call azzeraref()
   cryst(1)%at_refined = .false.
   call set_rcode_atoms(atom,cell,spg,constr,'XYZBO',0)
   call refine_constraint(constr,atom,0)
   riding_model = (dataset(1)%radtype == RX_SOURCE)
   call make_constraints(atom,legm,constr,spg,cell,riding_model,adp_factor=1.2)
   if (size_array(sstage%vet) > 0) then
       call set_rcode_atoms(atom,cell,spg,constr,sstage%spar,1,zspec=sstage%vet)
   else
       call set_rcode_atoms(atom,cell,spg,constr,sstage%spar,1)
   endif
!
   end subroutine setstagestru_new


!--------------------------------------------------------------
   subroutine check_coord(atom,vrem)
   type(atom_type), dimension(:), intent(in) :: atom
   integer,dimension(:), intent(inout)       :: vrem
   integer                                   :: i
   do i=1,size(atom)
      if(any(abs(atom(i)%xc) > 3.0)) vrem(i) = 1
   enddo
   end subroutine check_coord
!--------------------------------------------------------------
   subroutine fsconta_parametri(Nactot)
   USE RefinecomRef
   USE variables, only:atm,cryst
   USE constraints
   USE atom_type_util
!
   implicit none
   integer, intent(out) :: Nactot
   integer              :: Nstru
   integer              :: i
   integer              :: nconstra
!
   Nactot = 0
   if (scalf%rcod > 0) Nactot = Nactot + 1
!
!  Struttura
   Nstru = 0
   do i=1,numatoms(atm)
      Nstru = Nstru + count(atm(i)%rcod > 0)
   enddo
   nconstra = nconstraints_ref(constrv)
   cryst(1)%at_refined = Nstru + nconstra > 0
!
   Nactot = Nactot + Nstru + nconstra
!
   end subroutine fsconta_parametri
!----------------------------------------------------------------------------------------------------
   subroutine fscomplete(kevent)
   USE Atomi
   USE exploreset, only: more_trials
   USE General, only : neutro,knw,cell,spacegr,celem
   USE GENLSQ
   USE PRNUTIL
   USE variables, only:ref,atm,lconn
   USE var_samod, only:i_SA
   USE atom_type_util
   USE Phasemodule, only:numset,imove
   USE TestModel
   USE molpnew
   USE messagemod
   USE strutil
   USE enable_amb
   USE Molcom, only: jscreen
   USE drawatoms
   USE Mappa
   USE fourier_mod, only: AllocaMappa
   USE unit_cell
   USE reflection_type_util
   USE connect_mod
   USE sinterface, only: update_model
!
   integer, intent(out) :: kevent
   integer              :: npadd
   real                 :: anat1
   integer              :: nsteps
   integer              :: natc
!
!  Clear xmap
   call InitFour()
   call AllocaMappa(2) 
   call AllocaMappa(1) 
!
   if(i_SA==1)then
      call fscomplete_res()
      return
   endif    
!
   kevent = 0
   nmcicli = 8
   nsteps = nmcicli + 1
   if (jscreen > 0) then
       call write_message(string='Set ',inum=numset,pos=2)
       call abilita_tasti('run')
       call progress_bar_init('Starting Refinement',nsteps)
       if (more_trials) call toolbar_set_state('Skip'//char(0),1)
   endif
!
   valsel = huge(1.0)
   call setweilsq()
!
!  Cicli di affinamento + Fourier
   fscond%auto_stru = .true.
   if(imove.gt.0)call randomcoord
   do ncfs=1,nmcicli
      call progress_bar_update()
      call write_message('Cycle n. '//trim(i_to_s(ncfs))//'/'//trim(i_to_s(nsteps)),pos=3)
      call autofslsq(kevent,group=.true.)                                 ! affinamento
      if (statopt) call statfsnew()
      call save_bestmodel(icod=ncfs,scod='refinement')
!
      natc = nint(natom_cell(celem,neutro==0))
      anat1 = sum(atm(:nats)%ocry)*spacegr%nsymop
      npadd = nint((1.2*natc-anat1)/spacegr%nsymop)   
      npadd = sign(ceiling(real(abs(npadd)) / (nmcicli - ncfs + 1)),npadd)
!
!corr      call InitFour()
      call fsfourier(2,npadd,npref,krip,kcscal,ncfs,scalf%val) ! Fourier
!
      scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
      call calcerrefs(npref,kcscal,scalf%val,1)          ! calcola e stampa erref
      call save_bestmodel(icod=ncfs,scod='fourier')
      if (kevent > 0) exit
!
!corr      call setkcond()
   enddo
!
!  Concludi con un affinamento
   if (kevent == 0) call autofslsq(kevent,group=.true.)
   call write_message(' Cycle n. '//trim(i_to_s(ncfs))//'/'//trim(i_to_s(nsteps)),pos=3)
   call progress_bar_update()
!
!  prendi il modello migliore
   call save_bestmodel(scod='last refinement')
!
!  seleziona il modello migliore
   call get_bestmodel(1)
!
!  analisi del modello  !!!!FIXME
   if (neutro == 0) call modifica_modello(kpr=0)
!
!  Raggruppa gli atomi
   call calcola_occ(atm,spacegr,set_cell_type(cell))
   call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.,move=.true.)
!corr   call fillatom(atm)
   call bond_to_iconn(lconn,iconn)  ! update iconn at the end of procedure
   call update_model(atm,lconn,1)
   call print_atoms(atm(:nats),title='Final model') ! stampa struttura finale
!
!  Calcola RF per modello finale
   ref(:)%fo = fobsold(:)         ! ripristina gli Fo 
   call sfcalc(ref,atm,spacegr,celem)
   call calcerrefs(npref,1,kpr=1)    
   call clear_messages(ipos=4,fpos=6)
   if(knw.gt.0)then
      call to_coord(1)
      call write_message_found(4)
      write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,f8.3/)')' Found Atoms: (Final map) ', &
      vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
   endif
!
   call Allocafuncls(DEALLOCA)
   if (jscreen > 0) then
       call draw_atoms(atm,lconn)
       call write_message(string='Fourier recycling procedure on set '//trim(i_to_s(numset))//' is completed',pos=2)
       call write_message(string='Final model with RF '//trim(r_to_s(errefs*100,3))//' was selected',pos=3)
       call abilita_tasti('structure+pattern')
       call progress_bar_close()
   endif
!
   end subroutine fscomplete
!----------------------------------------------------------------------------------------------------
   subroutine fscomplete_res()
   USE Atomi
   USE variables, only:atm,ref
   USE RRESTR
   USE General, only : neutro
   USE GENLSQ
   USE atom_type_util
   USE sinterface, only: fillatom
!
   integer                  :: i
   integer                  :: kevent
   integer                  :: istamp
   integer                  :: kAction, iprinCode
   integer, dimension(nats) :: vrem
!corr   real                     :: dmini
!
!corr   if(neutro==0) then
!corr     dmini=1.1
!corr   else
!corr     dmini=0.85
!corr   endif
!corr   vrem(:)=0
   call check_distance(atm(:nats),vrem,kpr=1)
   if(any(vrem==1)) then
      fserr=.true.
   else
      call setweilsq()
      kblock(1:nats)=1
      kAction = 5; iprinCode = 1     ! gianluca 16/03/2007
      call maincl(kAction, iprinCode)
      kblock(1:nats)=1
!CORO
!    istamp=1
      istamp=0
!CORO
!serve per la lista di angoli e distanze per affinare il modello
      call avvisolati(5,istamp,5)
      do i=1,nats
         atm(i)%xc=xyzs(:3,i)
      enddo
      call fillatom(atm)
      call adjustbiso
      nmcicli=1
      call Allocafuncls(DEALLOCA)
      call impose_restr()
      call Allocafuncls(ALLOCA,numoss+nrestraints(resvf))
      call setweilsq()
      wqqf(1)=10000.0
      wqqf(2)=10000.0
      wqqsav(1)=0.0
      wqqsav(2)=0.0
      call autofslsq(kevent)
      call calcolaRwp(ref(:npref)%fc,150.0) ! calcolo di Rwp per ultimo mod. aff.
      call Allocafuncls(DEALLOCA)
      call fillatom(atm)
      call to_coord(0)
!corr     errem=errefs
!r         interp=1
      call check_distance(atm(:nats),vrem,kpr=1)
      if(any(vrem==1)) fserr=.true.
!r       call frm15(nats,interp)
!        call print_atoms(atm(:nats),title='FINALE B') ! stampa struttura finale
   endif
!
   end subroutine fscomplete_res
!----------------------------------------------------------------------------------------------------
   subroutine adjustbiso
   USE RefinecomRef
   USE Atomi, only : iconn,nats
   USE GENLSQ
   USE variables, only:ref,atm
   USE general, only: spacegr,celem
   USE var_samod, only:i_SA
   !USE atom_type_util
   USE connect_mod
   USE reflection_type_util
   USE sinterface, only: fillatom
!
   integer                         :: i,j,isav,l1,l2,imax
   real                            :: scal,erremin,erre,btt,nzmed,erresog
   integer, dimension(nats)        :: nbuild
!
   erremin=1.E+15
   isav=0
!corr   nzmed=sum(float(iabs(atm(:nats)%nz)/100))/float(nats)
   nzmed=sum(float(atm(:nats)%kscatt()))/float(nats)
   nbuild=0
!cccccccccccccccccccccccccccccccccccccccccc
!  nic=iconn(1) * 3 + 1
!  do j=1,nic
!      write(6,*)'TERMICO',j,iconn(j)
!  end do
!cccccccccccccccccccccccccccccccccccccccccc
   do j=1,iconn(1)
       l1=iconn((j-1)*3+2)
       l2=iconn((j-1)*3+3)
       nbuild(l1)=nbuild(l1)+1
       nbuild(l2)=nbuild(l2)+1
   enddo
   if(i_Sa.eq.1)then
     imax=20
   else
     imax=25
   endif
   do i=1,imax
         btt=1.0+(i-1)*0.5
     do j=1,nats
         atm(j)%biso = btt
         !atm(j)%biso= atm(j)%biso*sqrt(nzmed/(float(iabs(atm(j)%get_nz())/100)))
         atm(j)%biso= atm(j)%biso*sqrt(nzmed/(float(atm(j)%kscatt())))
         if(nbuild(j).le.1)atm(j)%biso=atm(j)%biso*1.2 
     enddo
     call fillatom(atm)
!corr     call fcalcan(ref,atm(:nats))
     call sfcalc(ref,atm,spacegr,celem)
     scal = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
     call calcerrefs(npref,0,scal)      ! calcola erref
     erre = errefs
     if(i_Sa.eq.1)then
       erresog=erremin
     else
       if(i.le.20)then
       erresog=erremin
       else
       erresog=erremin*0.993
       endif
     endif
     if(erre.lt.erresog)then
       erremin=erre
       isav=i
     endif
   enddo
   btt=1.0+(isav-1)*0.5
!corr   write(6,*)'New B-iso',btt
   do j=1,nats
         atm(j)%biso=(btt)
         !atm(j)%biso= atm(j)%biso*sqrt(nzmed/(float(iabs(atm(j)%nz)/100)))
         atm(j)%biso= atm(j)%biso*sqrt(nzmed/(float(atm(j)%kscatt())))
         if(nbuild(j).le.1)atm(j)%biso=atm(j)%biso*1.2 
!corr         write(6,'(i4,f8.3,i4)')j,atm(j)%biso,nbuild(j)
   enddo
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   scal = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
   call calcerrefs(npref,0,scal)      ! calcola erref
   end subroutine adjustbiso
!----------------------------------------------------------------------------------------------------
   subroutine randomcoord
   USE General, only : nrefl,knw,cell,celem,spacegr,neutro
   USE nr
   USE rand_mod 
   USE PhaseModule, only : aperc
   USE CommonExpo, only : isearchfo
   USE GENLSQ
   USE CGEOM
   USE Atomi
   USE atom_type_util
   USE variables, only : ref,atm
   USE Mappa
   USE fouriermap
   USE fourier_mod
   USE TestModel
   USE unit_cell
   USE reflection_type_util
   USE elements
   USE sinterface, only: fillatom
   use rrestr
   type(atom_type), allocatable, dimension(:) :: atm_copy,atm_sav
   real, dimension(nrefl)                     :: wei
   real, dimension(nrefl)                     :: work1
   real, dimension(nrefl)                     :: work2
   real, dimension(nrefl)                     :: frvet,eo,ec
   integer, dimension(3,nrefl)                :: hkl
   real                                       :: scal,yrandom,erremin,erref,rf0,erref1
   real                                       :: biso                                                   
   integer                                    :: ier
   integer                                    :: veta(100)
   real                                       :: rfv(100)
   integer                                    :: i,k,k2max
   integer                                    :: kAction, iprinCode, kprintcode,kevent
   integer                                    :: j,nvar,nvar2
   integer                                    :: i1,i2,ii
   real, dimension(8)                         :: on
   integer, dimension(10) :: code
   real                                       :: frac1,frac2,frac4,frac5,rfac,rfac2,cfrac
   integer,allocatable                        :: iorder(:)          
   type(cell_type)                            :: cellt
   integer                                    :: maxel,minel
   real                                       :: deltan
!
   cellt = set_cell_type(cell)
   do i=1,nrefl
      hkl(:,i) = ref(i)%hkl
   enddo
   call InitFour()
   kprintcode=0
   iprinCode=0
   kaction = 5 - kprintcode
   aperc(1) = nats
   call copy_atoms(atm_copy,atm)
   call copy_atoms(atm_sav,atm)
   call sfcalc(ref,atm(:nats),spacegr,celem)
   call simweight(ref(:nrefl),wei(:nrefl),eo(:nrefl),ec(:nrefl))
   k2max=2
   erremin=9999999.0
   allocate(iorder(nrefl))
   maxel = getmax_el(celem)
   minel = getmin_el(celem,neutro==0)
   frac5=1.0
   !frac4=0.5+(maxel-minel)*0.01
   !frac4=0.3+sqrt((celem(maxel)%z-celem(minel)%z)*0.02)
   !frac4=sqrt(float(celem(maxel)%z-celem(minel)%z))/5.0
   deltan=float(celem(maxel)%z-celem(minel)%z)
   !frac4=0.4596+0.0221*deltan-0.0001*(deltan**2.0)
   !frac4=0.4797+0.0224*deltan-0.0001*(deltan**2.0)
   !!frac4=0.5+0.0225*deltan-0.0001*(deltan**2.0)
   !frac4=0.546403+0.030873*deltan-0.0004*(deltan**2.0)+0.000002*(deltan**3.0)
   !frac4=0.5+0.0315*deltan-0.0004*(deltan**2.0)+0.000002*(deltan**3.0)
   frac4=0.5+0.0315*deltan-0.0004*(deltan**2.0)+0.000002*(deltan**3.0)
   !frac4=0.5+(1.0-exp(-0.03*deltan))                                                    
   write(6,*)'FRAC4',frac4
!corrang   if(frac4.gt.1.5)frac4=1.5
   !frac4=1.0
   biso=atm(1)%biso
!corr for bug
   call reset_restraints(resvf,wqqf)
   call Allocafuncls(ALLOCA,numoss,.true.) ! rialloca mantenedo il contenuto
!corr for bug
   do ii=1,k2max
    if(ii.ne.1)then
        wei=1.0
        nats=size(atm_copy)
        call copy_atoms(atm,atm_copy)
        call fillatom(atm)
        call sfcalc(ref,atm(:nats),spacegr,celem)
        call simweight(ref(:nrefl),wei(:nrefl),eo(:nrefl),ec(:nrefl))
        scal = sum (ref(:nrefl)%fo) / sum (ref(:nrefl)%fc)
        xmap=0.0
        frvet(1:nrefl) = (frac5*ref(1:nrefl)%fo + frac4*(ref(1:nrefl)%fo - scal*ref(:nrefl)%fc))
        call MakeMap(hkl,frvet,ref(:nrefl)%ph,wei,nrefl,0,xmap,work1,work2)
        isearchfo = 1
        call Search99(xmap,0,ier,nrefl)
        kblock(1:nats)=0
        call maincl(kAction, iprinCode)
        nz(:nats)=100
        call label(nats,on)
        bfac(1:nats)=2.0
        occpch(:nats) = 1.0
        call xyz_to_atom(atm,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,inte=xyzs(4,:),elem=celem)
        call calcola_occ(atm,spacegr,cellt)
        call atom_string(atm,celem)
        atm(1:nats)%biso=2.0
        call adjustbiso
        call fillatom(atm)
        call sfcalc(ref,atm(:nats),spacegr,celem)
        if(knw.gt.0)then
           call to_coord(0)
           write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,i5,/)')' Found Atoms: (FOURIER model) ', &
           vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),ii
        endif
    endif
        call setweilsq()
        scalf%val = scalefactor(ref(:nrefl)%fo,ref(:nrefl)%fc,ref(:nrefl)%m,ref(:nrefl)%lp(1)) ! nuova scala
        call calcerrefs(nrefl,1,scalf%val)
        call autofslsq(kevent)
        call fillatom(atm)
        call calcola_occ(atm,spacegr,cellt)
        call atom_string(atm,celem)
        call fillatom(atm)
        call sfcalc(ref,atm(:nats),spacegr,celem)
        scal = sum (ref(:nrefl)%fo) / sum (ref(:nrefl)%fc)
        erref = sum(abs(ref(:nrefl)%fo - scal*ref(:nrefl)%fc))/sum(ref(:nrefl)%fo)
        erremin=erref
        call copy_atoms(atm_copy,atm)
        call copy_atoms(atm_sav,atm)
        call fillatom(atm)
        call sfcalc(ref,atm(:nats),spacegr,celem)
        if(knw.gt.0)then
             call to_coord(0)
             call write_message_found(4)
             write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,i5,/)')' Found Atoms: (LSQ model) ', &
             vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),ii
        endif
       i2=nats
       rfac=1.0
       rfac2=1.0
       do i1=1,i2
        if(i1.lt.i2/5)then
          !oldfrac2=randvalue(1.0,1.06)
          frac2=randvalue(1.0,1.06)
        elseif(i1.lt.i2/4)then
          frac2=randvalue(1.0,1.04)
          !oldfrac2=randvalue(1.0,1.04)
        elseif(i1.lt.i2/3)then
          !frac2=randvalue(0.99,1.02)
          frac2=randvalue(1.00,1.02)
        elseif(i1.lt.i2/2)then
          frac2=randvalue(0.99,1.0)
        else
          !frac2=randvalue(0.97,0.99)
          frac2=randvalue(0.98,1.00)
        endif
        nats=size(atm_copy)
        call copy_atoms(atm,atm_copy)
        call sfcalc(ref,atm(:nats),spacegr,celem)
        call evaluate_rf(atm,ref,veta,rfv,rf0)
        !go to 99
        nvar=3*nats/3+1
        if(nvar.lt.1)nvar=1
        nvar2=0
        do k=1,nats    
          call random_number(yrandom)
          i=veta(k)
          code(:) = lsq_conditions(atm(i),spacegr,cellt,k)
          !call random_number(yrandom)
          !atm(i)%biso=max(3.0*yrandom, biso)  
          atm(i)%biso=3.0*yrandom
          call random_number(yrandom)
          !frac1=yrandom*0.12*rfac
          cfrac=0.2-0.01*(k-1)
          if(cfrac.lt.0.12)cfrac=0.12
          frac1=yrandom*cfrac*rfac
          do j=1,3
           !x1(j)=atm(i)%xc(j)
           if(code(j).ne.0)then
           call random_number(yrandom)
           if(yrandom.ge.0.5)then
             call random_number(yrandom)
             atm(i)%xc(j)=atm(i)%xc(j)+frac1                              
             nvar2=nvar2+1
             if(nvar2.eq.nvar)go to 12
           else
             call random_number(yrandom)
             atm(i)%xc(j)=atm(i)%xc(j)-frac1
             nvar2=nvar2+1
             if(nvar2.eq.nvar)go to 12
           endif
           endif
          enddo
        enddo
 12     continue
!99 continue
!!!!!!!!!!!!!!!!!!!!1
!       kblock(1:nats)=0
!       call maincl(kAction, iprinCode)
!       call adjustbiso
!!!!!!!!!!!!!!!!!!!!!!!!!!!
!corr  99 continue
        call fillatom(atm)
        call sfcalc(ref,atm(:nats),spacegr,celem)
        scalf%val = scalefactor(ref(:nrefl)%fo,ref(:nrefl)%fc,ref(:nrefl)%m,ref(:nrefl)%lp(1)) ! nuova scala
        call calcerrefs(nrefl,1,scalf%val)
        call autofslsq(kevent)
        call fillatom(atm)
        call calcola_occ(atm,spacegr,cellt)
        call atom_string(atm,celem)
        call fillatom(atm)
        call sfcalc(ref,atm(:nats),spacegr,celem)
        scal = sum (ref(:nrefl)%fo) / sum (ref(:nrefl)%fc)
        erref = sum(abs(ref(:nrefl)%fo - scal*ref(:nrefl)%fc))/sum(ref(:nrefl)%fo)
        if(i1.eq.1)erref1=erref
        rfac=1.0+(erref-erref1)/erref
        if(rfac.gt.1.0)rfac=1.0
        if((erref.lt.frac2*erremin))then
            erremin=erref
            call copy_atoms(atm_copy,atm)
            call copy_atoms(atm_sav,atm)
            if(knw.gt.0)then
             call to_coord(0)
             call write_message_found(4)
             write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,2i5,/)')' Found Atoms: (RANDOM COORD. model) ', &
             vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),ii,i1
            endif
        endif
        erref1=erref
       enddo
!corr 77 continue
   enddo
!corr 88 continue
   nats=size(atm_sav)
   call copy_atoms(atm,atm_sav)
   call fillatom(atm)
   call sfcalc(ref,atm(:nats),spacegr,celem)
   if(knw.gt.0)then
        call to_coord(0)
        call write_message_found(4)
        write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: (RANDOM COORD. Starting model) ', &
        vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4)
   endif
!corr 111 continue
   deallocate(iorder)
   call print_atoms(atm(:nats),title='RANDOM COORD. Starting model')
   end subroutine randomcoord
!----------------------------------------------------------------------------------------------------
   subroutine fsfourier(icalfo,npadd,nrr,kkrp,ksc,nc,scale)
   USE General, only : nrefl,knw,spacegr,celem
   USE PhaseModule, only : aperc
   USE CommonExpo, only : isearchfo
   USE RefinecomRef
   USE GENLSQ
   USE Atomi, only : xyzs,xyzo,nats
   USE atom_type_util
   USE nr
   USE variables, only : ref,atm
   USE Mappa
   USE fouriermap
   USE fourier_mod
   USE reflection_type_util
!
   integer, intent(in)                            :: icalfo
   integer, intent(in)                            :: npadd
   integer, intent(in)                            :: nrr
   integer, intent(in)                            :: kkrp
   integer, intent(in)                            :: ksc
   integer, intent(in)                            :: nc
   real, intent(in), optional                     :: scale
   real, dimension(nrefl)                          :: frvet
   real, dimension(nrefl)                          :: wei
   real, dimension(nrefl)                          :: foss,eo,ec
   integer, dimension(3,nrefl)                     :: hkl
   integer, dimension(nrefl)                       :: ovr     !!!!!, iphi
   real                                           :: scal
   integer                                        :: ier
   character(len=50)                              :: strfour
   character(len=200)                             :: ftitle
   integer                                        :: i
!
   wei = 1.0
   if (kkrp == 1) then
       call defovlexrN(ovr,sogover)
       call ripartisci_N(ovr,ref(:nrefl)%fo,fobsold(:nrefl),ref(:nrefl)%fc,ref(:nrefl)%m,ref(:nrefl)%lp(1),foss,nc)
   else
       foss = ref(:nrefl)%fo
   endif
   ref(:nrefl)%fo=foss
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
!
   if (icalfo /= 1) then
       if (ksc == 1) then
           scal = sum (foss) / sum (ref(:nrefl)%fc)
       else
           scal = scale
       endif
   endif
!
!  Seleziona il tipo di Fourier
!
   call simweight(ref(:nrefl),wei(:nrefl),eo(:nrefl),ec(:nrefl))
!
   select case(icalfo)

     case (1)                                ! Fobs
       frvet = foss
       strfour = 'Fourier map with Fo coefficients'
       aperc(1) = nats + npadd

     case (2)                                ! 2Fobs - Fcal
       frvet = foss + (foss - scal*ref(:nrefl)%fc)
       strfour = 'Fourier map with 2Fo - Fc coefficients'
       aperc(1) = nats + npadd

     case (3)                                ! Fobs - Fcal
       frvet = foss - scal*ref(:nrefl)%fc
       strfour = 'Fourier map with Fo - Fc coefficients'
       aperc(1) = npadd
       xyzo(4,:nats) = xyzs(4,:nats)   ! salva le intensita'

   end select
   !call scrper(strfour,0,0)
   call PrintMess(strfour)
!
!  Stampa informazioni sul vecchio modello
   if (index(fscond%sprint,'V') > 0) then
       write(6,'(/,13x,a)')'---------- Structure after refinement ----------'
       !call print_atoms(atm(:nats),xyzs(4,:nats))
       call print_atoms(atm(:nats),height=.true.)
       call to_coord(1)
       if (knw == 0) then
           write(6,'(3x,a3,f8.3)') 'R =',errefs
       else
           write(6,*)' '
           write(6,'(3x,a13,f8.3,2(3x,a14,f8.3) )')                          &
           'R(obs-calc) =',errefs,'R(true-calc) =',errefsv,'R(true-obs) =',errefsv1
       endif
       write(6,80)errefsw,errefsing,errepw
       write(6,'(/,20x,a)')strfour
   endif
!
!  Genera mappa Fourier
   do i=1,nrefl
      hkl(:,i) = ref(i)%hkl
   enddo
   call MakeMap(hkl,frvet,ref(:nrefl)%ph,wei,nrr,0,xmap)  !!!!,work1,work2)
!
!  Cerca i picchi nella mappa
   isearchfo = 1
   natold = nats
   call Search99(xmap,0,ier,nrr)
!
!  Analisi del nuovo modello
   call fslabel(icalfo,npadd,1)
!
!  Calcola Fc dal nuovo modello
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
!
!  Stampa informazioni sul nuovo modello
   !write(6,'(/,13x,a)')'---------- Structure after cycFourier ----------'
   write(ftitle,'(14x,"--- Structure after cycle n.",i0," of Fourier recycling ---")')nc
   call print_atoms(atm(:nats),height=.true.,title=ftitle)
   if (knw > 0) then
       if (index(fscond%sprint,'V') > 0) then
           call to_coord(1)
       else
           call to_coord(0)
       endif
       call write_message_found(6)
   endif
!
80 format(2x,'Rw(obs-calc)=',f8.4,3x,'RF(singoli)  =',f8.4,4x,'Rwp =',f8.4)
!
   end subroutine fsfourier
!----------------------------------------------------------------------------------------------------
   subroutine fsfourierbm1(npadd,nrr,nc,coderbm,kprintc,kevent)
   USE General, only : nrefl,cell,knw,spacegr,celem
   USE PhaseModule, only : aperc   !corr,errem
   USE ParametriMappa, only : np
   USE CommonExpo, only : isearchfo
   USE Atomi
!corr   USE Factor
!corr   USE sfacmod
   USE variables, only : ref,atm,lconn
   USE unit_cell
   USE TestModel
   USE CGEOM
   USE Molcom, only: jscreen
   USE atom_type_util
   USE molpnew
   USE Mappa, only:xmap
   USE drawatoms
   USE fouriermap
   USE fourier_mod
   USE reflection_type_util
!   
   integer, intent(in)                            :: npadd
   integer, intent(in)                            :: nrr
   integer, intent(in)                            :: nc
   integer, intent(in)                            :: kprintc
   integer, intent(in)                            :: coderbm
   integer, intent(out)                           :: kevent
   real, dimension(nrefl)                          :: frvet
   real, dimension(nrefl)                          :: wei,eo,ec
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: xmap2
   integer, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: imap
   integer                                        :: nmapcor
   real, dimension(nrefl)                          :: foss
   integer, dimension(nrefl,3)                     :: hkl
   integer, dimension(nrefl)                       :: ovr
   real                                           :: scal
   integer                                        :: ier
   integer                                        :: i
   integer                                        :: kaction
   real                                           :: dminneg,sigma1
   integer, dimension(nrefl)                      :: phase
   real, dimension(3,3)     :: gg
!
   kevent = 0
   kaction = 5 - kprintc
   gg = matrice_metrica(cell)
   do i=1,nrefl
      hkl(i,:) = ref(i)%hkl
   enddo
   call defovlexrN(ovr,sogover)
   call ripartisci_N(ovr,ref(:nrefl)%fo,fobsold(:nrefl),ref(:nrefl)%fc,ref(:nrefl)%m,ref(:nrefl)%lp(1),foss,nc)
   ref(:nrefl)%fo=foss(:nrefl)
   call simweight(ref(:nrefl),wei(:nrefl),eo(:nrefl),ec(:nrefl))
   scal = sum (foss(:nrefl)) / sum (ref(:nrefl)%fc)
   frvet = foss + (foss - scal*ref(:nrefl)%fc)
   phase(1:nrefl)=ref(1:nrefl)%ph
   aperc(1) = npadd
   if (kprintc == 1) then
       write(6,'(/,13x,a)')'---------- Starting Model ----------'
       call print_atoms(atm(:nats),height=.true.)
       if (knw == 1) call to_coord(0)
       call print_Rindex()
       write(6,'(/,20x,a)')'RBM Procedure: Fourier Map'
   endif
   xmap2=0.0
   call MakeMap(transpose(hkl),frvet,ref(:nrefl)%ph,wei,nrr,0,xmap)   !!!!!,work1,work2)
   xmap2=xmap
   imap=0
   isearchfo = 1
   natold = nats
   call Search99(xmap,0,ier,nrr)
   call fslabel(2,npadd,2)
   kblock(1:nats)=0
   call maincl(kaction,0)
   kblock(1:nats)=1
   call avvisolati(5,0,3)
   call adjustbiso
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (knw == 1) then
       call to_coord(0)
       call write_message_found(4)
   endif
   if (kprintc == 1) then
       write(6,'(/,13x,a)')'---------- 2Fo-Fc Map ----------'
       call print_atoms(atm(:nats),height=.true.)
       if (knw == 1) call to_coord(1)
       call print_Rindex()
       write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,f8.3/)')' Found Atoms: (2Fo-Fc Map) ',vett_test(3), &
       ' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
   endif
#if defined(REGROUP) 
   call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.,move=.true.)
#else
   call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.)
#endif
   if (jscreen > 0) then
!corr       call draw_atoms(atm,icon=iconn)
       call draw_atoms(atm,lconn)
   endif
   allocate(mapcor(2,np(1)*np(2)*np(3)))
       !write(0,*)'prima di indagamappa:',nats,size(atm)
   call indagamappa(nrr,dminneg,nmapcor,sigma1,coderbm,kprintc)
       !write(0,*)'prima di modificamappa:',nats,size(atm)
   call modificamappa(xmap2,dminneg,nmapcor,sigma1,coderbm,kevent)
   deallocate(mapcor)
   if (kevent == 1 .or. kevent == 2) return
   natold=nats
   aperc(1)=natold
   xmap=xmap2
   isearchfo = 1
       !write(0,*)'prima di search99:',nats,size(atm)
   call Search99(xmap,0,ier,nrr)
       !write(0,*)'prima di fslabel:',nats,size(atm)
   call fslabel(2,npadd,2)
   kblock(1:nats)=0
   call maincl(kaction,0)
   kblock(1:nats)=1
   call avvisolati(5,0,3)
   call adjustbiso
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   xyzo(4,:nats) = xyzs(4,:nats)   ! salva le intensita'
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintc == 1) then
       write(6,'(/,13x,a)')'---------- 2Fo-Fc Map Corrected in Direct Space  ----------'
       call print_atoms(atm(:nats),height=.true.)
       call print_Rindex()
       if (knw == 1) then
           call to_coord(1)
           write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,f8.3/)')' Found Atoms: (2Fo-Fc Map Corrected in Direct Space) ', &
             vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
   end subroutine fsfourierbm1
!----------------------------------------------------------------------------------------------------
   subroutine fsfourierbm2(npadd,nrr,nc,coderbm,kprintc,kevent)
   USE General, only : nrefl,cell,knw,spacegr,celem
   USE PhaseModule, only : aperc
   USE ParametriMappa, only : np
   USE CommonExpo, only : isearchfo
   USE Symmetry, only : icent,nsym
   USE RefinecomRef
   USE GENLSQ
   USE stat
   USE Atomi
   USE PRNUTIL
   USE nr
   USE variables, only : ref,atm,lconn
   USE unit_cell
   USE TestModel
   USE CGEOM
   USE Molcom, only: jscreen
   USE grexpomod
   USE atom_type_util
   USE molpnew
   USE PhaseModule, only:numset
   USE Mappa
   USE messagemod
   USE fouriermap
   USE fourier_mod
   USE reflection_type_util
   USE elements, only: Ca_at,S_at,C_at,Cl_at
!    
   integer                                        :: npadd
   integer, intent(in)                            :: nrr
   integer, intent(in)                            :: nc
   integer, intent(in)                            :: coderbm
   integer, intent(in)                            :: kprintc
   integer, intent(out)                           :: kevent
   real, dimension(nrefl)                          :: frvet
   real, dimension(nrefl)                          :: wei,eo,ec
!corr   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)-1) :: xmap
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: xmap2
   integer, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: imap
   integer                                        :: nmapcor
!corr   real, dimension(nrefl)                          :: work1
!corr   real, dimension(nrefl)                          :: work2
   real, dimension(nrefl)                          :: foss
   integer, dimension(nrefl,3)                     :: hkl
   integer, dimension(nrefl)                       :: ovr
   real                                           :: scal
   integer                                        :: ier
   !character(len=50)                              :: strfour
   integer                                        :: i
   integer                                        :: kaction
   real                                           :: dminneg,sigma1
   integer, dimension(nrefl)                      :: phase
   real, dimension(nrefl)                         :: wbias
   real                                           :: rh
   integer                                        :: nvolterip,nvolteripmax
   real, dimension(3)                              :: xo
   real,dimension(3)                               :: xeq
   real,dimension(2)                               :: vet
   real                                            :: dx,dy,dz
   integer                                         :: j,k,kt,ifi,ifin
   real                                            :: coef
   real                                            :: d
   real                                            :: distm
   integer                                         :: j1,j2,j3
   integer,allocatable                             :: iorder(:)          
   real, dimension(3,3)     :: gg
   character(len=20)                               :: strnum
!
   kevent = 0
   kaction = 5 - kprintc 
   gg = matrice_metrica(cell)
   nvolterip=0
   nvolteripmax=3
   do i=1,nrefl
      hkl(i,:) = ref(i)%hkl
   enddo
!10 nvolterip=nvolterip+1
   do nvolterip=1,nvolteripmax
   wbias=1.0
   call defovlexrN(ovr,sogover)
   call ripartisci_N(ovr,ref(:nrefl)%fo,fobsold(:nrefl),ref(:nrefl)%fc,ref(:nrefl)%m,ref(:nrefl)%lp(1),foss,nc)
   ref(:nrefl)%fo=foss(:nrefl)
   call simweight(ref(:nrefl),wei(:nrefl),eo(:nrefl),ec(:nrefl))
   scal = sum (foss(:nrefl)) / sum (ref(:nrefl)%fc)
   frvet = foss + (foss - scal*ref(:nrefl)%fc)
   phase(1:nrefl)=ref(1:nrefl)%ph
   do i=1,nrefl
      rh=ref(i)%slaq
      rh=sqrt(rh)
      wbias(i)=(corfscat(1)+corfscat(2)*rh+corfscat(3)*(rh**2.0)+corfscat(4)*(rh**3.0)+corfscat(5)*(rh**4.0))
      frvet(i)=frvet(i)*sqrt(wbias(i))
   enddo
   aperc(1) = npadd
   !strfour = 'RBM Procedure: Fourier Map'
   !call RunToolbar(1,'RBM Procedure: Fourier Map')
   if (kprintc == 1) then
       write(6,'(/,13x,a)')'---------- Starting Model ----------'
       !call print_atoms(atm(:nats),xyzs(4,:nats))
       call print_atoms(atm(:nats),height=.true.)
       if (knw == 1) call to_coord(0)
       call print_Rindex()
       write(6,'(/,20x,a)')'RBM Procedure: Fourier Map'
   endif
   xmap2=0.0
   call MakeMap(transpose(hkl),frvet,ref(:nrefl)%ph,wei,nrr,0,xmap)  !!!!!,work1,work2)
   xmap2=xmap
   imap=0
   isearchfo = 1
   natold = nats
   call Search99(xmap,0,ier,nrr)
   call fslabel(2,npadd,2)
   kblock(1:nats)=0
   !kaction=5
   call maincl(kaction,0)
   kblock(1:nats)=1
   call avvisolati(5,0,3)
   call adjustbiso
   do i=1,nats
        atm(i)%xc=xyzs(:3,i)
   enddo
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintc == 1) then
       write(6,'(/,13x,a)')'---------- 2Fo-Fc Map Corrected in Reciprocal Space  ----------'
       !call print_atoms(atm(:nats),xyzs(4,:nats))
       call print_atoms(atm(:nats),height=.true.)
       if (knw == 1) call to_coord(1)
       call print_Rindex()
       write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,f8.3/)')' Found Atoms: (2Fo-Fc Map Corrected in Reciprocal Space) ',vett_test(3), &
   ' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
   endif
   !errem=errefs
   !kAction = 5                                                 
   !call maincl(5, 0)
   !call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz)
#if defined(REGROUP) 
    call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.,move=.true.)
#else
    call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.)
#endif
   if (jscreen > 0) then
       call write_message('Reciprocal Space Correction',pos=3)
   endif
   allocate(mapcor(2,np(1)*np(2)*np(3)))
   allocate(mapdif(0:np(1)-1,0:np(2)-1,0:np(3)+1))
   mapdif=xmap2
   call indagamappa(nrr,dminneg,nmapcor,sigma1,coderbm,kprintc)
   call modificamappa(xmap2,dminneg,nmapcor,sigma1,coderbm,kevent)
   xmap=xmap2
   deallocate(mapcor)
   if (kevent == 1 .or. kevent == 2) return
   if (jscreen > 0) then
       write(strnum,'(i0)')numset
!corr       call RunToolbar(1,'RBM Procedure on set '//trim(strnum)//': Direct Space Correction')
       call write_message('Direct Space Correction',pos=3)
   endif
   if(nvolterip.eq.1)natold=nats
   aperc(1)=natold
   dx=1.0/float(np(1))
   dy=1.0/float(np(2))
   dz=1.0/float(np(3))
   do j1=0,np(1)-1
    do j2=0,np(2)-1
     do j3=0,np(3)-1
!corr        if(maxval(no(1:nk)).gt.20)then
        if(maxval(celem%z) > Ca_at) then
          if(xmap2(j1,j2,j3).gt.0.0)xmap2(j1,j2,j3)=(xmap2(j1,j2,j3))**1.2
!corr        elseif(maxval(no(1:nk)).gt.16)then
        elseif(maxval(celem%z) > S_at) then
          if(xmap2(j1,j2,j3).gt.0.0)xmap2(j1,j2,j3)=(xmap2(j1,j2,j3))**1.5
!corr        elseif(maxval(no(1:nk)).gt.12)then
        elseif(maxval(celem%z) > C_at) then
          if(xmap2(j1,j2,j3).gt.0.0)xmap2(j1,j2,j3)=(xmap2(j1,j2,j3))**1.7
        else
          if(xmap2(j1,j2,j3).gt.0.0)xmap2(j1,j2,j3)=(xmap2(j1,j2,j3))**2.0
        endif
     enddo
    enddo
   enddo
   !!!!!!!!!!!!!!!!!!!!!xmap=xmap2
   isearchfo = 1
   natold = nats
   call Search99(xmap2,0,ier,nrr)
   call fslabel(2,npadd,2)
   kblock(1:nats)=0
   !kaction=5
   call maincl(kaction,0)
   kblock(1:nats)=1
   call avvisolati(5,0,3)
   call adjustbiso
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   xyzo(4,:nats) = xyzs(4,:nats)   ! salva le intensita'
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintc == 1) then
       write(6,'(/,13x,a)')'---------- 2Fo-Fc Map Corrected in Direct Space  ----------'
       !call print_atoms(atm(:nats),xyzs(4,:nats))
       call print_atoms(atm(:nats),height=.true.)
       if (knw == 1) call to_coord(1)
       call print_Rindex()
       write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,f8.3/)')' Found Atoms: (2Fo-Fc Map Corrected in Direct Space) ', &
                vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
   endif
   !kAction = 5
   call maincl(5, 0)
   if(nvolterip.gt.2)go to 85
   natold = nats
   do j1=0,np(1)-1
    do j2=0,np(2)-1
     do j3=0,np(3)-1
        if(nats.gt.12)then
          if(mapdif(j1,j2,j3).gt.0.0)mapdif(j1,j2,j3)=(mapdif(j1,j2,j3))**2.5
        elseif(nats.gt.10)then
          if(mapdif(j1,j2,j3).gt.0.0)mapdif(j1,j2,j3)=(mapdif(j1,j2,j3))**2.0
        else
          if(mapdif(j1,j2,j3).gt.0.0)mapdif(j1,j2,j3)=(mapdif(j1,j2,j3))**1.5
        endif
     enddo
    enddo
   enddo
!corr   if(maxval(no(1:nk)).gt.17)then
   if(maxval(celem%z) > Cl_at) then
     aperc(1)=natold*2
   else
     aperc(1)=natold
   endif
   isearchfo = 1
   call Search99(mapdif,0,ier,nrr)
   call fslabel(4,natold,2)
   kblock(1:nats)=0
   !kaction=4  !!!!!2
   call maincl(kaction,0)
   kblock(1:nats)=1
   call avvisolati(5,0,3)
   call adjustbiso
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   vet(1)= 1.0
   vet(2)=-1.0
   ifin=icent+1
   allocate(iorder(nats))
   iorder=0
   do i=1,nats
        xo(:3)=atm(i)%xc
    do j=i+1,nats
     if(iorder(j).eq.1)cycle
        distm=9999
        do kt=1,spacegr%ncoper
         do ifi=1,ifin
            coef=vet(ifi)
            do k=1,nsym
               call xequi(xo,k,coef,xeq,kt)
               d = xdisteq(xyzs(:3,j),xeq,gg)
               if (d < distm .and. d > 0.0) then
                  distm=d
               endif
            enddo
         enddo
        enddo
!corr        if(maxval(no(1:nk)).gt.17)then
        if(maxval(celem%z) > Cl_at)then
          if(distm.le.0.6) iorder(j)=1
        else
          if(distm.le.0.5) iorder(j)=1
        endif
    enddo
   enddo
   call remove_atoms(iorder)
   kblock(1:nats)=0
   !kaction=4  !!!!2
   call maincl(kaction,0)
   kblock(1:nats)=1
   call avvisolati(5,0,3)
   call adjustbiso
   do i=1,nats
        atm(i)%xc=xyzs(:3,i)
   enddo
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   deallocate(iorder)
   if (kprintc == 1) then
       write(6,'(/,13x,a)')'---------- Difference Map ----------'
       call print_atoms(atm(:nats),height=.true.)
       if (knw == 1) call to_coord(1)
       call print_Rindex()
       write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: Difference Map',vett_test(3),' on',nats,   &
       vett_test(1),' true dist. ',vett_test(4),errefs
   endif
85 continue
   deallocate(mapdif)
   enddo
   end subroutine fsfourierbm2
!----------------------------------------------------------------------------------------------------
   subroutine mapconn(nrr,imore,nfrbm,nfrbmsog2)
   USE General, only : rtod,nrefl,cell,knw,celem,spacegr,neutro
   USE PhaseModule, only : aperc
   USE CommonExpo, only:isearchfo
   USE RRESTR
   USE ParametriMappa, only : np
   USE Symmetry, only : icent,nsym
   USE GENLSQ
   USE stat
   USE Atomi
   USE PRNUTIL
   USE nr
   USE variables, only : ref,atm
   USE unit_cell
   USE TestModel
   USE CGEOM
   USE Molcom, only: jscreen    !!!!,nptr,kptr
   USE grexpomod
   USE atom_type_util
   USE drawatoms
   USE setref, only: set_rcode_atoms, set_lsq_conditions
   USE connect_mod
   USE Mappa
   USE messagemod
   USE fouriermap
   USE fourier_mod
   USE reflection_type_util
   USE elements, only:O_at,P_at,nasym_unit
   USE sinterface, only: fillatom
   integer, intent(in)                            :: nrr
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: xmapsav
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: xmapdif
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: xmap2fo
   real(DP), dimension(nrefl)                   :: weilsqsav
   integer                                        :: ier
   integer                                        :: i
   real, dimension(3)                              :: xo2
   real, dimension(3)                              :: xo,xoo
   real,dimension(3)                               :: xeq
   real,dimension(2)                               :: vet
   real                                            :: dx,dy,dz
   integer                                         :: j,k,kt,ifi,ifin
   integer                                         :: kk,ktt,ifii
   real                                            :: coef,maxmap
   real                                            :: dr,dr1,dr2,d
   integer                                         :: j1,j2,j3
   integer                                         :: l1,l2
   integer,allocatable                             :: iorder(:),iorder0(:)
   integer,allocatable                                     :: nbuild(:)
   integer,allocatable                                     :: atombuild(:,:)
   real, dimension(3,3)     :: gg
   real,dimension(500)      :: xyzadd
   !real,dimension(3,nsym*2*ncentr)                :: xequiv1,xequiv2
   real,dimension(3,spacegr%nsymop)                :: xequiv1,xequiv2
   !real,dimension(3,nats*2*nsym*2*ncentr)                :: xequiv
   real,dimension(3,nats*2*spacegr%nsymop)                :: xequiv
   integer                                        :: nateq,nateq1,nateq2
   integer                                        :: jsav
   real                                           :: dmin,dd,d1,d2
   real                                           :: da,da1,da2,db,db1,db2
   integer                                        :: natbb,ij,ndadd,ndadd0
   integer                                        :: nnc,inc,jj,jjj,nnc1,nnc2
   integer                                        :: natom   !,natomm
   integer                                        :: nexp,nats0
   integer                                        :: nconnectivity
   real                                           :: scaleffe,erreffe,erreffe0
   real                     :: thres1,thres2
   real                     :: scaleffestart,erreffestart,erresog1
   real                     :: scalsav
   integer,dimension(nats*100,2)                    :: ncc
   type(atom_type), allocatable, dimension(:)                      :: atx
   type(atom_type), allocatable, dimension(:)                      :: atbb
   type(atom_type), allocatable, dimension(:)                      :: atadd
   type(atom_type), allocatable, dimension(:)                      :: atm_copy
   type(atom_type)                                                 :: atom
   integer              :: imore,nfrbm,nfrbmsog2
   integer              :: kprintcode
   real, dimension(nrefl)                          :: frvet,eo,ec
   real, dimension(nrefl)                          :: wei
   integer, dimension(nrefl,3)                     :: hkl
   real                                            :: scal
   integer                          :: kevent
   integer                          :: ii            
   type(cell_type) :: cellt
!
   kprintcode=0
   natold=nats
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   scaleffestart = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
   erreffestart = sum(abs(ref(:npref)%fo - scaleffestart*ref(:npref)%fc))/sum(ref(:npref)%fo)
   weilsqsav=weilsq
   scalsav=scalf%val
   call copy_atoms(atm_copy,atm)
   if(kprintcode.gt.0)write(6,'(/,13x,a)')'----------Map to be Optimized by Expected Connectivity----------'
   gg = matrice_metrica(cell)
   dx=1.0/float(np(1))
   dy=1.0/float(np(2))
   dz=1.0/float(np(3))
   nconnectivity=0
!corr   natom=0
!corr   do i=1,nk
!corr      natomm=int(float(nw(i))/float((icent+1)*spacegr%ncoper*nsym)+0.5)
!corr      if(natomm.lt.1)natomm=1
!corr      if(no(i).ne.1)natom=natom+natomm                                                   
!corr   enddo
   natom = nint(nasym_unit(celem,spacegr%nsymop,neutro==0))
   nats=natold
   nconnectivity=nconnectivity+1
   vet(1)= 1.0
   vet(2)=-1.0
   ifin=icent+1
   call fillatom(atm)
   kblock(1:nats)=0
   call maincl(5,0)
   call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,elem=celem)
   if(kprintcode.gt.0)then
      write(6,'(/,13x,a)')'----------Map to be Optimized by Expected Connectivity----------'
      call print_atoms(atm(:nats),height=.true.)
   endif
   if (kprintcode > 0 .and. knw > 0) then
       call to_coord(1)
       if(nconnectivity.eq.1)write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')     &
       ' Found Atoms: Map to be Improved by Expected Connectivity',vett_test(3),' on',nats,   &
       vett_test(1),' true dist. ',vett_test(4)
       write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: Map to be Optimized by Expected Connectivity',   &
             vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
       !call examin(1,(/(ref(i)%hkl,i=1,npref)/),ref%phv,ref%ph,npref,0,(/(1.0,i=1,npref)/),1)  
   endif
   call maincl(5, 0)
   call MakeLab(1,nats)
   call xyz_to_atom(atx,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,lab=aLab,elem=celem)
   if (jscreen > 0) then
       call draw_atoms(atx,icon=iconn)
       call write_message('Connectivity Optimization  Model. Please wait ...',pos=3)
   endif
   nateq=0
   do i=1,nats
     xo(:3)=atm(i)%xc
     do kt=1,spacegr%ncoper
       do ifi=1,ifin
         coef=vet(ifi)
         do k=1,nsym
           nateq=nateq+1
           call xequi(xo,k,coef,xeq,kt)
           xequiv(1:3,nateq)=xeq(1:3)
         enddo
       enddo
     enddo
   enddo
   ndadd=0
   natbb=nats
   call copy_atoms(atbb,atx)
!corr   call reallocate(atadd,0)
   call clear_atoms(atadd)
   nnc=0
   nnc1=0
   nnc2=0
   do nexp=1,2
   if(nexp.eq.1)then
     ij=1
   else
     ij=natold+1
   endif
   nnc1=nnc
   kblock(1:nats)=0
   call maincl(5,0)
   do j=1,nats
        atm(j)%xc=xyzs(:3,j)
   enddo
   allocate(nbuild(nats*2))
   allocate(atombuild(nats*2,nats*2))
   nbuild=0
   do i=1,iconn(1)
         l1=iconn((i-1)*3+2)
         l2=iconn((i-1)*3+3)
         nbuild(l1)=nbuild(l1)+1
         atombuild(l1,nbuild(l1))=l2
         nbuild(l2)=nbuild(l2)+1
         atombuild(l2,nbuild(l2))=l1
   enddo
   if (kprintcode > 0) then
       do i=1,nats
          write(6,'(a,10i6)')'Link',i,atombuild(i,1:nbuild(i))
          write(6,'(a,10a)')'Link',atm(i)%Lab,atm(atombuild(i,1:nbuild(i)))%Lab
       enddo
   endif
!corr                 if(maxval(no(1:nk)).le.8.or.natom.le.15)then
                 if(maxval(celem%z) <= O_at .or. natom <= 15)then
                   thres1=1.15
                   thres2=1.95
                 else
                   thres1=1.00
                   thres2=2.00
                 endif
   do i=1,nats
        xo2(:3)=atm(i)%xc
     do j=ij,nats
        xo(:3)=atm(j)%xc
       do kt=1,spacegr%ncoper
         do ifi=1,ifin
            coef=vet(ifi)
            do k=1,nsym
               call xequi(xo,k,coef,xeq,kt)
               d = xdisteq(xo2,xeq,gg)
              !  if(d.gt.(radii(iabs(atm(i)%nz/nzConst),1)+radii(iabs(atm(j)%nz/nzConst),1))*thres1          &
              !  .and.d.lt.(radii(iabs(atm(i)%nz/nzConst),1)+radii(iabs(atm(j)%nz/nzConst),1))*thres2.and.i.ne.j)then
                if(d.gt.(atm(i)%c_radius()+atm(j)%c_radius())*thres1          &
                .and.d.lt.(atm(i)%c_radius()+atm(j)%c_radius())*thres2.and.i.ne.j)then
                  if(nnc.gt.0)then
                    do jj=1,nnc
                      if(i.eq.ncc(jj,2).and.j.eq.ncc(jj,1))go to 45
                      if(i.eq.ncc(jj,1).and.j.eq.ncc(jj,2))go to 45
                    enddo
                    do jj=1,nbuild(i)
                      do jjj=1,nbuild(j)
                         if(atombuild(i,jj).eq.atombuild(j,jjj))go to 45
                      enddo
                    enddo
                  endif
                  nnc=nnc+1
                  ncc(nnc,1)=i
                  ncc(nnc,2)=j
                  if(kprintcode.gt.0)write(6,'(a,i6,3a,3f10.3,2i6)')' Interpeak distance to be studied ',       &
                  !nnc,' ' ,atm(i)%Lab,atm(j)%Lab,d,radii(iabs(atm(i)%nz/nzConst),1),radii(iabs(atm(j)%nz/nzConst),1)
                  nnc,' ' ,atm(i)%Lab,atm(j)%Lab,d,atm(i)%c_radius(),atm(j)%c_radius()
 45            continue
               endif
            enddo
         enddo
        enddo
!corr-unused 44  continue
     enddo
   enddo
   xmapsav=0.0
!!!!!!!!!!!!!!!!!!!!!
    call InitFour()
    do i=1,nrefl
       hkl(i,:) = ref(i)%hkl
    enddo
    xmapdif=0.0
    xmap2fo=0.0
!corr    work1=0.0
!corr    work2=0.0
    call simweight(ref(:nrefl),wei,eo,ec)
    scal = sum (ref(:nrefl)%fo) / sum (ref(:nrefl)%fc)
    frvet(:nrefl) = (ref(:nrefl)%fo - scal*ref(:nrefl)%fc)
    wei=1.0
    call MakeMap(transpose(hkl),frvet,ref(:nrefl)%ph,wei,nrefl,0,xmapdif)  !!!!!,work1,work2)
!corr    work1=0.0
!corr    work2=0.0
    wei=1.0
    scal = sum (ref(:nrefl)%fo) / sum (ref(:nrefl)%fc)
    frvet(:nrefl) = (2.0*ref(:nrefl)%fo - scal*ref(:nrefl)%fc)
    call MakeMap(transpose(hkl),frvet,ref(:nrefl)%ph,wei,nrefl,0,xmap2fo)  !!!!!,work1,work2)
    wei=1.0
   do inc=nnc1+1,nnc
     maxmap=-99999999.0             
     i=ncc(inc,1)
     jsav=ncc(inc,2)
     xo(:3)=atm(i)%xc
     xoo(:3)=atm(jsav)%xc
     !corr dr=(radii(iabs(atm(i)%nz/nzConst),1)+radii(iabs(atm(jsav)%nz/nzConst),1))                         
     dr=(atm(i)%c_radius()+atm(jsav)%c_radius())
     dr1=dr*0.8
     dr2=dr*1.0 
     !corr da=2.0*radii(iabs(atm(i)%nz/nzConst),1)
     !corr db=2.0*radii(iabs(atm(jsav)%nz/nzConst),1)
     da=2.0*atm(i)%c_radius()
     db=2.0*atm(jsav)%c_radius()
     da1=da*0.85
     db1=db*0.85
     da2=da*1.05
     db2=db*1.05
     if(kprintcode.gt.0)write(6,'(3a,2f8.2)')' atoms #, bond distance range  ',atm(i)%Lab,atm(jsav)%Lab,dr1,dr2
     nateq1=0
     do kt=1,spacegr%ncoper
       do ifi=1,ifin
         coef=vet(ifi)
         do k=1,nsym
           nateq1=nateq1+1
           call xequi(xo,k,coef,xeq,kt)
           xequiv1(1:3,nateq1)=xeq(1:3)
         enddo
       enddo
     enddo
     nateq2=0
     do kt=1,spacegr%ncoper
       do ifi=1,ifin
         coef=vet(ifi)
         do k=1,nsym
           nateq2=nateq2+1
           call xequi(xoo,k,coef,xeq,kt)
           xequiv2(1:3,nateq2)=xeq(1:3)
         enddo
       enddo
     enddo
     do ii=1,3
       if(xo(ii).lt.0.0)xo(ii)=1.0+xo(ii)
       if(xo(ii).gt.1.0)xo(ii)=1.0-xo(ii)
       if(xoo(ii).lt.0.0)xoo(ii)=1.0+xoo(ii)
       if(xoo(ii).gt.1.0)xoo(ii)=1.0-xoo(ii)
     enddo
     do j1=0,np(1)-1
       do j2=0,np(2)-1
         do j3=0,np(3)-1
           xo2(1)=float(j1)*dx
           xo2(2)=float(j2)*dy
           xo2(3)=float(j3)*dz
           do j=1,nateq1
             do jj=1,nateq2
               d1 = xdisteq(xequiv1(1:3,j),xo2,gg)
               d2 = xdisteq(xequiv2(1:3,jj),xo2,gg)
               d = xdisteq(xequiv1(1:3,j),xequiv2(1:3,jj),gg)
               if((d1.ge.dr1.and.d1.le.dr2).and.(d2.ge.dr1.and.d2.le.dr2)     &
                   .and.xmapdif(j1,j2,j3).ge.0.0.and.xmap2fo(j1,j2,j3).ge.0.0) then
                  xmapsav(j1,j2,j3)=xmapsav(j1,j2,j3)+xmap2fo(j1,j2,j3)
               endif
             enddo
           enddo
           !if(nbuild(i).le.1)then
           do j=1,nateq1
               d1 = xdisteq(xequiv1(1:3,j),xo2,gg)
                if((d1.ge.da1.and.d1.le.da2).and.xmap2fo(j1,j2,j3).ge.0.0.and.xmapdif(j1,j2,j3).ge.0.0)then
                   xmapsav(j1,j2,j3)=xmapsav(j1,j2,j3)+xmap2fo(j1,j2,j3)
                endif
           enddo
           !endif
           !if(nbuild(jsav).le.1)then
           do jj=1,nateq2
               d2 = xdisteq(xequiv2(1:3,jj),xo2,gg)
                if((d2.ge.db1.and.d2.le.db2).and.xmap2fo(j1,j2,j3).ge.0.0.and.xmapdif(j1,j2,j3).ge.0.0)then
                  xmapsav(j1,j2,j3)=xmapsav(j1,j2,j3)+xmap2fo(j1,j2,j3)
                endif
           enddo
           !endif
         enddo
       enddo
     enddo
   enddo
     aperc(1)=natom
     isearchfo = 1
     call Search99(xmapsav,0,ier,nrr)
!       do i=1,natom            
        do i=1,nats            
          if(xyzs(4,i).le.0.0)cycle
          xo2=xyzs(1:3,i)
          dmin=9999999.0
          jsav=0
          do jjj=1,natbb
          !da=radii(iabs(atbb(jjj)%nz/nzConst),1)
          da=atbb(jjj)%c_radius()
          if(da.lt.0.9)da=0.9
           do ktt=1,spacegr%ncoper
              do ifii=1,ifin
                 coef=vet(ifii)
                 do kk=1,nsym
                   call xequi(xo2,kk,coef,xeq,ktt)
                   dd = xdisteq(atbb(jjj)%xc(1:3),xeq,gg)
                   if(dd.lt.dmin)then
                      dmin=dd
                      jsav=jjj
                   endif
                 enddo
              enddo
           enddo
          enddo
         if(dmin.gt.da.and.ndadd.gt.0)then
           dmin=9999999.0
           jsav=0
          do jjj=1,ndadd
           do ktt=1,spacegr%ncoper
              do ifii=1,ifin
                 coef=vet(ifii)
                 do kk=1,nsym
                   call xequi(xo2,kk,coef,xeq,ktt)
                   dd = xdisteq(atadd(jjj)%xc,xeq,gg)
                   if(dd.lt.dmin)then
                      dmin=dd
                      jsav=jjj
                   endif
                 enddo
              enddo
           enddo
          enddo
          if(dmin.le.da)cycle    
         endif
         if(dmin.gt.da)then
         ndadd=ndadd+1
         xyzadd(ndadd)=xyzs(4,i) 
         atom%xc=xyzs(1:3,i) 
         atom%biso=atm(natold)%biso
         atom%ocry=xyzs(5,i) 
         !atom%nz=atm(natold)%nz
         call atom%set_specie(atm(natold)%get_nz(),celem)
         atom%Lab=atm(natold)%Lab
         call add_atom(atadd,atom)
         ndadd0=ndadd
         if(kprintcode.gt.0)write(6,'(/,a,i7,a,f15.3)')' The number of added peaks is now',    &
                            ndadd,' last peak intensity',xyzadd(ndadd)
            else
            if(kprintcode.gt.0)write(6,'(/,a,i7,a,i7,f10.3)')' Peak nr.',i,' discarded, close to',&
                               jsav,dmin                                  
          endif
     enddo
     if(ndadd.gt.0.and.kprintcode.gt.0)write(6,'(/,i7,a)')ndadd,' peaks have been added'
     if(knw.gt.0 .and. kprintcode > 0)call to_coord(1)
   deallocate(nbuild)
   deallocate(atombuild)
   if(ndadd.eq.0)then
      nats=natold
      call copy_atoms(atm,atm_copy)
      call fillatom(atm)
      weilsq=weilsqsav
      scalf%val=scalsav
      if(kprintcode.gt.0)write(6,'(a)')' No more peaks added for Expected Connectivity'
        if(knw.gt.0)then
           call to_coord(1)
           if(kprintcode.gt.0)write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: Map Corrected by Expected Connectivity ',   &
                              vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
        endif
      go to 98
   endif
   allocate(iorder(ndadd))
   call indexx(xyzadd(:ndadd),iorder)
   iorder(:)=iorder(ndadd:1:-1)
   atadd(:) = atadd(iorder)
   xyzadd(:ndadd) = xyzadd(iorder)
   deallocate(iorder)
   nats = ndadd
   xyzs(4,1:nats)=xyzadd(1:nats)
   !atm(1:nats)%inte=xyzs(4,1:nats)
   call fillatom(atadd)     ! forse non serve -- controllare
   call fslabel(4,natold,2)
   if (kprintcode > 0 .and. knw > 0) then
      call to_coord(1)
      write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: New peaks by Expected Connectivity ',  &
                         vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
   endif
   kblock(1:nats)=0
   call MakeLab(1,nats)
   !call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,lab=aLab)
   call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,lab=aLab,inte=xyzs(4,:),elem=celem)
   call maincl(5,0)
   do j=1,nats
        atm(j)%xc=xyzs(:3,j)
   enddo
!!!!!!!!!!!!!!!!!!!!!!!!
   if(natold.eq.nats)then
      call copy_atoms(atm,atm_copy)
      call fillatom(atm)
      weilsq=weilsqsav
      scalf%val=scalsav
      if(kprintcode.gt.0)then
         write(6,'(a)')' No more peaks added for Expected Connectivity'
         if(knw.gt.0)then
           call to_coord(1)
           write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: Map Corrected by Expected Connectivity ',   &
                              vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
        endif
      endif
      go to 98
   endif
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   scaleffe = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
   erreffe0 = sum(abs(ref(:npref)%fo - scaleffe*ref(:npref)%fc))/sum(ref(:npref)%fo)
   call copy_atoms(atx,atm)
   nats0=nats
   allocate(iorder(nats0))
   allocate(iorder0(nats0))
   iorder0(1:natold)=0
   iorder(1:natold)=0
   iorder(natold+1:nats)=0
   do i=natold+1,nats0
   nats=nats0
   call copy_atoms(atm,atx)
   iorder(i)=1
   call remove_atoms(iorder)
!corr    call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   scaleffe = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
   erreffe = sum(abs(ref(:npref)%fo - scaleffe*ref(:npref)%fc))/sum(ref(:npref)%fo)
   !if(erreffe.le.0.95*erreffe0)then
   if(erreffe.le.0.9*erreffe0)then
     iorder(i)=0
     iorder0(i)=1
     if(kprintcode.gt.0)write(6,'(a,i6,a,2f15.3,a)')' Peak nr.',i,' erref', erreffe,erreffe0,' discarded'
     erreffe0=erreffe
   else
     iorder(i)=0
     iorder0(i)=0
     if(kprintcode.gt.0)write(6,'(a,i6,a,2f15.3,a)')' Peak nr.',i,' erref', erreffe,erreffe0,' kept'
   endif
   enddo
   nats=nats0
   call copy_atoms(atm,atx)
   call remove_atoms(iorder0)
   deallocate(iorder)
   deallocate(iorder0)
   if(natold.eq.nats)then
      call copy_atoms(atm,atm_copy)
      call fillatom(atm)
      weilsq=weilsqsav
      scalf%val=scalsav
      if(kprintcode.gt.0)write(6,'(a)')' No more peaks added for Expected Connectivity'
        if(knw.gt.0)then
           call to_coord(1)
           if(kprintcode.gt.0)write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: Map Corrected by Expected Connectivity ',   &
                              vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
        endif
      go to 98
   endif
   kblock(1:nats)=0
   call MakeLab(1,nats)
   call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,lab=aLab,elem=celem)
   call maincl(5,0)
   do j=1,nats
        atm(j)%xc=xyzs(:3,j)
   enddo
   if(kprintcode.gt.0)then
      write(6,'(/,13x,a)')'----------Map Corrected by Expected Connectivity----------'
      call print_atoms(atm(:nats),height=.true.)
      if (knw > 0)then
          call to_coord(1)
          write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')                   &
                  ' Found Atoms: Map Corrected by Expected Connectivity ',   &
                  vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
      endif
   endif
    call maincl(5, 0)
    do j=1,nats
         atm(j)%xc=xyzs(:3,j)
    enddo
   call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,elem=celem)
   if (jscreen > 0) then
       call write_message('RBM Procedure: Map Corrected by Expected Connectivity',pos=3)
   endif
   if(natold.eq.nats)then
      call copy_atoms(atm,atm_copy)
      call fillatom(atm)
      if(kprintcode.gt.0)write(6,'(a)')' No more peaks added for Expected Connectivity'
        if(knw.gt.0)then
           call to_coord(1)
           if(kprintcode.gt.0)write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: Map Corrected by Expected Connectivity ',    &
                              vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
        endif
      go to 98
   endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!corr         call reallocate(atadd,0)
         call clear_atoms(atadd)
         ndadd=nats-natold
         do i=1,ndadd
            xyzadd(i)=xyzs(4,natold+i) 
            atom%xc=atm(natold+i)%xc
            atom%biso=atm(natold+i)%biso
            atom%ocry=atm(natold+i)%ocry
            !corr atom%nz=atm(natold+i)%nz
            call atom%set_specie(atm(natold+i)%get_nz(),celem)
            atom%Lab=atm(natold+i)%Lab
            call add_atom(atadd,atom)
         enddo
         ndadd0=ndadd
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   call copy_atoms(atx,atm)
   if(nexp.eq.2)then
      call reset_restraints(resvf,wqqf)
      kblock(1:nats)=0
      call maincl(5,0)
      kblock(1:nats)=1
      call avvisolati(5,0,1)
      do i=1,nats
         atm(i)%xc=xyzs(:3,i)
      enddo
      auto_complete=0
      fscond%auto_stru = .false.
      fscond%sprint = 'F'            
      cellt = set_cell_type(cell)
      call set_rcode_atoms(atm(1:nats),cellt,spacegr,constrv,'XYZO',0)
      call set_rcode_atoms(atm(1:nats),cellt,spacegr,constrv,'B',0)
      call set_rcode_atoms(atm(natold+1:nats),cellt,spacegr,constrv,'XYZ',1)
      call set_lsq_conditions(atm,spacegr,cellt)
      call fslsqexe(kevent)
      allocate(iorder(nats))
      iorder=0
      call check_distance(atm(:nats),iorder,0.8,kpr=1)
      call remove_atoms(iorder)
      deallocate(iorder)
      call fillatom(atm)
      if(natold.eq.nats)then
         call copy_atoms(atm,atm_copy)
         call fillatom(atm)
         weilsq=weilsqsav
         scalf%val=scalsav
         if(kprintcode.gt.0)write(6,'(a)')' No more peaks added for Expected Connectivity'
           if(knw.gt.0)then
              call to_coord(1)
              if(kprintcode.gt.0)write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')                   &
                                 ' Found Atoms: Map Corrected by Expected Connectivity ',   &
                                 vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
           endif
         go to 98
      endif
      kblock(1:nats)=0
      call maincl(5,0)
      kblock(1:nats)=1
      call avvisolati(5,0,5)
      do i=1,nats
         atm(i)%xc=xyzs(:3,i)
      enddo
      allocate(iorder(nats))
      iorder=0
      allocate(nbuild(nats*2))
      nbuild=0
      do i=1,iconn(1)
         l1=iconn((i-1)*3+2)
         l2=iconn((i-1)*3+3)
         nbuild(l1)=nbuild(l1)+1
         nbuild(l2)=nbuild(l2)+1
      enddo
      do i=1,nats
           if(nbuild(i).eq.0.and.i.gt.natold)iorder(i)=1
           !if(nbuild(i).eq.0)iorder(i)=1
      enddo
      call remove_atoms(iorder)
      deallocate(iorder)
      deallocate(nbuild)
      call fillatom(atm)
      call sfcalc(ref,atm,spacegr,celem)
      scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
      if(kprintcode.gt.0)then
         write(6,'(/,13x,a)')'----------Map Corrected by Expected Connectivity and refined by RLSQ ----------'
         call print_atoms(atm(:nats),height=.true.)
         if(knw.gt.0)then
            call to_coord(1)
            write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')                &
             ' Found Atoms: New peaks by Expected Connectivity refined by RLSQ',    &
             vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
         endif
      endif
      call maincl(5, 0)
      do j=1,nats
           atm(j)%xc=xyzs(:3,j)
      enddo
      if (jscreen > 0) then
          call write_message('RBM Procedure: Map Corrected by Expected Connectivity',pos=3)
      endif
   endif
   enddo
   if(nats.gt.int(natom*2.0))nats=int(natom*2.0)
      if(nfrbm.ge.nfrbmsog2.and.natom.le.20.and.natom.gt.10.and.nats.gt.int(natom*1.5))nats=int(natom*1.5)
      if(nfrbm.ge.nfrbmsog2+1.and.natom.le.15.and.nats.gt.int(natom*1.15))nats=int(natom*1.15)
      if(nfrbm.ge.nfrbmsog2+1.and.natom.gt.15.and.nats.gt.int(natom*1.20))nats=int(natom*1.15)
      if(nfrbm.ge.nfrbmsog2+1.and.natom.gt.25.and.nats.gt.int(natom*1.20))nats=int(natom*1.20)
      if(nfrbm.ge.nfrbmsog2+1.and.natom.gt.30.and.nats.gt.int(natom*1.25))nats=int(natom*1.25)
    call fillatom(atm)
   scaleffe = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
   erreffe = sum(abs(ref(:npref)%fo - scaleffe*ref(:npref)%fc))/sum(ref(:npref)%fo)
!corr   write(6,*)'ERRE',erreffestart,erreffe
     erresog1=1.19*erreffestart
!corr     if(maxval(no(1:nk)).gt.15)then             
     if(maxval(celem%z) > P_at) then
        erresog1=1.1*erreffestart
     else
        erresog1=1.3*erreffestart
     endif
    if(erreffe.gt.erresog1)then
      nats=natold
      call copy_atoms(atm,atm_copy)
      call fillatom(atm)
      weilsq=weilsqsav
      scalf%val=scalsav
      if(kprintcode.gt.0)write(6,'(a)')' No more peaks added for Expected Connectivity'
        if(knw.gt.0)then
           call to_coord(1)
           if(kprintcode.gt.0)write(6,'(/,a,f5.0,a,i5,f5.0,a,f8.3,/)')' Found Atoms: Map Corrected by Expected Connectivity ',   &
                              vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4)
        endif
    endif
 98 continue
   call reset_restraints(resvf,wqqf)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if(nats.gt.natold)imore=1
   if(kprintcode.gt.0)then
      write(6,'(/,13x,a)')'----------Final Map Corrected by Expected Connectivity ----------'
      call print_atoms(atm(:nats),height=.true.)
   endif
   end subroutine mapconn
!----------------------------------------------------------------------------------------------------
   subroutine print_Rindex()
   USE variables, only : ref
   USE General, only:knw,nrefl
   real                     :: scal
   real                     :: sumfc,sumfo,sumfv,sumfold
   sumfc = sum(ref(:nrefl)%fc)
   sumfo = sum (ref(:nrefl)%fo)
   sumfv = sum (ref(:nrefl)%fv)
   sumfold = sum(fobsold(:nrefl))
   scal = sum (fobsold(:nrefl)) / sumfv
   errefsv1 = sum(abs(fobsold(:nrefl) - scal*ref(:nrefl)%fv))/sumfold
   scal = sumfc / sumfv
   errefsv = sum(abs(ref(:nrefl)%fc - scal*ref(:nrefl)%fv))/sumfc
   scal = sumfc / sumfold
   errefs = sum(abs(ref(:nrefl)%fc - scal*fobsold(:nrefl)))/sumfc
   if (knw == 0) then
       write(6,'(/,3x,a8,f8.3,/)') 'R parti=',errefs
   else
       write(6,'(/,3x,a,f8.3,2(3x,a,f8.3,/) )')                          &
       'R(obs-calc) =      ',errefs,'R(true-calc) =',errefsv,'R(true-obs) =      ',errefsv1
   endif
   scal = sumfo / sumfv
   errefsv1 = sum(abs(ref(:nrefl)%fo - scal*ref(:nrefl)%fv))/sumfo
   scal = sumfc / sumfo
   errefs = sum(abs(ref(:nrefl)%fc - scal*ref(:nrefl)%fo))/sumfc
   if (knw == 0) then
       write(6,'(3x,a3,f8.3,/)') 'R =',errefs
   else
       write(6,'(3x,a,f8.3,2(3x,a,f8.3,/) )')                          &
       'R(obs-calc parti) =',errefs,'R(true-calc) =',errefsv,'R(true-obs parti) =',errefsv1
   endif

   end subroutine print_Rindex
!----------------------------------------------------------------------------------------------------
!corr   subroutine simweight_old(refl,sim,eoo,ecc) 
!corr   USE General, only : ff,al,cl,bs,nk,nw,bt
!corr   USE Symmetry, only : pts
!corr   USE reflection_type_util, only: reflection_type
!corr!
!corr   type(reflection_type), dimension(:), intent(in) :: refl
!corr   real, dimension(:),intent(out)                  :: sim
!corr   real, dimension(:),intent(out), optional        :: eoo,ecc
!corr   real, dimension(size(refl))                     :: eo,ec
!corr   integer                                         :: nr
!corr   real                                            :: sumff,den,bes
!corr   real                                            :: eps
!corr   integer                                         :: multi
!corr   integer                                         :: i,ij
!corr!
!corr   nr = size(refl)
!corr   do i=1,nr
!corr      do ij=1,nk
!corr         ff(ij)=cl(ij) + sum(al(:,ij)*exp(-bs(:,ij)*refl(i)%slaq))
!corr      enddo
!corr      sumff = 0.0
!corr      do ij=1,nk
!corr         sumff = sumff + nw(ij)*(ff(ij)**2)
!corr      enddo
!corr      call cmult2002(refl(i)%hkl,eps,multi)
!corr      den = sqrt((exp(-2.0*bt*refl(i)%slaq))*sumff*eps)
!corr      ec(i)=refl(i)%fc/(sqrt(pts)*den)
!corr      eo(i)=refl(i)%fo/(sqrt(pts)*den)
!corr      sim(i)=bes(2.0*eo(i)*ec(i))
!corr   enddo
!corr   where(eo < 0.1 .and. ec < 0.1)sim=0.0
!corr   if (present(eoo) .and. present(ecc)) then
!corr       eoo(:) = eo(:)
!corr       ecc(:) = ec(:)
!corr   endif
!corr!
!corr   end subroutine simweight_old
!----------------------------------------------------------------------------------------------------
   subroutine ripartisci(ovr,fo,fc,mult,lp,for)
!
   integer, dimension(:), intent(in) :: ovr    ! vettore da defov
   real, dimension(:), intent(in)    :: fo     ! fs osservati
   real, dimension(:), intent(in)    :: fc     ! fs calcolati
   integer, dimension(:), intent(in) :: mult   ! molteplicit�
   real, dimension(:), intent(in)    :: lp     ! LP
   real, dimension(:), intent(out)   :: for    ! fs ripartiti
   real, dimension(size(ovr))        :: mlp,fc2
   real                              :: sumfc2
   integer, dimension(size(ovr))     :: overl
   integer                           :: i
   integer                           :: jin,jfin
   integer                           :: nr
!
!  numero di riflessi
   nr = size(overl)
!
!  modifica sul vettore che definisce i gruppi
   do i=1,npref
      if (ovr(i) == 0) then
          overl(i) = ovr(i-1)
      else
          overl(i) = ovr(i)
      endif
      mlp(i) = mult(i)*lp(i)   ! calcolo di mlp
      fc2(i) = fc(i)**2        ! calcolo fc**2
   enddo
!
   jfin = 0
!
!  loop sui gruppi
   do
      jin = 1 + jfin
      if (jin > nr) exit
      jfin = jin + overl(jin) - 1
      sumfc2 = sum (mlp(jin:jfin)*fc2(jin:jfin))
      if (sumfc2 /= 0) then
          for(jin:jfin) = sqrt( fc2(jin:jfin)*sum (mlp(jin:jfin)*fo(jin:jfin)**2)/sumfc2 )
      else
          for(jin:jfin) = fo(jin:jfin)
      endif
   enddo
!
   end subroutine ripartisci
!----------------------------------------------------------------------------------------------------
   subroutine ripartisci_N(ovr,fo,fold,fc,mult,lp,for,nc)
!
   integer, dimension(:), intent(in) :: ovr    ! vettore da defov
   real, dimension(:), intent(in)    :: fo     ! fs osservati
   real, dimension(:), intent(in)    :: fold   ! fs osservati
   real, dimension(:), intent(in)    :: fc     ! fs calcolati
   integer, dimension(:), intent(in) :: mult   ! molteplicit�
   real, dimension(:), intent(in)    :: lp     ! LP
   real, dimension(:), intent(out)   :: for    ! fs ripartiti
   real, dimension(size(ovr))        :: mlp,fc2,fo2
   real, dimension(size(ovr))        :: coeffi
   real                              :: sumfo2
   real                              :: sumfc2,scala,scal,erfs
   integer, dimension(size(ovr))     :: overl
   integer                           :: i
   integer                           :: jin,jfin
   integer                           :: nr
   integer                           :: nc
!
!  numero di riflessi
   nr = size(overl)
   scal = sum (fo(:nr)) / sum (fc(:nr))
   erfs = sum(abs(fo(:nr) - scal*fc(:nr)))/sum(fo(:nr))
   if(nc.eq.1)errefsmin=erfs
!
!  modifica sul vettore che definisce i gruppi
   do i=1,npref
      if (ovr(i) == 0) then
          !overl(i) = ovr(i-1)
          overl(i) = overl(i-1)
      else
          overl(i) = ovr(i)
      endif
      mlp(i) = mult(i)*lp(i)   ! calcolo di mlp
      fc2(i) = fc(i)**2        ! calcolo fc**2
!     fo2(i) = fo(i)**2        ! calcolo fc**2
      fo2(i) = fold(i)**2        ! calcolo fc**2
   enddo
   sumfc2 = sum (mlp(1:npref)*fc2(1:npref))
   sumfo2 = sum (mlp(1:npref)*fo2(1:npref))
   scala=sumfo2/sumfc2
   do i=1,npref
      fc2(i) = scala*fc2(i)
   enddo
!
   jfin = 0
!
!  loop sui gruppi
   coeffi(1:nr)=1.0
   do
      jin = 1 + jfin
      if (jin > nr) exit
      jfin = jin + overl(jin) - 1
      sumfc2 = sum ((1.0-wprint(jin:jfin))*mlp(jin:jfin)*fc2(jin:jfin))
      sumfo2 = sum ((1.0-wprint(jin:jfin))*mlp(jin:jfin)*fo2(jin:jfin))
      coeffi(jin:jfin)=1.0-0.15*float(nc-2)
      if(erfs.gt.1.005*errefsmin)coeffi(jin:jfin)=1.0
     !!coranna if(nc.ge.6)coeffi(jin:jfin)=0.0
      if(nc.ge.nmcicli/2+1)coeffi(jin:jfin)=0.0
      where(coeffi(jin:jfin).le.0.0)coeffi(jin:jfin)=0.0
      where(coeffi(jin:jfin).ge.1.0)coeffi(jin:jfin)=1.0
      coeffi(jin:jfin)=wprint(jin:jfin)*coeffi(jin:jfin)
      sumfc2 = sum ((1.0-coeffi(jin:jfin))*mlp(jin:jfin)*fc2(jin:jfin))
      sumfo2 = sum ((1.0-coeffi(jin:jfin))*mlp(jin:jfin)*fo2(jin:jfin))
      if (sumfc2 /= 0) then
        for(jin:jfin) = sqrt(coeffi(jin:jfin)*fo2(jin:jfin)+(sumfo2/sumfc2)*(1.0-coeffi(jin:jfin))*fc2(jin:jfin))
      else
        for(jin:jfin) = fo(jin:jfin)
      endif
   enddo
   if(erfs.le.errefsmin)errefsmin=erfs
!
   end subroutine ripartisci_N
!----------------------------------------------------------------------------------------------------
   subroutine fslabel(icalfo,npadd,isov)
   USE Atomi, only : xyzs,nz,aLab,aLabOld,bfac,xyzo,nats,nzConst,occpch
   USE Symmetry, only : icent,nsym,ddmin
   USE General, only : neutro,celem,spacegr
   USE stat
   USE General, only : cell
   USE unit_cell
   USE CGEOM
   USE variables
   USE atom_type_util
   USE unit_cell
   USE molpnew
   USE elements, only: getmin_el
   USE sinterface, only: fillatom
!
   integer, intent(in)      :: icalfo
   integer, intent(in)      :: npadd
   real, dimension(8)       :: on
   real, dimension(11)      :: xo,xn
   integer, dimension(10)   :: key
   integer                  :: ksp,kspecb
   integer, dimension(192,3) :: newvet
   integer, dimension(500)     :: q
   real, dimension(3)       :: xeq
   real, dimension(2)       :: vet
   integer                  :: i,j,k,kt,ifi
   integer                  :: iold,inew
   integer                  :: itype
   integer                  :: ifin
   integer                  :: jpunt
   integer                  :: isov
   real                     :: distm,d
   real                     :: coef
   real                     :: bmed
   integer                  :: nzmin
   real, allocatable, dimension(:)     :: bsav
   real, dimension(5,500)     :: xapp
   real, dimension(3,3)     :: gg
   real :: distmin
   type(cell_type) :: cellt
!
   cellt = set_cell_type(cell)
   gg = cellt%get_g()
!
!  Fourier differenza
!
   if (icalfo == 3) then
       do i=1,nats
          xyzs(:3,npadd+i) = atm(i)%xc
          xyzs(4,npadd+i) = xyzo(4,i)
       enddo
       nats = nats + npadd
   endif
   if (icalfo == 4) then
       do i=1,nats
         xapp(1:5,i)=xyzs(1:5,i)
       enddo
       do i=1,npadd
          xyzs(1:3,i) = atm(i)%xc
          xyzs(4,i) = xyzo(4,i)
          bfac(i) = atm(i)%biso              ! ... prendi il b dell'affinamento
          xyzs(5,i) = atm(i)%ocry           ! prendi l'occupanza
          nz(i) = atm(i)%get_nz() 
          aLab(i)=atm(i)%lab
       enddo
       allocate(bsav(npadd))
       bsav(:) = atm(:npadd)%biso
       where(bsav(:) < 0.0) bsav(:) = 0.0
       call avestd(bsav(:),2.0,bmed)
       deallocate(bsav)
       do i=1,nats
          xyzs(1:3,npadd+i) = xapp(1:3,i)
          !xyzs(4,npadd+i) = xyzo(4,npadd)
          xyzs(4,npadd+i) = xapp(4,i)
          bfac(npadd+i) = atm(npadd)%biso              ! ... prendi il b dell'affinamento
          !bfac(npadd+i) = bmed                                                                           
          xyzs(5,npadd+i) = atm(npadd)%ocry           ! prendi l'occupanza
          nz(npadd+i) = atm(npadd)%get_nz()
          aLab(npadd+i)=atm(npadd)%lab
       enddo
       nats = nats + npadd
!corr       itype = 0
!corr       do i=1,nats
!corr          xo(:3) = xyzs(1:3,i)
!corr          ksp=kspecb(newvet,xo,xn,key,0,i,0,2)
!corr          xyzs(5,i) = 1.0/key(10)
!corr          xyzs(1:3,i) = xn(:3)
!corr       enddo
!corr       call MakeLab(1,nats)
       go to 111
   endif
!
!  Calcola occupanza
!
   itype = 0
   do i=1,nats
      xo(:3) = xyzs(1:3,i)
      ksp=kspecb(newvet,xo,xn,key,0,i,0,2)
      xyzs(5,i) = 1.0/key(10)
      xyzs(1:3,i) = xn(:3)
   enddo
!
!  Rilabella mappa
!
   aLabOld(:nats) = aLab(:nats)  ! salva vecchie labels
   nz(1:nats) = 100
   call label(nats,on)
   call MakeLab(1,nats)
!
!  Cerca atomi in comune tra vecchio e nuovo modello
   q(1:nats)=0
   vet(1)= 1.0
   vet(2)=-1.0
   ifin=icent+1
   if (isov == 1) then
       distmin = ddmin
   else
       distmin = 0.8
   endif
   do iold=1,natold
      xo(:3)=atm(iold)%xc
      distm=9999
      jpunt=0
      do inew=1,nats
         !if (q(inew).gt.0.5) cycle
         if (q(inew).gt.0) cycle
         do kt=1,spacegr%ncoper
            do ifi=1,ifin
               coef=vet(ifi)
               do k=1,nsym
                  call xequi(xo,k,coef,xeq,kt)
                  d = xdisteq(xyzs(:3,inew),xeq,gg)
                  if (d < distm .and. d < distmin) then
                      distm=d
                      jpunt=inew
                  endif
!corr                  if(isov.eq.1)then
!corr                    if (d < distm .and. d < ddmin) then
!corr                        distm=d
!corr                        jpunt=inew
!corr                    endif
!corr                  elseif(isov.eq.2)then
!corr                    if (d < distm .and. d < 0.8) then
!corr                        distm=d
!corr                        jpunt=inew
!corr                    endif
!corr                  endif
               enddo
            enddo
         enddo
      enddo
      if (jpunt.ne.0) q(jpunt)=iold
   enddo
!
!  Stampa risultati della ricerca
!
   if (index(fscond%sprint,'V') > 0) then
       if(isov.eq.1)write(6,'(/,13x,a)')'--------------- Compare models ----------------'
       if(isov.eq.1)write(6,*)'                  New model                       Old model'
       if(isov.eq.1)write(6,*)'              X      Y      Z                 X      Y     Z        B'
       do j=1,nats
          i=q(j)
          if (i.gt.0) then
              if(isov.eq.1)write(6,'(1x,i3,a1,1x,a5,3f7.3,i3,a1,1x,a5,3f7.3,f10.2)')               &
                    j,')',aLab(j),xyzs(1:3,j),i,')',aLabOld(i),atm(i)%xc,atm(i)%biso
!!!!!                    j,')',aLab(j),xyzs(1:3,j),i,')',aLabold(i),xrx(1:4,i)
          else
              if(isov.eq.1)write(6,'(1x,i3,a1,1x,a5,3f7.3)')j,')',aLab(j),xyzs(1:3,j)
          endif
       enddo
   endif
!
!  Calcola fattore termico medio
   allocate(bsav(natold))
   bsav(:) = atm(:natold)%biso
   where(bsav(:) < 0.0) bsav(:) = 0.0
   call avestd(bsav(:),2.0,bmed)
   
!
!  Calcola nz minimo
!
!corr   if (neutro == 1) then
!corr       nzmin = 100
!corr   else
!corr       if (any(no(:nk)==1)) then
!corr           nzmin = 200
!corr!           write(6,*)'Idrogeno presente nzmin=',nzmin
!corr       else
!corr           nzmin = 100
!corr!           write(6,*)'Idrogeno non presente nzmin=',nzmin
!corr       endif
!corr   endif
   nzmin = getmin_el(celem,neutro==0)*nzConst
!
!  Apporta modifiche ai picchi in comune
!
   do j=1,nats
      i=q(j)
      if (i > 0) then                   ! se il picco e' in comune ...
          if(isov.eq.1)then
             bfac(j) = atm(i)%biso              ! ... prendi il b dell'affinamento
             xyzs(1:3,j) = atm(i)%xc        ! prendi le coord. dell'affinamento
             xyzs(5,j) = atm(i)%ocry           ! prendi l'occupanza
          elseif(isov.eq.2)then
!corr            if(no(iabs(atm(i)%nz)/nzConst).gt.20)then
            if(atm(i)%z() > 20)then
               xo(:3) = atm(i)%xc
               ksp=kspecb(newvet,xo,xn,key,0,i,0,2)
               if(1.0/key(10).lt.1.0)then
                  bfac(j) = atm(i)%biso              ! ... prendi il b dell'affinamento
                  xyzs(1:3,j) = atm(i)%xc        ! prendi le coord. dell'affinamento
                  xyzs(5,j) = atm(i)%ocry           ! prendi l'occupanza
                  nz(j) = atm(i)%get_nz() 
               endif
             endif
             bfac(j) = atm(i)%biso 
          endif
      else                              ! ... altrimenti assegna il bmedio
          bfac(j) = bmed
          if(isov.eq.1)nz(j)   = nzmin               ! e assegna la specie piu' leggera
      endif
   enddo
!
!  Ricrea le labels
!corr   call MakeLab(1,nats)
!corr   do i=1,nats
!corr      xo(:3) = xyzs(1:3,i)
!corr      ksp=kspecb(newvet,xo,xn,key,0,i,0,2)
!corr      xyzs(5,i) = 1.0/key(10)
!corr      xyzs(1:3,i) = xn(:3)
!corr   enddo
!
111 continue
!
   occpch(:nats) = 1.0
!corr   call xyz_to_atom(atm,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,inte=xyzs(4,:))
   call xyz_to_atom(atm,xyzs(:3,:nats),bfac,occh=occpch,nz=nz,inte=xyzs(4,:),elem=celem)
   call atom_string(atm,celem)
   call calcola_occ(atm,spacegr,cellt,modcoor=.true.)
   call create_connectivity(atm,lconn,cellt,spacegr,check=.true.)
   call fillatom(atm)
!
   end subroutine fslabel
!-------------------------------------------------------------------
   subroutine check_bt2(x,atom,constr,btmin,btmax,kaction,sprint,ierror)
!
!  Check thermal factor. If kaction = 1 parameter is blocked
!
   USE constraints
   USE type_constants, only: DP
   USE atom_type_util
!
   implicit none
   real(DP), dimension(:), intent(in)                        :: x            ! parametri affinati
   type(atom_type), dimension(:), allocatable, intent(inout) :: atom
   type(constraint_type), dimension(:), allocatable          :: constr
   real, intent(in)                                          :: btmin,btmax  ! max e min per parametri termici
   integer, intent(in)                                       :: kaction      ! codice per gestione del parametro
   character(len=*), intent(in)                              :: sprint       ! codice di stampa
   integer, intent(out)                                      :: ierror       ! codice di errore
   integer                                                   :: i
   integer                                                   :: nco
   integer                                                   :: codej
!
   ierror = 0
   do i=1,numatoms(atom)
      nco = par_in_constraint(constr,i,4) 
      if (nco > 0) then
          codej = constr(nco)%ref
      else
          codej = atom(i)%rcod(4)
      endif
      if (codej > 0) then
          if (x(codej) < btmin .or. x(codej) > btmax) then
          !if (atom(i)%biso < btmin .or. atom(i)%biso > btmax) then
              if (index(sprint,'V') > 0) then
                  write(6,'(a,i0,a,f0.2,a,a,f0.2,a,f0.2,a)')' WARNING: for atom ',i,' thermal factor ',  &
                        x(codej),' is out of range ','(',btmin,'<-->',btmax,')'
          !              atom(i)%biso,' is out of range ','(',btmin,'<-->',btmax,')'
              endif
              if (kaction == 1) then
                  if (nco > 0) then
                      constr(nco)%ref = 0
                  else
                      atom(i)%rcod(4) = 0
                  endif
              endif
              ierror = 1
          endif
      endif
   enddo
!
   end subroutine check_bt2
!----------------------------------------------------------------------------------------------------
   subroutine ffsgauss(npar,iflag,nls,err)
   USE RefinecomRef
   USE GENLSQ
   USE General, only:lo
!corr   USE RIETV, only:check_bt2
   USE type_constants, only: DP
   USE variables, only: atm
   USE constraints
!
   implicit none
   integer, intent(in)            :: npar
   integer, intent(in), optional  :: nls
   integer, intent(in)            :: iflag
   integer, intent(out), optional :: err
   real(DP), dimension(size(xpar))    :: xparsav
   real, parameter :: btmin=-1.0, btmax=1000.0
   integer :: ierp
!
   ierp = 0
   select case (iflag)

     case (-1)                                      ! calcolo iniziale di funzioni                 
       call calcerrefs(npref,kcscal,scalf%val)      

     case (0)                                       ! calcola jacobiano
       call fsjacobian(npar)

     case (1)                                       ! applica gli shift e calcola erref
       xpar = xparold + step_length*shiftx
       call fset_parameter(numoss,xpar)
       call calcerrefs(npref,kcscal,scalf%val)      ! calcola erref

     case (2)
       !call to_coord(0)
       call fsprint_statusbar()
       if (index(fscond%sprint,'V') > 0) call stampa_all_parameters(lo,npar,fscond)

     case (3)
       call check_bt2(xpar,atm,constrv,btmin,btmax,1,fscond%sprint,ierp)

     case (4)
       xparsav = xpar
       step_length = 0.0
       xpar = xparold + step_length*shiftx
       call fset_parameter(numoss,xpar)
       call calcerrefs(npref,kcscal,scalf%val)  
       call check_bt2(xparsav,atm,constrv,btmin,btmax,1,fscond%sprint,ierp)

     case (5)                     ! save parameters
       xparold(:) = xpar(:)
!!!Enable this lines if you use constrv
!       if (nconstraints(constrv) > 0) then     ! se ci sono constraints e' necessario salvare anche gli atomi
!           call copy_atoms(atm_sav,atm)
!       endif

   end select
   if (present(err)) err=ierp
!
   end subroutine ffsgauss
!----------------------------------------------------------------------------------------------------
   subroutine ffslm(mfun,npar,x,fvec,fjac,ldfjac,iflag)
   USE RefinecomRef
   USE GENLSQ
   USE General, only:lo
   USE type_constants, only: DP
!
   integer, intent(in)                                :: mfun   !numero di funzioni
   integer, intent(in)                                :: npar   !numero di parametri (n<=m)
   integer, intent(in)                                :: ldfjac
   integer, intent(inout)                             :: iflag
   real(DP), dimension(mfun),        intent(out) :: fvec   !funzioni che entrano nella somma di quadrati
   real(DP), dimension(ldfjac,npar), intent(out) :: fjac   !jacobiano di fvec
   real(DP), dimension(npar),        intent(in)  :: x      !i parametri da affinare
!
   select case (iflag)

     case (0)
       nclev = nclev + 1
       if (nclev == 0) then                      ! ciclo 0 non gestito

       elseif (nclev <= fscond%maxcy) then
           call setweilsq()
           ncytot = ncytot + 1
           shiftx = xpar-xparold
           !call stampa_risultati(ncytot,10,npar,lo)
           if (index(fscond%sprint,'V') > 0) call stampa_all_parameters(lo,npar,fscond)
           call fsprint_statusbar()
           !call to_coord(0)
           if (nclev == fscond%maxcy) iflag = -1       ! se sei all'ultimo ciclo fermati
       endif

     case (1)                                    ! calcola le funzioni in x
       call fset_parameter(numoss,x)
       call calcerrefs(npref,kcscal,scalf%val)      ! calcola erref
       fvec = funcls
       xparold = xpar

     case (2)                                    ! calcola lo jacobiano
       call fsjacobian(npar)
       fjac = jacob

   end select
!
   end subroutine ffslm
!----------------------------------------------------------------------------------------------------
   subroutine calcerrefs(nrefl,ksc,scale,kpr)
   USE Refinecomref, only:noverl
   USE GENLSQ
   USE variables, only : ref
   USE var_samod, only : i_SA
   USE RRESTR
   USE General, only:knw
   USE reflection_type_util
!
   integer, intent(in)           :: nrefl
   integer, intent(in)           :: ksc
   real, intent(in),optional     :: scale
   integer, intent(in), optional :: kpr
   real                          :: scaleR
   real                          :: scal
   real                          :: sumfv
!
!  Aggiorna funcls e calcola chisquared
   select case(typeref)
      case (INTREF)
           funcls(:nrefl) = weilsq(:nrefl)*ref(:nrefl)%m*ref(:nrefl)%lp(1)*(ref(:nrefl)%fo**2-scalf%val*ref(:nrefl)%fc**2)

      case (GRUREF)
           call update_int_refg(ref,gref,2)
           funcls(:ngr) = weilsq(:ngr)*(gref(:ngr)%Io - scalf%val*gref(:ngr)%Ic)

      case (FREF)
           funcls(:nrefl) = weilsq(:nrefl)*(ref(:nrefl)%fo - scalf%val*ref(:nrefl)%fc)

      case (GR_AND_REF)
           funcls(:nrefl) = weilsq(:nrefl)*ref(:nrefl)%m*ref(:nrefl)%lp(1)*(ref(:nrefl)%fo**2-scalf%val*ref(:nrefl)%fc**2)
           call update_int_refg(ref,gref,2)
           funcls(nrefl+1:nrefl+ngr) = weilsq(nrefl+1:nrefl+ngr)*(gref(:ngr)%Io - scalf%val*gref(:ngr)%Ic)

   end select
   chisquarednow = dot_product(funcls,funcls)
   if(nrestraints(resvf).gt.0.and.ncytot.gt.0.and.i_SA.gt.0)call weight_restr() 
!
!  Calcola Rf tra Fs osservati e Fs calcolati
   if (ksc == 1) then
       scal = sum (ref(:nrefl)%fo) / sum (ref(:nrefl)%fc)
   else
       scal = scale
   endif
   errefs = sum(abs(ref(:nrefl)%fo - scal*ref(:nrefl)%fc))/sum(ref(:nrefl)%fo)
   select case (typeref)
     case (INTREF,GR_AND_REF)
        !errefsw = sqrt(chisquarednow/sum((weilsq(:nrefl)*integ(:nrefl))**2))
        errefsw = sqrt(chisquarednow/sum((weilsq(:nrefl)*ref(:nrefl)%m*ref(:nrefl)%lp(1)*ref(:nrefl)%fo**2)**2))
     case (GRUREF)
        errefsw = sqrt(chisquarednow/sum((weilsq(:ngr)*gref(:ngr)%Io)**2))
     case (FREF)
        errefsw = sqrt(chisquarednow/sum((weilsq(:nrefl)*ref(:nrefl)%fo)**2))
   end select
   errefsing = geterrefsing(ref(:npref)%fo,ref(:npref)%fc,noverl(:npref))
!
   if (knw /= 0) then             ! Se la struttura e' nota ....
!
!      ... calcola Rf tra Fs veri e Fs calcolati
       sumfv = sum(ref(:npref)%fv)
       scaleR = sumfv / sum(ref(:npref)%fc)  ! calcola scala tra Fveri e Fcalc
       errefsv = sum(abs(ref(:npref)%fv-scaleR*ref(:npref)%fc)) / sumfv
!
!      ... calcola Rf tra Fs veri e Fs osservati
       scaleR = sumfv / sum(ref(:npref)%fo)  ! calcola scala tra Fveri e Fcalc
       errefsv1 = sum(abs(ref(:npref)%fv-scaleR*ref(:npref)%fo)) / sumfv
   endif
!
!  Calcola R-profilo se richiesto
   if (rwpopt) call calcolaRwp(ref(:npref)%fc,60.0)
!
!  Stampa se richiesto
   if (present(kpr)) then
       if (kpr > 0) then
           if (knw == 1) then
               write(6,'(2(3x,a,f0.4) )')'R(true-calc) = ',errefsv,'R(true-obs) =',errefsv1
           endif
           write(6,'(2(3x,a,f0.4) )')'RF(obs-calc) = ',errefs,'RFw(obs-calc) = ',errefsw
       endif
   endif
!
!80 format(2x,'Rw(obs-calc)=',f12.4,3x,'RF(singoli)  =',f12.4,4x,'Rwp =',f12.4)
!
   end subroutine calcerrefs
!----------------------------------------------------------------------------------------------------
   real function geterrefsing(fs1,fs2,overl)     result(erref)
!
   real, dimension(:), intent(in)    :: fs1
   real, dimension(:), intent(in)    :: fs2
   integer, dimension(:), intent(in) :: overl
   integer                           :: nrefl,nsing
   real, allocatable                 :: fs1s(:),fs2s(:)
   integer                           :: i
   real                              :: scala
!
   nrefl  = size(fs1)                  ! num. di riflessi
   nsing = sum(overl, mask=overl==1)  ! num. di riflessi singoli
   allocate(fs1s(1:nsing),fs2s(1:nsing))
   nsing = 0
   do i=1,nrefl
      if (overl(i) == 1) then
          nsing = nsing + 1
          fs1s(nsing) = fs1(i)
          fs2s(nsing) = fs2(i)
      endif
   enddo
   scala = sum(fs1s)/sum(fs2s)
   erref = sum(abs(fs1s - scala*fs2s)) / sum(fs1s)
!
   end function geterrefsing
!----------------------------------------------------------------------------------------------------

   subroutine fsprerefine()
   USE genlsq
   USE variables, only: atm,ref,cryst
   USE rietv
   integer :: nkref
!
   nkref = 0
!
!  Scala
   if (scalf%rcod > 0) then
       nkref = nkref + 1
       par_string(nkref) = scalf%str
       xpar(nkref) = scalf%val
       scalf%rcod = nkref
   endif
!
   if (cryst(1)%at_refined) then
       call prerefine_structure(atm,ref,constrv,nkref)
   endif
!
   end subroutine fsprerefine

!----------------------------------------------------------------------------------------------------
   subroutine fsjacobian(Nactot)
   USE RefinecomRef
   USE GENLSQ
   USE RRESTR
   USE progtype, only:deratom
   USE variables, only:ref,atm
   USE Atomi, only:nats
   !USE atom_type_util
   USE General, only: spacegr,celem,alambda,cell
   USE unit_cell
   USE reflection_type_util
   USE sinterface, only: fillatom
!
   integer, intent(in)            :: Nactot
   type(deratom), dimension(npref,nats) :: der
!
   call fillatom(atm)     ! forse non serve -- controllare
   !corr call fcalcadern(ref(:npref),atm(:nats),spacegr,al,bs,cl,nk,alambda,der)
   call fcalcadern(ref(:npref),atm(:nats),spacegr,celem,alambda,der)
!
   select case (typeref)
     case (INTREF)
           call fsjac_reflI(der)
     case (GRUREF)
           call fsjac_gruppi(Nactot,der)
     case (FREF)
           call fsjac_reflF(der)
     case (GR_AND_REF)
           call fsjac_gruppireflI(Nactot,der)
   end select
!
   call resapp(atm,set_cell_type(cell),resvf,wqqf,numoss,1)
!
   end subroutine fsjacobian
!----------------------------------------------------------------------------------------------------
   subroutine fsjac_gruppi(Nactot,der)
   USE GENLSQ
   USE variables, only : ref,atm
   USE progtype, only : deratom
   USE Atomi, only:nats
   USE type_constants, only: DP
!
   integer, intent(in)            :: Nactot
   type(deratom), dimension(:,:), intent(in) :: der
   integer                        :: kka
   integer                        :: j
   integer                        :: nr
   integer                        :: kk
   real                           :: doc
   integer                        :: ng
   real(DP), dimension(Nactot) :: derf
   integer                        :: code
   integer                        :: nc
!
   loop_gruppi : do ng=1,ngr
      derf = 0.0
      code = gref(ng)%code
      loop_riflessi : do nc=1,code
         kka = 0
         nr = gref(ng)%vref(nc)
!
!        Scala
         if (scalf%rcod > 0) then
             kka = kka + 1
             derf(scalf%rcod) = derf(scalf%rcod) + ref(nr)%m*ref(nr)%lp(1)*ref(nr)%fc**2
         endif
!
!        Parametri strutturali
         do j=1,nats
            do kk=1,5
               if (atm(j)%rcod(kk) > 0) then
                   kka = kka + 1
                   if (kk.eq.1) doc = der(nr,j)%co(1)
                   if (kk.eq.2) doc = der(nr,j)%co(2)
                   if (kk.eq.3) doc = der(nr,j)%co(3)
                   if (kk.eq.4) doc = der(nr,j)%b
                   if (kk.eq.5) doc = der(nr,j)%occ
                   derf(kka) = derf(kka) + scalf%val*ref(nr)%m*ref(nr)%lp(1)*doc
               endif
            enddo
         enddo
!
!        Constraints su x,y,z per atomi in posizione speciale
!!!         do j=1,nconstrx
!!!            kka = kka + 1
!!!            katom = num_at_constr(j)
!!!            derf(kka) = derf(kka) + scalf%val*ref(nr)%m*ref(nr)%lp*                &
!!!                                                 (key_constr(j,1)*der(nr,katom)%co(1) + &
!!!                                                  key_constr(j,2)*der(nr,katom)%co(2) + &
!!!                                                  key_constr(j,3)*der(nr,katom)%co(3))
!!!         enddo
!
      enddo loop_riflessi
      jacob(ng,:kka) = -weilsq(ng)*derf(:kka)
   enddo loop_gruppi

!
   end subroutine fsjac_gruppi
!----------------------------------------------------------------------------------------------------
   subroutine fsjac_reflF(der)
   !USE RefinecomRef
   USE GENLSQ
!corr   USE Factor
   USE variables, only:atm,ref
   USE progtype, only : deratom
   USE Atomi, only:nats
!
   type(deratom), dimension(:,:), intent(in) :: der
   integer                        :: kka
   integer                        :: j
   integer                        :: nr
   integer                        :: kk
   real                           :: doc
!!!!   integer                        :: katom
!
!  Affinamento sui riflessi
   do nr=1,npref
      kka = 0
!
!     Scala
      if (scalf%rcod > 0) then
          kka = kka + 1
          jacob(nr,scalf%rcod) = ref(nr)%fc
      endif
!
!     Parametri strutturali
      do j=1,nats
         do kk=1,5
            if (atm(j)%rcod(kk) > 0) then
                kka = kka + 1
                if (kk.eq.1) doc = der(nr,j)%co(1)
                if (kk.eq.2) doc = der(nr,j)%co(2)
                if (kk.eq.3) doc = der(nr,j)%co(3)
                if (kk.eq.4) doc = der(nr,j)%b
                if (kk.eq.5) doc = der(nr,j)%occ
                jacob(nr,kka) = 0.5*scalf%val*doc/ref(nr)%fc
            endif
         enddo
      enddo
!
!     Constraints su x,y,z per atomi in posizione speciale
!!!!      do j=1,nconstrx
!!!!         kka = kka + 1
!!!!         katom = num_at_constr(j)
!!!!         if (ref(nr)%fc > epsmch) then
!!!!             jacob(nr,kka) = 0.5*scalf%val*(key_constr(j,1)*der(nr,katom)%co(1) + &
!!!!                                  key_constr(j,2)*der(nr,katom)%co(2) + &
!!!!                                  key_constr(j,3)*der(nr,katom)%co(3))/ref(nr)%fc
!!!!         endif
!!!!      enddo
!
      jacob(nr,:kka) = -weilsq(nr)*jacob(nr,:kka)
   enddo
!
   end subroutine fsjac_reflF
!----------------------------------------------------------------------------------------------------
   subroutine fsjac_reflI(der)
   USE GENLSQ
!corr   USE Factor
   USE variables, only:atm,ref
   USE progtype, only:deratom
   USE Atomi, only:nats
!
   type(deratom), dimension(:,:), intent(in) :: der
   integer                                   :: kka
   integer                                   :: j
   integer                                   :: nr
   integer                                   :: kk
   real                                      :: doc
!!!!   integer                                   :: katom
!
!  Affinamento sui riflessi
   do nr=1,npref
      kka = 0
!
!     Scala
      if (scalf%rcod > 0) then
          kka = kka + 1
          jacob(nr,scalf%rcod) = ref(nr)%m*ref(nr)%lp(1)*ref(nr)%fc**2
      endif
!
!     Parametri strutturali
      do j=1,nats
         do kk=1,5
            if (atm(j)%rcod(kk) > 0) then
                kka = kka + 1
                if (kk.eq.1) doc = der(nr,j)%co(1)
                if (kk.eq.2) doc = der(nr,j)%co(2)
                if (kk.eq.3) doc = der(nr,j)%co(3)
                if (kk.eq.4) doc = der(nr,j)%b
                if (kk.eq.5) doc = der(nr,j)%occ
                jacob(nr,kka) = scalf%val*ref(nr)%m*ref(nr)%lp(1)*doc
            endif
         enddo
      enddo
!
!     Constraints su x,y,z per atomi in posizione speciale
!!!!      do j=1,nconstrx
!!!!         kka = kka + 1
!!!!         katom = num_at_constr(j)
!!!!         if (ref(nr)%fc > epsmch) then
!!!!             jacob(nr,kka) = scalf%val*ref(nr)%m*ref(nr)%lp*       &
!!!!                                 (key_constr(j,1)*der(nr,katom)%co(1) + &
!!!!                                  key_constr(j,2)*der(nr,katom)%co(2) + &
!!!!                                  key_constr(j,3)*der(nr,katom)%co(3))   !!!!/ref(nr)%fc
!!!!         endif
!!!!      enddo
!
      jacob(nr,:kka) = -weilsq(nr)*jacob(nr,:kka)
   enddo
     !stop
!
   end subroutine fsjac_reflI
   
!----------------------------------------------------------------------------------------------------

   subroutine fsjac_gruppireflI(Nactot,der)
   USE GENLSQ
   USE variables, only:atm,ref
   USE progtype, only:deratom
   USE Atomi, only:nats
   USE type_constants, only: DP
!
   integer, intent(in)                       :: Nactot
   type(deratom), dimension(:,:), intent(in) :: der
   integer                                   :: kka
   integer                                   :: j
   integer                                   :: nr
   integer                                   :: kk
   real                                      :: doc
   real(DP), dimension(Nactot) :: derf
   integer                        :: code
   integer                        :: nc
   integer                        :: ng
   integer                        :: npg
!
!  Affinamento sui riflessi
   do nr=1,npref
      kka = 0
!
!     Scala
      if (scalf%rcod > 0) then
          kka = kka + 1
          jacob(nr,scalf%rcod) = ref(nr)%m*ref(nr)%lp(1)*ref(nr)%fc**2
      endif
!
!     Parametri strutturali
      do j=1,nats
         do kk=1,5
            if (atm(j)%rcod(kk) > 0) then
                kka = kka + 1
                if (kk.eq.1) doc = der(nr,j)%co(1)
                if (kk.eq.2) doc = der(nr,j)%co(2)
                if (kk.eq.3) doc = der(nr,j)%co(3)
                if (kk.eq.4) doc = der(nr,j)%b
                if (kk.eq.5) doc = der(nr,j)%occ
                jacob(nr,kka) = scalf%val*ref(nr)%m*ref(nr)%lp(1)*doc
            endif
         enddo
      enddo
!
      jacob(nr,:kka) = -weilsq(nr)*jacob(nr,:kka)
   enddo

   loop_gruppi : do ng=1,ngr
      derf = 0.0
      code = gref(ng)%code
      loop_riflessi : do nc=1,code
         kka = 0
         nr = gref(ng)%vref(nc)
!
!        Scala
         if (scalf%rcod > 0) then
             kka = kka + 1
             derf(scalf%rcod) = derf(scalf%rcod) + ref(nr)%m*ref(nr)%lp(1)*ref(nr)%fc**2
         endif
!
!        Parametri strutturali
         do j=1,nats
            do kk=1,5
               if (atm(j)%rcod(kk) > 0) then
                   kka = kka + 1
                   if (kk.eq.1) doc = der(nr,j)%co(1)
                   if (kk.eq.2) doc = der(nr,j)%co(2)
                   if (kk.eq.3) doc = der(nr,j)%co(3)
                   if (kk.eq.4) doc = der(nr,j)%b
                   if (kk.eq.5) doc = der(nr,j)%occ
                   derf(kka) = derf(kka) + scalf%val*ref(nr)%m*ref(nr)%lp(1)*doc
               endif
            enddo
         enddo
!
      enddo loop_riflessi
      npg = ng + npref
      jacob(npg,:kka) = -weilsq(npg)*derf(:kka)
   enddo loop_gruppi
!
   end subroutine fsjac_gruppireflI
!----------------------------------------------------------------------------------------------------

   subroutine fset_parameter(noss,parx)
   USE RefinecomRef
   USE general, only: spacegr,celem,cell
   USE ccryst
   USE RRESTR
   USE variables, only:ref,atm,cryst
   USE atom_type_util
   USE unit_cell
   USE reflection_type_util
   USE sinterface, only: fillatom
!
   implicit none
   real(DP), dimension(:), intent(in) :: parx
   integer, intent(in)                   :: noss
   integer                               :: j
   integer                               :: nkref
   integer                               :: icalcFc = 0
   integer                               :: kk
!
   nkref = 0
!
!  Scala
!
   if (scalf%rcod > 0) then
       nkref = nkref + 1
       scalf%val = parx(scalf%rcod)
   endif
!
!  Struttura
!
   if (cryst(1)%at_refined) then
       do j=1,numatoms(atm)
          do kk=1,3
             if(atm(j)%rcod(kk) > 0) then
                nkref = nkref + 1
                atm(j)%xc(kk) = parx(nkref)
             endif
          enddo
          if(atm(j)%rcod(4) > 0) then
             nkref = nkref + 1
              atm(j)%biso = parx(nkref)
          endif
          if(atm(j)%rcod(5) > 0) then
             nkref = nkref + 1
             atm(j)%och = parx(nkref)
          endif
       enddo
!
!      Constraints su parametri strutturali x,y,z
!
!!!!       do kcon=1,nconstrx
!!!!          nkref = nkref + 1
!!!!         do kpar = 1,3
!!!!             if (key_constr(kcon,kpar) /= 0) then
!!!!                 atm(num_at_constr(kcon))%xc(kpar) = key_constr(kcon,kpar)*parx(nkref)
!!!!             endif
!!!!          enddo
!!!!       enddo
!
!      Constrain su B termici
!
!!!!       do kcon=1,nconstrB
!!!!          nkref = nkref + 1
!!!!          do kat = 1,natconstrB(kcon)
!!!!             atm(atconstrB(kcon,kat))%biso = xparconstr(kcon,kat) + step_length*shiftx(nkref)
!!!!          enddo
!!!!       enddo
       icalcFc = 1
       call fillatom(atm)
       call resapp(atm,set_cell_type(cell),resvf,wqqf,noss,0)  !aggiorna funcls
   endif
   if (icalcFc == 1) then
!corr       call fcalcan(ref,atm(:nats))
       call sfcalc(ref,atm,spacegr,celem)
   endif
!
   end subroutine fset_parameter
   
!----------------------------------------------------------------------------------------------------

   subroutine setreflections(nrf,fra,icod)
   USE RefinecomRef
   USE nr
   USE variables, only : ref
   USE reflection_type_util
!
!  nrf = num. di riflessi su cui applicare la selezione
!  fra = percentuale di riflessi da usare
!
   implicit none
   integer, intent(in)      :: nrf
   real,    intent(in)      :: fra
   integer, intent(in)      :: icod
   integer                  :: i,j
   real                     :: sogisav
   real, dimension(nrf)     :: ivetv
   real                     :: scalaioc,erreioc,erreioc1,sumio1
   real                     :: scalaiov,erreiov,erreiov1,erreiocmin
!
!  Crea codice di overlapping noverl
!
   call defovlexr(ref,sogh,noverl(:nrf))
!
   select case(icod)

     case (INTREF) ! affinamento con le intensita 
       ngr = 0
       npref = nrf*fra
       !fscond%lim%nrefu = nrf*fra
       numoss = npref
       allocate(integg(npref))
       integg(:) = ref(:npref)%m*ref(:npref)%lp(1)*ref(:npref)%fo**2
       kcscal = 1
       krip = 1

     case (GRUREF)  ! affinamento con i gruppi    
       npref = nrf*fra
       !fscond%lim%nrefu = npref
       call make_ref_groups(ref(:npref),gref,sogi=0.6,selcodei=1)
       !call print_refg(gref)
       ngr = size(gref)
       numoss = ngr
       kcscal = 1
       krip = 1

     case (FREF)   ! affinamento con riflessi 
       ngr = 0
       npref = nrf*fra
       !fscond%lim%nrefu = npref
       allocate(integg(npref))
       integg(:) = ref(:npref)%m*ref(:npref)%lp(1)*ref(:npref)%fo**2
       numoss = npref
       kcscal = 0
       krip = 0

     case (GR_AND_REF)   ! affinamento con riflessi 
       npref = nint(nrf*fra)
       !fscond%lim%nrefu = npref
       allocate(integg(npref))
       integg(:) = ref(:npref)%m*ref(:npref)%lp(1)*ref(:npref)%fo**2
!
!      seleziona solo gruppi in forte sovrapposizione
       call make_ref_groups(ref(:npref),gref,sogi=0.2,selcodei=2)
       sogisav=0.02
       erreiocmin=999999.0
       do i=1,100
         call make_ref_groups(ref(:npref),gref,sogi=0.01*float(i),selcodei=2)
         ngr = size(gref)
         do j=1,ngr
           ivetv(j) = sum(ref(gref(j)%vref)%m*ref(gref(j)%vref)%lp(1)*ref(gref(j)%vref)%fv**2)
         enddo
         erreioc=0.0
         erreiov=0.0
         erreioc1=0.0
         erreiov1=0.0
         sumio1=0.0
         scalaioc=sum(gref(1:ngr)%Io)/sum(gref(1:ngr)%Ic)
         scalaiov=sum(gref(1:ngr)%Io)/sum(ivetv(1:ngr))
         do j=1,ngr
           erreioc=erreioc+abs(gref(j)%Io-scalaioc*gref(j)%Ic)
           erreiov=erreiov+abs(gref(j)%Io-scalaiov*ivetv(j))
           if(gref(j)%Io.gt.sum(gref(1:ngr)%Io)/float(ngr))then
             erreioc1=erreioc1+abs(gref(j)%Io-scalaioc*gref(j)%Ic)
             erreiov1=erreiov1+abs(gref(j)%Io-scalaiov*ivetv(j))
             sumio1=sumio1+gref(j)%Io
           endif
         enddo
         erreioc=erreioc/sum(gref(1:ngr)%Io)
         erreiov=erreiov/sum(gref(1:ngr)%Io)
         erreioc1=erreioc1/sumio1                        
         erreiov1=erreiov1/sumio1                        
         write(6,'(a,3i5,f8.3)')'  Number of groups vs sogh',ngr,npref,maxval(gref(1:ngr)%code),0.01*float(i)
         write(6,'(a,4f15.4)')'  Erre of groups vs sogh',erreioc,erreiov,erreioc1,erreiov1                                         
         if(maxval(gref(1:ngr)%code).gt.20)exit 
         !if(ngr.gt.npref/5.or.maxval(gref(1:ngr)%code).gt.15)exit 
            sogisav=0.01*float(i)
         !if(erreioc.lt.erreiocmin)then
         !   erreiocmin=erreioc
         !   sogisav=0.02*float(i)
         !endif
       enddo
       !sogisav=1.0                         
       call make_ref_groups(ref(:npref),gref,sogi=sogisav,selcodei=2)
       call print_refg(gref)
       ngr = size(gref)
       numoss = npref + ngr
       write(6,'(a,3i5,f8.3)')'  Number of groups and sogh',ngr,npref,maxval(gref(1:ngr)%code),sogisav
       kcscal = 1
       krip = 1

   end select
!
   end subroutine setreflections
!-------------------------------------------------------------------
   subroutine setall
   USE RefinecomRef
   USE General, only : nrefl
   USE variables, only:ref
   USE reflection_type_util
!
   integer, dimension(nrefl)                       :: ovr
   integer                                        :: i,j,iref,ovrm
!
   sogover=1.0
   do i=7,10
     call defovlexr(ref,float(i)*0.1,ovr)
     iref=0
     do j=1,nrefl
       if(ovr(j).eq.1)iref=iref+1
     enddo
     ovrm=maxval(ovr(1:nrefl))
     if((float(iref)/float(nrefl)).le.0.4.or.ovrm.gt.50)then
       sogover=float(i)*0.1
       exit
     endif
   enddo
   end subroutine setall
!-------------------------------------------------------------------
   subroutine setweilsq()
   USE GENLSQ
   USE variables, only:ref
   USE reflection_type_util
!corr   USE nr                
   real :: sumref,sumgruppi
!
   if(.not.allocated(wprint))allocate(wprint(npref))
   wprint = 1.0
!
   select case (typeref)
     case (INTREF)
       call setgwei()

     case (GRUREF)
       call setgwei_onlywprint
       weilsq(:) = 1.0    !!!/ (gref(:ngr)%Io + 1)

     case (FREF)
       weilsq(:) = 1.0

     case (GR_AND_REF)
!
!      peso per i riflessi
       call setgwei()
!
!      peso per  i gruppi
       call update_int_refg(ref,gref,2)
       where (gref(:ngr)%Io /= 0.0)
         weilsq(npref+1:npref+ngr) = sqrt(1.0 / gref(:ngr)%Io)
       elsewhere
         weilsq(npref+1:npref+ngr) = 0.0
       endwhere
       sumref = sum((weilsq(:npref)*ref(:npref)%m*ref(:npref)%lp(1)*(ref(:npref)%fo**2-scalf%val*ref(:npref)%fc**2))**2)
       sumgruppi = sum((weilsq(npref+1:npref+ngr)*(gref(:ngr)%Io - scalf%val*gref(:ngr)%Ic))**2)
       weilsq(1:npref) = (float(npref)/float(npref+ngr))*(weilsq(1:npref))
       weilsq(npref+1:) =  (float(ngr)/float(npref+ngr))*weilsq(npref+1:npref+ngr)*sqrt(sumref / sumgruppi)

   end select
!
   end subroutine setweilsq
 !-------------------------------------------------------------------
   subroutine defovlexr2(indov,sogh)
   USE RefinecomRef
   USE variables, only:ref
!
   implicit none
   real, intent(in)                   :: sogh
   integer, intent(out), dimension(:) :: indov
   integer                            :: js,jg
   integer                            :: ifl
   integer                            :: nr
   integer                            :: jk
   integer, dimension(size(indov))    :: ies
!
   nr = size(indov)
   indov = 1
   ies=1
!
   DO JS=1,nr-1
      if(ies(js).eq.0)cycle
      DO JG=JS+1,nr
         IFL = 0
         IF(ABS(ref(jg)%tthd(1)-ref(jg-1)%tthd(1)) <= sogh*ref(jg)%fwhm(1)) THEN
            indov(JS) = indov(JS)+1
                  do  jk=js+1,jg
                  indov(jk)=indov(js)
                  enddo
                  ies(jg)=0
                  IFL = 1
         END IF
         IF(IFL == 0) exit
      enddo
   enddo
!
   end subroutine defovlexr2
 !-------------------------------------------------------------------
 !-------------------------------------------------------------------
   subroutine defovlexrN(indov,sogh)
   USE RefinecomRef
   USE variables, only:ref
!
   implicit none
   real, intent(in)                   :: sogh
   integer, intent(out), dimension(:) :: indov
   integer                            :: js,jg
   integer                            :: ifl
   integer                            :: nr
!
   nr = size(indov)
   indov = 1
!
   DO JS=1,nr-1
      If(indov(JS).EQ.0) cycle
      indov(JS) = 1
      DO JG=JS+1,nr
         IFL = 0
         IF(ABS(ref(jg)%tthd(1)-ref(jg-1)%tthd(1)) <= sogh*ref(jg)%fwhm(1)) THEN
            indov(JS) = indov(JS)+1
            indov(JG) = 0
            if(indov(js)==7)exit
            IFL = 1
         END IF
         IF(IFL == 0) exit
      enddo
   enddo
!
   end subroutine defovlexrN
 !-------------------------------------------------------------------
   subroutine lsqfun(iflag,m,n,xc,fvecc,fjacc,ljc,iw,liw,w,lw)
   USE GENLSQ
   !USE RefinecomRef
!
   integer, intent(inout)                        :: iflag ! = 0,1,2
   integer, intent(in)                           :: m     ! num. di funzioni in f
   integer, intent(in)                           :: n     ! num. di variabili
   real(kind=8), dimension(n), intent(in)        :: xc    ! x in cui calcolare le f o le derivate
   integer, intent(in)                           :: ljc   ! prima dimensione di fjacc
   real(kind=8), dimension(m), intent(inout)     :: fvecc ! f
   real(kind=8), dimension(ljc,n), intent(inout) :: fjacc ! jacobiano di f
   integer, intent(in)                           :: lw
   integer, intent(in)                           :: liw
   real(kind=8), dimension(lw), intent(out)      :: w
   integer,dimension(liw),intent(out)            :: iw
!
   w = 0
   iw = 0
   select case(iflag)

      case (0)           ! calcola le funzioni in x
!!!!!!       call fset_parameter(numoss,n,xc)
       call fset_parameter(numoss,xc)
       call calcerrefs(npref,kcscal,scalf%val)      ! calcola erref
       fvecc = funcls
       xparold = xc

      case (1)           ! calcola la matrice jacobiano
       call fsjacobian(n)
       fjacc = jacob

      case (2)           ! calcola le funzioni e la matrice jacobiana
!!!!!!       call fset_parameter(numoss,n,xc)
       call fset_parameter(numoss,xc)
       call calcerrefs(npref,kcscal,scalf%val)      ! calcola erref
       fvecc = funcls
       xparold = xc

       call fsjacobian(n)
       fjacc = jacob

   end select
!
   end subroutine lsqfun
 !-------------------------------------------------------------------
   subroutine fscalcr(n,p,x,nf,r,stoplsq)       !!!!!!!!!,urparm,ufparm)
   USE GENLSQ
   USE RIETV
   USE variables, only: atm
!
   integer, intent(in)                     :: n  ! num. di funzioni in f
   integer, intent(in)                     :: p  ! num. di parametri
   real(kind=8), dimension(p), intent(in)  :: x  ! parametri
   integer, intent(inout)                  :: nf
   real(kind=8), dimension(n), intent(out) :: r  ! le funzioni
   integer, intent(inout)                  :: stoplsq
   integer                                 :: ierror
   real, parameter :: btmin=-1.0, btmax=1000.0
!
   stoplsq = 0
   call check_bt2(x,atm,constrv,btmin,btmax,1,fscond%sprint,ierror)
   if (ierror > 0) then
      nf = 0
      stoplsq = 1
   else
      call fset_parameter(numoss,x)
      call calcerrefs(npref,kcscal,scalf%val)      ! calcola erref
      r = funcls
   endif
!
   end subroutine fscalcr
 !-------------------------------------------------------------------
   subroutine fscalcj(n,p,x,nf,j,stoplsq)     !!!!!!!!!,urparm,ufparm)
   USE GENLSQ
!
   integer, intent(in)                       :: n  ! num. di funzioni in f
   integer, intent(in)                       :: p  ! num. di parametri
   real(kind=8), dimension(p), intent(in)    :: x  ! parametri
   integer, intent(inout)                    :: nf
   real(kind=8), dimension(n,p), intent(out) :: j  ! le funzioni
   integer, intent(inout)                    :: stoplsq
   !real(kind=8),dimension(1),    intent(inout)          :: urparm
   !real(kind=8),    intent(inout)          :: ufparm
!
   call fsjacobian(p)
   j = jacob
   stoplsq = stoplsq
!
   end subroutine fscalcj
 !-------------------------------------------------------------------
   real(kind=8) function scalefactor(Fo,Fc,mult,lp)  result(scale)
   USE variables, only:ref
   USE reflection_type_util
!
   real, dimension(:), intent(in)    :: Fo
   real, dimension(:), intent(in)    :: Fc
   integer, dimension(:), intent(in) :: mult
   real, dimension(:), intent(in)    :: lp
   real, dimension(size(Fo))         :: inteo
!
   select case (typeref)
      case (INTREF,GR_AND_REF)
           inteo(:) = mult(:)*lp(:)*Fo(:)**2
            !write(0,*)'suminteo=',sum(inteo)
           scale = sum(inteo(:)) / sum(mult(:)*lp(:)*Fc(:)**2) ! calcola scala tra Iobs e Icalc
           !scale = sum(integg(:)) / sum(mult(:)*lp(:)*Fc(:)**2) ! calcola scala tra Iobs e Icalc
      case (GRUREF)
           call update_int_refg(ref,gref)
           scale = sum(gref(:ngr)%Io) / sum(gref(:ngr)%Ic)
      case (FREF)
           scale = sum(Fo) / sum(Fc)   ! calcola scala tra Fobs e Fcalc
   end select
!
   end function scalefactor

 !-------------------------------------------------------------------

   subroutine check_distance(atom,va,dmini,coef,kpr)
   USE unit_cell
   USE CGEOM
   use General, only : cell, spacegr
   USE atom_type_util
!
   type(atom_type), dimension(:), intent(in) :: atom
   integer, dimension(:), optional           :: va
   real, intent(in), optional                :: dmini
   real, intent(in), optional                :: coef
   integer, intent(in)                       :: kpr
   integer                                   :: n
   integer                                   :: i,j,k
   real, dimension(3)                        :: xeq
   real                                      :: d,distm,dmin
   real, dimension(3,3)                      :: gg
   logical                                   :: first
!
   gg = matrice_metrica(cell)
!
   first = .true.
   va(:) = 0
   n = size(atom)
   do i=1,n
      do j=i+1,n
         distm = huge(1.0)
         do k=1,spacegr%nsymop
            xeq(:) = atom_symm(atom(j)%xc,spacegr%symop(k))
            d = xdisteq(atom(i)%xc,xeq,gg)
            if (d < distm) then
                distm = d
            endif
         enddo

         if (present(dmini)) then
             dmin = dmini
         else
             if (present(coef)) then
                 dmin = (atom(i)%c_radius() + atom(j)%c_radius())*coef
             else
                 dmin = (atom(i)%c_radius() + atom(j)%c_radius())*0.3
             endif
         endif
         if (distm < dmin) then
             if (kpr == 1) then
                 if (first) then
                     write(6,'(" CRITICAL DISTANCES ")')
                     first = .false.
                 endif
                 write(6,'(3x,a,"-",a,"=",f8.3," < DMIN = ",f8.3)')trim(atom(i)%lab),trim(atom(j)%lab),distm,dmin
             endif
             va(j) = 1    ! segnala l'atomo piu' in basso nella lista
         endif

      enddo
   enddo
!
   end subroutine check_distance

 !-------------------------------------------------------------------

   subroutine remove_atoms(var)
   USE general, only: spacegr,celem
   USE RefinecomRef
   USE Atomi, only : nats
   USE variables, only: atm, ref
   USE atom_type_util
   USE reflection_type_util
   USE sinterface, only: fillatom
!
!  Se var = 1 l'atomo viene rimosso collocandolo in fondo alla lista
!
   integer, dimension(:), intent(in) :: var
   integer, dimension(size(var))     :: iorder
   integer                           :: nrem
   integer                           :: i
   integer                           :: j1,j2
   integer                           :: nnat
!
   nrem = sum(var)  ! num. di atomi da eliminare
!
   if(nrem.eq.nats)return
   if (nrem > 0) then
       nnat = nats - nrem
       j1 = 0
       j2 = nnat
       do i=1,nats
          if (var(i) == 0) then
              j1 = j1 + 1
              iorder(j1) = i
          else
              j2 = j2 + 1
              iorder(j2) = i
! da ripristinare             write(6,*)'Removed atom n.',i,aLab(i)
              !write(6,*)'Removed atom ',atm(i)%lab
          endif
       enddo
!
       atm(:nats) = atm(iorder)
       nats = nats - nrem
       call resize_atoms(atm,nats)
       call fillatom(atm)
       call sfcalc(ref,atm,spacegr,celem)
   endif
!
   end subroutine remove_atoms

 !-------------------------------------------------------------------

   subroutine statfs(vetx,vobs,vtrue,ivet)
   USE RefinecomRef
   USE nr
   USE GENLSQ, only : weilsq
   USE General, only:knw
!
   real, dimension(:), intent(in) :: vetx
   real, dimension(:), intent(in) :: vobs
   real, dimension(:), intent(in) :: vtrue
   integer, dimension(:), intent(in) :: ivet
   integer, dimension(size(vetx)) :: iorder
   integer, dimension(size(vetx)) :: veti
   real, dimension(size(vetx))    :: vetxo
   real, dimension(size(vetx))    :: vobso
   real, dimension(size(vetx))    :: vtrueo
   real, dimension(size(vetx))    :: vetw
   real, dimension(50)            :: voutx,vouty
   integer                        :: n,nn
   integer                        :: maxmult
   integer                        :: i
   integer                        :: nrm
   integer                        :: kinf,ksup
   real                           :: scal
   logical                        :: firstwr = .FALSE.
!
   if (knw == 0) return   ! struttura non nota
!
   n = size(vetx)           ! num. di riflessi
!
!  Statistica in base al 2-theta (Fobs-Fveri)
!
   if (ngr /= 0) then
   endif
   write(6,10)
   write(6,20)
   write(6,50)
   call indexx(vetx,iorder) ! ordina in base al 2-theta
   vobso = vobs(iorder)
   vetxo = vetx(iorder)
   vtrueo = vtrue(iorder)
   call statistic(vetxo,vobso,vtrueo,30,voutx,vouty,nn)
!
!  Statistica in base all'Fobs  (Fobs-Fveri)
!
   write(6,30)
   write(6,40)
   write(6,50)
   call indexx(vobs,iorder)     ! ordina in base all'Fo
   iorder = iorder(n:1:-1)      ! ordine decrescente
   vobso = vobs(iorder)
   vetxo = vetx(iorder)
   vtrueo = vtrue(iorder)
   call statistic(vobso,vobso,vtrueo,30,voutx,vouty,nn)
!
!  Statistica in base alla molteplicita'  (Fobs-Fveri)
!
   write(6,60)
   write(6,70)
   write(6,50)
   veti = ivet
   do i=1,n
      if (veti(i) == 0) veti(i) = veti(i-1)
   enddo
   call indexx(veti,iorder)     ! ordina in base alla molteplicita'
   veti = veti(iorder)
   vobso = vobs(iorder)
   vtrueo = vtrue(iorder)
   maxmult = veti(n)
   nrm = 0
   ksup = 0
   scal = sum(vtrue) / sum(vobs)
   do i=1,maxmult
      kinf = ksup + 1
      nrm = sum(veti/veti,mask=veti==i)
      ksup = nrm + kinf - 1
      if (nrm == 0) then
          write(6,80)i,nrm
      else
          write(6,80)i,nrm,                &
                100.*sum(abs(vtrueo(kinf:ksup)-scal*vobso(kinf:ksup)))/sum(vtrueo(kinf:ksup))
      endif
   enddo
!
!  Statistica in base al peso
!
   write(6,85)
   write(6,90)
   write(6,50)
  !if (ngr == 0) then
       vetw = weilsq**2
!       vetw = wprint
       call indexx(vetw,iorder)     ! ordina in base al peso
       vetw = vetw(iorder)
       vobso = vobs(iorder)
       vtrueo = vtrue(iorder)
       call statistic(vetw,vobso,vtrueo,30,voutx,vouty,nn)
       if (firstwr) then
           write(40,*)nn
           firstwr = .FALSE.
       endif
!!       do i=1,nn
!!          write(40,*)voutx(i),vouty(i)
!!       enddo
!
10 format(/,10x,'Statistica in base al 2-theta con Rf tra Fobs e Fveri',/)
!15 format(/,10x,'Statistica in base al 2-theta con Rf tra Fcal e Fobs',/)
20 format('               delta2-theta               Rf')
30 format(/,10x,"Statistica in base all'Fobs con Rf tra Fobs e Fveri",/)
!35 format(/,10x,"Statistica in base all'Fcal con Rf tra Fcal e Fobs",/)
40 format('               deltaFobs                  Rf')
50 format('     ------------------------------------------------')
60 format(/,10x,"Statistica in base alla molteplicita con Rf tra Fobs e Fveri'",/)
!!!!65 format(/,10x,"Statistica in base alla molteplicita con Rf tra Fcal e Fobs'",/)
70 format('       overlapping        num.          Rf')
80 format(10x,i4,10x,i4,8x,f8.3)
85 format(/,10x,"Statistica in base al peso con Rf tra Fobs e Fveri",/)
90 format('               deltaw                     Rf')
!
   end subroutine statfs

 !-------------------------------------------------------------------

   subroutine statistic(vetx,vobs,vtrue,numint,voutx,vouty,nn)
!
   real, dimension(:), intent(in)      :: vetx
   real, dimension(:), intent(in)      :: vobs
   real, dimension(:), intent(in)      :: vtrue
   real, dimension(:), intent(out)     :: voutx,vouty
   integer, intent(in)                 :: numint
   integer, intent(out)                :: nn
   real                                :: scal
   integer                             :: n
   integer                             :: i
   integer                             :: wint
   integer                             :: kinf,ksup
!
   nn = numint
   n = size(vetx)
   scal = sum(vtrue) / sum(vobs)
   wint = n / numint
   do i=1,numint
      kinf = (i-1)*wint+1
      ksup = kinf+wint-1
      voutx(i) = (vetx(kinf) + vetx(ksup)) / 2
      vouty(i) = 100.*sum(abs(vtrue(kinf:ksup)-scal*vobs(kinf:ksup)))/sum(vtrue(kinf:ksup))
      write(6,10)i,vetx(kinf),kinf,vetx(ksup),ksup,vouty(i)
   enddo
   if (ksup < n) then
      kinf = ksup+1
      ksup = n
      voutx(i) = (vetx(kinf) + vetx(ksup)) / 2
      vouty(i) = 100.*sum(abs(vtrue(kinf:ksup)-scal*vobs(kinf:ksup)))/sum(vtrue(kinf:ksup))
      write(6,10)i,vetx(kinf),kinf,vetx(ksup),ksup,vouty(i)
      nn = nn + 1
   endif
10 format(2x,i4,')',2x,g10.2,'(',i4,')',3x,g10.2,'(',i4,')',6x,g10.3)
!
   end subroutine statistic
  !-------------------------------------------------------------------
   subroutine recipcorr(kpr)
   USE General, only : nrefl,cell,twopi,rtod,alambda,pi,NMAXSPECIE,celem,spacegr,neutro
   USE unit_cell
   USE patternref, only : thmax
   USE CGEOM
   USE variables, only : atm,ref
   USE Symmetry, only : icent,nsym,nSpaceG
   USE ParametriMappa, only : np
   USE Atomi
   USE PhaseModule, only : aperc
   USE CommonExpo, only : isearchfo
   USE PRNUTIL
   USE GENLSQ
   USE atom_type_util
   USE Mappa
   USE fourier_mod
   USE reflection_type_util
   USE elements, only: S_at,numelem
   USE sinterface, only: fillatom
!
   integer, intent(in)                             :: kpr
   integer,  parameter :: dbl = kind(1.0d0)
!corr   type(atom_type), dimension(nk)                  :: atx
   type(atom_type), dimension(:), allocatable :: atx
   type(reflection_type), allocatable              :: refc(:)
   integer                                         :: i
   integer                                         :: natssav
   real, dimension(2*np(1)*np(2)*np(3),2)          :: rho
   integer                                         :: nrho
   integer, allocatable                            :: hkl(:,:)
   real, allocatable                               :: finv(:),frvet(:),fir(:)
   integer, allocatable                            :: iphinv(:),iphir(:)
   real, allocatable                               :: ffrippc(:,:)
   real, allocatable                               :: ffrippl(:,:)
   real, allocatable                               :: wei(:)
   integer, allocatable                            :: hkl2(:,:)
!   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)-1)  :: xmap
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1)  :: xmap0
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1)  :: xmap2
!corr   real, allocatable                               :: work1(:)
!corr   real, allocatable                               :: work2(:)
   real,dimension(2)                               :: vet              
   real,dimension(3,3)                             :: gg               
   real, dimension(3)                              :: xo,xo1
   real                                            :: dx,dy,dz
   real                                            :: distrifsav,sigma1
   integer                                         :: j,k,kt,ifi,ifin
   real                                            :: xx1,yy1,zz1
   integer                                         :: ier
   integer                                         :: j1,j2,j3
   real,dimension(3)                               :: xeq
   real                                            :: d,xmapmax
   real                                            :: dmin,coef
   integer                                         :: isav,nh             
   integer                                         :: jsav,nreflsav
   real                                            :: rh
   character(80)                                   :: spaceg,spacegsav
   integer                                         :: nrhosav
   real                                            :: thmaxsav,thmaxsavv
   real,dimension(5)                               :: dmat,amt
   real,dimension(5,5)                             :: amat
   real,dimension(2)                               :: ddmat,aamt
   real,dimension(2,2)                             :: aamat
   real                                            :: rifzero,rifmeno0,rifmeno1,rifzero0
   real                                            :: rif0,rif1,dd                        
   integer                                         :: ii                
   real                                            :: ddmax                          
   real                                            :: rif1sav,rifrapsav,rifmeno1sav
   real,allocatable                                :: fscato(:),fscatc(:)                        
   real, dimension(4,NMAXSPECIE)                   :: alsav,bssav 
   real, dimension(NMAXSPECIE)                     :: clsav
   real(dbl), allocatable                          :: am(:,:)  
   real(dbl), allocatable                          :: bm(:)    
   real(dbl)                                       :: xcoef(5)    
   real                                            :: sogr1,sogr2                                             
   real                                            :: sumr                                        
   integer                                         :: sogrip                                           
   integer                                         :: nmed,jrip            
   real                                            :: y,yk,yksav,sigma1sav                        
   real                                            :: erre,erremin,sum1,sum2,peso                      
   integer,dimension(2)                            :: indx
   integer                                         :: i16
   real                                            :: limmap
   integer                                         :: nkel
   real, dimension(:,:), allocatable :: al,bs
   real, dimension(:), allocatable :: cl
!
!corr   if(maxval(no(1:nk)).ge.16)then
   nkel = numelem(celem)
   allocate(al(4,nkel),bs(4,nkel),cl(nkel))
   do i=1,nkel
      al(:,i) = celem(i)%al
      bs(:,i) = celem(i)%bs
      cl(i) = celem(i)%cl
   enddo
!
   allocate(atx(nkel))
   if(maxval(celem%z) >= S_at) then
     limmap=4.0
   else
     limmap=3.5
   endif
   icorfscat=0
!corr   nmed=0
!corr   do i=1,nk
!corr     if(no(i).gt.1)then
!corr       nmed=nmed+nw(i)
!corr     endif
!corr   enddo
   nmed = nint(natom_cell(celem,neutro==0))
   clsav=cl
   alsav=al
   bssav=bs
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   natssav=nats
   corfscat(1)=0.0
   corfscat(2:5)=0.0
   if (kpr > 0) then
       write(6,'(/,a)')'    Resolution Bias Correction in the Reciprocal Space'
       write(6,'(a,/)')'            Scattering Factor Correction              '
   endif
   nreflsav=nrefl
   rh=ref(nrefl)%slaq
   vet(1)= 1.0
   vet(2)=-1.0
   ifin=icent+1
   gg = matrice_metrica(cell)
   thmaxsav=thmax
   thmaxsavv=thmax
   allocate(refc(nrefl))
   refc=ref
   write(spacegsav,'(16a1)') nSpaceG
15 continue
   ddmax=alambda/(2.0*sin(thmax*0.5*dtor))
!bug-on-ref   if(allocated(ref))deallocate(ref)
   if (kpr > 0) write(6,'(/,a,/)')'    The Map will be calculated in P1    '
   spaceg(:)=' '
   spaceg='P 1'                        
   call modifyspace(spaceg,0,ier)
   if(ier.ne.0)then
      thmax=thmax-5.0
      ier=0
      do i=1,nkel
      enddo
      go to 15
   endif
!bug-on-ref   allocate(ref(nrefl))
   call new_reflections(ref,nrefl)
!bug-on-ref
   allocate(hkl(nrefl,3),hkl2(3,nrefl),wei(nrefl),frvet(nrefl),finv(nrefl),iphinv(nrefl),fir(nrefl),iphir(nrefl))
!corr   allocate(work1(nrefl),work2(nrefl))
   allocate(ffrippc(nkel,nrefl))
   allocate(ffrippl(nkel,nrefl))
   do jsav=1,nkel
      if(kpr > 0) write(6,'(a,i5,/)')'    Species nr.',jsav                                   
      atx(jsav)%xc(1)=0.0                        
      atx(jsav)%xc(2)=0.0                        
      atx(jsav)%xc(3)=0.0                        
      atx(jsav)%biso = 0.0                           
      atx(jsav)%och  = 1.0                           
      atx(jsav)%ocry = 1.0                           
      !corr atx(jsav)%nz   = (nkel-jsav+1)*nzConst
      call atx(jsav)%set_specie_from_el(nkel-jsav+1,celem)
      !corr nh=iabs(atx(jsav)%nz/100)                           
      !corr if(no(nh).eq.1)go to 11
      if (atx(jsav)%z() == 1) go to 11
      nh=atx(jsav)%kscatt()
      ffrippc(nh,1:nrefl)=0.0
      ffrippl(nh,1:nrefl)=0.0
      call fillref2
      call InitFour()
!corr      call fcalcan(ref,atx(jsav:jsav))
      call sfcalc(ref,atx(jsav:jsav),spacegr,celem)
      dd=alambda/(2.0*sin(ref(nrefl)%tthd(1)*0.5*dtor))
      do j=1,nrefl
         hkl(j,1:3) = ref(j)%hkl
      enddo
      hkl2=transpose(hkl)
      frvet=0.0
      frvet(:nrefl)=ref(:nrefl)%fc
      wei=1.0
      do i=1,nrefl
         dd=alambda/(2.0*sin(ref(i)%tthd(1)*0.5*dtor))
         rh=ref(i)%slaq
         if(dd.lt.ddmax)then
           frvet(i)=0.0
           ref(i)%ph=0
           wei(i)=0.0
         endif
      enddo
!!      do i=jsav,jsav
!!          write(6,'(/,a,4f10.3,i3,/)')' Input atom for calculating rho: x y z B',atx(i)%xc,atx(i)%biso,atx(i)%nz
!!      enddo
      xmap2=0.0
!corr      work1=0.0
!corr      work2=0.0
      call MakeMap(transpose(hkl),frvet(:nrefl),ref(:nrefl)%ph,wei(:nrefl),nrefl,0,xmap2)  !!corr,work1,work2)
      xmap0=xmap2
      dx=1.0/float(np(1))
      dy=1.0/float(np(2))
      dz=1.0/float(np(3))
      aperc(1)=10
      nats=0
      isearchfo = 1
      call Search99(xmap2,0,ier,nrefl)
      rifzero0=xyzs(4,1)
      rifzero=xyzs(4,1)
      rif0=xyzs(4,2)/xyzs(4,1)
      aperc(1)=10
      nats=0
      isearchfo = 1
      call Search99(-xmap2,0,ier,nrefl)
      if (kpr > 0) then
          write(6,'(/,a,f8.5)')'  Before Correction: Positive Ripple Ratio',rif0                          
          write(6,'(a,f8.5,/)')'  Before Correction: Negative Ripple Ratio',xyzs(4,1)/rifzero   
      endif
      rifmeno0=xyzs(4,1)/rifzero
      i16=0
16    continue
      i16=i16+1
      jrip=0
!corr      sumr=0.003*float(no(nh))
      sumr=0.003*celem(nh)%z
13    continue
      xmap2=xmap0
      jrip=jrip+1
      distrifsav=2.0    
      xo(1)=atx(jsav)%xc(1)
      xo(2)=atx(jsav)%xc(2)
      xo(3)=atx(jsav)%xc(3)
      xmapmax=maxval(xmap2)
      rho=0.0
      nrho=0
      do j1=0,np(1)-1
        do j2=0,np(2)-1
          do j3=0,np(3)-1
             xx1=float(j1)*dx
             yy1=float(j2)*dy
             zz1=float(j3)*dz
             xo1(1)=xx1
             xo1(2)=yy1
             xo1(3)=zz1
             dmin=9999999.0
             do kt=1,spacegr%ncoper
                do ifi=1,ifin
                 coef=vet(ifi)
                 do k=1,nsym
                  call xequi(xo,k,coef,xeq,kt)
                  d= xdisteq(xeq(:3),xo1(:3),gg)
                  if(d.lt.dmin) dmin=d
                 enddo
               enddo
             enddo
             if(nrho.eq.0)then
                nrho=nrho+1
                rho(nrho,1)=dmin
                rho(nrho,2)=xmap2(j1,j2,j3)
             else
                nrho=nrho+1
                rho(nrho,1)=dmin
                rho(nrho,2)=xmap2(j1,j2,j3)
!!!! 77             continue
             endif
          enddo
        enddo
      enddo
   call ordinatab(rho(1:nrho,1:2),1)
   !do i=1,nrho
   !  write(48+jsav,'(2f10.3)')rho(i,1:2)
   !enddo
   nrhosav=nrho
   isav=nrho
   do i=1,nrho
     if(rho(i,1).gt.distrifsav)then
       isav=i-1                      
       exit
     endif
   enddo
    do i=1,nrho
      if(rho(i,2).le.0.0)then
        nrho=i-1
        distrifsav=rho(i-1,1)
        exit
!!!!  76  continue
      endif
    enddo
   sigma1=distrifsav
   do i=1,nrho
      if(rho(i,2).lt.rho(1,2)*0.5)then
         sigma1=rho(i,1)
         exit
      endif
   enddo
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
         xmap(j1,j2,j3)=0.0
       enddo
     enddo
   enddo
!corr   pi=4.0*datan(1.d0)
   yk=sigma1*sqrt(2.0*pi)*rho(1,2)      
   erremin=9999999.0
   sigma1sav=sigma1
   yksav=yk
   if (kpr > 0) then
       if(jrip.eq.1)write(6,'(/,a)')' ***  Gaussian Fitting  *** '
       if(jrip.eq.1)write(6,'(a,3f15.5)')' Intensity, Sigma, Maximum ',yk,sigma1,rho(1,2)
   endif
   do ii=1,10
        ddmat=0.0
        aamat=0.0
        aamt=0.0
        erre=0.0
        sum1=0.0
        sum2=0.0
        do i=1,nrho
         if(rho(i,2).gt.0.0)then
         peso=1.0/rho(i,2)
         !peso=1.0
         aamt(1)=(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2))
         aamt(2)=yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2))*(rho(i,1)**2/sigma1**2-1.0)*(1.0/sigma1)
         ddmat(1)=ddmat(1)+(rho(i,2)-yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2)))*aamt(1)*peso                
         ddmat(2)=ddmat(2)+(rho(i,2)-yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2)))*aamt(2)*peso                
         aamat(1,1)=aamat(1,1)+aamt(1)*aamt(1)*peso                
         aamat(1,2)=aamat(1,2)+aamt(1)*aamt(2)*peso                
         aamat(2,1)=aamat(2,1)+aamt(2)*aamt(1)*peso                
         aamat(2,2)=aamat(2,2)+aamt(2)*aamt(2)*peso                
         endif
        enddo
        call LUDCMP(aamat,2,2,INDX,D,ier)
        call LUBKSB(aamat,2,2,INDX,ddmat)
            if((yk+ddmat(1)).gt.0.0) yk=yk+ddmat(1)
            if((sigma1+ddmat(2)).gt.0.05) sigma1=sigma1+ddmat(2)
          do i=1,nrho
            if(rho(i,2).gt.0)then
              y=yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2))
              sum1=sum1+abs(rho(i,2)-y)
              sum2=sum2+rho(i,2)
            endif
          enddo
          erre=sum1/sum2
          if(erre.lt.erremin)then
            erremin=erre
            yksav=yk
            sigma1sav=sigma1
          endif
          sigma1=sigma1sav
          yk=yksav
   enddo
   if (kpr > 0) then
       if(jrip.eq.1)write(6,'(a,f15.4)')' R-minimum  ',erremin
       if(jrip.eq.1)write(6,'(a,f15.5)')' Peak Width ',distrifsav                 
       if(jrip.eq.1)write(6,'(a,/)')' ***                    *** '
   endif
   rh=ref(1)%slaq
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
            xx1=float(j1)*dx
            yy1=float(j2)*dy
            zz1=float(j3)*dz
            xo1(1)=xx1
            xo1(2)=yy1
            xo1(3)=zz1
            dmin=9999999.0
            do kt=1,spacegr%ncoper
               do ifi=1,ifin
                coef=vet(ifi)
                do k=1,nsym
                 call xequi(xo,k,coef,xeq,kt)
                 d= xdisteq(xeq(:3),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
                enddo
               enddo
            enddo
            if(dmin.ge.distrifsav.and.dmin.le.limmap)then
                  xmap(j1,j2,j3)=xmap2(j1,j2,j3)
            elseif(dmin.lt.distrifsav)then
                    xmap(j1,j2,j3)=xmap2(j1,j2,j3)-(1.0+sumr)*yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-dmin**2/(2.0*sigma1**2))
            endif
       enddo
     enddo
   enddo
   call inversione(nrefl,hkl2,iphinv,finv,xmap)
   fir=finv
   iphir=iphinv
   do i=1,nrefl
       if(iphir(i).gt.10.0.and.iphir(i).lt.300.0)then
         fir(i)=-fir(i)
       endif
       rh=ref(i)%slaq
       dd=alambda/(2.0*sin(ref(i)%tthd(1)*0.5*dtor))
       ffrippc(nh,i)=ffrippl(nh,i)+fir(i)
   enddo
   call fcalcannoripple(ref,atx(jsav:jsav),ffrippc(1:nkel,1:nrefl))
   do i=1,nrefl
      frvet(i)=ref(i)%fc
   enddo
   wei=1.0
   xmap=0.0
!corr   work1=0.0
!corr   work2=0.0
   call MakeMap(hkl2,frvet,ref(:nrefl)%ph,wei,nrefl,0,xmap)  !!!!corr,work1,work2)
   rho=0.0
   nrho=0
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
            xx1=float(j1)*dx
            yy1=float(j2)*dy
            zz1=float(j3)*dz
            xo1(1)=xx1
            xo1(2)=yy1
            xo1(3)=zz1
            dmin=9999999.0
            do kt=1,spacegr%ncoper
               do ifi=1,ifin
                coef=vet(ifi)
                do k=1,nsym
                 call xequi(xo,k,coef,xeq,kt)
                 d= xdisteq(xeq(:3),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
                enddo
               enddo
            enddo
              if(nrho.eq.0)then
                nrho=nrho+1
                rho(nrho,1)=dmin
                rho(nrho,2)=xmap(j1,j2,j3)
              else
                nrho=nrho+1
                rho(nrho,1)=dmin
                rho(nrho,2)=xmap(j1,j2,j3)
              endif
       enddo
     enddo
   enddo
   call ordinatab(rho(1:nrho,1:2),1)
   aperc(1)=10
   nats=0
   isearchfo = 1
   call Search99(xmap,0,ier,nrefl)
   rifzero=xyzs(4,1)
   rif1=xyzs(4,2)/rifzero         
   aperc(1)=10
   nats=0
   isearchfo = 1
   call Search99(-xmap,0,ier,nrefl)
   rifmeno1=xyzs(4,1)/rifzero         
   rif1sav=rif1
   rifrapsav=rifzero/rifzero0
   rifmeno1sav=rifmeno1
   xmap2=xmap
   rif1sav=rif1
   rifrapsav=rifzero/rifzero0
   rifmeno1sav=rifmeno1
   sogrip=50
   sogr1=1.1
   sogr2=1.25
   if(jrip.lt.sogrip.and.rifrapsav.lt.sogr1)then         
!corr     sumr=sumr+0.005*float(no(nh))
     sumr=sumr+0.005*celem(nh)%z
     go to 13
   elseif(jrip.lt.sogrip.and.rifrapsav.gt.sogr2)then         
!corr     sumr=sumr-0.007*float(no(nh))
     sumr=sumr-0.007*celem(nh)%z
     go to 13
   endif
   if (kpr > 0) then
       write(6,'(/,a,f8.5,i5)')'  After Correction: Intensity Ratio  Cycle',rifrapsav,jrip          
       write(6,'(a,f8.5)')'  After Correction: Final Positive Ripple Ratio',rif1sav
       write(6,'(a,f8.5,/)')'  After Correction: Final Negative Ripple Ratio',rifmeno1sav                 
   endif
   if(rif1.gt.rif0)then
     ffrippc(nh,1:nrefl)=ffrippl(nh,1:nrefl)
     go to 88
   else
     rif0=rif1
   endif
   if(rif1sav.gt.0.01.and.i16.lt.5)then
     xmap0=xmap
     ffrippl(nh,1:nrefl)=ffrippc(nh,1:nrefl)
     go to 16
   endif
 88 continue
   allocate(fscato(nrefl),fscatc(nrefl))
   do i=1,nrefl
      rh=ref(i)%slaq
      fscato(i)= 1.0-ffrippc(nh,i)/(cl(nh) + sum(al(:,nh)*exp(-bs(:,nh)*rh),dim=1))
   enddo
   rh=ref(1)%slaq
   cl(nh)=fscato(1)      
   al(1:4,nh)=0.0
   bs(1:4,nh)=0.0
   allocate(am(nrefl,5),bm(nrefl))
   do ii=1,1
      dmat=0.0
      amat=0.0
      amt=0.0
      do i=1,nrefl
         rh=ref(i)%slaq
         rh=sqrt(rh)
         fscatc(i)= cl(nh) + al(1,nh)*rh+al(2,nh)*(rh**2.0)+al(3,nh)*(rh**3.0)+bs(1,nh)*(rh**4.0)
         am(i,1)=1.0
         am(i,2)=rh
         am(i,3)=rh**2.0
         am(i,4)=rh**3.0
         am(i,5)=rh**4.0
         bm(i)=fscato(i)
         call solve_linlsq(am,bm,xcoef,ier)
      enddo
      cl(nh)=xcoef(1)               
      al(1,nh)=xcoef(2)               
      al(2,nh)=xcoef(3)               
      al(3,nh)=xcoef(4)               
      bs(1,nh)=xcoef(5)               
      do i=1,nrefl
         rh=ref(i)%slaq
         rh=sqrt(rh)
         fscatc(i)= cl(nh) + al(1,nh)*rh+al(2,nh)*(rh**2.0)+al(3,nh)*(rh**3.0)+bs(1,nh)*(rh**4.0)
      enddo
   enddo
   deallocate(am,bm)
!corr   corfscat(1)=corfscat(1)+nw(nh)*cl(nh)
!corr   corfscat(2)=corfscat(2)+nw(nh)*al(1,nh)
!corr   corfscat(3)=corfscat(3)+nw(nh)*al(2,nh)
!corr   corfscat(4)=corfscat(4)+nw(nh)*al(3,nh)
!corr   corfscat(5)=corfscat(5)+nw(nh)*bs(1,nh)
   corfscat(1)=corfscat(1)+celem(nh)%nw*cl(nh)
   corfscat(2)=corfscat(2)+celem(nh)%nw*al(1,nh)
   corfscat(3)=corfscat(3)+celem(nh)%nw*al(2,nh)
   corfscat(4)=corfscat(4)+celem(nh)%nw*al(3,nh)
   corfscat(5)=corfscat(5)+celem(nh)%nw*bs(1,nh)
   deallocate(fscato,fscatc)
11 continue
   enddo    
   corfscat(1)=corfscat(1)/float(nmed)
   corfscat(2)=corfscat(2)/float(nmed)
   corfscat(3)=corfscat(3)/float(nmed)
   corfscat(4)=corfscat(4)/float(nmed)
   corfscat(5)=corfscat(5)/float(nmed)
!!!!!12 continue
!!!!!666 continue
   deallocate(hkl,hkl2,wei,frvet,finv,iphinv,fir,iphir)
!corr   deallocate(work1,work2)
   thmax=thmaxsav
   call modifyspace(spacegsav,nreflsav,ier)
   deallocate(ref)
   nrefl=nreflsav
   allocate(ref(nrefl))
!
   call LeggiRiflessi ! rimetto a posto le variabili sui riflessi dopo modifyspace
!
   ref=refc
   nats=natssav
   call InitFour()
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   call fillatom(atm)  ! ripristino xyzs e nz
   cl=clsav
   al=alsav
   bs=bssav
!corr   do i=1,nrefl
!corr      rh=ref(i)%slaq
!corr      rhh=sqrt(rh)             
!corr   enddo
   return
   end subroutine recipcorr
  !-------------------------------------------------------------------
   subroutine indagamappa(nrr,dminneg,nmapcor,sigma1,coderbm,kprintc)
   USE General, only : nrefl,cell,celem,spacegr
   USE unit_cell
   USE CGEOM
   USE variables, only : atm,ref
   USE Symmetry, only : icent,nsym
   USE ParametriMappa, only : np
   USE Atomi
   USE PhaseModule, only : aperc
   USE CommonExpo, only : isearchfo
   !USE atom_type_util
   USE nr
   USE m_mrgrnk
   USE Mappa
   USE fourier_mod
   USE reflection_type_util
   USE elements, only: Cl_at
   USE sinterface, only: fillatom
!
   type(atom_type), dimension(nats)                        :: atx
   integer, intent(in)                             :: kprintc
   integer                                         :: i,natbb                                         
   integer, intent(in)                             :: nrr
   integer, intent(in)                            :: coderbm
   integer, dimension(nrefl,3)                     :: hkl
   real, dimension(nrefl)                          :: wei
!corr   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)-1)  :: xmap
   real, dimension(np(1)*np(2)*np(3))              :: distr
   real, dimension(np(1)*np(2)*np(3))              :: fourr
   real, dimension(np(1)*np(2)*np(3))              :: distr2
   real, dimension(np(1)*np(2)*np(3))              :: fourrmax
   real, dimension(np(1)*np(2)*np(3))              :: fourrmin
   real, dimension(np(1)*np(2)*np(3))              :: fourr2,fourr2piu,fourr2meno
   integer, dimension(:), allocatable              :: iorder
   integer,dimension(np(1)*np(2)*np(3))            :: nfourr2,nfourr2piu,nfourr2meno                          
!corr   real, dimension(nrefl)                          :: work1,work2
   real,dimension(2)                               :: vet              
   real,dimension(3,3)                             :: gg               
   real, dimension(3)                              :: xo,xo1,xo2
   real, dimension(3)                              :: xsav                       
   real                                            :: xx1,yy1,zz1
   real                                            :: scal
   real                                            :: dx,dy,dz
   integer                                         :: j,k,kt,ifi,ifin
   integer                                         :: nfourr                           
   integer                                         :: nmapcor
   integer                                         :: ier
   integer                                         :: j1,j2,j3,j1sav,j2sav,j3sav
   real,dimension(3)                               :: xeq
   real                                            :: d,xmapmax
   real                                            :: dmin,coef,dminpos,dminneg,dminnegmin
   integer                                         :: ndstep,isav                   
   real                                            :: dstep1,dstep2
   real                                            :: sigma1 
   real                                            :: pos2,neg3,distr2max 
   real                                            :: distmax,dstep,coe      
   integer                                         :: isav1,isav2
   real, dimension(nrefl)                          :: wbias
   real, dimension(nrefl)                          :: frvet
   real                                            :: rh
   !real,dimension(3,nsym*2*ncentr)                :: xequiv
   real,dimension(3,spacegr%nsymop)                :: xequiv
   integer                                        :: nateq               
!
   gg = matrice_metrica(cell)
   natbb=nats
   nmapcor=0
   mapcor=0.0
   atx(:) = atm(:)
   j=1
   do i=1,nats
   if(atm(i)%ocry.gt.0.9)then
   !if(atm(i)%ocry.gt.0.9.and.no(atm(i)%nz/nzConst).le.17)then
       j=i
       exit 
   endif
   enddo
   !coe=1.0
   coe=1.0
!corr   if(maxval(no(1:nk)).gt.17.and.no(iabs(atm(j)%nz/nzConst)).le.17)coe=1.2
   if(maxval(celem%z) > Cl_at .and. atm(j)%z() <= Cl_at)coe=1.2
   distr=0.0
   fourr=0.0
   nfourr=0
!non-usato   mapcor2=0.0
   distr2=0.0
   fourr2=0.0
   nfourr2=0
   fourr2piu=0.0
   nfourr2piu=0
   fourr2meno=0.0
   nfourr2meno=0
   fourrmax=-1.E+10   
   fourrmin=1.E+10   
!corr   call fcalcan(ref,atx(j:j))
   call sfcalc(ref,atx(j:j),spacegr,celem)
   !call simweight(ref(:nrefl),we,eo,ec)
   wei(:)=1.0
   scal = sum (ref(:nrefl)%fo) / sum (ref(:nrefl)%fc)
   if(coderbm.le.1)then
     frvet = ref(:nrefl)%fc
   else
     do i=1,nrefl
       rh=ref(i)%slaq
       rh=sqrt(rh)
       wbias(i)=(corfscat(1)+corfscat(2)*rh+corfscat(3)*(rh**2.0)+corfscat(4)*(rh**3.0)+corfscat(5)*(rh**4.0))
       frvet(i) = ref(i)%fc*(wbias(i))
     enddo
   endif
!-inutile   frvet = ref(:nrefl)%fc
   aperc(1)=nats
   if (kprintc == 1) write(6,'(/,a,4f10.3,i3,/)')' Input atom for calculating rho: x y z B',atm(j)%xc,atm(j)%biso,atm(j)%get_nz()
   xmap=0.0
   do i=1,nrefl
      hkl(i,:) = ref(i)%hkl
   enddo
   call MakeMap(transpose(hkl),frvet,ref(:nrefl)%ph,wei,nrr,0,xmap) !!!!!,work1,work2)
!!!   call MakeMap(transpose(hkl),ref(:nrefl)%fc,ref(:nrefl)%ph,wei,nrr,0,xmap,work1,work2)
!!!   if (jscreen > 0) call scrper('RBM Procedure: Map Correction in Direct Space',0,0)
   pos2=0.0
   nats=0
   isearchfo = 1
   call Search99(xmap,0,ier,nrr)
   xo1(1)=atm(j)%xc(1)
   xo1(2)=atm(j)%xc(2)
   xo1(3)=atm(j)%xc(3)
   vet(1)= 1.0
   vet(2)=-1.0
   ifin=icent+1
   xo(1)=xyzs(1,1)
   xo(2)=xyzs(2,1)
   xo(3)=xyzs(3,1)
   dmin=9999999.0
   do kt=1,spacegr%ncoper
      do ifi=1,ifin
       coef=vet(ifi)
       do k=1,nsym
                 call xequi(xo1,k,coef,xeq,kt)
                 d= xdisteq(xeq(:3),xo(:3),gg)
                 if(d.lt.dmin)then
                   dmin=d
                   xo2(1)=xeq(1)           
                   xo2(2)=xeq(2)           
                   xo2(3)=xeq(3)           
                 endif
       enddo
      enddo
   enddo
   dminpos=1.E+10     
   xo2(1)=xyzs(1,1)
   xo2(2)=xyzs(2,1)
   xo2(3)=xyzs(3,1)
   do i=1,nats
     xo1(1)=xyzs(1,i)
     xo1(2)=xyzs(2,i)
     xo1(3)=xyzs(3,i)
     dmin=1.E+10     
            do kt=1,spacegr%ncoper
               do ifi=1,ifin
                coef=vet(ifi)
                do k=1,nsym
                 call xequi(xo2,k,coef,xeq,kt)
                 d= xdisteq(xeq(:3),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
                enddo
               enddo
            enddo
     if(i.eq.2)pos2=dmin
     if(dmin.lt.dminpos.and.dmin.gt.1.5)dminpos=dmin
   enddo
   xmap=-xmap
   nats=0
   isearchfo = 1
   call Search99(xmap,0,ier,nrr)
   dminneg=99999999.0
   neg3=-100.0
   do i=1,nats
     xo1(1)=xyzs(1,i)
     xo1(2)=xyzs(2,i)
     xo1(3)=xyzs(3,i)
     dmin=9999999.0
            do kt=1,spacegr%ncoper
               do ifi=1,ifin
                coef=vet(ifi)
                do k=1,nsym
                 call xequi(xo2,k,coef,xeq,kt)
                 d= xdisteq(xeq(:3),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
                enddo
               enddo
            enddo
     if(dmin.gt.pos2.and.neg3.lt.0.0)neg3=dmin
     if(dmin.lt.dminneg)dminneg=dmin
   enddo
   xmap=-xmap
   nats=0
   isearchfo = 1
   call Search99(xmap,0,ier,nrr)
   xsav=xo2
   dx=1.0/float(np(1))
   dy=1.0/float(np(2))
   dz=1.0/float(np(3))
   j1sav=0
   j2sav=0
   j3sav=0
   xmapmax=-1.E+10                  
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
                 if(xmap(j1,j2,j3).gt.xmapmax)then
                   xmapmax=xmap(j1,j2,j3)
                   j1sav=j1
                   j2sav=j2
                   j3sav=j3
                 endif
       enddo
     enddo
   enddo
   xo(1)=float(j1sav)*dx
   xo(2)=float(j2sav)*dy
   xo(3)=float(j3sav)*dz
!!!!!!!!!!!!!!!!!!!!!!!!!
   nateq=0
   do kt=1,spacegr%ncoper
      do ifi=1,ifin
         coef=vet(ifi)
         do k=1,nsym
            call xequi(xo,k,coef,xeq,kt)
            nateq=nateq+1
            xequiv(1:3,nateq)=xeq(1:3)
         enddo
      enddo
   enddo
!!!!!!!!!!!!!!!!!!!!!!!!!
   distmax=-1.E+10
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
            xx1=float(j1)*dx
            yy1=float(j2)*dy
            zz1=float(j3)*dz
            xo1(1)=xx1
            xo1(2)=yy1
            xo1(3)=zz1
            dmin=9999999.0
            do kt=1,nateq
                 d= xdisteq(xequiv(:3,kt),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
            enddo
            if(dmin.gt.distmax)distmax=dmin
            nfourr=nfourr+1
            distr(nfourr)=dmin
            fourr(nfourr)=xmap(j1,j2,j3)
       enddo
     enddo
   enddo
!corr   fourrr(1:nfourr,1)=distr(1:nfourr)
!corr   fourrr(1:nfourr,2)=fourr(1:nfourr)
!corr   call ordinatab(fourrr(1:nfourr,1:2),1)
!corr   distr(1:nfourr)=fourrr(1:nfourr,1)
!corr   fourr(1:nfourr)=fourrr(1:nfourr,2)
!
!  ordina secondo distr
   allocate(iorder(nfourr))
!   call indexx(distr(:nfourr),iorder)
   call mrgrnk(distr(:nfourr),iorder)
!!!   call psort(distr(:nfourr),nfourr,iorder,nfourr)
!!!   call psort(fourr(:nfourr),nfourr,iorder,nfourr)
   distr(:nfourr) = distr(iorder)
   fourr(:nfourr) = fourr(iorder)
   deallocate(iorder)
!
   dminnegmin=-99999999.0
   do i=1,nfourr
     if(distr(i).lt.dminneg.and.fourr(i).gt.xmapmax*0.5.and.distr(i).gt.dminnegmin)then
       dminnegmin=distr(i)
       sigma1=distr(i)
     endif
   enddo
   isav=0
   dminnegmin=1.E+10     
   do i=1,nfourr
     if(distr(i).lt.dminneg.and.fourr(i).lt.0.0.and.distr(i).lt.dminnegmin)then
       dminnegmin=distr(i)
       isav=i
     endif
   enddo
   isav=0
   dminnegmin=1.E+10     
   do i=1,nfourr
     if(distr(i).lt.dminnegmin)then
       dminnegmin=distr(i)
       isav=i
     endif
   enddo
!corr   ndstep=2000
      !write(0,*)'NDSTEP=',np,product(np)
!!!! corr 
   ndstep = min(2000,size(nfourr2)) ! hydroflu con grid 1.0
!!!  corr 
   dstep=(distmax-distr(isav))/float(ndstep-1)
   do i=1,nfourr
    do k=1,ndstep
      dstep1=distr(isav)+(k-1)*dstep
      dstep2=distr(isav)+k*dstep
      if(k.eq.1)then
        dstep1=0.0
        dstep2=distr(isav)
      endif
      if(k.eq.ndstep)dstep2=distr(isav)+(k+1)*dstep
      if(distr(i).ge.dstep1.and.distr(i).lt.dstep2)then
         nfourr2(k)=nfourr2(k)+1
         if(fourr2(i).ge.0.0)nfourr2piu(k)=nfourr2piu(k)+1
         if(fourr2(i).lt.0.0)nfourr2meno(k)=nfourr2meno(k)+1
         distr2(k)=dstep2                  
         fourr2(k)=fourr2(k)+fourr(i)
         if(fourr2(i).ge.0.0)fourr2piu(k)=fourr2piu(k)+fourr(i)
         if(fourr2(i).lt.0.0)fourr2meno(k)=fourr2meno(k)+fourr(i)
         if((fourr(i)).gt.fourrmax(k))fourrmax(k)=fourr(i)
         if((fourr(i)).lt.fourrmin(k))fourrmin(k)=fourr(i)
         go to 150
      endif
    enddo
150  continue
    enddo
    do i=1,ndstep
       if(nfourr2(i).gt.0)then
          fourr2(i)=fourr2(i)/float(nfourr2(i))
          fourr2(i)=fourrmax(i)                            
       endif
    enddo
    isav=0
    do i=1,ndstep
       if(fourr2(i).lt.0.0.and.distr2(i).lt.2.5)then
         isav=i
         exit
       endif
    enddo
    if(isav.eq.0)then
       dminnegmin=1.E+10      
       do i=2,ndstep
         if(distr2(i).lt.dminpos.and.distr2(i).gt.0.8.and.fourr2(i).lt.dminnegmin)then
           dminnegmin=distr2(i)
           isav=i
           exit
         endif
       enddo
       if(dminneg.gt.1000.0)dminneg=distr2(isav)
    endif
    do i=1,ndstep
          if(distr2(i).gt.neg3.and.fourr2(i).gt.0.0)then
            distr2max=distr2(i-1)
            exit
          endif
    enddo
    do i=1,ndstep
       if(i.ge.isav)fourr2(i)=-fourr2(i)/xmapmax    
    enddo
    fourr2(1:isav-1)=0.0
      do i=1,ndstep
          if(distr2(i).gt.7.0)fourr2(i)=0.0
           !if(maxval(no(1:nk)).gt.17.and.distr2(i).gt.4.0)fourr2(i)=0.0
      enddo
    isav=0
    do i=2,ndstep
       if(distr2(i).gt.dminpos.and.fourr2(i).gt.0.0)then
         isav=i
         exit
       endif
    enddo
    do i=1,ndstep
       if(nfourr2(i).gt.0)then
          nmapcor=nmapcor+1
          mapcor(1,nmapcor)=distr2(i)
          mapcor(2,nmapcor)=fourr2(i)*coe
       endif
    enddo
!!!!555  continue
   isav1=0
   isav2=0
   do i=1,nmapcor
          if(abs(mapcor(2,i)).gt.0.0)then
            isav1=i
            exit
          endif
   enddo
   do i=nmapcor,1,-1
          if(abs(mapcor(2,i)).gt.0.0)then
            isav2=i
            exit
          endif
   enddo
   mapcor(2,1:isav1-1)=0.0
   !write(6,'(3a)')' Rho Correction Function  ','        dist      ','     Corr        '
   !do i=1,nmapcor
   !       !if(maxval(no(1:nk)).gt.17)mapcor(2,i)=mapcor(2,i)
   !      write(6,'(a,2f15.5)')' Rho Correction Function  ',mapcor(1:2,i)
   !enddo
   nats=natbb
   call fillatom(atm)
   return
   end subroutine indagamappa
  !-------------------------------------------------------------------
   subroutine modificamappa(xmap2,dminneg,nmapcor,sigma1,coderbm,kevent)
   USE General, only : cell,celem,spacegr
   USE unit_cell
   USE CGEOM
   USE variables, only : atm
   USE Symmetry, only : icent,nsym
   USE ParametriMappa, only : np
   USE Atomi
   USE RefinecomRef
   USE PhaseModule, only : aperc
   USE PRNUTIL
   USE Molcom, only : jscreen
   USE atom_type_util
   USE messagemod
   USE fourier_mod
   USE elements, only: Cl_at
!
   integer                                        :: i,natbb                                         
   integer, intent(in)                            :: coderbm
   integer, intent(out)                           :: kevent
   type(atom_type), dimension(nats*2)             :: atx
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)-1) :: xmap2
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)-1) :: xmap
   real, dimension(2)                             :: vet              
   real, dimension(np(1)*np(2)*np(3),2)           :: rho
   integer                                        :: nrho
   real,dimension(3,3)                            :: gg               
   real, dimension(3)                             :: xo,xo1
   real, dimension(nats*2)                             :: xmapmax
   real                                           :: dx,dy,dz
   integer                                        :: j,k,kt,ifi,ifin
   real                                           :: xx1,yy1,zz1
   integer                                        :: ier
   integer                                        :: nmapcor
   integer                                        :: ii,j1,j2,j3,j1sav,j2sav,j3sav
   integer                                        :: j11sav,j22sav,j33sav
   real,dimension(3)                              :: xeq
   real                                           :: d
   real                                           :: dmin,coef,dminneg,dminnegmin
   integer                                        :: isav
   real                                           :: sigma1,yk,sigma1savv,coeff,dmins
   real                                           :: peso,erre,erremin,sum1,sum2,yksav,sigma1sav,y
   real,dimension(2)                              :: dmat,amt
   integer,dimension(2)                           :: indx
   real,dimension(2,2)                            :: amat
   integer                                        :: natssav,ncic
   integer                                        :: jj1,jj2,jj3 
   real, dimension(8)                             :: on
   !corr real,dimension(3,nsym*2*ncentr)                :: xequiv
   real,dimension(3,nsym*2*spacegr%nsymop)        :: xequiv
   integer                                        :: nateq               
!
!!!!   if (jscreen > 0) call scrper('RBM Procedure: Map Correction in Direct Space',0,0)
   natssav=nats
   sigma1sav=sigma1
   gg = matrice_metrica(cell)
   vet(1)= 1.0
   vet(2)=-1.0
   ifin=icent+1
   xmap=xmap2
   dx=1.0/float(np(1))
   dy=1.0/float(np(2))
   dz=1.0/float(np(3))
   natbb=nats
!corr   atx(1:nats)%xc(1)=atm(1:nats)%xc(1)
!corr   atx(1:nats)%xc(2)=atm(1:nats)%xc(2)
!corr   atx(1:nats)%xc(3)=atm(1:nats)%xc(3)
!corr   atx(1:nats)%biso=atm(1:nats)%biso
!corr   atx(1:nats)%och=atm(1:nats)%och
!corr   atx(1:nats)%ocry=atm(1:nats)%ocry
!corr   atx(1:nats)%nz=atm(1:nats)%nz
   atx(1:nats)=atm(1:nats)
!corr
   ncic=0
 8 ncic=ncic+1
   coeff=0.5
   !coeff=1.0/4.0
   j=0
 9 j=j+1
   if (jscreen > 0) then
       call progress_bar_update()
   endif
   call gestione_eventi(kevent)
   if (kevent == 1 .or. kevent == 2) return
   xequiv=0.0
   dmins=10.0
   j1sav=0
   j2sav=0
   j3sav=0
   xo(1)=atx(j)%xc(1)
   xo(2)=atx(j)%xc(2)
   xo(3)=atx(j)%xc(3)
   if(xo(1).lt.0.0)xo(1)=1.0+xo(1)
   if(xo(2).lt.0.0)xo(2)=1.0+xo(2)
   if(xo(3).lt.0.0)xo(3)=1.0+xo(3)
   if(xo(1).gt.1.0)xo(1)=xo(1)-1.0
   if(xo(2).gt.1.0)xo(2)=xo(2)-1.0
   if(xo(3).gt.1.0)xo(3)=xo(3)-1.0
   jj1=int(xo(1)/dx)
   jj2=int(xo(2)/dy)
   jj3=int(xo(3)/dz)
   dmin=1.E+10   
   xmapmax(j)=0.0
   do j1=max(0,jj1-3),min(np(1)-1,jj1+3)
     do j2=max(0,jj2-3),min(np(2)-1,jj2+3)
       do j3=max(0,jj3-3),min(np(3)-1,jj3+3)
            xx1=float(j1)*dx
            yy1=float(j2)*dy
            zz1=float(j3)*dz
            xo1(1)=xx1
            xo1(2)=yy1
            xo1(3)=zz1
            d= xdisteq(xo(:3),xo1(:3),gg)
            if(d.lt.dmin.and.xmap2(j1,j2,j3).gt.xmapmax(j)) then
                   dmin=d
                   j1sav=j1
                   j2sav=j2
                   j3sav=j3
            endif
       enddo
     enddo
   enddo
   xmapmax(j)=xmap2(j1sav,j2sav,j3sav)
   j11sav=j1sav
   j22sav=j2sav
   j33sav=j3sav
   j1sav=0
   j2sav=0
   j3sav=0
   do j1=max0(j11sav-1,0),min0(j11sav+1,np(1)-1)
     do j2=max0(j22sav-1,0),min0(j22sav+1,np(2)-1)
       do j3=max0(j33sav-1,0),min0(j33sav+1,np(3)-1)
          if(xmap2(j1,j2,j3).gt.xmapmax(j))then
             xmapmax(j)=xmap2(j1,j2,j3)
             j1sav=j1
             j2sav=j2
             j3sav=j3
          endif
       enddo
     enddo
   enddo
   if(j1sav.ne.0.and.j2sav.ne.0.and.j3sav.ne.0)then
     xo(1)=float(j1sav)*dx
     xo(2)=float(j2sav)*dy
     xo(3)=float(j3sav)*dz
   else
     xo(1)=float(j11sav)*dx
     xo(2)=float(j22sav)*dy
     xo(3)=float(j33sav)*dz
   endif
!!!!!!!!!!!!!!!!!!!!!!!!!
            nateq=0
            do kt=1,spacegr%ncoper
               do ifi=1,ifin
                coef=vet(ifi)
                do k=1,nsym
                 call xequi(xo,k,coef,xeq,kt)
                 nateq=nateq+1
                 xequiv(1:3,nateq)=xeq(1:3)
                enddo
               enddo
            enddo
!!!!!!!!!!!!!!!!!!!!!!!!!
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
            xo1(1)=float(j1)*dx
            xo1(2)=float(j2)*dy
            xo1(3)=float(j3)*dz
            dmin=1.E+10   
            do kt=1,nateq 
                 d= xdisteq(xequiv(:3,kt),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
            enddo
            do kt=1,nmapcor
               if(kt.eq.1)then
                 if(dmin.ge.0.0.and.dmin.lt.mapcor(1,kt).and.dmin.le.dmins)then
                   if(xmapmax(j).gt.0.0)xmap2(j1,j2,j3)=xmap2(j1,j2,j3)+xmapmax(j)*mapcor(2,kt)*coeff
                   exit
                 endif
               else
                 if(dmin.ge.mapcor(1,kt-1).and.dmin.lt.mapcor(1,kt).and.dmin.le.dmins)then
                   if(xmapmax(j).gt.0.0)xmap2(j1,j2,j3)=xmap2(j1,j2,j3)+xmapmax(j)*mapcor(2,kt)*coeff
                   exit
                 endif
               endif
            enddo
       enddo
     enddo
   enddo
   if(j.lt.natbb)go to 9
   aperc(1)=nats
   natold = nats
   call Search99(xmap2,0,ier,npref)
   call fslabel(2,0,2)
   natbb=nats
!corr   atx(1:nats)%xc(1)=atm(1:nats)%xc(1)
!corr   atx(1:nats)%xc(2)=atm(1:nats)%xc(2)
!corr   atx(1:nats)%xc(3)=atm(1:nats)%xc(3)
!corr   atx(1:nats)%biso=atm(1:nats)%biso
!corr   atx(1:nats)%och=atm(1:nats)%och
!corr   atx(1:nats)%ocry=atm(1:nats)%ocry
!corr   atx(1:nats)%nz=atm(1:nats)%nz
   atx(1:nats)=atm(1:nats)
!corr
   if(ncic.le.1)go to 8
   !if(ncic.le.3)go to 8
   ncic=0
!!!!!89 ncic=ncic+1
   ncic=ncic+1
   j=0
10 j=j+1
   j1sav=0
   j2sav=0
   j3sav=0
   xo(1)=atx(j)%xc(1)
   xo(2)=atx(j)%xc(2)
   xo(3)=atx(j)%xc(3)
   if(xo(1).lt.0.0)xo(1)=1.0+xo(1)
   if(xo(2).lt.0.0)xo(2)=1.0+xo(2)
   if(xo(3).lt.0.0)xo(3)=1.0+xo(3)
   if(xo(1).gt.1.0)xo(1)=xo(1)-1.0
   if(xo(2).gt.1.0)xo(2)=xo(2)-1.0
   if(xo(3).gt.1.0)xo(3)=xo(3)-1.0
   jj1=int(xo(1)/dx)
   jj2=int(xo(2)/dy)
   jj3=int(xo(3)/dz)
   dmin=1.E+10   
   xmapmax(j)=0.0
   do j1=max(0,jj1-3),min(np(1)-1,jj1+3)
     do j2=max(0,jj2-3),min(np(2)-1,jj2+3)
       do j3=max(0,jj3-3),min(np(3)-1,jj3+3)
            xx1=float(j1)*dx
            yy1=float(j2)*dy
            zz1=float(j3)*dz
            xo1(1)=xx1
            xo1(2)=yy1
            xo1(3)=zz1
            d= xdisteq(xo(:3),xo1(:3),gg)
            if(d.lt.dmin.and.xmap2(j1,j2,j3).gt.xmapmax(j)) then
                   dmin=d
                   j1sav=j1
                   j2sav=j2
                   j3sav=j3
            endif
       enddo
     enddo
   enddo
   xmapmax(j)=xmap2(j1sav,j2sav,j3sav)
   j11sav=j1sav
   j22sav=j2sav
   j33sav=j3sav
   j1sav=0
   j2sav=0
   j3sav=0
   do j1=max0(j11sav-1,0),min0(j11sav+1,np(1)-1)
     do j2=max0(j22sav-1,0),min0(j22sav+1,np(2)-1)
       do j3=max0(j33sav-1,0),min0(j33sav+1,np(3)-1)
          if(xmap2(j1,j2,j3).gt.xmapmax(j))then
             xmapmax(j)=xmap2(j1,j2,j3)
             j1sav=j1
             j2sav=j2
             j3sav=j3
          endif
       enddo
     enddo
   enddo
   if(j1sav.ne.0.and.j2sav.ne.0.and.j3sav.ne.0)then
     xo(1)=float(j1sav)*dx
     xo(2)=float(j2sav)*dy
     xo(3)=float(j3sav)*dz
   else
     xo(1)=float(j11sav)*dx
     xo(2)=float(j22sav)*dy
     xo(3)=float(j33sav)*dz
   endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            nateq=0
            do kt=1,spacegr%ncoper
               do ifi=1,ifin
                coef=vet(ifi)
                do k=1,nsym
                 call xequi(xo,k,coef,xeq,kt)
                 nateq=nateq+1
                 xequiv(1:3,nateq)=xeq(1:3)
                enddo
               enddo
            enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   sigma1=sigma1sav
   yk=sigma1*sqrt(2.0*pi)*xmapmax(j) 
   nrho=0
   rho=0.0
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
            xo1(1)=float(j1)*dx
            xo1(2)=float(j2)*dy
            xo1(3)=float(j3)*dz
            dmin=1.E+10   
            do kt=1,nateq
                 d= xdisteq(xequiv(:3,kt),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
            enddo
            if(dmin.ge.0.0.and.dmin.le.dminneg)then
              nrho=nrho+1
              rho(nrho,1)=dmin
              rho(nrho,2)=xmap2(j1,j2,j3)
            endif
       enddo
     enddo
   enddo
   call ordinatab(rho(1:nrho,1:2),1)
   isav=1
   do i=2,nrho
     if(abs(rho(i,1)-rho(isav,1)).lt.0.001)then
        rho(isav,2)=(rho(i,2)+rho(isav,2))*0.5
        rho(i,1)=1000.0
     else
        isav=i
     endif
   enddo
   call ordinatab(rho(1:nrho,1:2),1)
   isav=0
   do i=1,nrho
     if(rho(i,1).gt.100.0)then
       isav=i-1
       exit
     endif
   enddo
   nrho=isav
   isav=0
   do i=1,nrho
     if(rho(i,2).lt.0.0)then
       isav=i-1
       exit
     endif
   enddo
   if(isav.eq.0)then
   isav=nrho
   do i=1,nrho
     if(rho(i,1).gt.dminneg)then
       isav=i-1
       exit
     endif
   enddo
   endif
   nrho=isav
   dminnegmin=rho(isav,1)
   if(maxval(rho(1:nrho,2)).le.0.0)go to 99
   isav=0
   do i=1,nrho
     if(rho(i,2).lt.maxval(rho(1:nrho,2))*0.5)then
       isav=i-1
       exit
     endif
   enddo
   if(isav.gt.1)then
      sigma1=rho(isav,1)
      yk=sigma1*sqrt(2.0*pi)*xmapmax(j)    
   else
      sigma1=sigma1sav
      yk=sigma1*sqrt(2.0*pi)*xmapmax(j) 
   endif
   erremin=9999999.0
   sigma1savv=sigma1
   yksav=yk
   do ii=1,10
        dmat=0.0
        amat=0.0
        amt=0.0
        erre=0.0
        sum1=0.0
        sum2=0.0
        do i=1,nrho
         if(rho(i,2).gt.0.0)then
         peso=1.0/(rho(i,2))
         amt(1)=(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2))
         amt(2)=yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2))*(rho(i,1)**2/sigma1**2-1.0)*(1.0/sigma1)
         dmat(1)=dmat(1)+(rho(i,2)-yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2)))*amt(1)*peso                
         dmat(2)=dmat(2)+(rho(i,2)-yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2)))*amt(2)*peso                
         amat(1,1)=amat(1,1)+amt(1)*amt(1)*peso                
         amat(1,2)=amat(1,2)+amt(1)*amt(2)*peso                
         amat(2,1)=amat(2,1)+amt(2)*amt(1)*peso                
         amat(2,2)=amat(2,2)+amt(2)*amt(2)*peso                
         endif
        enddo
        call LUDCMP(amat,2,2,INDX,D,ier)
        if (ier /= 0) exit
        call LUBKSB(amat,2,2,INDX,dmat)
            if((yk+dmat(1)).gt.0.0) yk=yk+dmat(1)
            if((sigma1+dmat(2)).gt.0.05) sigma1=sigma1+dmat(2)
          do i=1,nrho
            y=yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-rho(i,1)**2/(2.0*sigma1**2))
            sum1=sum1+abs(rho(i,2)-y)
            sum2=sum2+rho(i,2)
          enddo
          erre=sum1/sum2
          if(erre.lt.erremin)then
            erremin=erre
            yksav=yk
            sigma1savv=sigma1
          endif
          sigma1=sigma1savv
          yk=yksav
   enddo
      yk=sigma1*sqrt(2.0*pi)*xmapmax(j)*0.9
      sigma1=sigma1*0.8
   do j1=0,np(1)-1
     do j2=0,np(2)-1
       do j3=0,np(3)-1
            xo1(1)=float(j1)*dx
            xo1(2)=float(j2)*dy
            xo1(3)=float(j3)*dz
            dmin=1.E+10
            do kt=1,nateq
                 d= xdisteq(xequiv(:3,kt),xo1(:3),gg)
                 if(d.lt.dmin) dmin=d
            enddo
            if (coderbm.le.1) then
            if(dmin.ge.0.0.and.dmin.le.dminnegmin)then
              xmap2(j1,j2,j3)=yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-dmin**2/(2.0*sigma1**2))
            endif
            else
            if(dmin.ge.0.0.and.dmin.le.dminnegmin)then
              xmap2(j1,j2,j3)=yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-dmin**2/(2.0*sigma1**2))
              mapdif(j1,j2,j3)=mapdif(j1,j2,j3)-yk*(1.0/(sqrt(2.0*pi)*sigma1))*exp(-dmin**2/(2.0*sigma1**2))
            endif
            endif
       enddo
     enddo
   enddo
 99 continue
   if(j.lt.natbb)go to 10
!corr   if (maxval(no(:nk)) <= 17) then
   if (maxval(celem%z) <= Cl_at) then
       aperc(1) = natssav
       call Search99(xmap2,0,ier,npref)
       nz(:nats) = 100
       call label(nats,on)
       call MakeLab(1,nats)
       occpch(:nats) = 1.0
       call xyz_to_atom(atm,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,inte=xyzs(4,:),elem=celem)
   endif
   !aperc(1)=natssav
   !call Search99(xmap2,0,ier,npref)
   !nats=natbb
   !nats=natssav
   !call fillatom(atm)
   return
   end subroutine modificamappa
 !-------------------------------------------------------------------
   subroutine deleting(natsav,figurai1,figurai2,figurao1,figurao2,kprint)
   USE nr
   USE Atomi     
   USE genlsq
   USE RefinecomRef
   USE General, only : celem,spacegr,neutro
!corr   USE Symmetry, only : nsym,pts,icent
   USE variables, only: ref,atm
   USE atom_type_util
   USE conteggi, only:npunti
   USE stat, only:Rvalue
   USE reflection_type_util
   USE sinterface, only: fillatom
!
   integer, intent(in) :: kprint
   real                             :: sum1,sum2,figure,figureall,scal
   real                             :: figure2,figureall2
   integer, dimension(nats)         :: ncondist
   integer, dimension(nats)         :: nbuild
   integer, dimension(nats,nats*10)    :: atombuild
   real, dimension(nats)            :: rap1,rap2
   integer, dimension(npref)        :: overlap
   real, dimension(npref)           :: fs1,fs2
!corr   integer                          :: i,j,movrmax,movr,isav,num,movrm
   integer                          :: i,j,movrmax,isav,num,movrm
   real                             :: rap,rapp
   type(atom_type), dimension(:), allocatable :: atbb       ! contiene il modello migliore
   integer                          :: natbb         ! il numero di atomi del modello migliore
   integer                          :: l1,l2,i100
   integer                          :: kaction          
!corr   real                             :: amult    !!!corr,pi
   real                             :: figurai1,figurai2    
   real                             :: figurao1,figurao2    
   integer                          :: isav1,isav2,natsav,natc
!
    do i=1,nats
        atm(i)%xc=xyzs(:3,i)
    enddo
   natc = natom_cell(celem,neutro==0)
!corr   amult = pts * float(nsym * ( icent + 1 ) )
!corr   pi=4.0*datan(1.d0)
!corr   movr=minval(iabs(atm(:nats)%nz),mask=no(iabs(atm(:nats)%nz)/100)>1)
   natbb=nats
   call copy_atoms(atbb,atm)
   call fillatom(atm)
!!!!!   call to_coord(0)
   call sfcalc(ref,atm(:nats),spacegr,celem)
   call defovlexr2(overlap,0.7)
   movrmax=2
   movrm=maxval(overlap(1:npref))
   do i=1,movrm
      num=0
      do j=1,npref
        if(overlap(j).le.i)num=num+1
      enddo
      if(num.gt.nats*3*3)then
        movrmax=i
        go to 92
      endif
   enddo
92 continue
   if(movrmax.lt.2)movrmax=2
   i100=0
100 continue
   i100=i100+1
   if (kprint == 1) call to_coord(1)
   do j=1,npref
     fs1(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fo**2
     fs2(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fc**2
   enddo
   sum1=0.0
   sum2=0.0
   num=0
   do j=1,npref
          if(overlap(j).le.movrmax.and.weilsq(j).gt.0.0)then
            sum1=sum1+fs1(j)
            sum2=sum2+fs2(j)
            num=num+1
          endif
   enddo
   scal=sum1/sum2
   sum1=0.0
   do j=1,npref
          if(overlap(j).le.movrmax) then
            sum1=sum1+(weilsq(j)*(fs1(j)-scal*fs2(j)))**2
          endif
   enddo
   if (npunti > 0) then   ! se non ci sono i conteggi calcola RF
       call calcolaRwp(ref%fc,150.0)
   else
       errepw = Rvalue(ref%fo,ref%fc)
   endif
   figure2=errepw
   figure=sum1
   rap=0.85
   rapp=0.95
   rapp=1.4
   rapp=1.9
   if(i100.eq.1)figurai1=sum1   
   if(i100.eq.1)figurai2=errepw
   figureall=figure
   figureall2=figure2
   if (kprint == 1) write(6,'(/,a,2f25.5,3i6)')' Figure overall',figure,figure2,num,npref,movrmax
   kblock(1:nats)=0
   kaction=5 - kprint
   call maincl(kaction,0)
   kblock(1:nats)=1
   call avvisolati(5,0,5)
   do i=1,nats
        atm(i)%xc=xyzs(:3,i)
   enddo
   nbuild=0
   atombuild=0
   do j=1,iconn(1)
       l1=iconn((j-1)*3+2)
       l2=iconn((j-1)*3+3)
         nbuild(l1)=nbuild(l1)+1
         atombuild(l1,nbuild(l1))=l2
         nbuild(l2)=nbuild(l2)+1
         atombuild(l2,nbuild(l2))=l1
   enddo
   ncondist(:nats)=0
   isav=0
   isav1=0
   isav2=0
   do i=natsav,natbb
     if(nbuild(i).gt.1.and.i.le.natbb/2)cycle
     if(i.le.natbb/3)cycle
     nats=natbb
     call copy_atoms(atm,atbb)
     ncondist(i)=1
     call remove_atoms(ncondist(1:nats))
     call fillatom(atm)
     if (kprint == 1) call to_coord(0)
!corr     call fcalcan(ref,atm(:nats))
     call sfcalc(ref,atm(:nats),spacegr,celem)
     do j=1,npref
       fs1(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fo**2
       fs2(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fc**2
     enddo
     sum1=0.0
     sum2=0.0
     do j=1,npref
          if(overlap(j).le.movrmax.and.weilsq(j).gt.0.0)then
            sum1=sum1+fs1(j)
            sum2=sum2+fs2(j)
          endif
     enddo
     scal=sum1/sum2
     sum1=0.0
     do j=1,npref
          if(overlap(j).le.movrmax) then
            sum1=sum1+(weilsq(j)*(fs1(j)-scal*fs2(j)))**2
         endif
     enddo
     if (npunti > 0) then   ! se non ci sono i conteggi calcola RF
         call calcolaRwp(ref%fc,150.0)
         figure2=errepw
     else
         figure2 = Rvalue(ref%fo,ref%fc)
     endif
     figure=sum1
     rap1(i)=figure/figureall
     rap2(i)=figure2/figureall2
     ncondist=0
     if(rap1(i)*rap2(i).lt.rapp.and.(rap1(i).lt.1.05.and.rap2(i).lt.1.05))then
       rapp=rap1(i)*rap2(i)
       isav1=i
       isav2=i
     endif
     !write(6,*)'              '
     !write(6,'(a,i3,4f8.3)')'Figure eliminated atom ',i,rap1(i),rap,rap2(i),rapp
     ncondist(1:nats)=0
     call fillatom(atm)
     if (kprint == 1) call to_coord(0)
!corr     call fcalcan(ref,atm(:nats))
     call sfcalc(ref,atm(:nats),spacegr,celem)
     do j=1,npref
       fs1(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fo**2
       fs2(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fc**2
     enddo
     sum1=0.0
     sum2=0.0
     do j=1,npref
          if(overlap(j).le.movrmax.and.weilsq(j).gt.0.0)then
            sum1=sum1+fs1(j)
            sum2=sum2+fs2(j)
          endif
     enddo
     scal=sum1/sum2
     sum1=0.0
     do j=1,npref
          if(overlap(j).le.movrmax) then
            sum1=sum1+(weilsq(j)*(fs1(j)-scal*fs2(j)))**2
          endif
     enddo
     if (npunti > 0) then   ! se non ci sono i conteggi calcola RF
         call calcolaRwp(ref%fc,150.0)
         figure2=errepw
     else
         figure2 = Rvalue(ref%fo,ref%fc)
     endif
     figure=sum1
     rap1(i)=figure/figureall
     rap2(i)=figure2/figureall2
     ncondist=0
     if(rap1(i)*rap2(i).lt.rapp.and.(rap1(i).lt.1.05.and.rap2(i).lt.1.05))then
       rapp=rap1(i)*rap2(i)
       isav1=i
       isav2=i
     endif
     !write(6,*)'              '
     !write(6,'(a,i3,4f8.3)')'Figure eliminated atom ',i,rap1(i),rap,rap2(i),rapp
     ncondist(1:nats)=0
     call fillatom(atm)
!corr     call fcalcan(ref,atm(:nats))
     call sfcalc(ref,atm(:nats),spacegr,celem)
   enddo
   nats=natbb
   call copy_atoms(atm,atbb)
   if(isav1.gt.0.and.isav2.gt.0.and.isav1.eq.isav2)then
      ncondist=0
      ncondist(isav1)=1
      call remove_atoms(ncondist(1:nats))
      isav=isav1
   elseif(isav1.gt.0.and.isav2.gt.0.and.isav1.ne.isav2)then
      if(rap.lt.0.5*rapp)then
        ncondist=0
        ncondist(isav1)=1
        call remove_atoms(ncondist(1:nats))
        isav=isav1
      else
        ncondist=0
        ncondist(isav2)=1
        call remove_atoms(ncondist(1:nats))
        isav=isav2
      endif
   elseif(isav1.gt.0.and.isav2.eq.0)then
          ncondist=0
          ncondist(isav1)=1
          call remove_atoms(ncondist(1:nats))
          isav=isav1
   elseif(isav2.gt.0.and.isav1.eq.0)then
           ncondist=0
           ncondist(isav2)=1
           call remove_atoms(ncondist(1:nats))
           isav=isav2
   endif
   natbb=nats
   do i=1,natbb
      atbb(i)%xc   = atm(i)%xc
      atbb(i)%biso = atm(i)%biso
      atbb(i)%och  = atm(i)%och
      atbb(i)%ocry = atm(i)%ocry
      !atbb(i)%nz   = atm(i)%nz
      call atbb(i)%set_specie(atm(i)%get_nz(),celem)
   enddo
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm(:nats),spacegr,celem)
   if (kprint == 1) call to_coord(1)
   do j=1,npref
       fs1(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fo**2
       fs2(j) = ref(j)%m*ref(j)%lp(1)*ref(j)%fc**2
   enddo
   sum1=0.0
   sum2=0.0
   do j=1,npref
      if(overlap(j).le.movrmax.and.weilsq(j).gt.0.0)then
        sum1=sum1+fs1(j)
        sum2=sum2+fs2(j)
      endif
   enddo
   scal=sum1/sum2
   sum1=0.0
   do j=1,npref
          if(overlap(j).le.movrmax) then
            sum1=sum1+(weilsq(j)*(fs1(j)-scal*fs2(j)))**2
          endif
   enddo
   call calcolaRwp(ref%fc,150.0)
   if (kprint == 1) write(6,'(/,a,2f25.5)')' Figure after deleting ',sum1,errepw
!corr   if(isav.gt.0.and.float(nats).gt.0.9*(float(natc)/amult))go to 100
   if(isav.gt.0.and.float(nats).gt.0.9*(float(natc)/spacegr%nsymop))go to 100
   figurao1=sum1
   figurao2=errepw
   return
   end subroutine deleting
  !-------------------------------------------------------------------

   subroutine modifica_modello(kpr)
   USE RefinecomRef
   USE variables, only: ref,atm
   USE Atomi, only:nats
   USE general, only: spacegr,celem
   USE reflection_type_util
   integer, intent(in)         :: kpr
   real                        :: scal
   integer, dimension(nats)    :: ncondist
   integer                     :: i
!
   scal = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
   errefs = sum(abs(ref(:npref)%fo - scal*ref(:npref)%fc))/sum(ref(:npref)%fo)
   if (kpr == 1) call to_coord(1)
   i=0
   do
     i=i+1
     call treatmodel_new(atm(:nats),ncondist)
     if(all(ncondist(1:nats)==0))exit
     call remove_atoms(ncondist(1:nats))
     call sfcalc(ref,atm,spacegr,celem)
     scal = sum (ref(:npref)%fo) / sum (ref(:npref)%fc)
     errefs = sum(abs(ref(:npref)%fo - scal*ref(:npref)%fc))/sum(ref(:npref)%fo)
     if(kpr == 1) call to_coord(1)
   enddo
!
   end subroutine modifica_modello

  !-------------------------------------------------------------------

   subroutine wdfanalysis(yoss,wei,df,nbin)
   USE nr
!
   real, dimension(:), intent(in)    :: yoss
   real, dimension(:), intent(in)    :: wei
   real, dimension(:), intent(in)    :: df
   real, dimension(size(yoss))       :: yossc
   real, dimension(size(yoss))       :: weic
   real, dimension(size(yoss))       :: dfc
   integer, intent(in)               :: nbin
   integer                           :: n
   integer                           :: wint
   integer                           :: kinf,ksup
   integer                           :: nb,i
   real, allocatable                 :: ym(:),sdf(:),swdf(:)
   integer, allocatable              :: noss(:)
   real                              :: s1,s2
   integer, dimension(size(yoss))    :: iorder
!
   n = size(wei)
   call indexx(yoss,iorder)
   yossc(:n) = yoss(iorder)
   weic(:n) = wei(iorder)
   dfc(:n) = df(iorder)
!
   allocate(ym(nbin+1),sdf(nbin+1),swdf(nbin+1),noss(nbin+1))
   wint = n / nbin + 1
   write(6,5)
   nb = 0
   do
      nb = nb + 1
      kinf = (nb-1)*wint+1
      if (kinf > n) then
          nb = nb - 1
          exit
      endif
      ksup = min(kinf+wint-1,n)
      ym(nb) = (yossc(kinf) + yossc(ksup)) / 2.0
      noss(nb) = ksup - kinf + 1
      sdf(nb) = sum(dfc(kinf:ksup)**2)
      swdf(nb) = sum(weic(kinf:ksup)*df(kinf:ksup)**2)
   enddo
!
!  Stampa tabella riscalando
!
   s1 = sum(sdf(:nb))
   s2 = sum(swdf(:nb))
   sdf(:nb) = nb*sdf(:nb) / s1
   swdf(:nb) = nb*swdf(:nb) / s2
   do i=1,nb
      write(6,10)ym(i),noss(i),sdf(i),swdf(i)
   enddo
!
 5 format('               Analysis of w*DF**2',/,                     &
          '   ===============================================',/,     &
          '   Interval     Number of obs.    DF**2    w*DF**2',/)
10 format(2x,f12.3,8x,i4,6x,f8.3,4x,f8.3)
!
   end subroutine wdfanalysis

 !-------------------------------------------------------------------

   subroutine calcolaRwp(fc,maxdg0)
   USE CalcProfile
   USE Counts
   USE Conteggi
   USE General, only : nrefl,rtod,alambda
   USE nr
   USE variables, only : ref
   USE arrayutil
   USE xdataMod, only: clp0
   USE extramodule, only: inizc,ifinc
   USE commandsmod
   USE comandiexpo, only: icomat
   USE stat, only: Rvalue
!
   real, dimension(:), intent(in) :: fc
   real, intent(in)               :: maxdg0
   real                           :: maxdg
   integer, dimension(size(fc))   :: mult
   real, dimension(size(fc))      :: fcc
   integer                        :: i,j
   integer                        :: ier
   real, allocatable              :: ycountcalc(:),weig(:),ttetac(:),ycoss(:)
   integer                        :: iniz,ifin
   real                           :: ffx,scal,sumyow
   real                           :: ttmax,rappo
   integer,save                   :: isav
   integer, dimension(size(fc))   :: iorder
   integer                        :: ncs
     integer :: nreflsav

   if (npunti == 0) then
       errepw = 0
       return  ! conteggi assenti per direttiva ref2 attiva
   endif
!  this line is for new extraction
   if (command_is_before(commands,EXTRA_CMD,icomat) == 0) then
       errepw = Rvalue(ref%fo,ref%fc)
       return
   endif
   !if (ngr /= 0) then
       call indexx(ref(:nrefl)%tthd(1),iorder)
       fcc = fc(iorder)
   !else
   !    fcc = fc
   !endif
   isav=0
   if (.not.kload12) then
       rappo=1.0
!!!!!corrr
      nreflsav = nrefl
!!!!!corrr-perche' azzera il calcolato
!!!       call LoadList12(rappo,0,ier)
!!!!!corrr
      nrefl = nreflsav
!!!!!corrr
       !!!!ttmax=2.0*asin(lambda(1)/4.0)*rtod
       ttmax=2.0*asin(alambda/4.0)*rtod
       do i=1,npunti
       call indexx(ref(:nrefl)%tthd(1),iorder)
          if(theta_int(i,1).gt.ttmax)then
             isav=i
             exit
          endif
       enddo
       call CalcProfleast(ier)
       kload12 = .TRUE.
   endif
   if(isav.eq.0)isav=npunti
   allocate(ycountcalc(npunti),weig(npunti),ttetac(npunti),ycoss(npunti))
   mult = ref(:)%m
   ycoss(:) = theta_int(:npunti,2)
   ttetac    = theta_int(:npunti,7)
   maxdg = min(maxdg0,ttetac(isav))
!!!!corr
   !ncs = nint((maxdg-ttetac(1)) / thstep) + 1
   !if (ncs > npunti) ncs = npunti
   ncs = clocate(ttetac,maxdg)
!!!!corr
   ycountcalc = 0.0
   do i=1,nrefl
      ffx=mult(i)*clp0(i)*(fcc(i)**2)
      iniz = inizc(i); ifin = ifinc(i)
      do j=iniz,ifin
         ycountcalc(j)=ycountcalc(j)+ffx*profcalc(i,j-iniz+1)
      enddo
   enddo
   scal = sum(ycoss(:ncs)-back_int(:ncs,1)) / sum(ycountcalc(:ncs))


   where (ycoss(:ncs) > 0.0)
          weig(:ncs) = 1.0/ycoss(:ncs)
   elsewhere
          weig(:ncs) = 1.0
   endwhere
   sumyow = sum(weig(:ncs)*ycoss(:ncs)**2)
   errepw = sum(weig(:ncs)*abs(ycoss(:ncs) - scal*ycountcalc(:ncs) - back_int(:ncs,1))**2) / sumyow
   errepw=100.0*sqrt(errepw)
   end subroutine calcolaRwp

 !-------------------------------------------------------------------
   subroutine calcrint(ovr,tteta,mult,lp,fs,fwhm,intg)
   integer, parameter  :: dpp = selected_real_kind(15,307)
   integer, dimension(:), intent(in)       :: ovr
   real, dimension(:), intent(in)         :: tteta
   integer, dimension(:), intent(in)       :: mult
   real, dimension(:), intent(in)          :: lp
   real, dimension(:), intent(in)          :: fs
   real, dimension(size(ovr)), intent(in)  :: fwhm
   real(dpp), dimension(size(ovr)), intent(out) :: intg
   integer                                 :: numb
     integer                        :: inv
     integer                        :: i,j,k
     real                           :: essee
     real                           :: qq
!
   numb = size(ovr)
      do i=1,numb
        if(ovr(i) > 0)then
          inv=ovr(i)-1
          do j=0,inv
             essee=0.0
             do k=0,inv
                  qq=abs(tteta(i+k)-tteta(i+j))/(fwhm(i+j))
                  if(qq.gt.1.0) qq=1.0
                  essee = essee + (1-qq**2)*mult(i+k)*lp(i+k)*(fs(i+k)**2)
             enddo
             intg(i+j)=essee
          enddo
         endif
       enddo
!
   end subroutine calcrint
 !-------------------------------------------------------------------

   subroutine setgwei()
!corr   USE refinecomref
   USE genlsq
!corr   USE nr
   USE General, only: nrefl
   USE variables, only : ref
!corr   USE Factor
!corr   USE nr                
!
   integer                 :: i
   integer, parameter      :: dpp = selected_real_kind(15,307)
   real(dpp), allocatable  :: bh(:)
   integer, allocatable    :: overl(:)
   real(dpp), allocatable  :: integc(:)     ! intensit� calcolata
   real(dpp), allocatable  :: intego(:)     ! intensit� ossservata
   real(dpp), allocatable  :: ww1(:),ww2(:)
   real                 :: rh
   real, dimension(nrefl)                         :: wbias
!
   allocate(bh(npref),overl(npref))
   allocate(intego(npref),integc(npref),ww1(npref),ww2(npref))
!corr   if(.not.allocated(wprint))allocate(wprint(npref))
   call defovlexrN(overl,0.7)
   call calcrint(overl,ref%tthd(1),ref%m,ref%lp(1),ref%fo,ref%fwhm(1),bh)
   do i=1,npref
      intego(i) = ref(i)%m*ref(i)%lp(1)*(ref(i)%fo**2)
      integc(i) = ref(i)%m*ref(i)%lp(1)*ref(i)%fo
      if(intego(i)>0.0_dpp)then
        ww1(i)=1.0/(1.0_dpp+4.0_dpp*(integc(i)**2))
        ww2(i)=sqrt(intego(i)/bh(i))
        if(ww2(i).lt.0.2_dpp)ww2(i)=0.2_dpp
        ww2(i)=ww2(i)*exp(-0.5*(ref(i)%slaq))
        weilsq(i) = sqrt(ww1(i)*ww2(i))
        rh=ref(i)%slaq
        rh=sqrt(rh)
        wbias(i)=(corfscat(1)+corfscat(2)*rh+corfscat(3)*(rh**2.0)+corfscat(4)*(rh**3.0)+corfscat(5)*(rh**4.0))
        !wprint(i)=ww2(i)*(wbias(i))
        wprint(i)=ww2(i)
        weilsq(i)=weilsq(i)
      else
        weilsq(i) = 0.0
        wprint(i)=0.0
      endif
   enddo
   end subroutine setgwei

 !-------------------------------------------------------------------

   subroutine setgwei_onlywprint()
   USE refinecomref
   USE genlsq
   USE nr
   USE variables, only : ref
!corr   USE Factor
   USE nr                
!
   integer                 :: i
   integer, parameter      :: dpp = selected_real_kind(15,307)
   real(dpp), allocatable  :: bh(:)
   integer, allocatable    :: overl(:)
   real(dpp), allocatable  :: integc(:)     ! intensit� calcolata
   real(dpp), allocatable  :: intego(:)     ! intensit� ossservata
   real(dpp), allocatable  :: ww1(:),ww2(:)
!
   allocate(bh(npref),overl(npref))
   allocate(intego(npref),integc(npref),ww1(npref),ww2(npref))
!corr   if(.not.allocated(wprint))allocate(wprint(npref))
   call defovlexrN(overl,0.7)
   call calcrint(overl,ref%tthd(1),ref%m,ref%lp(1),ref%fo,ref%fwhm(1),bh)
   do i=1,npref
      intego(i) = ref(i)%m*ref(i)%lp(1)*(ref(i)%fo**2)
      integc(i) = ref(i)%m*ref(i)%lp(1)*ref(i)%fo
      if(intego(i)>0.0_dpp)then
        ww2(i)=sqrt(intego(i)/bh(i))
        if(ww2(i).lt.0.2_dpp)ww2(i)=0.2_dpp
        ww2(i)=ww2(i)*exp(-0.5*(ref(i)%slaq))
        wprint(i)=ww2(i)
      else
        wprint(i)=0.0
      endif
   enddo
   end subroutine setgwei_onlywprint

 !-------------------------------------------------------------------

   subroutine statfsnew()
   USE refinecomref
   USE variables, only:ref
   integer              :: nrini,nrfin
   real, allocatable    :: ttgr(:),intev(:),inteo(:)
   integer              :: ng
!
   select case (typeref)
       case (INTREF,GR_AND_REF)
           allocate(intev(npref),inteo(npref))
           intev(:) = ref(:npref)%m*ref(:npref)%lp(1)*ref(:npref)%fv**2
           inteo(:) = ref(:npref)%m*ref(:npref)%lp(1)*ref(:npref)%fo**2
           call statfs(ref(:npref)%tthd(1),inteo(:npref),intev(:npref),noverl(:npref)) 

       case (GRUREF)
           allocate(ttgr(ngr),intev(ngr))
           do ng=1,ngr
              nrini = gref(ng)%vref(1) 
              nrfin = gref(ng)%vref(gref(ng)%code)
              intev(ng) = sum(ref(nrini:nrfin)%m*ref(nrini:nrfin)%lp(1)*ref(nrini:nrfin)%fv**2)
              ttgr(ng) = ( ref(nrfin)%tthd(1) + ref(nrini)%tthd(1) ) / 2  ! il 2-theta del gruppo
           enddo
           call statfs(ttgr(:ngr),gref(:ngr)%Io,intev(:ngr),gref(:ngr)%code) 

       case (FREF)
           call statfs(ref(:npref)%tthd(1),ref(:npref)%fo,ref(:npref)%fv,noverl(:npref)) 
   end select
!
   end subroutine statfsnew

  !----------------------------------------------------------------------------------------------------

   subroutine treatmodel_new(atx,ncondist)
   USE General, only : cell,rtod,dtor,neutro,spacegr,celem
   USE RefinecomRef
   USE NR
   USE Atomi, only : nzConst,nats
   USE Symmetry, only : icent,nsym
   USE variables, only:atm
   USE unit_cell
   USE CGEOM
   USE elements, only: numelem
   type atom_cella
      real, dimension(3) :: co
      integer            :: ag
   end type atom_cella
   type legame
      integer a1
      integer a2
   end type legame
!
   type(atom_type), dimension(:), intent(in)                        :: atx ! x(1:4,1:n) = il modello
   real, dimension(size(atx))                                   :: rx  ! raggio degli atomi
   integer, dimension(size(atx)), intent(out)    :: ncondist
   real, dimension(size(atx))    :: ord1
   real, dimension(size(atx))    :: wdist
   integer, dimension(size(atx))    :: iord2
   integer, dimension(size(atx))    :: icare
   integer, dimension(size(atx))    :: ncondist2
   !type(atom_cella), dimension((icent+1)*nsym*ncentr*size(atx)) :: eq
   type(atom_cella), dimension(spacegr%nsymop*size(atx)) :: eq
   type(legame), allocatable                                    :: leg(:)
   integer                                                      :: na
   integer                                                      :: i1,i2,i3,ii1
   integer                                                      :: i,ii,j,jj
   real                                                         :: dmin,dmax
   real, dimension(3,3)                                         :: gg
   !real, dimension(3,(icent+1)*nsym*ncentr)                     :: xeq
   real, dimension(3,spacegr%nsymop)                            :: xeq
   real, allocatable                                          :: tabdistapp(:,:)
   real, allocatable                                          :: tabangapp(:,:)
   real, allocatable                                          :: tabdist(:,:)
   real, allocatable                                          :: tabang(:,:)
   real, allocatable                                          :: distanzam(:,:)
   integer, dimension(size(atx))                               :: ndistanze
   integer, dimension(size(atx))                               :: ncentri
   integer, dimension(size(atx))                               :: nperif
   real                                                         :: dd,ang
   integer                                                      :: neq,neqa
   integer                                                      :: nleg
   real                                                         :: tol,angmin,angmax,bmed
   real                                                         :: tol2,peso
   integer                                                      :: numdistapp,numangapp
   integer                                                      :: numdist,numang
   integer                                                      :: nb,ncare,isav
   integer                                                      :: nv,nv2
   integer,dimension(1)                                         :: lmin

   gg = matrice_metrica(cell)
   wdist=0.0
!
   na = size(atx)                    ! num. di atomi
   !corr rx=radii(iabs(atm(:nats)%nz)/nzConst,1)
   rx=atm(:nats)%c_radius()
   tol = 0.3
   tol2 = tol+0.1
   neq=0
   do i=1,na
      call get_equivalent(atx(i)%xc,gg,spacegr,xeq,neqa)
      do j=1,neqa
         neq=neq+1
         eq(neq) = atom_cella(xeq(:3,j),i)
      enddo
   enddo
   nleg = 0
   do i=1,neq
      do j=i+1,neq
         dmin = (rx(eq(i)%ag) + rx(eq(j)%ag))*(1.0-tol)
         dmax = (rx(eq(i)%ag) + rx(eq(j)%ag))*(1.0+tol)
         dd = xdisteq(eq(i)%co,eq(j)%co,gg)
         if (dd > dmin .and. dd < dmax) then
             nleg = nleg + 1
         endif
      enddo
   enddo
   ncondist = 0
   if(nleg == 0) return 
   nv=nleg**2
   allocate(tabdistapp(nv,6),tabdist(nv,6))
   allocate(leg(nv))
!  if(neutro.eq.1)tol=0.2
!!!!corrado 333 continue 
!!!!corrado   ncondist=0 !spostato prima
   ncondist2=0
   numdistapp=0
   numangapp=0
   ncare=0
   bmed=0.0
   nb=0
   do i=1,na
     if(atx(i)%biso.lt.10.0.and.atx(i)%biso.gt.0.0)then
       bmed=bmed+atx(i)%biso
       nb=nb+1
     endif
   enddo
   if(nb.gt.0) then
      bmed = bmed/nb
   else
      bmed=3.0
   endif
!
!  alloca leg sul numero massimo possibile di legami = (neq**2 - neq)/2
!dariattivare   write(6,*)' ------------------------------------------------'
!dariattivare   write(6,*)'              Atoms  (a. u.)    '
!dariattivare   write(6,*)' ------------------------------------------------'
!dariattivare   do i=1,na
!dariattivare         write(6,'(3x,a5,i5,4f10.3)')aLab(i),i,x(:4,i)
!dariattivate   enddo
!  Genera e stampa tutti gli equivalenti
!  write(6,*)'              Atomi nella cella'
!  write(6,*)' ------------------------------------------------'
!  neq=0
!  do i=1,na
!     call  get_equivalent(x(:3,i),xeq,neqa)
!!     neq=neq+neqa
!!     nn = neqa*(i-1)
!      do j=1,neqa
!         neq=neq+1
!!        write(6,'(3x,a10,3f10.3)')strlab(aLab(i),neq),xeq(:3,j)
!         eq(neq) = atom_cella(xeq(:3,j),i)
!      enddo
!   enddo
!
!  Cerca e stampa i legami nella cella
!  write(6,*)'       Legame           distanza         min.          max.'
!  write(6,*)'-------------------------------------------------------------'
   nleg = 0
   angmin=50.0*dtor
   angmax=180.0*dtor
   do i=1,neq
      do j=i+1,neq
         dmin = (rx(eq(i)%ag) + rx(eq(j)%ag))*(1.0-tol)
         dmax = (rx(eq(i)%ag) + rx(eq(j)%ag))*(1.0+tol)
         dd = xdisteq(eq(i)%co,eq(j)%co,gg)
            !write(6,'(3x,2a10,f10.3,3x,2f10.3)')strlab(atx(eq(i)%ag)%lab,i),strlab(atx(eq(j)%ag)%lab,j),dd,dmin,dmax
         if (dd > dmin .and. dd < dmax) then
!
!            memorizza e stampa il legame
             nleg = nleg + 1
             leg(nleg) = legame(i,j)
            !write(6,'(3x,2a10,f10.3,3x,2f10.3)')strlab(atx(eq(i)%ag)%lab,i),strlab(atx(eq(j)%ag)%lab,j),dd,dmin,dmax
            !write(6,'(3x,2i10,f10.3,3x,2f10.3)')eq(i)%ag,eq(j)%ag,dd,dmin,dmax
             numdistapp=numdistapp+1
             tabdistapp(numdistapp,1)=real(eq(i)%ag)
             tabdistapp(numdistapp,2)=real(eq(j)%ag)
             tabdistapp(numdistapp,3)=dd
             tabdistapp(numdistapp,4)=dmin
             tabdistapp(numdistapp,5)=dmax
             tabdistapp(numdistapp,6)=abs(tabdistapp(numdistapp,3)-(dmin+dmax)*0.5)/((dmin+dmax)*0.5)
         endif
      enddo
   enddo
!Rosanna
   if(nleg == 0) return 
!Rosanna
!
!  Cerca legami contigui e determina l'angolo.
!  write(6,*)'       Atomi                    angolo'
!  write(6,*)'-----------------------------------------------'
   nv2=numdistapp**2
   allocate(tabangapp(nv2,5),tabang(nv2,5))
   do i=1,nleg
      do j=i+1,nleg
         if (leg(i)%a1 == leg(j)%a1) then
             ang = angoloeq(eq(leg(i)%a2)%co,eq(leg(i)%a1)%co,eq(leg(j)%a2)%co,gg)
!            write(6,'(3x,3a10,f10.2)')strlab(aLab(eq(leg(i)%a2)%ag),leg(i)%a2),strlab(aLab(eq(leg(i)%a1)%ag),leg(i)%a1),      &
!                         strlab(aLab(eq(leg(j)%a2)%ag),leg(j)%a2),ang*rtod
!            write(6,'(3x,3i10,f10.2)')eq(leg(i)%a2)%ag,eq(leg(i)%a1)%ag,eq(leg(j)%a2)%ag,ang*rtod
         numangapp=numangapp+1
         tabangapp(numangapp,1)=real(eq(leg(i)%a2)%ag)
         tabangapp(numangapp,2)=real(eq(leg(i)%a1)%ag)
         tabangapp(numangapp,3)=real(eq(leg(j)%a2)%ag)
         tabangapp(numangapp,4)=ang*rtod
         tabangapp(numangapp,5)=tabdistapp(i,6)+tabdistapp(j,6)
         elseif (leg(i)%a1 == leg(j)%a2) then
             ang = angoloeq(eq(leg(i)%a2)%co,eq(leg(i)%a1)%co,eq(leg(j)%a1)%co,gg)
!            write(6,'(3x,3a10,f10.2)')strlab(aLab(eq(leg(i)%a2)%ag),leg(i)%a2),strlab(aLab(eq(leg(i)%a1)%ag),leg(i)%a1),      &
!                         strlab(aLab(eq(leg(j)%a1)%ag),leg(j)%a1),ang*rtod
!            write(6,'(3x,3i10,f10.2)')eq(leg(i)%a2)%ag,eq(leg(i)%a1)%ag,eq(leg(j)%a1)%ag,ang*rtod
         numangapp=numangapp+1
         tabangapp(numangapp,1)=real(eq(leg(i)%a2)%ag)
         tabangapp(numangapp,2)=real(eq(leg(i)%a1)%ag)
         tabangapp(numangapp,3)=real(eq(leg(j)%a1)%ag)
         tabangapp(numangapp,4)=ang*rtod
         tabangapp(numangapp,5)=tabdistapp(i,6)+tabdistapp(j,6)
         elseif (leg(i)%a2 == leg(j)%a1) then
             ang = angoloeq(eq(leg(i)%a1)%co,eq(leg(i)%a2)%co,eq(leg(j)%a2)%co,gg)
!            write(6,'(3x,3a10,f10.2)')strlab(aLab(eq(leg(i)%a1)%ag),leg(i)%a1),strlab(aLab(eq(leg(i)%a2)%ag),leg(i)%a2),      &
!                         strlab(aLab(eq(leg(j)%a2)%ag),leg(j)%a2),ang*rtod
!            write(6,'(3x,3i10,f10.2)')eq(leg(i)%a1)%ag,eq(leg(i)%a2)%ag,eq(leg(j)%a2)%ag,ang*rtod
         numangapp=numangapp+1
         tabangapp(numangapp,1)=real(eq(leg(i)%a1)%ag)
         tabangapp(numangapp,2)=real(eq(leg(i)%a2)%ag)
         tabangapp(numangapp,3)=real(eq(leg(j)%a2)%ag)
         tabangapp(numangapp,4)=ang*rtod
         tabangapp(numangapp,5)=tabdistapp(i,6)+tabdistapp(j,6)
         elseif (leg(i)%a2 == leg(j)%a2) then
             ang = angoloeq(eq(leg(i)%a1)%co,eq(leg(i)%a2)%co,eq(leg(j)%a1)%co,gg)
!            write(6,'(3x,3a10,f10.2)')strlab(aLab(eq(leg(i)%a1)%ag),leg(i)%a1),strlab(aLab(eq(leg(i)%a2)%ag),leg(i)%a2),      &
!                         strlab(aLab(eq(leg(j)%a1)%ag),leg(j)%a1),ang*rtod
!            write(6,'(3x,3i10,f10.2)')eq(leg(i)%a1)%ag,eq(leg(i)%a2)%ag,eq(leg(j)%a1)%ag,ang*rtod
         numangapp=numangapp+1
         tabangapp(numangapp,1)=real(eq(leg(i)%a1)%ag)
         tabangapp(numangapp,2)=real(eq(leg(i)%a2)%ag)
         tabangapp(numangapp,3)=real(eq(leg(j)%a1)%ag)
         tabangapp(numangapp,4)=ang*rtod
         tabangapp(numangapp,5)=tabdistapp(i,6)+tabdistapp(j,6)
         endif
      enddo
   enddo
!Rosanna
   if(numangapp == 0) return 
!Rosanna
   numdist=1
   tabdist(1,1:6)=tabdistapp(1,1:6)
   if(tabdistapp(1,1).ne.tabdistapp(1,2))then
     numdist=2
     tabdist(2,1)=tabdistapp(1,2)
     tabdist(2,2)=tabdistapp(1,1)
     tabdist(2,3:6)=tabdistapp(1,3:6)
   endif
   numang=1
   tabang(1,1:5)=tabangapp(1,1:5)
   do i=2,numdistapp
     do j=1,numdist
      if(abs(tabdistapp(i,3)-tabdist(j,3)).lt.0.001.and.&
        ((tabdistapp(i,1).eq.tabdist(j,1).or.tabdistapp(i,1).eq.tabdist(j,2)) &
         .and.(tabdistapp(i,2).eq.tabdist(j,1).or.tabdistapp(i,2).eq.tabdist(j,2))))go to 111
     enddo
        numdist=numdist+1
        tabdist(numdist,1:6)=tabdistapp(i,1:6)
        if(tabdistapp(i,1).ne.tabdistapp(i,2))then
          numdist=numdist+1
          tabdist(numdist,1)=tabdistapp(i,2)
          tabdist(numdist,2)=tabdistapp(i,1)
          tabdist(numdist,3:6)=tabdistapp(i,3:6)
        endif
111 continue
   enddo
   ndistanze=0
   call ordinatab(tabdist(1:numdist,:),1)
   do i=1,numdist
      do j=1,na
        if(int(tabdist(i,1)).eq.j)then
          ndistanze(j)=ndistanze(j)+1
        endif
      enddo
   enddo
   i1=1
   i2=1
   do i=1,na
      if(ndistanze(i).gt.0)then
        i2=i1+ndistanze(i)-1
      endif
      call ordinatab(tabdist(i1:i2,:),4)
      i1=i2+1
   enddo
   allocate(distanzam(numdist,2))
   distanzam=0.0
!  do i=1,numdist
!     do j=1,na
!       if(int(tabdist(i,1)).eq.j)then
!         ndistanze(j)=ndistanze(j)+1
!         distanzam(j)=distanzam(j)+tabdist(i,3)
!       endif
!     enddo
!  enddo
!  do j=1,na
!     if(ndistanze(j).gt.0)then
!       distanzam(j)=distanzam(j)/float(ndistanze(j))
!     endif
!  enddo
   do i=1,numdist
     if(distanzam(i,1).le.0.0)then
         distanzam(i,1)=tabdist(i,3)
         distanzam(i,2)=1.0
     else
        go to 201
     endif
     do j=i+1,numdist
       if(int(tabdist(i,1)).eq.int(tabdist(j,1)))then
         if(abs(tabdist(i,4)-tabdist(j,4)).lt.0.01.and.abs(tabdist(i,5)-tabdist(j,5)).lt.0.01)then
             distanzam(i,1)=distanzam(i,1)+tabdist(j,3)
             distanzam(i,2)=distanzam(i,2)+1.0
             do ii=i+1,j
               distanzam(ii,1)=distanzam(i,1)
               distanzam(ii,2)=distanzam(i,2)
             enddo
         endif
       else
         go to 201
       endif
     enddo
 201 continue
   enddo
   ncondist=0
   ncare=0
!dariattivare   write(6,*)'                                                             '
!dariattivare   write(6,*)'------------------------------------------------------------------'
!dariattivare   write(6,*)'        Bonds     distance     min.     max.     w1      w2      w'
!dariattivare   write(6,*)'------------------------------------------------------------------'
   do i=1,numdist
      distanzam(i,1)=distanzam(i,1)/distanzam(i,2)
!     peso=tabdist(i,6)+abs(tabdist(i,3)-distanzam(i,1))/distanzam(i,1)
      peso=distanzam(i,2)*abs(tabdist(i,3)-distanzam(i,1))/distanzam(i,1)
      if(peso.gt.1.0)then
!dariattivare        write(6,'(2i8,3f10.4,3f8.3,a)')int(tabdist(i,1:2)),tabdist(i,3:6),abs(tabdist(i,3)-distanzam(i,1))/distanzam(i,1),peso,' **'
      else
!dariattivare        write(6,'(2i8,3f10.4,3f8.3,a)')int(tabdist(i,1:2)),tabdist(i,3:6),abs(tabdist(i,3)-distanzam(i,1))/distanzam(i,1),peso
      endif
      tabdist(i,6)=peso
      if(tabdist(i,6).gt.1.0)then
        ncare=ncare+1
        ncondist(int(tabdist(i,2)))=1
      endif
   enddo
   if(ncare.gt.0)then
     isav=0
     do i=1,na
       if(ncondist(i).gt.0.and.atx(i)%biso.gt.2.0*bmed)isav=i
!!!!!       if(ncondist(i).gt.0.and.x(4,i).gt.2.0*bmed)isav=i
     enddo
     ncondist=0
     if(isav.gt.0)then
       ncondist(isav)=1
!dariattivare       write(6,'(a,i5)')'  Bad distance for atom ',isav
       return
     endif
   endif
   ncentri=0
   nperif=0
   do i=2,numangapp
     do j=1,numang
      if(abs(tabangapp(i,4)-tabang(j,4)).lt.0.001.and.&
        ((tabangapp(i,1).eq.tabang(j,1).or.tabangapp(i,1).eq.tabang(j,2).or.tabangapp(i,1).eq.tabang(j,3))                   &
         .and.(tabangapp(i,2).eq.tabang(j,1).or.tabangapp(i,2).eq.tabang(j,2).or.tabangapp(i,2).eq.tabang(j,3))              &
         .and.(tabangapp(i,3).eq.tabang(j,1).or.tabangapp(i,3).eq.tabang(j,2).or.tabangapp(i,3).eq.tabang(j,3))))go to 222
     enddo
        numang=numang+1
        tabang(numang,1:5)=tabangapp(i,1:5)
222 continue
   enddo
   call ordinatab(tabang(1:numang,:),1)
!  allocate(iorder2(numang),stat=ier)
!  if(ier.ne.0)write(6,*)'ERRORE',ier
!  call indexx((tabang(:numang,2)),iorder2(:numang))
!  do i=1,6
!    tabang(:numang,i)=tabang(iorder2(:numang),i)
!  enddo
!  tabang(:numang,:)=tabang(iorder(:numang),:)
!dariattivare   write(6,*)'                                               '
!dariattivare   write(6,*)'-----------------------------------------------'
!  write(6,*)'                Atomi           angolo   weight'
!dariattivare   write(6,*)'                Atoms           Angle          '
!dariattivare   write(6,*)'-----------------------------------------------'
   ncondist=0
   ncondist2=0
   do i=1,numang
!     write(6,'(3i10,2f10.4)')int(tabang(i,1:3)),tabang(i,4:5)
!dariattivare      write(6,'(3i10,f10.4)')int(tabang(i,1:3)),tabang(i,4)
      i1=int(tabang(i,1))
      i2=int(tabang(i,2))
      i3=int(tabang(i,3))
!     if((tabang(i,4)*dtor.lt.angmin.or.tabang(i,4)*dtor.gt.angmax).and.tabang(i,5).le.0.2)then
      if((tabang(i,4)*dtor.lt.angmin.or.tabang(i,4)*dtor.gt.angmax))then
        ncondist(i1)=1
        ncondist(i2)=1
        ncondist(i3)=1
        ncondist2(i1)=ncondist2(i1)+1
        wdist(i1)=wdist(i1)+tabang(i,5)
        if(i2.ne.i1)then
           ncondist2(i2)=ncondist2(i2)+1
           wdist(i2)=wdist(i2)+tabang(i,5)
        endif
        if(i3.ne.i2.and.i3.ne.i1)then
          ncondist2(i3)=ncondist2(i3)+1
           wdist(i3)=wdist(i3)+tabang(i,5)
        endif
      endif
      do j=1,na
        if(int(tabang(i,2)).eq.j)ncentri(j)=ncentri(j)+1
        if((int(tabang(i,1)).eq.j.or.int(tabang(i,3)).eq.j).and.(int(tabang(i,2)).ne.j))nperif(j)=nperif(j)+1
      enddo
   enddo
!dariattivare   write(6,*)'                                               '
!dariattivare   write(6,*)'----------------------------------------------------------------------------------'
!  write(6,*)'   Atomi nr.dista. nr.angoli(centro)  nr.angoli(perif.) extrarange  peso         '
!dariattivare   write(6,*)'   Atoms nr.dista. nr.angles(centre)  nr.angles(neigh.) extrarange               '
!dariattivare   write(6,*)'----------------------------------------------------------------------------------'
   do i=1,na
      if(ncondist(i).gt.0)then
!       write(6,'(2i8,i12,i15,a2,i18,f10.2)')i,ndistanze(i),ncentri(i),nperif(i),' *',ncondist2(i),wdist(i)
!dariattivare        write(6,'(2i8,i12,i15,a2,i18)')i,ndistanze(i),ncentri(i),nperif(i),' *',ncondist2(i)
      else
!       write(6,'(2i8,i12,i15,20x,f10.2)')i,ndistanze(i),ncentri(i),nperif(i),wdist(i)
!dariattivare        write(6,'(2i8,i12,i15,20x)')i,ndistanze(i),ncentri(i),nperif(i)
      endif
   enddo
!  ncare=0
!  do i=1,na
!     write(6,*)ncondist(i)
!     if(ncondist(i).gt.0)ncare=ncare+1
!  enddo
!  if(ncare.ge.na*2/3.and.tol.gt.0.1)then
!    tol=tol-0.05
!    write(6,'(a,f8.2,2i5)')'  Ridotta tolleranza', tol,ncare,na
!    go to 333
!  endif
   do i=1,na
      if(ndistanze(i).eq.0)then
         call  get_equivalent(atx(i)%xc,gg,spacegr,xeq,neqa)
         do j=1,neqa
            do jj=1,neq
               dd = xdisteq(xeq(:3,j),eq(jj)%co,gg)
!corr               ii1=no(iabs(nz(i))/100)
               ii1 = atx(i)%z()
               do ii=1,numelem(celem)
!corr                  if(iabs(no(ii)-ii1).le.5.or.neutro.eq.1)then
                  if(iabs(celem(ii)%z-ii1).le.5.or.neutro.eq.1)then
                     if(eq(jj)%ag.eq.i)then
                      !corr dmin=radii(ii,1)+radii(ii,1)*(1.0-tol2)
                      !corr dmax=radii(ii,1)+radii(ii,1)*(1.0+tol2)
                       dmin=celem(ii)%c_radius+celem(ii)%c_radius*(1.0-tol2)
                       dmax=celem(ii)%c_radius+celem(ii)%c_radius*(1.0+tol2)
                     else
                      !corr dmin=radii(ii,1)+rx(eq(jj)%ag)*(1.0-tol2)
                      !corr dmax=radii(ii,1)+rx(eq(jj)%ag)*(1.0+tol2)
                       dmin=celem(ii)%c_radius+rx(eq(jj)%ag)*(1.0-tol2)
                       dmax=celem(ii)%c_radius+rx(eq(jj)%ag)*(1.0+tol2)
                     endif
                     if(dd.gt.0.0.and.dd.ge.dmin.and.dd.le.dmax)then
                        go to 233
                     endif
                   endif
               enddo
            enddo
         enddo
         ncondist(i)=1
      endif
 233  continue
      if((atx(i)%biso.le.3.0*bmed.or.i.le.na/2).or.(ndistanze(i).eq.0.and.i.le.na/2))ncondist(i)=0
   enddo
   ncare=0
   do i=1,na
     if(ncondist(i).gt.0) ncare=ncare+1
   enddo
   if(ncare.gt.0)then
 !dariattivare    write(6,*)'                                               '
 !dariattivare    write(6,*)'--------------------------------------------------------------------------------------------------'
 !dariattivare    write(6,*)' Check b-term   aver-b  nr.dist. nr.ang.(centre) nr.ang.(neigh.) extrarange '
 !dariattivare    write(6,*)'--------------------------------------------------------------------------------------------------'
   endif
   do i=1,na
     if(ncondist(i).gt.0)then
!dariattivare       write(6,'(i5,2f8.3,i8,i12,i15,i15)') i,x(4,i),bmed,ndistanze(i),ncentri(i),nperif(i),ncondist2(i)
     endif
   enddo
   ncare=0
   do i=1,na
     if(ncondist(i).gt.0)then
       ncare=ncare+1
       icare(ncare)=i
       ord1(ncare)=atx(i)%biso
!!!!!       ord1(ncare)=x(4,i)
       if(ncondist2(i).gt.0)then
         iord2(ncare)=ncondist2(i)
       else
         iord2(ncare)=maxval(ncondist2)
       endif
       ord1(ncare)=ord1(ncare)*float(iord2(ncare))
     endif
   enddo
   if(ncare.gt.0)then
!    allocate(iorder3(ncare))
!    call indexx(ord1(:ncare),iorder3(:ncare))
!    iorder3(:ncare) = iorder3(ncare:1:-1)      ! ordine decrescente
     lmin=maxloc(ord1(:ncare))
!    isav=icare(iorder3(1))
     isav=icare(lmin(1))
     ncondist=0
     ncondist(isav)=1
   endif
   !write(6,*)'              '
!
   CONTAINS

   function strlab(lab,i) result(str)
   character(len=*), intent(in)       :: lab
   integer, intent(in)                :: i
   character(len = len_trim(lab)+2+6) :: str
!
   write(str,'(i6)')i
   str = trim(lab)//'('//trim(adjustl(str))//')'
!
   end function strlab
!
   end subroutine treatmodel_new

  !----------------------------------------------------------------------------------------------------

   subroutine ordinatab(tab,ikey)
   USE nr
!
   real, dimension(:,:), intent(inout)         :: tab
   integer , intent(in)                        :: ikey
   integer , dimension(size(tab,1))            :: iorder
   integer                                     :: i
!
   call indexx(tab(:,ikey),iorder)
   do i=1,size(tab,2)
     tab(:,i)=tab(iorder,i)
   enddo

   end subroutine ordinatab

  !----------------------------------------------------------------------------------------------------

   real function angoloeq(x1,x2,x3,gm)
   USE CGEOM
!
!  Calcola l' angolo in radianti tra 3 atomi considerando gli equivalenti
!
   implicit none
   real, intent(in), dimension(3)     :: x1,x2,x3  ! coordinate dei tre atomi
   real, intent(in), dimension(3,3)   :: gm        ! matrice metrica
   real :: XGX
   real                               :: argcos
   real :: dis12,dis23
   real, dimension(3)                 :: delta12,delta23
!
   call xdisteqs(x1,x2,gm,dis12,delta12)
   call xdisteqs(x2,x3,gm,dis23,delta23)
   XGX = DOT_PRODUCT(delta12,MATMUL(gm,-delta23))
   argcos = XGX / (dis12 * dis23)
   if (argcos > 1.0) argcos = 1.0
   if (argcos < -1.0) argcos = 1.0
   angoloeq = acos ( argcos )
!
   end function angoloeq

  !----------------------------------------------------------------------------------------------------

   subroutine save_bestmodel(icod,scod)
!
!  Memorizza il modello migliore
!
   USE refinecomref
   USE Atomi, only:nats
   USE variables, only:atm
   USE atom_type_util
!
   integer, intent(in), optional :: icod
   character(len=*), optional    :: scod
   real                          :: vals
   integer                       :: i
   character(len=3)              :: strn
!
   select case(selcode)
      case (1)          ! Selezione in base all'RF(obs-calc) pesato
        vals = errefsw
      case (2)          ! Selezione in base all'RF(obs-calc) 
        vals = errefs
      case (3)          ! Selezione in base all'R-profilo pesato
        vals = errepw
   end select
   if (vals < valsel) then
       valsel = vals
!
!      Genera stringa identificativa del modello
       if (present(icod).and. present(scod)) then
           write(strn,'(i3)')icod
           strsel = trim(scod)//' n.'//trim(adjustl(strn))
       else
           if (present(scod)) then
               strsel = trim(scod)
           endif
       endif
!
!      memorizza il modello nella variabile atb
       natb = nats
       call new_atoms(atb,natb)  ! rialloca at al numero di atomi
       do i=1,natb
          atb(i) = atm(i) 
       enddo
   endif
!
   end subroutine save_bestmodel

  !----------------------------------------------------------------------------------------------------

   subroutine get_bestmodel(kpr)
   USE refinecomref
   USE variables, only:atm
   USE Atomi, only:nats
   USE atom_type_util
   USE General, only:celem
   USE sinterface, only: fillatom
!
   implicit none
   integer, intent(in) :: kpr
!corr   integer             :: i
   character(len=10)   :: strn
!
!  Prendi il modello migliore
   call copy_atoms(atm,atb)
   nats = numatoms(atm)
   !call reallocate(atm,natb,.false.)
   !do i=1,natb
   !   atm(i) = atb(i)
   !enddo
!
!corr   call reallocate(atb,0) ! dealloca atb
   call clear_atoms(atb)
!
!  Rigenera label e seriale
!corr   do i=1,nats
!corr      nz(i)=atm(i)%nz 
!corr   enddo
!corr   call MakeLab(1,nats)
!corr   do i=1,nats
!corr      atm(i)%lab = aLab(i)
!corr   enddo
   call atom_string(atm,celem)
!
   call fillatom(atm)
   if (kpr == 1) then
       write(strn,'(f10.3)')valsel
       write(6,*)'  Best model: '//trim(strsel)//' R = '//trim(adjustl(strn))
   endif
!
   end subroutine get_bestmodel

  !----------------------------------------------------------------------------------------------------

   subroutine impose_restr()
   USE General, only: celem
   USE RRESTR
   USE RefinecomRef
   USE Atomi   ,only:iconn,nats,nzConst
   USE Atomi   ,only:iconn,nats,nzConst
   USE BuildModule, only:tabdst,tabang,numang
   USE variables, only : atm
   USE var_samod, only : i_SA
   USE atom_type_util
   USE elements, only: Cl_at
   integer                          :: i
!corr   integer                          :: nang
   integer                          :: j,jj,l1,l2
   integer, dimension(nats)         :: nbuild
   integer,allocatable              :: ino(:)           
   integer, dimension(nats,nats*10) :: numbuild
   integer                          :: z1,z2
!
   call reset_restraints(resvf,wqqf)
!
!  Pesi per restraints
   allocate(ino(numang))
!!!!!   call print_atoms(atm(:nats))
   wqqf(1) = 1000000.0
   wqqf(2) = 1000000.0
   ino=0
   if(i_Sa.eq.0)then
     nbuild=0
     numbuild=0
     do j=1,iconn(1)
        l1=iconn((j-1)*3+2)
        l2=iconn((j-1)*3+3)
        nbuild(l1)=nbuild(l1)+1
        nbuild(l2)=nbuild(l2)+1
        numbuild(l1,nbuild(l1))=l2
        numbuild(l2,nbuild(l2))=l1
     enddo
     do j=1,numang
        if(nbuild(int(tabang(3,j))).gt.3)then
          if(nbuild(int(tabang(1,j))).le.1.or.nbuild(int(tabang(5,j))).le.1)then
             ino(j)=1
          endif
        endif
        if(ino(j).eq.1)cycle
        do jj=1,numang
          if(jj.eq.j)cycle
          if(ino(jj).eq.1)cycle
          if(tabang(1,j).eq.tabang(1,jj).and.tabang(3,j).eq.tabang(3,jj).and.tabang(5,j).eq.tabang(5,jj))ino(jj)=1
        enddo
     enddo
   endif
   do i=1,iconn(1)
      if(i_SA.eq.1)then
         call set_restr(resvf,1,int(tabdst(1:2,i)),tabdst(4,i),0.01)
      else
         if(maxval(celem%z) <= Cl_at)then
           call set_restr(resvf,1,int(tabdst(1:2,i)),tabdst(3,i),0.01)
         else
           z1 = atm(int(tabdst(1,i)))%z()
           z2 = atm(int(tabdst(2,i)))%z()
           if(z1.gt.17.or.z2.gt.17) call set_restr(resvf,1,int(tabdst(1:2,i)),tabdst(3,i),0.01)
         endif
      endif
   enddo
   nresd=nrestraints(resvf)
   if(maxval(celem%z) <= Cl_at)then
      do i=1,numang
         if(ino(i).eq.1)cycle
!corr         nang=nint(tabang(6,i))
         if(i_SA.eq.1)then
            call set_restr(resvf,2,int(tabang(1:5:2,i)),tabang(6,i),0.01)
         else
            call set_restr(resvf,2,int(tabang(1:5:2,i)),120.0,0.01)
         endif
      enddo
   endif
   nresa=nrestraints(resvf)-nresd
!
   if(nrestraints(resvf) <= 25)then
      wqqf(1) = 10000.0
      wqqf(2) = 10000.0
   else
      wqqf(1) = 1000000.0
      wqqf(2) = 1000000.0
   endif
   deallocate(ino)
!
   end subroutine impose_restr
  !----------------------------------------------------------------------------------------------------
   subroutine impose_restr_partial(nofree,nfree)
   USE General, only: celem
   USE RRESTR
   USE RefinecomRef
   USE Atomi, only:iconn,nats,nzConst
   USE BuildModule, only:tabdst,tabang,numang
   USE variables, only : atm
   USE atom_type_util
   USE elements, only: Cl_at
   integer                          :: i
!corr   integer                          :: nang
   integer                          :: j,jj,l1,l2
   integer, dimension(nats)         :: nbuild
   integer                          :: nofree
   integer, dimension(nats)         :: nfree
   integer,allocatable              :: ino(:)           
   integer, dimension(nats,nats*10) :: numbuild
   integer                          :: z1,z2
!
   call reset_restraints(resvf,wqqf)
!
!  Pesi per restraints
   allocate(ino(numang))
!!!!!   call print_atoms(atm(:nats))
   wqqf(1) = 1000000.0
   wqqf(2) = 1000000.0
   ino=0
     nbuild=0
     numbuild=0
     do j=1,iconn(1)
       l1=iconn((j-1)*3+2)
       l2=iconn((j-1)*3+3)
       nbuild(l1)=nbuild(l1)+1
       nbuild(l2)=nbuild(l2)+1
       numbuild(l1,nbuild(l1))=l2
       numbuild(l2,nbuild(l2))=l1
     enddo
     do j=1,numang
        if(nbuild(int(tabang(3,j))).gt.3)then
          if(nbuild(int(tabang(1,j))).le.1.or.nbuild(int(tabang(5,j))).le.1)then
             ino(j)=1
          endif
        endif
        if(ino(j).eq.1)cycle
        do jj=1,numang
          if(jj.eq.j)cycle
          if(ino(jj).eq.1)cycle
          if(tabang(1,j).eq.tabang(1,jj).and.tabang(3,j).eq.tabang(3,jj).and.tabang(5,j).eq.tabang(5,jj))ino(jj)=1
        enddo
     enddo
   do i=1,iconn(1)
!corr        if(maxval(no(1:nk)).le.17) then
        if(maxval(celem%z) <= Cl_at) then
          do j=1,nofree
             if(tabdst(1,i).eq.nfree(j).or.tabdst(2,i).eq.nfree(j))call set_restr(resvf,1,int(tabdst(1:2,i)),tabdst(3,i),0.01)
          enddo
        else
!corr          nz1 = iabs(atm(int(tabdst(1,i)))%nz/nzConst)
!corr          nz2 = iabs(atm(int(tabdst(2,i)))%nz/nzConst)
!corr          if(no(nz1).gt.17.or.no(nz2).gt.17) then
          z1 = atm(int(tabdst(1,i)))%z()
          z2 = atm(int(tabdst(2,i)))%z()
          if(z1.gt.17.or.z2.gt.17) then
             do j=1,nofree
                if(tabdst(1,i).eq.nfree(j).or.tabdst(2,i).eq.nfree(j))call set_restr(resvf,1,int(tabdst(1:2,i)),tabdst(3,i),0.01)
             enddo
          endif
        endif
   enddo
   nresd=nrestraints(resvf)
!corr   if(maxval(no(1:nk)).le.17) then
   if(maxval(celem%z) <= Cl_at)then
   do i=1,numang
    if(ino(i).eq.1)cycle
!corr    nang=nint(tabang(6,i))
    do j=1,nofree
       if(tabang(1,i).eq.nfree(j).or.tabang(3,i).eq.nfree(j).or.tabang(5,i).eq.nfree(j))     &
           call set_restr(resvf,2,int(tabang(1:5:2,i)),120.0,0.01)
    enddo
   enddo
   endif
   nresa=nrestraints(resvf)-nresd
!
   if(nrestraints(resvf).le.25)then
      wqqf(1) = 10000.0
      wqqf(2) = 10000.0
   else
      wqqf(1) = 1000000.0
      wqqf(2) = 1000000.0
   endif
   deallocate(ino)
!
   end subroutine impose_restr_partial
  !----------------------------------------------------------------------------------------------------
   subroutine weight_restr()
   USE RRESTR
   USE GENLSQ
   USE Atomi
   USE RefinecomRef
   USE unit_cell
   USE General, only: cell
   USE unit_cell
   USE variables, only: atm
   real :: contrif,contrid,contria,contrida
   type(cell_type) :: cellt
!
   wqqf(1) = 1.0
   wqqf(2) = 1.0
   cellt = set_cell_type(cell)
   call resapp(atm,cellt,resvf,wqqf,numoss,0)
   contrif=dot_product(funcls(1:numoss),funcls(1:numoss))
   contrid=dot_product(funcls(numoss+1:numoss+nresd),funcls(numoss+1:numoss+nresd))
   contria=dot_product(funcls(numoss+nresd+1:numoss+nresd+nresa),funcls(numoss+nresd+1:numoss+nresd+nresa))
   contrida=dot_product(funcls(numoss+1:numoss+nresd+nresa),funcls(numoss+1:numoss+nresd+nresa))
   if(contrid.gt.1.E-20) then
      wqqf(1) = (contrif/contrid)/3.0
      wqqsav(1) = (contrif/contrid)/3.0
   else
      wqqf(1) = wqqsav(1)
   endif
   if(contria.gt.1.E-20) then
      wqqf(2) = (contrif/contria)/3.0
      wqqsav(2) = (contrif/contria)/3.0
   else
      wqqf(2) = wqqsav(2)
   endif
   !if(contrid.gt.1.E-20.and.contria.gt.1.E-20) then
   !   wqq(1) = (contrif/contrid)/3.0
   !   wqq(2) = (contrif/contria)/3.0
   !   wqqsav(1) = (contrif/contrid)/3.0
   !   wqqsav(2) = (contrif/contria)/3.0
   !else
   !   wqq(1) = wqqsav(1)
   !   wqq(2) = wqqsav(2)
   !endif
   call resapp(atm,cellt,resvf,wqqf,numoss,0)
!
   end subroutine weight_restr

!----------------------------------------------------------------------------------------------------

   subroutine fsprint_statusbar()
   USE RefinecomRef   
   USE messagemod
!   
!!!!!   if (fscond%auto_stru .and. auto_complete == 1) then
       call write_message('RF = ',rnum=errefs*100,pos=5)
!!!!!   endif 
!   
   end subroutine fsprint_statusbar

!----------------------------------------------------------------------------------------------------

   subroutine fsetref(nrr)
   USE arrayutil
   USE genlsq, only:funcls,weilsq
!   
!  Modifica il numero di reflessi da usare durante l'affinamento
!
   USE General, only:nrefl
!
   integer, intent(in) :: nrr
!
!  write(6,'(a,i0,a,i0)')'Numero di reflessi modificato da ',nrefl,' a ',nrr
!
!  Cambia il numero di riflessi
   nrefl = nrr
!
!  Rigenera integ,aggiorna npref
   if (allocated(integg))deallocate(integg)
   call setreflections(nrefl,fra=fracref,icod=typeref)
!
!  Rialloca funcls e weilsq
   call resize_array(funcls,numoss)
   call resize_array(weilsq,numoss)
!   
   end subroutine fsetref

!----------------------------------------------------------------------------------------------------
   
   subroutine fsclose()
   USE PatternRef, only: iriet
   USE RefinecomRef, only: noverl
   USE arrayutil
!
   !call reallocate(noverl,0)
   call delete_array(noverl)
   if(allocated(wprint))deallocate(wprint)
   if (allocated(integg)) deallocate(integg)
   deallocate(fobsold)
   iriet = 0
!
   end subroutine fsclose

!----------------------------------------------------------------------------------------------------

   integer function get_refine_code() result(code)
   USE comandiexpo
   USE commandsmod
   USE strutil
   implicit none
!
   if (commands(icomat)%ndir > 0) then
       select case(trim(upper(commands(icomat)%strdir(1))))
          case ('RBM')
            code = 1
          case ('RBM-REC')
            code = 2
          case ('RBM-COV')
            code = -10
          case default
            code = 1
       end select
   else
       code = 1
   endif
   !write(0,*)'code=',code
!
   end function get_refine_code

!----------------------------------------------------------------------------------------------------

   subroutine ref_execute(coderef)
   USE exportfiles
   USE messagemod
   implicit none
   integer, intent(in) :: coderef
   integer             :: kevent
!
   call write_message('Refinement procedure',pos=1)
   call fsrbm(coderef,kevent)
   call export_files() ! esporta modello in presenza del comando '%export'
!
   end subroutine ref_execute
!----------------------------------------------------------------------------------------------------
   subroutine fsinterface(code)
!
!  Prende informazioni per affinamento dai common
!  Se ord e' vero gli atomi vengono ordinati per nz eliminando i ghosts
!
   USE PatternRef, only : iriet
   USE variables, only : atm,ref
   USE progtype, only: ALLOCA
   USE RefinecomRef, only : noverl
   USE Atomi
   USE General, only : cell,nrefl,vetint,knw,alambda,celem
   USE unit_cell
   USE atom_type_util
   USE reflection_type_util
   USE proginterface
   USE arrayutil
   USE sinterface
   USE connect_mod
   USE unit_cell
   USE variables, only: lconn
!
   implicit none
   integer, intent(in) :: code
   type(cell_type)     :: cellt
!
   iriet = code
!
!  la lunghezza d'onda
!corr   kalphar = 1
!
!  Modello
   if (nats > 0) then
       call xyz_to_atom(atm,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,inte=xyzs(4,:),elem=celem)
       cellt = set_cell_type(cell)
       call delete_ghosts(atm,lconn)
       call atom_to_xyzs(atm,lconn)  ! aggiorna xyzs, iconn
   endif
!
!  I riflessi
   call calcphklleast
   call new_array(noverl,nrefl)
   call fillref(ref)
   call calculate_2theta(ref,cell,[alambda])
                      !allocate(veta(size(atm)),rfv(size(atm)))
                      !call evaluate_rf(atm,ref,veta,rfv,rf0)
!
   end subroutine fsinterface

!----------------------------------------------------------------------------------------------------

   subroutine fcalcannoripple(ref,atx,ffripple)
   USE General, only : ff,rtod,twopi,celem
   USE Atomi, only : nzConst
   USE Symmetry, only : nsym,pts,icent,kmat,tmat
   USE reflection_type_util, only: reflection_type
!
   type(reflection_type), dimension(:), intent(inout) :: ref    ! i riflessi
   type(atom_type), dimension(:), intent(in)              :: atx    ! modello strutturale
   real, dimension(:,:), intent(in)                     :: ffripple
   integer                                            :: natoms
   real, dimension(4,nsym)                              :: hkle
   integer, dimension(3)                              :: i1
   integer                                            :: i,j,k,l,jj
   real                                               :: t
   real                                               :: rho
   integer                                            :: kz
   real                                               :: contc
   real                                               :: conts
   real                                               :: tfocc
   real                                               :: act,bct
   real                                               :: faze
   real                                               :: at,bt
   real                                               :: argg
!
   natoms = size(atx)
   loop_riflessi: do i=1,size(ref)
!
!-- compute H*R and H*T
      i1 = ref(i)%hkl
      do j=1,nsym
         t=0
         do l=1,3
            t=t+i1(l)*tmat(j,l)
            hkle(l,j)=0

           do k=1,3
              hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
           enddo

        enddo
        hkle(4,j)=t
      enddo

      !do j=1,nsym
      !   t=0.0   !!!!!!prova  1000.0
      !   do l=1,3
      !      t=t+i1(l)*tsmat(l,j)
      !      hkle(l,j)=0
      !   enddo
      !   do l=1,3
      !      do k=1,2
      !       m=iabs(ismat(k,l,j))
      !       if(m.gt.0) hkle(m,j)=hkle(m,j)+i1(l)*isign(1,ismat(k,l,j))
      !      enddo
      !   enddo
      !   hkle(4,j)=t
      !enddo
      rho=ref(i)%slaq
!
!corr      ff(:nk) = cl(:nk) + sum(al(:,:nk)*exp(-bs(:,:nk)*rho),dim=1)
      do j=1,size(celem)
         ff(j) = celem(j)%cl + sum(celem(j)%al*exp(-celem(j)%bs*rho))
      enddo
!
      act=0.0
      bct=0.0
      loop_atomi: do jj=1,natoms
!corr         kz=iabs(atx(jj)%nz/nzConst)
         kz=atx(jj)%kscatt()
         tfocc=pts*(ff(kz)-ffripple(kz,i))*exp(-atx(jj)%biso*rho)*atx(jj)%och*atx(jj)%ocry
         at=0.0
         bt=0.0
         do j=1,nsym
            argg = twopi*(dot_product(hkle(:3,j),atx(jj)%xc) + hkle(4,j))
            at = at + cos(argg)
            bt = bt + sin(argg)
         enddo
         if (icent == 0) then
             contc=at
             conts=bt
         else
             contc=2.0*at
             conts=0.0
         endif
         act=act+contc*tfocc
         bct=bct+conts*tfocc
      enddo loop_atomi
!
      ref(i)%fc = sqrt(act**2+bct**2)
      faze=rtod*atan2(bct,act)+360.0
      ref(i)%ph = mod(int(faze+0.5),360)
   enddo loop_riflessi
!
   end subroutine fcalcannoripple

!----------------------------------------------------------------------------------------------------

   subroutine evaluate_rf(atom,ref,veta,rfv,rf0)
   USE atom_type_util
   USE reflection_type_util
   USE stat, only: Rvalue
   USE General, only: spacegr, celem
   USE nr
   type(atom_type), dimension(:), allocatable, intent(in) :: atom
   type(reflection_type), dimension(:), intent(inout)     :: ref
   integer, dimension(:), intent(out)                     :: veta
   real, dimension(size(veta)), intent(out)               :: rfv
   real                                                   :: rf0
   integer                                                :: i,nat
   integer, dimension(:), allocatable                     :: iord
   integer, dimension(size(veta))                         :: veta1
!
   nat = numatoms(atom)
!
!  Check for size of array
   if (numatoms(atom) == 0) return
   if ((size(veta) < nat)) then
       write(0,*)'Error calling evaluete_rf'
       return
   endif
!
!  Compute Rf for all atoms
   call sfcalc(ref,atom,spacegr,celem)
   rf0 = Rvalue(ref%fo,ref%fc)
!
!  Compute Rf
   veta = [(i,i=1,nat)]
   do i=1,nat
      veta1(1:nat-1) = pack(veta,mask=veta /= i)
      call sfcalc(ref,atom(veta1(1:nat-1)),spacegr,celem)
      rfv(i) = Rvalue(ref%fo,ref%fc)
   enddo
!
!  Sort
   allocate(iord(nat))
   call indexx(rfv(:nat),iord)
   !iord(:) = iord(nat:1:-1)
   rfv(:nat) = rfv(iord)
   veta(:nat) = veta(iord)
!corr   write(0,'(a,f8.2)')'RF=',rf0
!corr   write(0,'(f8.2,i5)')(rfv(i),veta(i),i=1,nat)
!
   end subroutine evaluate_rf

 END MODULE FSREFINEMENT

!----------------------------------------------------------------------------------------------------
   subroutine fslsq()
!
!  From C++ when press 'Fourier Recycling'
!
   USE PatternRef, only : iriet
   USE ilmviewmod
   USE General, only: StructureName
!
   implicit none
   integer :: kevent
!
   iriet = 2
   if (.not.jav_opened())call ilmview_open(StructureName)
   call fslsqnwin(kevent)
!
   end subroutine fslsq
!----------------------------------------------------------------------------------------------------
   subroutine randomsolve()
   USE ilmviewmod
   USE molcom, only:jscreen
   USE General, only:StructureName, is_normal, ifAutomatic, is_extraction
   USE fsrefinement, only:fsmodel,numfsmodel
   USE wlist
   USE model_util
   USE patternref, only:kexitrun
   implicit none
   integer, parameter :: CODE_RAMM = 10
   integer :: ier
   integer :: kevent
   integer :: ifautosav
   external rammfunc
!                logical :: modif
!
!!!!! FIXME
!   if (.not.is_cell_defined_list()) then
!             call set_spaceg('P 1')
!       call set_cell_and_spg(modif)
!           !call CreaListaRiflessi
!!           !call ysfr37(npunti)
!               call data3(4,ier)
!           icomat = 1
!           call set_command_for('extra',ipcom,icomq)
!       !if (modif .and. jav_opened()) then
!       !    call ilmview_draw(atm,lconn)
!       !    write(0,*) 'jav modificato'
!       !endif
!   endif
!
   if (.not.is_extraction) then
       call make_extra(ier)
       if (kexitrun == 1 .or. ier /= 0) return  ! exit by graphic
   endif 
   if (.not.is_normal) then
       ifautosav = ifAutomatic
       ifAutomatic = 1
       call normal(ier)
       ifAutomatic = ifautosav
   endif
!
   if (jscreen > 0) then
       call ilmview_open(StructureName)    ! apri viewer
       call jav_set_modify(0)              ! disabilita modifiche da grafica
   endif
!
   call yfl02() 
   call fsrbm(-20,kevent)
!
!  apri la lista dei modelli
   !call model_print_info(fsmodel(:numfsmodel))
   if (jscreen > 0 .and. numfsmodel > 1) then
       call model_sort(fsmodel(:numfsmodel),2)
       call wlist_create(CODE_RAMM,2,numfsmodel,(/'Run.              ','Cost function (RF)'/), &
       'RAMM procedure','Select model generated by RAMM procedure', 2, 1, rammfunc,            & 
       (/set_column(int(fsmodel(:numfsmodel)%info(1))),set_column(fsmodel(:numfsmodel)%info(2))/))

   endif
!
   if (jscreen > 0) call jav_set_modify(1) ! riabilita modifiche
!
   end subroutine randomsolve
   
!----------------------------------------------------------------------------------------------------

   subroutine rammfunc(code)
   USE testmodel
   USE variables
   USE model_util
   USE General, only:knw,celem,spacegr,cell
   USE unit_cell
   USE fsrefinement, only:fsmodel
   USE ilmviewmod
   USE sinterface
   USE strutil
   USE messagemod
   implicit none
   integer, intent(in) :: code
   real, dimension(4)  :: info
   integer             :: isel
   logical             :: cancel
!
   select case (code)
     case (0)   ! apro la lista

     case (1)   ! OK
      call atom_to_xyzs(atm,lconn)

     case (:-1, 2) ! seleziono o Cancel
      if (allocated(fsmodel)) then ! la lista può essere deallocata se vado su un'altra struttura
          cancel = code == 2       ! e la finestra e' aperta
          if (cancel) then
              isel = 1
          else
              isel = abs(code)
          endif
          call model_get(fsmodel(isel),atm,leg=lconn,fom=info)
          call ilmview_draw(atm,lconn,celem,set_cell_type(cell),spacegr)
          if (isel == 1) then
              call write_message('The best structure (trial n.'//trim(i_to_s(int(info(1))))//') was selected',pos=3)
          else
              call write_message('The structure of trial n.'//trim(i_to_s(int(info(1))))//' was selected',pos=3)
          endif
          if (knw > 0) then
              vett_test(3) = info(3)           ! trovati
              vett_test(4) = info(4)           ! distanza
              call write_message_found(4)
          endif
          if (cancel) call atom_to_xyzs(atm,lconn)
      endif
   end select
!
   end subroutine rammfunc
!
!----------------------------------------------------------------------
#if 0
    subroutine test_makemap()
    USE variables
!corr    USE factor
    USE rand_mod
    USE fouriermap
    USE mappa
    implicit none
    integer, parameter :: NPHRAND = 20
    integer, dimension(NPHRAND) :: ichange
    real, dimension(NPHRAND) :: rvalue
    real, dimension(2) :: PHCENT = [0.0,180.0]
    real, dimension(size(ref)) :: ph0
    integer :: i
!
!corr    call fcalcan(ref,atm)
    call sfcalc(ref,atm,spacegr,celem)
    ph0(:) = ref%ph
!
    do i=1,40
!
!      Set NPHRAND random phase
       call random_number(rvalue)
       ichange(:) = randvalue(NPHRAND,1,size(ref))
       ref(ichange)%ph = nint(rvalue) + 1
!
!      Compute map
       call create_map(FOUR_FO,ref,size(ref),1)
       write(0,*)'MAXVAL_FO=',maxval(xmap)
       call create_map(FOUR_FO_FC,ref,size(ref),1)
       write(0,*)'MAXVAL_FO_FC=',maxval(xmap)
       call create_map(FOUR_2FO_FC,ref,size(ref),1)
       write(0,*)'MAXVAL_2FO_FC=',maxval(xmap)
!
!      Reset phases
       ref(ichange)%ph = ph0(ichange)
    enddo
!
    end subroutine test_makemap
#endif
!----------------------------------------------------------------------------------------------------
!
   subroutine fsrbm(coderbm,kevent)
   USE Atomi
   USE Molcom
   USE exploreset, only:more_trials
   USE General, only : knw,bt,cell,celem,spacegr,lo,neutro
   USE Symmetry, only : pts,nsym,icent
   USE PatternRef, only : iriet
   USE variables, only:ref,atm,lconn,cryst
   USE GENLSQ
   USE TestModel
   USE FSREFINEMENT
   USE RRESTR
   USE atom_type_util
   USE drawatoms
   USE molpnew
   USE Phasemodule, only:numset,imove
   USE ParametriMappa, only : np
   USE stat
   USE Mappa
   USE messagemod
   USE strutil
   USE enable_amb
   USE compare_struct
   USE connect_mod
   USE importexport
   USE model_util
   USE fourier_mod, only: AllocaMappa
   USE unit_cell
   USE reflection_type_util
   USE proginterface
   USE elements, only: Cl_at,nasym_unit
   USE sinterface, only: update_model,fillatom
   implicit none
   type(atom_type), allocatable, dimension(:) :: atm_copy
   real, dimension(:,:,:), allocatable :: xmapbest
   !real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)+1) :: xmapbest
   integer, intent(in)  :: coderbm
   integer, intent(out) :: kevent
   integer              :: i,j
   integer              :: iz
   integer              :: ncase3,ncase3max,natom !!!,natomm
   integer              :: kAction, iprinCode
   real                 :: figurai1,figurai2,figurao1,figurao2
   real                 :: amult                            
   integer              :: npadd,natcopy
   integer              :: natsold
   integer,allocatable  :: ovr(:)           
   real,allocatable     :: foss(:)         
   integer              :: noptim
   real,allocatable     :: xyzssav(:)
   real                 :: scaleffe,erreffe,errefsm
   real                 :: s1,s2                           
   integer              :: kprintcode
   real                 :: fstart_time,fend_time
   character(len=200)   :: title
   integer              :: ntsteps
   integer              :: imore,nfrbm
   integer              :: nfrbmsog1,nfrbmsog2
   real,dimension(10)   :: erreovr
   real,allocatable     :: bapp(:)
   integer,allocatable     :: vrem(:)
   real                 :: bmed,bvar,bsog
   real                 :: erreffemin,erreffesog
   real                 :: rfrandomstart,rfrandomfinal,rfrandomfinalmax
   integer              :: nbb1,nvb
   integer                                         :: coderbmsav
   integer,allocatable                             :: iorder(:)
   integer                                        :: ico,icomax
   integer                                        :: ico2,icomax2
   integer                                        :: natsrandom     
   integer,allocatable                            :: nbuild(:)
   integer                                        :: l1,l2
   real                                           :: rsog  
!
!  Clear xmap
   call InitFour()
   allocate(xmapbest(0:np(1)-1,0:np(2)-1,0:np(3)+1))
!corr   if (knw == 1 .or. ModelToCompare == 1) call AllocaTestStuff(1)
!
   coderbmsav=coderbm
   if(coderbmsav.lt.-10)then
     numset=1
     !icomax=20
     icomax=20
     natom = nint(nasym_unit(celem,spacegr%nsymop,neutro==0))
     if(natom.le.26)then
         icomax2=1
     else
         icomax2=2
     endif
     !icomax2=1
     call resize_models(fsmodel,icomax*icomax2+numfsmodel)
   endif
   rfrandomfinalmax=99999999.0
   rfrandomfinal=99999999.0
   ico=0
 2 ico=ico+1
   ico2=0
 3 ico2=ico2+1
   call AllocaMappa(2) 
   call AllocaMappa(1) 
                 !call test_makemap()
!
   imore=0
   call c_fortran_al_lavoro(0)
   call cpu_time(fstart_time)               ! tempo di calcolo
   kprintcode = 0  ! set 1 to actvite print
   iprinCode = 0
   if (kprintcode == 0) then
       kAction = 5
   else
       kAction = 4
   endif
   iriet = 2
   kevent = 0
!
   if (jscreen /= 0) then
       call abilita_tasti('run')
       if (more_trials) call toolbar_set_state('Skip'//char(0),1)
       if(coderbm.lt.-10) then
         call write_message(string='    Structure Solution       ',pos=1)
         call write_message(string='RAMM procedure on trial ',inum=ico,pos=2)
         call write_message('RAMM procedure',pos=3)
       elseif(coderbm==-10) then
         call write_message(string='COVMAP + RBM procedure on set ',inum=numset,pos=2)
         call write_message('COVMAP + RBM procedure',pos=3)
       else
         call write_message(string='RBM procedure on set ',inum=numset,pos=2)
         call write_message('RBM procedure',pos=3)
       endif
   endif

   call AllocaRiflessi(1)
   call LeggiRiflessi
   call fsinterface(code=2)
   if(nats.gt.0)call sfcalc(ref,atm,spacegr,celem)
   if(knw.gt.0)then
      call to_coord(0)
      call write_message_found(4)
      write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Starting model) ', &
!corr      vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),errefs
      vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),Rvalue(ref%fo,ref%fc)
      call write_phase_error(ref)
   endif
   call InitFour()
   allocate(xyzssav(nats))
   do i=1,nats
       xyzssav(i)=xyzs(4,i)
   enddo
   if(coderbm.gt.1)call recipcorr(kprintcode)
   call fsinitlsq()
   if (index(fscond%sprint,'V') > 0 .and. knw > 0) then
       call write_reflections(lo,refl=ref,code=7)
   endif
!!!!!!test SA
      !call test_SA(); return
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   !if(coderbm.lt.-10.and.maxval(no(1:nk)).gt.17.and.bt.gt.2.0)bt=2.0
   if(coderbm.lt.-10)bt=0.0
   !if(coderbm.lt.-10.and.nats.gt.27)bt=3.0
   if (kprintcode == 0) fscond%sprint = 'S'
   do i=1,nats
      xyzs(4,i)=xyzssav(i)
   enddo
   deallocate(xyzssav)
   iz = 1
   call EnableSingleIteration(iz)
!   
!  Esegui un affinamento automatico della struttura
   fscond%auto_stru = .true.
   if(coderbm.lt.-10.and.ico2.eq.1) call randommodel(coderbm,ico,ico2,kevent,rfrandomstart,rfrandomfinal)
!   
    nfrbm=0
    nfrbmsog2=2
24 nfrbm=nfrbm+1
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   !call avvisolati(5,0,5)
   if(coderbm.ge.-10)then
   call avvisolati(5,0,5)
   else
   call avvisolati(5,0,3)
   endif
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   call fillatom(atm)
   if(ico2.eq.1)call adjustbiso
!  Disegna
   if (kprintcode == 1.and.nfrbm.eq.1) then
   !if (kprintcode == 1) then
       write(6,'(/,a)')'       **** RESOLUTION BIAS MINIMIZATION (RBM) Procedure ****'
       if(coderbm.le.1)write(6,'(/,a)')'       ****           DIRECT SPACE                       ****'
       if(coderbm.gt.1)write(6,'(/,a)')'       ****            DUAL SPACE                        ****'
       write(6,'(/,a)')' RBM Procedure Starting Model'                                     
       call print_atoms(atm(:nats))
   endif
#if defined(REGROUP) 
   call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.,move=.true.)
#else
   call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.)
#endif
   if (jscreen > 0) then
       call draw_atoms(atm,lconn)
   endif
   call fillatom(atm)
   call maincl(5, iprinCode) ! genera iconn per adjustbiso 
   if(ico2.eq.1)call adjustbiso
   ncase3=0
   ncase3max=5
   nmcicli=6
   amult = pts * float(nsym * ( icent + 1 ) )
   valsel = huge(1.0)
   ntsteps = ncase3max + 1
   errefsm=99999.0
   call progress_bar_init('Starting RBM Procedure',2*ncase3max*nats+2)
   if(imove.eq.1)call randomcoord
   do ncase3=1,ncase3max
      call progress_bar_update()
      kblock(1:nats)=0
      call maincl(kaction,0)
      kblock(1:nats)=1
      call avvisolati(5,0,3)
      do i=1,nats
         atm(i)%xc=xyzs(:3,i)
      enddo
      call Allocafuncls(ALLOCA,numoss+nrestraints(resvf))
      call setweilsq()
      if(knw > 0 .and. kprintcode == 1) call to_coord(0)
      if(ncase3.eq.1) then
         natsold=nats
         if(nats>1.and.nfrbm.eq.1) call deleting(1,figurai1,figurai2,figurao1,figurao2,kprintcode)
         if (kprintcode == 1) then
             if(nats < natsold)then
                write(6,'(/,a,i5,a)')' Discarding Atoms Procedure:',(natsold-nats),' atoms have been rejected' 
                write(6,'(/,a,2(f20.2,f20.2))')' Cost Functions: Discarding Atoms Procedure',figurai1,figurai2,figurao1,figurao2
                write(6,'(/,a)')' RBM Procedure: Discarded atoms '                                     
                call print_atoms(atm(:nats))
                if(knw.gt.0)then
                  call to_coord(0)
                  write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Discarded positions) ', &
                  vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),errefs
                endif
             else
                write(6,'(/,a)')' Discarding Atoms Procedure:no atom has been rejected' 
             endif
         endif
      endif
!corr      anat1 = sum(atm(:nats)%ocry)*amult
!corr      npadd = (1.2*nat-anat1)/amult
!corr      npadd = sign(ceiling(real(abs(npadd)) / (nmcicli - ncase3 + 1)),npadd)
!corr      natom=0
!corr      do i=1,nk
!corr         natomm=int(float(nw(i))/float((icent+1)*spacegr%ncoper*nsym)+0.5)
!corr         if(natomm.lt.1)natomm=1
!corr         if(no(i).ne.1)natom=natom+natomm                                                   
!corr      enddo
      natom = nint(nasym_unit(celem,spacegr%nsymop,neutro==0))
      npadd=(1.2-0.05*(ncase3-1))*natom
      if(natom.lt.10.and.ncase3.lt.(ncase3max-1))then
        if(npadd.lt.(natom+2))npadd=(natom+2)
      else
        if(npadd.lt.(natom+1))npadd=(natom+1)
      endif
      call InitFour()
      if (kprintcode == 1) write(6,'(/,a,i5)')' RBM Procedure: FOURIER MAP cycle nr.',ncase3 
      scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
      !call RunToolbar(1,'RBM Procedure on set '//trim(strnum)//': Fourier Map')
      call write_message('Fourier Map Calculation. Cycle n. ',inum=ncase3,pos=3)
      call clear_messages(ipos=4,fpos=6)
      if(coderbm.le.1)call fsfourierbm1(npadd,npref,ncase3,coderbm,kprintcode,kevent) ! Fourier
      if(coderbm.gt.1)call fsfourierbm2(npadd,npref,ncase3,coderbm,kprintcode,kevent) ! Fourier
      if (kevent == 2 .or. kevent == 1) go to 20
      if(ncase3.eq.ncase3max.and.coderbm.lt.0.and.ico2.eq.1)call mapconn(npref,imore,nfrbm,nfrbmsog2)
      if (kprintcode == 1) write(6,'(/,a,i5,/)')' RBM Procedure: LSQ cycle nr.',ncase3 
      call write_message('Automatic structure refinement',pos=3)
      if (knw == 1) then
          call to_coord(0)
          call write_message_found(6)
          if (kprintcode == 1) call write_phase_error(ref)
      endif
      call reset_restraints(resvf,wqqf)
      !write(0,*)'sump=',sum(weilsq(:nrefl)),numoss,nrefl
      call Allocafuncls(ALLOCA,numoss,.true.) ! rialloca mantenedo il contenuto
      !write(0,*)'sumd=',sum(weilsq(:nrefl)),numoss,nrefl
      call autofslsq(kevent)
      if(errefs.lt.errefsm)then
        errefsm=errefs
        xmapbest=xmap
        natcopy=nats
        call copy_atoms(atm_copy,atm)
      endif
      if(knw > 0 .and. kprintcode == 1)call to_coord(0)
      call maincl(5, iprinCode)
      call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,inte=xyzs(4,:),elem=celem)
      if (jscreen > 0) then
          call draw_atoms(atm,icon=iconn)
      endif
      if (kevent == 2 .or. kevent == 1) go to 20
   enddo
   if (kprintcode == 1) write(6,'(/,a,/)')'  RBM Procedure: Best LSQ Map'
   xmap=xmapbest
   nats=natcopy
   call copy_atoms(atm,atm_copy)
   call fillatom(atm)
   call sfcalc(ref,atm,spacegr,celem)
   call maincl(5, iprinCode)
   call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,inte=xyzs(4,:),elem=celem)
   if (jscreen > 0) then
       call draw_atoms(atm,icon=iconn)
       call write_message('Best LSQ Model',pos=3)
   endif
!corr-non serve   call fillatom(atm)
   if(knw > 0 .and. kprintcode == 1) then
      call to_coord(0)
      write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Best LSQ map) ', &
      vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
   endif
   allocate(ovr(npref),foss(npref))
   call defovlexrN(ovr,sogover)
   call ripartisci_N(ovr,ref(:npref)%fo,fobsold(:npref),ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1),foss,nmcicli)
   ref(:npref)%fo=foss
   deallocate(ovr,foss)
   call Allocafuncls(DEALLOCA)
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   call avvisolati(5,0,4)
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   call impose_restr()
   call Allocafuncls(ALLOCA,numoss+nrestraints(resvf))
   call setweilsq()
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)  
   call weight_restr()
!corr   if(maxval(no(1:nk)).le.17)then
   if(maxval(celem%z) <= Cl_at)then
     wqqf(1)=wqqf(1)*2.0
     wqqf(2)=wqqf(2)*2.0
     wqqsav(1)=wqqf(1)*2.0
     wqqsav(2)=wqqf(2)*2.0
   else
     wqqf(1)=wqqf(1)*0.5
     wqqf(2)=wqqf(2)*0.0
     wqqsav(1)=wqqf(1)*0.5
     wqqsav(2)=wqqf(2)*0.0
   endif
!corr   call setkcond()
   if (kprintcode == 1) write(6,'(/,a)')' RBM Procedure: AUTOMATIC RESTRAINED LSQ'
   call write_message('Automatic structure refinement',pos=3)
   call progress_bar_update()
   if (knw == 1) then
       call to_coord(0)
       call write_message_found(6)
   endif
   call autofslsq(kevent)
   scaleffe = sum (fobsold(:npref)) / sum (ref(:npref)%fc)
   erreffe = sum(abs(fobsold(:npref) - scaleffe*ref(:npref)%fc))/sum(fobsold(:npref))
   if(erreffe.gt.0.55)go to 33
!corr   if(maxval(no(1:nk)).gt.17)go to 33
   if(maxval(celem%z) > Cl_at) go to 33
   allocate(ovr(npref),foss(npref))
   call defovlexrN(ovr,sogover)
   call ripartisci_N(ovr,ref(:npref)%fo,fobsold(:npref),ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1),foss,nmcicli)
   ref(:npref)%fo=foss
   deallocate(ovr,foss)
   call Allocafuncls(DEALLOCA)
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   call avvisolati(5,0,4)
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   call impose_restr()
   call Allocafuncls(ALLOCA,numoss+nrestraints(resvf))
   call setweilsq()
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)
   call weight_restr()
   wqqf(1)=wqqf(1)*0.5
   wqqf(2)=wqqf(2)*0.5
   wqqsav(1)=wqqf(1)*0.5
   wqqsav(2)=wqqf(2)*0.5
!corr   call setkcond()
   if (kprintcode == 1) write(6,'(/,a)')' RBM Procedure: AUTOMATIC RESTRAINED LSQ'
   call write_message('Automatic structure refinement',pos=3)
   call progress_bar_update()
   if (knw == 1) then
       call to_coord(0)
       call write_message_found(6)
   endif
   call autofslsq(kevent)
33 continue
!corr   write(6,*)'KPRINTCODE',kprintcode,imore
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   call reset_restraints(resvf,wqqf)
   !if(imore.gt.0.and.nats.gt.nint(1.2*natom))go to 65
   if((coderbm.lt.0.and.nats.gt.nint(1.2*natom)))go to 65
   noptim=0
!corr-unused 500 continue
   noptim=noptim+1
!corr-bug: moved before go to 65  call reset_restraints(resvf,wqqf)
   call optimize_mod(noptim,kprintcode)
65 continue
   if (coderbm.le.1) then
       title = 'Final Model after RBM Procedure in Direct Space'
   elseif (coderbm >= 2) then
       title = ' Final Model after RBM Procedure in Dual Space'
   endif
   call print_atoms(atm(:nats),title=title)
   call maincl(kAction, iprinCode)
   call xyz_to_atom(atm,xyzs(:3,:nats),occr=xyzs(5,:),nz=nz,inte=xyzs(4,:),elem=celem)
   if (jscreen > 0) then
       call draw_atoms(atm,icon=iconn)
       !corr call scrper('RBM Procedure: Final Model',0,-1)
       !call RunToolbar(-1,' ')
   endif
   if(natom.le.10)then                         
     nvb=1
   else
     nvb=nfrbmsog2
   endif
   if(coderbm.lt.0.and.imore.gt.0.and.nfrbm.ge.nvb)then
   allocate(bapp(nats))
   bapp(:) = atm(:nats)%biso
   where(bapp(:) < 0.0) bapp(:) = 0.0
   call avevar(bapp(:),bmed,bvar)
   call avestd(bapp(:nats),3.0,bmed)
   nbb1=0
   do i=1,nats
     if(atm(i)%biso.le.bmed)nbb1=nbb1+1
   enddo
   bvar=sqrt(bvar)
   deallocate(bapp)
   allocate(vrem(nats))
   vrem=0
   if(float(nbb1)/float(nats).gt.0.75)then
     bsog=3.0
   else
     bsog=6.0
   endif
   do i=1,nats
     if((atm(i)%biso.gt.bsog*bmed).or.atm(i)%biso.gt.100.0.and.natom.le.30)vrem(i)=1
   enddo
   call remove_atoms(vrem)
   deallocate(vrem)
   endif
   if(coderbm.lt.0)then
   allocate(vrem(nats))
   vrem=0
   do i=1,nats
     if(atm(i)%biso.gt.100.0.and.nats.le.15)vrem(i)=1
     if(atm(i)%biso.gt.150.0.and.nats.le.25)vrem(i)=1
     if(atm(i)%biso.gt.300.0.and.nats.le.35)vrem(i)=1
!corr     if(atm(i)%biso.gt.100.0.and.maxval(no(1:nk)).gt.17)vrem(i)=1                    
     if(atm(i)%biso.gt.100.0.and.maxval(celem%z) > Cl_at)vrem(i)=1                    
   enddo
   call remove_atoms(vrem)
   deallocate(vrem)
   endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))      
   call sfcalc(ref,atm,spacegr,celem)
   if(knw > 0) then
      call to_coord(1)
      call write_message_found(4)
      write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Final map) ', &
        vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
      if (kprintcode == 1) then
          write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Final map) ', &
           vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
      endif
   endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!
   allocate(ovr(npref))
   call defovlexr2(ovr,0.7)
   do j=1,10
   scaleffe=0.0
   erreffe=0.0
   s1=0.0
   s2=0.0
   do i=1,npref
     if(ovr(i).le.j)then
       !s1=s1+ref(i)%fo
       s1=s1+fobsold(i)
       s2=s2+ref(i)%fc
     endif
   enddo
   scaleffe = s1/s2                                                               
   s1=0.0
   do i=1,npref
     if(ovr(i).le.j)then
       !if(ref(i)%fo.gt.0.0)s1=s1+ref(i)%fo
       if(fobsold(i).gt.0.0)s1=s1+fobsold(i)
     endif
   enddo
   scaleffe = s1/s2                                                               
   s2=0.0
   do i=1,npref
     if(ovr(i).le.j)then
       !if(ref(i)%fo.gt.0.0)s2=s2+(abs(ref(i)%fo - scaleffe*ref(i)%fc)**2.0)/ref(i)%fo
       if(fobsold(i).gt.0.0)s2=s2+(abs(fobsold(i) - scaleffe*ref(i)%fc)**2.0)/fobsold(i)
       !s2=s2+abs(ref(i)%fo - scaleffe*ref(i)%fc)
       !s2=s2+abs(fobsold(i) - scaleffe*ref(i)%fc)
     endif
   enddo
   !erreffe = s2/s1                                                                          
   erreffe = sqrt(s2/s1)                                                                          
   erreovr(j)=erreffe
   enddo
   !write(6,'(a,10f15.5)')' Reliability', erreovr(1:10)
   erreffe=erreovr(1)
   deallocate(ovr)
   if(nfrbm.eq.1) erreffemin=erreffe
   if(erreffemin.le.0.2)then
     erreffesog=erreffemin
   else
     erreffesog=1.05*erreffemin
   endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!
      natbest = nats
      call copy_atoms(atbest,atm)
!   if(coderbm.lt.0.and.natom.lt.10)then
!      nfrbmsog1=2
!      nfrbmsog2=2
!  !elseif(coderbm.lt.0.and.natom.le.15.and.natom.gt.10.and.nfrbm.le.3)then
!    elseif(coderbm.lt.0.and.natom.le.15.and.natom.ge.10.and.nfrbm.le.3)then
!      nfrbmsog1=4
!      nfrbmsog2=4
!    elseif(coderbm.lt.0.and.natom.gt.15.and.nfrbm.le.3)then
!      nfrbmsog1=6
!      nfrbmsog2=6
!    endif
    if(coderbm.lt.0.and.natom.lt.10)then
       nfrbmsog1=2
       nfrbmsog2=2
   !elseif(coderbm.lt.0.and.natom.le.15.and.natom.gt.10.and.nfrbm.le.3)then
     elseif(coderbm.lt.0.and.natom.le.15.and.natom.ge.10.and.nfrbm.le.3)then
       nfrbmsog1=4
       nfrbmsog2=4
     elseif(coderbm.lt.0.and.natom.gt.15.and.nfrbm.le.3)then
       nfrbmsog1=4
       nfrbmsog2=4
     elseif(coderbm.lt.0.and.natom.gt.30.and.nfrbm.le.3)then
       nfrbmsog1=6
       nfrbmsog2=6
     endif
     if(ico2.gt.1)then
       nfrbmsog1=2
       nfrbmsog2=2
     endif
     ref(:)%fo = fobsold(:)         ! ripristina gli Fo 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
   if(coderbm.lt.-10)then
     kblock(1:nats)=0
     call maincl(5,0)
     kblock(1:nats)=1
     call avvisolati(5,0,0)
     do i=1,nats
         atm(i)%xc=xyzs(:3,i)
     enddo
     allocate(iorder(nats))
     iorder=0
     allocate(nbuild(nats*2))
     nbuild=0
     do i=1,iconn(1)
        l1=iconn((i-1)*3+2)
        l2=iconn((i-1)*3+3)
        nbuild(l1)=nbuild(l1)+1
        nbuild(l2)=nbuild(l2)+1
     enddo
     do i=1,nats
!corr       if(nbuild(i).eq.0.and.no(atm(i)%nz/nzConst).lt.8)iorder(i)=1
       if(nbuild(i).eq.0.and.atm(i)%z().lt.8)iorder(i)=1
       !if(nbuild(i).eq.0.and.i.gt.natom/2)iorder(i)=1
     enddo
     call remove_atoms(iorder)
     deallocate(iorder)
     deallocate(nbuild)
     call fillatom(atm)
!corr     call fcalcan(ref,atm(:nats))
     call sfcalc(ref,atm,spacegr,celem)
   endif
!!!!!!!!!!!!!!!!!!!!!!!!!!
   if(coderbm.ge.-10)then
   if(coderbm.lt.0.and.natom.le.10.and.nfrbm.le.nfrbmsog2)then
       go to 24
   elseif(coderbm.lt.0.and.natom.le.15.and.natom.gt.10.and.nfrbm.le.nfrbmsog2)then
       go to 24
   elseif(coderbm.lt.0.and.natom.gt.15.and.nfrbm.le.nfrbmsog2)then
       go to 24
   endif
   else
   if(coderbm.lt.-10)then
     call calcola_occ(atm,spacegr,set_cell_type(cell))
     call atom_string(atm,celem)
     call fillatom(atm)
!corr     call fcalcan(ref,atm(:nats))      
     call sfcalc(ref,atm,spacegr,celem)
     scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
     call calcerrefs(npref,1,scalf%val)  
     if(natom.le.26)then
       rsog=0.5
     else
       rsog=0.6
     endif
   endif
   !if(errefs.gt.0.93*rfrandomstart.or.nfrbm.le.3)then
   !if(errefs.lt.1.25*rfrandomstart.and.errefs.gt.0.95*rfrandomstart)then
   write(6,'(a,2f10.2)')' Rf Final map', errefs,rfrandomstart
   !if(errefs.lt.1.25*rfrandomstart.and.errefs.lt.0.6)then
   if(coderbm.lt.0.and.natom.le.10.and.nfrbm.le.nfrbmsog2)then
       go to 24
   elseif(coderbm.lt.0.and.natom.le.15.and.natom.gt.10.and.nfrbm.le.nfrbmsog2)then
       go to 24
   elseif(coderbm.lt.0.and.natom.gt.15.and.nfrbm.le.nfrbmsog2)then
       go to 24
   endif
   !endif
   endif
   if(coderbm.lt.0)then
      nats = natbest
      call copy_atoms(atm,atbest)
      call fillatom(atm)
!corr      call fcalcan(ref,atm(:nats))
      call sfcalc(ref,atm,spacegr,celem)
   endif
20 continue
   ref(:)%fo = fobsold(:)         ! ripristina gli Fo 
   title = 'Final Model'
   call calcola_occ(atm,spacegr,set_cell_type(cell))
   call atom_string(atm,celem)
   call print_atoms(atm(:nats),title=title)
   call create_connectivity(atm,lconn,set_cell_type(cell),spacegr,check=.true.,move=.true.) !  Raggruppa gli atomi
   if (jscreen > 0) then
       call draw_atoms(atm,lconn)
       call abilita_tasti('structure+pattern')
   endif
!
!  Update model at the end
!corr   call fillatom(atm)
   call bond_to_iconn(lconn,iconn)
   call update_model(atm,lconn,1)
!
   call sfcalc(ref,atm,spacegr,celem)
   call clear_messages(ipos=4,fpos=6)
   if (knw > 0) then
       call to_coord(1)
       write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Last map) ', &
         vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
   endif
   if(coderbm.lt.-10)then
      scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
      call calcerrefs(npref,1,scalf%val)  
      rfrandomfinal=errefs
      !if(((ico2.eq.icomax2.or.errefs.lt.rfrandomstart)).or.rfrandomfinal.ge.0.5)then
      if (knw > 0) then
        call to_coord(1)
        write(6,'(/,a,2i6,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (RANDOM Final map) ', ico,ico2,&
        vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
      endif
      !endif
   endif
!corr   call to_coord_ref(-1)
   if (knw > 0 .or. ModelToCompare /= 0) then
       call to_coord_sir(-1,atm,ref,size(ref),set_cell_type(cell),spacegr,lo,cryst(1)%atpub)
       call write_message_found(4)
   endif
   call progress_bar_close()
   call calcerrefs(npref,1,kpr=1) ! calcola RF
   if(coderbm<-10) then
     call write_message(string='RAMM procedure on set '//trim(i_to_s(ico))//' is completed',pos=2)
   elseif(coderbm==-10) then
     call write_message(string='COVMAP procedure on set '//trim(i_to_s(numset))//' is completed',pos=2)
   else
     call write_message(string='RBM procedure on set '//trim(i_to_s(numset))//' is completed',pos=2)
   endif
   call write_message(string='Final model with RF '//trim(r_to_s(errefs*100,3))//' was selected',pos=3)
   call Allocafuncls(DEALLOCA)
   call AllocaCalcProfile(2)
   call fsclose()
   kload12 = .FALSE.
   call cpu_time(fend_time)               ! tempo di calcolo
   write(6,'(2x,a9,f0.3,a)')'CPU time:',(fend_time-fstart_time)/60.0,'m'
   call c_fine_lavoro(0)
   if (kevent == 2 .and. coderbm.lt.-10) go to 99
   if(coderbm.lt.-10)then
!corr - salva il modello
      numfsmodel = numfsmodel + 1
      call model_set(fsmodel(numfsmodel),atm,lconn,fom=(/real(numfsmodel),rfrandomfinal*100,vett_test(3),vett_test(4)/))
!corr
      if(rfrandomfinal.lt.rfrandomfinalmax)then
        rfrandomfinalmax=rfrandomfinal
        natsrandom=nats
      endif
!     if(rfrandomfinal.lt.rfrandomstart.and.rfrandomfinal.lt.0.5)then
     if(rfrandomfinal.lt.rfrandomstart.and.rfrandomfinal.lt.0.47)then
        write(6,'(a,2i6,2f10.5,a)') 'Rf RANDOM Trial nr.', ico,ico2,rfrandomfinal,rfrandomstart,' MAY BE A SOLUTION *******'
        go to 99   
        !if(ico.lt.icomax)go to 2
        !if(ico.lt.icomax) go to 2
     else
        !if(ico2.lt.icomax2.and.rfrandomfinal.lt.rsog)then
!        if(ico2.lt.icomax2.and.(rfrandomfinal.lt.rsog.or.(rfrandomfinal.lt.rfrandomstart.and.rfrandomfinal.ge.0.5)))then
        if(ico2.lt.icomax2.and.(rfrandomfinal.lt.rsog.or.(rfrandomfinal.lt.rfrandomstart.and.rfrandomfinal.ge.0.47)))then
        !if(ico2.lt.icomax2.and.rfrandomfinal.lt.0.5)then
           write(6,'(a,2i6,2f10.5,a)') 'Rf RANDOM Trial nr.', ico,ico2,rfrandomfinal,rfrandomstart,' MAY BE NOT  SOLUTION'
           go to 3
        else
           write(6,'(a,2i6,2f10.5,a)') 'Rf RANDOM Trial nr.', ico,ico2,rfrandomfinal,rfrandomstart,' MAY BE NOT  SOLUTION'
            if(ico.lt.icomax) go to 2
        endif
     endif
   endif
99 continue
   end subroutine fsrbm
!----------------------------------------------------------------------------------------------------
!corr
!corr   subroutine test_SA()
!corr   USE simulated_anneal
!corr   USE bb_bc
!corr   USE sannel
!corr   USE variables, only:lconn,atm      ,ref
!corr   USE atom_type_util
!corr   USE General, only:celem, neutro,cell
!corr   USE symmetry, only:nsymtot
!corr   USE fragmentmod
!corr   USE strutil
!corr   USE model_util
!corr   USE FSREFINEMENT, only: fobsold
!corr   USE unit_cell
!corr   USE connect_mod
!corr   USE errormod
!corr   implicit none
!corr   type(SimAnn_Conditions_type) :: scf
!corr   type(bb_bc_condition)        :: bcondf
!corr   type(opti_info_type)         :: goptf
!corr!corr   integer                      :: irefb
!corr   integer :: i,j
!corr   integer, parameter :: NMODEL=1
!corr   type(atom_type), dimension(:), allocatable :: atmr
!corr   type(error_type) :: saerr
!corr!
!corr!  Init conditions outside main loop
!corr   call global_init(goptf)
!corr   call sa_set_default(scf)
!corr   call bb_bc_initialize(bcondf)
!corr!
!corr!  Change conditions
!corr   goptf%cftype=CHI2FACT
!corr   goptf%popt = 'PMVSB'
!corr   !scf%autont = .false.
!corr   !scf%nt = 20
!corr   goptf%nrun = 10
!corr   !goptf%autoalgo = .false.
!corr   call reallocate_legm(lconn,0)  ! cancel connectivity if you work on isolated atoms
!corr      !SetFob(:size(ref),4) = ref%fo**2
!corr      !iFirstRietveld = 1
!corr   do i=1,NMODEL
!corr      write(0,*)'MODELLO n.',i
!corr!
!corr!     Set structure model here in atm/lconn
!corr      call reallocate(atm,nint(sum(celem%nw,mask=celem%ptab>1)/nsymtot))
!corr      call set_atoms(atm,celem,nsymtot,neutro)
!corr      call randomize_molecule(atm,lconn,set_cell_type(cell))
!corr      !call print_atoms(atm,kpr=0)
!corr!
!corr!!!FIXME - disabilita la creazione dei file cif
!corr      write(0,*)'1REF=',size(ref),sum(ref%fo),size(fobsold)
!corr      call sa_prelim(goptf,scf,bcondf,.false.,init_cond=.false.,saerr=saerr)
!corr      ref%fo = fobsold(:size(ref))
!corr      write(0,*)'2REF=',size(ref),sum(ref%fo)
!corr      call sa_run(goptf,scf,bcondf,extra=.true.,speedup=0.01)
!corr      write(0,*)'3REF=',size(ref),sum(ref%fo)
!corr      do j=1,goptf%nrun
!corr         call model_get(samodel(i),atmr)
!corr         !call print_atoms(atmr,title='modello n.'//trim(i_to_s(j)),kpr=0)
!corr      enddo
!corr   enddo
!corr   call exitsannel()
!corr      write(0,*)'4REF=',size(ref),sum(ref%fo)
!corr!
!corr   end subroutine test_SA
!corr
!----------------------------------------------------------------------------------------------------
   subroutine randommodel(coderbm,ico,ico2,kevent,rfrandomstart,rfrandomfinal)
   USE Atomi
   USE General, only:nrefl,cell,vetint,celem,spacegr
   USE Molcom
   USE General, only : knw,neutro
   USE Symmetry, only : nsym,icent,jsys
   USE variables, only:ref,atm
   USE GENLSQ
   USE TestModel
   USE FSREFINEMENT, only:calcerrefs,resvf,numoss,scalf,errefs,npref,scalefactor,autofslsq,wqqf
   USE RRESTR
   USE atom_type_util
   USE sinterface, only: fillatom
   USE drawatoms
   USE molpnew
   USE CGEOM
   USE stat
   USE Mappa
   USE messagemod
   USE strutil
   USE enable_amb
   USE compare_struct
   USE connect_mod
   USE importexport
   USE unit_cell
   USE nr
   USE reflection_type_util
   USE elements, only: nasym_unit,Cl_at,H_at,numelem
   USE progtype, only: ALLOCA,DEALLOCA
   implicit none
   type(atom_type), allocatable, dimension(:) :: atm_copy
   type(atom_type), allocatable, dimension(:) :: atm_copy2
   type(atom_type), allocatable, dimension(:) :: atm_start
   !!!!!!!!!!!!!!!!!!!!integer, intent(in)  :: coderbm
   integer              :: coderbm
   integer              :: i,j
   integer              :: natom,natomm
   integer              :: kAction, iprinCode
   real                 :: erreffe,errefsm,erreffe0,errefsm0
   integer              :: kprintcode
   integer              :: k,ijj,ntrial,ntrial1,ntrial2,ntrial3  
   integer              :: ik1,ik2,ik3                                            
   integer              :: kevent
   real                 :: dd,da,coef
   real                 :: liminf,limsup,yrandom                                
   real                 :: rfrandomstart,rfrandomfinal   
   real                 :: dmin,dmax            
   integer              :: imin,imax            
   integer              :: jmin,jmax            
   real, dimension(3,3) :: gg
   real, dimension(3)   :: vet
   real, dimension(3)   :: xeq,xrandom
   integer              :: ifin
   integer              :: kk,ktt,ifii
   integer              :: ico
   integer              :: ico2
   integer              :: natssav                      
   integer              :: iyes                  
   integer              :: nkel
   if (jscreen /= 0) call write_message('RAMM model generation',pos=3)
   write(6,'(20x,40("+"),//,30x,"RAMM model generation",//,20x,40("+"))')
   errefsm=rfrandomfinal
   errefsm=999999999.0  
   iyes=0
   kprintcode=0
   iprinCode=0
   kaction = 5 - kprintcode
! 11 continue
   call random_number(yrandom)
!corr   natom=0
!corr   do i=1,nk
!corr         natomm=nint(float(nw(i))/float((icent+1)*spacegr%ncoper*nsym)+0.4)
!corr         if(natomm.lt.1)natomm=1
!corr         if(no(i).ne.1)natom=natom+natomm                                                   
!corr   enddo
   natom = nint(nasym_unit(celem,spacegr%nsymop,neutro==0))
   nkel = numelem(celem)
   if(coderbm.lt.-10.and.ico2.eq.1)then
   if(ico.gt.1)then
     do i=2,ico
       call random_number(yrandom)
     enddo
   endif
   gg = matrice_metrica(cell)
   vet(1)= 1.0
   vet(2)=-1.0
   ifin=icent+1
      ntrial1=200                
      if(natom.le.10)ntrial1=150
      if(natom.ge.20.and.jsys.eq.1)ntrial1=250
      if(natom.gt.25.and.jsys.eq.1)ntrial1=270
      ntrial2=1
      ntrial3=1
   ntrial=ntrial1*ntrial2*ntrial3                                                                 
   write(6,'(a,i0)')'   Number of generated models: ', ntrial
   !ntrial1=1
   do ik1=1,ntrial1
   do ik2=1,1
   do ik3=1,1
   !go to 111
   nats=natom
   j=nats+1
   do i=1,nkel
      !natomm=nint(float(nw(i))/float((icent+1)*spacegr%ncoper*nsym)+0.4)
      natomm=nint(celem(i)%nw/spacegr%nsymop)
      if(natomm.lt.1)natomm=1
!corr      if(no(i).ne.1)then
      if(celem(i)%z /= H_at)then
         do k=1,natomm
            j=j-1
            nz(j)=i*100
!corr            xyzs(4,j)=float(no(i)*100)
!corr            vetint(j)=float(no(i)*100)
            xyzs(4,j)=float(celem(i)%z*100)
            vetint(j)=xyzs(4,j)
         enddo
      endif
   enddo
! 6  continue
   do i=1,nats
         liminf=0.0        
         limsup=1.0              
         call random_number(xrandom)
         xyzs(1,i)=liminf+xrandom(1)*(limsup-liminf)
         xyzs(2,i)=liminf+xrandom(2)*(limsup-liminf)
         xyzs(3,i)=liminf+xrandom(3)*(limsup-liminf)
      if(i.gt.1)then
 5    continue
      dmin=9999999.0
      dmax=-9999999.0
      do ijj=1,i-1
            do ktt=1,spacegr%ncoper
               do ifii=1,ifin
                  coef=vet(ifii)
                  do kk=1,nsym
                    call xequi(xyzs(1:3,i),kk,coef,xeq,ktt)
                    dd = xdisteq(xyzs(1:3,ijj),xeq,gg)
                    if(dd.lt.dmin)then
                      dmin=dd
                      imin=i
                      imax=ijj
                    endif
                    if(dd.gt.dmax)then
                      dmax=dd
                      jmin=i
                      jmax=ijj
                    endif
                  enddo
               enddo
            enddo
      enddo
          if (natom .le. 30) then
          call random_number(yrandom)
          if(natom.le.22.or.natom.ge.25)then
          da=1.0+yrandom*0.5
          else
          da=1.0+yrandom*0.3
          endif
                    if(dmin.lt.da)then
                     call random_number(xrandom)
                     xyzs(1,i)=liminf+xrandom(1)*(limsup-liminf)
                     xyzs(2,i)=liminf+xrandom(2)*(limsup-liminf)
                     xyzs(3,i)=liminf+xrandom(3)*(limsup-liminf)
                     go to 5
                    endif
          endif
!corr  55 continue
      endif
!corr    if(maxval(no(1:nk)).le.17)then
   if(maxval(celem%z) <= Cl_at)then
       bfac(i)=3.5
   else
       bfac(i)=2.5
    endif
   enddo
   occpch(:nats) = 1.0
   call xyz_to_atom(atm,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,inte=xyzs(4,:),elem=celem)
! 77 continue
   call calcola_occ(atm,spacegr,set_cell_type(cell))
   call atom_string(atm,celem)
! 111 continue
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   call reset_restraints(resvf,wqqf)
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   call fillatom(atm)
   call Allocafuncls(ALLOCA,numoss)
   call setweilsq()
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)  
   erreffe0=errefs
   call copy_atoms(atm_start,atm)
   call autofslsq(kevent)
   call fillatom(atm)
   call calcola_occ(atm,spacegr,set_cell_type(cell))
   call atom_string(atm,celem)
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)  
   erreffe=errefs
   if ( kevent == 2) go to 7
   if((erreffe.lt.errefsm.and.nats.gt.natom/2) .or. ik1 == 1)then
        errefsm=erreffe
        errefsm0=erreffe0
        natssav=nats
        call copy_atoms(atm_copy,atm)
        call copy_atoms(atm_copy2,atm_start)
        write(6,'(/,a)')'       **** RANDOM GOOD MODEL ****'
        write(6,'(a,f8.2)')'     R-f RANDOM MODEL   ',erreffe
        call print_atoms(atm(:nats))
        if(knw.gt.0)then
           call to_coord(0)
           call write_message_found(4)
           write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (RANDOM GOOD model) ', &
           vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),erreffe
        endif
        iyes=1
   endif
   enddo
   enddo
   enddo
7  continue
   if(iyes.eq.1)then
   rfrandomstart=errefsm
   nats=natssav
   call copy_atoms(atm,atm_copy)
   call fillatom(atm)
   endif
   if(iyes.eq.1)then
   write(6,'(a,f8.2)')'     R-f RANDOM Starting Model   ',errefsm0
   write(6,'(a,f8.2)')'     R-f RANDOM Refined Starting Model   ',errefsm
   write(6,'(a,2i6,f10.3/)')'     nr. Observ. Param. Ratio', nrefl,nats*4+1,float(nrefl)/float(nats*4+1)
   call print_atoms(atm(:nats),title='RANDOM Refined Starting Model')
   if(knw.gt.0)then
      call fillatom(atm_copy2)
      call to_coord(0)
      call write_message_found(4)
      write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (RANDOM Starting model) ', &
      vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),errefs
      call fillatom(atm)
      call to_coord(1)
      call write_message_found(4)
      write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (RANDOM Refined Starting model) ', &
      vett_test(3),' on',nats,vett_test(1),' true dist.  ',vett_test(4),errefs
   endif
   endif
   endif
   call Allocafuncls(DEALLOCA)
   call Allocafuncls(ALLOCA,numoss)
   end subroutine randommodel
!----------------------------------------------------------------------------------------------------

   subroutine fsrbmw(coderbm)
!
!  Chiamata dalla grafica per RBM
!
   USE ilmviewmod
   USE exportfiles
   implicit none
   integer, intent(in) :: coderbm
   integer             :: kevent
!
   call jav_set_modify(0)
   call save_action(RBM,0,1)
   call fsrbm(coderbm,kevent)
   call export_files() ! esporta modello in presenza del comando '%export'
   call save_action(RBM,1,1)
   call jav_set_modify(1)
!
   end subroutine fsrbmw

!----------------------------------------------------------------------------------------------------
   subroutine optimize_mod(noptim,kprintcode)
   USE Atomi
   USE Molcom
   USE General, only : knw,spacegr,celem,cell
   USE variables, only:ref,atm
   USE PRNUTIL
   USE GENLSQ
   USE TestModel
   USE FSREFINEMENT
   USE setref, only:set_rcode_atoms
   USE RRESTR
   USE atom_type_util
   USE stat
   USE reflection_type_util
   USE unit_cell
   USE elements, only: Cl_at
   USE sinterface, only: fillatom
   implicit none
   integer, intent(in)      :: noptim
   integer, intent(in)      :: kprintcode
   integer,allocatable      :: vrem(:)           
   real,allocatable         :: bs(:)
   integer                  :: nfram
   integer                  :: i,natsold
   integer                  :: kAction,iprincode
   real                     :: bmed   
   real,dimension(6,nats*3) :: infofram
   real,dimension(6,nats*3) :: xfram
   integer,allocatable      :: ovr(:)           
   real,allocatable         :: foss(:)         
   integer,allocatable      :: nbuild(:)           
   integer                  :: l1,l2
   integer                  :: kevent
   type(cell_type)          :: cellt

   natsold=nats
   iprinCode = 0
   kaction = 5 - kprintcode
   if (kprintcode == 0) fscond%sprint = ' '
   call InitFour()
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   if (kprintcode == 1) then
       write(6,'(/,a)')' Optimization Procedure: Model to Improve'                                     
       call print_atoms(atm(:nats))
       if(knw.gt.0)then
          call to_coord(0)
          write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Model to Improve) ', &
          vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
   allocate(vrem(nats))
   call check_distance(atm(:nats),vrem,0.8,kpr=kprintcode)
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   call avvisolati(5,0,4)
!  natom=0
!  do i=1,nk
!        natomm=int(float(nw(i))/float((icent+1)*ncentr*nsym)+0.5)
!        if(natomm.lt.1)natomm=1
!        if(no(i).ne.1)natom=natom+natomm                                                   
!  enddo
   allocate(nbuild(nats*2))
   nbuild=0
   do i=1,iconn(1)
       l1=iconn((i-1)*3+2)
       l2=iconn((i-1)*3+3)
       nbuild(l1)=nbuild(l1)+1
       nbuild(l2)=nbuild(l2)+1
   enddo
   do i=1,nats
     !if(nbuild(i).eq.0.and.i.gt.nats*3/4.and.i.gt.(natom+2))vrem(i)=1
     if(nbuild(i).eq.0.and.i.gt.nats*3/4)vrem(i)=1
   enddo
   deallocate(nbuild)
   call fillatom(atm)
   call remove_atoms(vrem)
   deallocate(vrem)
   if (kprintcode == 1) then
       call print_atoms(atm(:nats))
       if(knw.gt.0)then
          call to_coord(0)
          write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Model to Improve:Discarding) ', &
          vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
   nfram=0
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   call avvisolati(5,0,4)
   call checkfram(noptim,nfram,infofram,xfram,kprintcode)
   if(nfram.gt.0)call checkmap(nfram,infofram,xfram,kprintcode)
   if(nfram.eq.0)go to 55
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintcode == 1) then
       call print_atoms(atm(:nats))
       if(knw.gt.0)then
          call to_coord(0)
          write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Model to Improve:Adding) ', &
          vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   call avvisolati(5,0,5)
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   call fillatom(atm)
   allocate(ovr(npref),foss(npref))
   call defovlexrN(ovr,sogover)
   call ripartisci_N(ovr,ref(:npref)%fo,fobsold(:npref),ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1),foss,nmcicli)
   ref(:npref)%fo=foss
   deallocate(ovr,foss)
   call Allocafuncls(DEALLOCA)
   call Allocafuncls(ALLOCA,numoss)
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)  
   call setweilsq()
   auto_complete=0
   fscond%auto_stru = .false.
   call fslsqexe(kevent)
   allocate(vrem(nats))
   call check_distance(atm(:nats),vrem,0.9,kpr=kprintcode)
   call remove_atoms(vrem)
   deallocate(vrem)
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintcode == 1) then
       call print_atoms(atm(:nats))
       if(knw.gt.0)then
          call to_coord(0)
          write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Model to Improve:Adding Refinement) ', &
          vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
   call Allocafuncls(DEALLOCA)
   call reset_restraints(resvf,wqqf)
   call Allocafuncls(ALLOCA,numoss)
   call setweilsq()
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)  
   auto_complete=0
   fscond%auto_stru = .false.
   cellt = set_cell_type(cell)
   call set_rcode_atoms(atm(:nats),cellt,spacegr,constrv,'XYZO',0)
   call set_rcode_atoms(atm(:nats),cellt,spacegr,constrv,'B',1)
   !do i=1,nrefl
   !     if(0.5/sqrt(ref(i)%slaq).lt.1.4)weilsq(i)=0.0
   !enddo
   call fslsqexe(kevent)
   allocate(bs(nats))
   allocate(vrem(nats))
   bs (:nats) = atm(:nats)%biso
   where(bs(:nats) < 0.0) bs(:nats) = 0.0
   call avestd(bs(:nats),1.0,bmed)
   vrem=0
   do i=1,nats
     if(atm(i)%biso.gt.5.0*bmed.and.atm(i)%biso.ge.50.0)then
       vrem(i)=1
     endif
   enddo
   call remove_atoms(vrem)
   deallocate(vrem)
   deallocate(bs)
!!!!!!!!!!!!!!!!!!!!!!!!
   if(nats.gt.int(1.3*natsold))nats=int(natsold*1.3)
!!!!!!!!!!!!!!!!!!!!!!!!
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintcode == 1) then
       call print_atoms(atm(:nats))
       if(knw.gt.0)then
            call to_coord(0)
            write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Model to Improve: B-factor Refinement) ', &
            vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   call avvisolati(5,0,0)
   do i=1,nats
      atm(i)%xc=xyzs(:3,i)
   enddo
   call fillatom(atm)
   allocate(ovr(npref),foss(npref))
   call defovlexrN(ovr,sogover)
   call ripartisci_N(ovr,ref(:npref)%fo,fobsold(:npref),ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1),foss,nmcicli)
   ref(:npref)%fo=foss
   deallocate(ovr,foss)
   call Allocafuncls(DEALLOCA)
   call impose_restr()
   call Allocafuncls(ALLOCA,numoss+nrestraints(resvf))
   call setweilsq()
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)  
   call weight_restr()
!corr   if(maxval(no(1:nk)).le.17)then                         
   if(maxval(celem%z) <= Cl_at)then
     wqqf(1)=wqqf(1)**0.5
     wqqf(2)=wqqf(2)**0.5
     wqqsav(1)=wqqf(1)**0.5
     wqqsav(2)=wqqf(2)**0.5
   else
     wqqf(1)=wqqf(1)**0.5
     wqqf(2)=wqqf(2)**0.5
     wqqsav(1)=wqqf(1)**0.5
     wqqsav(2)=wqqf(2)**0.5
   endif
   call autofslsq(kevent)
   allocate(vrem(nats))
   call check_distance(atm(:nats),vrem,0.9,kpr=kprintcode)
   call remove_atoms(vrem)
   deallocate(vrem)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintcode == 1) then
       call print_atoms(atm(:nats))
       if(knw.gt.0)then
            call to_coord(0)
            write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Model to Improve:Soft Restrains Refinement) ', &
            vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
55 continue
   allocate(ovr(npref),foss(npref))
   call defovlexrN(ovr,sogover)
   call ripartisci_N(ovr,ref(:npref)%fo,fobsold(:npref),ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1),foss,nmcicli)
   ref(:npref)%fo=foss
   deallocate(ovr,foss)
   call reset_restraints(resvf,wqqf)
   call Allocafuncls(DEALLOCA)
   call Allocafuncls(ALLOCA,numoss)
   call setweilsq()
   scalf%val = scalefactor(ref(:npref)%fo,ref(:npref)%fc,ref(:npref)%m,ref(:npref)%lp(1)) ! nuova scala
   call calcerrefs(npref,1,scalf%val)  
   auto_complete=0
   fscond%auto_stru = .false.
   call set_rcode_atoms(atm(:nats),set_cell_type(cell),spacegr,constrv,'XYZO',0)
   call set_rcode_atoms(atm(:nats),set_cell_type(cell),spacegr,constrv,'B',1)
   call fslsqexe(kevent)
   allocate(bs(nats))
   allocate(vrem(nats))
   bs (:nats) = atm(:nats)%biso
   where(bs(:nats) < 0.0) bs(:nats) = 0.0
   call avestd(bs(:nats),1.0,bmed)
   vrem=0
   do i=1,nats
     if(atm(i)%biso.gt.4.0*bmed.and.atm(i)%biso.ge.50.0)then
       vrem(i)=1
     endif
   enddo
   kblock(1:nats)=0
   call maincl(kAction, iprinCode)
   kblock(1:nats)=1
   call avvisolati(5,0,4)
   allocate(nbuild(nats*2))
   nbuild=0
   do i=1,iconn(1)
       l1=iconn((i-1)*3+2)
       l2=iconn((i-1)*3+3)
       nbuild(l1)=nbuild(l1)+1
       nbuild(l2)=nbuild(l2)+1
   enddo
   do i=1,nats
     if(nbuild(i).eq.0.and.i.gt.nats*3/4)vrem(i)=1
   enddo
   deallocate(nbuild)
   call remove_atoms(vrem)
   deallocate(vrem)
   deallocate(bs)
!!!!!!!!!!!!!!!!!!!!!!!!
!  if(nats.gt.int(1.3*natsold))nats=int(natsold*1.3)
!!!!!!!!!!!!!!!!!!!!!!!!
   call fillatom(atm)
!corr   call fcalcan(ref,atm(:nats))
   call sfcalc(ref,atm,spacegr,celem)
   if (kprintcode == 1) then
       call print_atoms(atm(:nats))
       if(knw.gt.0)then
            call to_coord(0)
            write(6,'(/,a,f5.0,a,i5,f5.0,a,2f8.3,/)')' Found Atoms: (Model to Improve: B-factor Refinement) ', &
            vett_test(3),' on',nats,vett_test(1),' true dist. ',vett_test(4),errefs
       endif
   endif
   end subroutine optimize_mod
!----------------------------------------------------------------------------------------------------
   subroutine checkfram(noptim,nfram,infofram,xfram,kprintcode) 
   USE Atomi
   USE BuildModule,only:numeroframmenti,numeroframmento
   USE Symmetry, only : nsym,icent
   USE General
   USE variables, only:atm
   USE unit_cell
   USE RefinecomRef
   USE FSREFINEMENT
   USE cgeom
!
   implicit none
   integer, intent(in)                            :: noptim
   integer, intent(in) :: kprintcode
   integer                  :: i,j,jj,ii,iii
   integer                  :: l1,l2                       
   integer                  :: k,kt,ifi,isav,jsav,iisav,jjsav
   integer                  :: kk,ktt,ifii,ifin,ifinn
   integer                  :: nfram                        
   real                     :: coef1,coeff
   real                     :: d
   real                     :: dl1,dl2
   real,dimension(3)                              :: s
   real,dimension(3)                              :: xo
   real,dimension(3)                              :: xoo
   real,dimension(3)                              :: xeq,xeqq
   real,dimension(2)                              :: vet
   real,dimension(6,nats*3)                         :: infofram
   real,dimension(6,nats*3)                         :: xfram
   real,dimension(3,3)                            :: gg               
   integer,allocatable                            :: vrem(:)              
   integer, dimension(nats*2)                     :: nbuild
   integer, dimension(numeroframmenti)            :: nfr
!
   dl1=1.6
   dl2=1.6
   if(noptim.eq.2)then
     dl1=1.3
     dl2=1.3
   endif
   gg = matrice_metrica(cell)
   nfram=0
   infofram=0.0
   nbuild=0
   do j=1,iconn(1)
       l1=iconn((j-1)*3+2)
       l2=iconn((j-1)*3+3)
       nbuild(l1)=nbuild(l1)+1
       nbuild(l2)=nbuild(l2)+1
   enddo
   if(numeroframmenti.eq.1)then
     do i=1,nats
        if(nbuild(i).eq.0)go to 888
     enddo
     if (kprintcode == 1) write(6,'(a)') ' Only one Fragment'
     go to 999
888  continue
   endif
   !if(numeroframmenti.eq.1)then
   !   write(6,'(a)') ' Only one Fragment'
   !   go to 999
   !endif
   allocate(vrem(nats))
   call check_distance(atm(:nats),vrem,1.3,kpr=kprintcode)
   nbuild(1:nats)=0
   do i=1,nats
      if(vrem(i).eq.1)nbuild(i)=1
   enddo
   vrem=0
   deallocate(vrem)
   ifin=icent+1
   ifinn=icent+1
   vet(1)=1.0
   vet(2)=-1.0
   nfr=0
   do i=1,numeroframmenti
     do j=1,nats
       if(numeroframmento(j).eq.i)nfr(i)=nfr(i)+1
     enddo
   enddo
   do i=1,numeroframmenti-1
     if(nfr(i).eq.1)cycle
     do ii=1,nats
       if(numeroframmento(ii).ne.i)cycle
       xo(:3)=atm(ii)%xc
       do kt=1,spacegr%ncoper
        do ifi=1,ifin
         coef1=vet(ifi)
         do k=1,nsym
           call xequi(xo,k,coef1,xeq,kt)
             do j=i+1,numeroframmenti
               do jj=1,nats
                 if(nfr(j).eq.1)cycle
                 if(numeroframmento(jj).ne.j)cycle
                     xoo(:3)=atm(jj)%xc
                     do ktt=1,spacegr%ncoper
                      do ifii=1,ifinn
                       coeff=vet(ifii)
                       do kk=1,nsym
                         call xequi(xoo,kk,coeff,xeqq,ktt)
                         !call xdist(xeq(:3),xeqq(:3),d,s)
                         call xdisteqs(xeq(:3),xeqq(:3),gg,d,s)
                         !corr if(d.gt.(radii(iabs(atm(ii)%nz/nzConst),1)+radii(iabs(atm(jj)%nz/nzConst),1))*1.0     &
                         !corr    .and.d.lt.(radii(iabs(atm(ii)%nz/nzConst),1)+radii(iabs(atm(jj)%nz/nzConst),1))*dl1)then
                         if(d.gt.(atm(ii)%c_radius()+atm(jj)%c_radius())*1.0     &
                            .and.d.lt.(atm(ii)%c_radius()+atm(jj)%c_radius())*dl1)then
                           if(nfram.gt.0)then
                              do iii=1,nfram
                                 if(infofram(1,iii).eq.float(ii).and.infofram(2,iii).eq.float(jj))then
                                      infofram(1,iii)=float(ii) 
                                      infofram(2,iii)=float(jj)
                                      infofram(3,iii)=(infofram(3,iii)+d)*0.5               
                                      infofram(4,iii)=float(i)             
                                      infofram(5,iii)=float(j)
                                      infofram(6,iii)=1.0          
                                      xfram(1:3,iii)=xeq(1:3)
                                      xfram(4:6,iii)=xeqq(1:3)
                                      go to 555
                                 endif
                              enddo
                              nfram=nfram+1
                              infofram(1,nfram)=float(ii)
                              infofram(2,nfram)=float(jj)
                              infofram(3,nfram)=d               
                              infofram(4,nfram)=float(i)
                              infofram(5,nfram)=float(j)
                              infofram(6,nfram)=1.0          
                              xfram(1:3,nfram)=xeq(1:3)
                              xfram(4:6,nfram)=xeqq(1:3)
                              iisav=ii
                              jjsav=jj
                              isav=i
                              jsav=j
                           else
                             nfram=nfram+1
                             infofram(1,nfram)=float(ii)
                             infofram(2,nfram)=float(jj)
                             infofram(3,nfram)=d               
                             infofram(4,nfram)=float(i)
                             infofram(5,nfram)=float(j)
                             infofram(6,nfram)=1.0          
                             xfram(1:3,nfram)=xeq(1:3)
                             xfram(4:6,nfram)=xeqq(1:3)
                             iisav=ii
                             jjsav=jj
                             isav=i
                             jsav=j
                           endif
 555                       continue
                         endif
                       enddo
                      enddo
                     enddo
               enddo
             enddo
         enddo
        enddo
      enddo
     enddo
   enddo
   do ii=1,nats
      if(numeroframmento(ii).ne.0)cycle
       xo(:3)=atm(ii)%xc
       do kt=1,spacegr%ncoper
        do ifi=1,ifin
         coef1=vet(ifi)
         do k=1,nsym
           call xequi(xo,k,coef1,xeq,kt)
              do j=1,numeroframmenti
               do jj=1,nats
                  if(jj.eq.ii)cycle
                  if(numeroframmento(jj).ne.j)cycle
                     xoo(:3)=atm(jj)%xc
                     do ktt=1,spacegr%ncoper
                      do ifii=1,ifinn
                       coeff=vet(ifii)
                       do kk=1,nsym
                         call xequi(xoo,kk,coeff,xeqq,ktt)
                         !call xdist(xeq(:3),xeqq(:3),d,s)
                         call xdisteqs(xeq(:3),xeqq(:3),gg,d,s)
                         if(d.gt.(atm(ii)%c_radius()+atm(jj)%c_radius())*1.0   &
                            .and.d.lt.(atm(ii)%c_radius()+atm(jj)%c_radius())*dl2)then
                           if(nfram.gt.0)then
                              do iii=1,nfram
                                 if(infofram(1,iii).eq.float(ii).and.infofram(2,iii).eq.float(jj))then
                                      infofram(1,iii)=float(ii) 
                                      infofram(2,iii)=float(jj)
                                      infofram(3,iii)=(infofram(3,iii)+d)*0.5               
                                      !infofram(4,iii)=0.0                  
                                      infofram(4,iii)=float(numeroframmento(ii))
                                      infofram(5,iii)=float(j)
                                      !!infofram(5,iii)=float(numeroframmento(jj))
                                      infofram(6,iii)=1.0          
                                      xfram(1:3,iii)=xeq(1:3)
                                      xfram(4:6,iii)=xeqq(1:3)
                                      go to 666
                                 endif
                              enddo
                              nfram=nfram+1
                              infofram(1,nfram)=float(ii) 
                              infofram(2,nfram)=float(jj)
                              infofram(3,nfram)=d               
                              infofram(4,nfram)=0.0                  
                              infofram(5,nfram)=float(j)
                              !!infofram(5,nfram)=float(numeroframmento(jj))
                              infofram(6,nfram)=1.0          
                              xfram(1:3,nfram)=xeq(1:3)
                              xfram(4:6,nfram)=xeqq(1:3)
                              iisav=ii
                              jjsav=jj
                              isav=i
                              !jsav=j
                           else
                             nfram=nfram+1
                             infofram(1,nfram)=float(ii)
                             infofram(2,nfram)=float(jj)
                             infofram(3,nfram)=d               
                             infofram(4,nfram)=0.0                  
                             infofram(5,nfram)=float(j)
                             !!!infofram(5,nfram)=float(numeroframmento(jj))
                             infofram(6,nfram)=1.0          
                             xfram(1:3,nfram)=xeq(1:3)
                             xfram(4:6,nfram)=xeqq(1:3)
                             iisav=ii
                             jjsav=jj
                             isav=i
!!!!!!!!!!!!!!!!!!!!!!!!
!                            jsav=j
!!!!!!!!!!!!!!!!!!!!!!!!
                           endif
 666                       continue
                         endif
                       enddo
                      enddo
                     enddo
              enddo
             enddo
         enddo
        enddo
      enddo
   enddo
999 continue
   if (kprintcode == 1) then
       do i=1,nfram
        if(infofram(6,i).eq.1.0)then
          write(6,'(a,f4.0,a,f4.0,f8.3,a,2f4.0)')' Interesting bond distance between fram.',     &
          infofram(4,i),' and',infofram(5,i),infofram(3,i),' between atoms',infofram(1,i),infofram(2,i)
        else if(infofram(6,i).eq.2.0)then
          write(6,'(a,f4.0,a,f4.0,a,f8.3)')' Single bonded atom',infofram(1,i),' with',infofram(2,i), &
          ' possible additional distance',infofram(3,i)
        endif
       enddo
   endif
   end subroutine checkfram
!----------------------------------------------------------------------------------------------------
   subroutine checkmap(nfram,infofram,xfram,kprintcode)
   USE Atomi
   USE General
   USE Symmetry, only : nsym,icent
   USE variables, only:ref,atm
   USE PhaseModule, only : aperc
   USE CommonExpo, only : isearchfo
   USE ParametriMappa, only : np
   USE RefinecomRef
   USE unit_cell
   USE CGEOM
   USE RefinecomRef
   USE PRNUTIL
   USE FSREFINEMENT
   USE atom_type_util
   USE sinterface, only: fillatom
   USE setref, only: set_rcode_atoms, set_lsq_conditions
   USE fouriermap
   USE fourier_mod
   USE reflection_type_util
   USE elements, only: Cl_at
   implicit none
   integer, intent(in)                            :: kprintcode
   integer, allocatable                           :: vrem(:)
   integer                                        :: nfram                                       
   integer                                        :: ier
   real                                           :: scal                                        
   real,dimension(6,nats*3)                       :: infofram                            
   real,dimension(6,nats*3)                       :: xfram                            
   integer, dimension(npref,3)                    :: hkl
   real, dimension(npref)                         :: frvet
   real, dimension(npref)                         :: eo,ec,wei
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)-1) :: xmap
   real, dimension(0:np(1)-1,0:np(2)-1,0:np(3)-1) :: xmapsav
   integer                                        :: kk,ktt,ifii,ifinn
   real                                           :: coef1
   integer                                        :: i,iii,ii,jj
   integer                                        :: k,kt,ifi,ifin
   real                                           :: coeff
   real                                           :: d1,d2,d3
   real                                           :: dx,dy,dz
   real                                           :: dfra1,dfra2
   real                                           :: ang,ang1,ang2     
   integer                                        :: j1,j2,j3                           
   integer                                        :: natssav,natsold
   real,dimension(3)                              :: s
   real,dimension(3)                              :: xo,xoo
   real,dimension(3)                              :: xeq,xeqq
   real,dimension(3)                              :: xd                 
   real,dimension(2)                              :: vet
   real,dimension(3,3)                            :: gg               
   real                                           :: xmaprif          
   type(atom_type)                                :: atmadd
   type(cell_type)                                :: cellt
!
   natsold=nats
   if (kprintcode == 1) call to_coord(1)
   dx=1.0/float(np(1)-1)
   dy=1.0/float(np(2)-1)
   dz=1.0/float(np(3)-1)
!corr non serve   pi=4.0*datan(1.d0)
   gg = matrice_metrica(cell)
   natssav=nats
   wei = 1.0
   call sfcalc(ref,atm,spacegr,celem)
   do i=1,npref
      hkl(i,:) = ref(i)%hkl
   enddo
   call simweight(ref(:npref),wei,eo,ec)
   !do i=1,npref
   !  if(1.0/(2.0*sqrt(ref(i)%slaq)).lt.ressog)wei(i)=0.0
   !enddo
!corr-g95   foss(1:npref)=ref(1:npref)%fo
   scal = sum (fobsold(:npref)) / sum (ref(:npref)%fc)
   frvet(:npref) = (fobsold(:npref) - scal*ref(:npref)%fc)
   aperc(1) = nats
   if (kprintcode == 1) write(6,'(/,13x,a)')'---------- Check Map ----------'
   xmap=0.0
   call MakeMap(transpose(hkl),frvet,ref(:npref)%ph,wei,npref,0,xmap)  !!!!,work1,work2)
   xmapsav=xmap
!corr-g95   mappa=xmapsav
   isearchfo = 1
   call Search99(xmap,0,ier,npref)
   xmaprif=xyzs(4,1)
   vet(1)=1.0
   vet(2)=-1.0
   ifin=icent+1
   ifinn=icent+1
!corr   if(maxval(no(1:nk)).le.17)then
   if(maxval(celem%z) <= Cl_at)then
     ang1=110.0
     ang2=130.0
     dfra1=0.9
     dfra2=0.9
   else
     ang1=75.0
     ang2=180.0
     dfra1=0.9
     dfra2=0.9
   endif
   do i=1,nfram
     xmap=0.0
     do j1=0,np(1)-1
       do j2=0,np(2)-1
         do j3=0,np(3)-1
           xo(1)=float(j1)*dx
           xo(2)=float(j2)*dy
           xo(3)=float(j3)*dz
           xeq=xo
           do kt=1,spacegr%ncoper
            do ifi=1,ifin
             coeff=vet(ifi)
             do k=1,nsym
                  call xequi(xo,k,coeff,xeq,kt)
                  if(infofram(6,i).eq.1.0)then
                    xd(1:3)=xfram(1:3,i)
                    !call xdist(xeq(:3),xd,d1,s)
                    call xdisteqs(xeq(:3),xd,gg,d1,s)
                    xd(1:3)=xfram(4:6,i)
                    !call xdist(xeq(:3),xd,d2,s)
                    call xdisteqs(xeq(:3),xd,gg,d2,s)
                    if(d1.gt.0.0.and.d2.gt.0.0)ang = angoloeq(xfram(1:3,i),xeq,xfram(4:6,i),gg)
                    if(d1.lt.infofram(3,i)*dfra1.and.d2.lt.infofram(3,i)*dfra2.and.ang*rtod.gt.ang1.and.ang*rtod.lt.ang2)then
                       xmap(j1,j2,j3)=xmapsav(j1,j2,j3)
                    endif
                  endif
             enddo
            enddo
           enddo
         enddo
       enddo
     enddo
     if(infofram(6,i).eq.1.0)then
       aperc(1)=5
       isearchfo = 1
       call Search99(xmap,0,ier,npref)
!corr-g95-aperc(1) reale       do iii=1,aperc(1)
       do iii=1,int(aperc(1))
         xo(:3)=xyzs(:3,iii) 
         do kt=1,spacegr%ncoper
          do ifi=1,ifin
           coeff=vet(ifi)
           do k=1,nsym
             call xequi(xo,k,coeff,xeq,kt)
                  xd(1:3)=xfram(1:3,i)
                  !call xdist(xeq,xd,d1,s)
                  call xdisteqs(xeq,xd,gg,d1,s)
                  xd(1:3)=xfram(4:6,i)
                  !call xdist(xeq,xd,d2,s)
                  call xdisteqs(xeq,xd,gg,d2,s)
                  if(d1.gt.infofram(3,i)*0.5.and.d1.lt.infofram(3,i)*0.85.and.d2.gt.infofram(3,i)*0.5.and.   &
                     d2.lt.infofram(3,i)*0.85.and.xyzs(4,iii).gt.0.2*xmaprif)then
                    if(natssav.gt.natsold)then
                      do kk=natsold+1,natssav
                         xd(1:3)=xyzs(1:3,iii)
                         !call xdist(xd,atm(kk)%xc,d3,s)
                         call xdisteqs(xd,atm(kk)%xc,gg,d3,s)
                         if(d3.lt.1.0)go to 775
                      enddo
                    endif
                    natssav=natssav+1
                    if (kprintcode == 1) then
                        write(6,'(a,3f12.3,a,2f7.0,a,2f12.3,a,f12.3)')' Found: atom ',xyzs(1:3,iii),' between ',   &
                        infofram(1,i),infofram(2,i),' distances',d1,d2,' Intensity ',xyzs(4,iii)
                    endif
                    atmadd%xc=xyzs(1:3,iii)
                    atmadd%biso=(atm(int(infofram(1,i)))%biso+atm(int(infofram(2,i)))%biso)*0.5
                    atmadd%och=1.0                    
                    atmadd%ocry=1.0                         
                    !corr atmadd%nz=minval(atm(1:natsold)%nz)                
                    call atmadd%set_specie(minval(atm(1:natsold)%get_nz()),celem)                
                    call add_atom(atm,atmadd)
                    go to 775
                   endif
           enddo
          enddo
         enddo
       enddo
775    continue
     endif
!corr-unused999 continue
   enddo
   nats=natssav
   call fillatom(atm)
   call MakeLab(1,nats)
   do i=1,nats
      atm(i)%lab = aLab(i)
   enddo
   allocate(vrem(nats))
   vrem=0
   do ii=1,nats
       if(vrem(ii).eq.1)cycle
       xo(:3)=atm(ii)%xc
       do kt=1,spacegr%ncoper
        do ifi=1,ifin
         coef1=vet(ifi)
         do k=1,nsym
           call xequi(xo,k,coef1,xeq,kt)
               do jj=1,nats
                     if(vrem(jj).eq.1)cycle
                     xoo(:3)=atm(jj)%xc
                     do ktt=1,spacegr%ncoper
                      do ifii=1,ifinn
                       coeff=vet(ifii)
                       do kk=1,nsym
                         call xequi(xoo,kk,coeff,xeqq,ktt)
                         !call xdist(xeq(:3),xeqq(:3),d1,s)
                         call xdisteqs(xeq(:3),xeqq(:3),gg,d1,s)
                         !if(d1.gt.0.1.and.d1.lt.1.0)then
                         if(d1.gt.0.1.and.d1.lt.0.9.and.jj.gt.natsold)then
                           vrem(jj)=1
                           go to 665
                         endif
                       enddo
                      enddo
                     enddo
               enddo
         enddo
        enddo
       enddo
 665  continue
   enddo
   call remove_atoms(vrem)
   deallocate(vrem)
   call fillatom(atm)
   call MakeLab(1,nats)
   do i=1,nats
      atm(i)%lab = aLab(i)
   enddo
   cellt = set_cell_type(cell)
   call set_rcode_atoms(atm(:nats),cellt,spacegr,constrv,'XYZBO',0)
   if(nats.gt.natsold)then
      call set_rcode_atoms(atm(natsold+1:nats),cellt,spacegr,constrv,'XYZ',1)
      call set_lsq_conditions(atm,spacegr,cellt)
   else
     nfram=0
   endif
   end subroutine checkmap
!----------------------------------------------------------------------------------------------------
   subroutine fslsqnwin(kevent)
   USE RefinecomRef
   USE FSREFINEMENT
!
   implicit none
   integer, intent(out) :: kevent
!
   call c_fortran_al_lavoro(0)
   call AllocaRiflessi(1)
   call LeggiRiflessi
   call fsinterface(code=2)
   call fsinitlsq()
   auto_complete = 1
   call fslsqexe(kevent)
   auto_complete = 0
   call fsclose()
   call c_fine_lavoro(0)
!
   end subroutine fslsqnwin
 !-------------------------------------------------------------------
   subroutine printlsq2(niter,p,x)
   USE GENLSQ
   USE RefinecomRef
   USE FSREFINEMENT
   USE General, only:lo
   USE RRESTR, only:nrestraints
   USE var_samod, only:i_SA
!
   implicit none
   integer, intent(in)                    :: niter
   integer, intent(in)                    :: p
   real(kind=8), dimension(p), intent(in) :: x
   integer                                :: i,numosstrue
   integer                                :: numres
!
   ncyclestep=niter
   if (niter /= 0) then
       call setweilsq()
       ncytot = ncytot + 1
!
       shiftx = x-xparold
!
       if (index(fscond%sprint,'V') > 0) then
           call stampa_all_parameters(lo,p,fscond)
!
!          stampa numoss/parametri
           numosstrue = 0
           do i=1,numoss
             if(weilsq(i)>0.0)numosstrue=numosstrue+1
           enddo
           write(6,10)real(numosstrue)/p,ncytot
  10       format(10x,'Ratio obs./par.    = ',f7.2,' at cycle ',i5)
       endif
!
       call fsprint_statusbar()
       xparold = x
       numres = nrestraints(resvf)
       if(numres.gt.0 .and. i_SA.gt.0)call weight_restr()
!!!!!!!!!!!!!!!!!! per ottenere = risultati con e senza alltrial
       call fset_parameter(numoss,x)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   endif
!
   end subroutine printlsq2

 !-------------------------------------------------------------------

   subroutine stampa_all_parameters(unit,Nact,refcond)
   USE RefinecomRef
   USE Atomi, only : aLab
   USE GENLSQ
   USE RIETV
   USE constraints
   USE RRESTR
   USE variables, only:atm,cryst,dataset
   USE compare_struct
   USE General, only:knw,cell,lo
   USE Conteggi, only:npunti
   USE fsrefinement
   USE unit_cell
!
   implicit none
   integer, intent(in)   :: Nact
   integer, intent(in)   :: unit
   type(refine_condition_type) :: refcond
   integer               :: i
   character(20)         :: strat
   integer               :: kat
   real                  :: esdd
   character(len=14)     :: stresd
   integer               :: iat,ipar
   integer               :: nconstr
!
!  Stampa intestazione
   write(unit,'(2x,76("="))')
   if (.not.refcond%auto_stru) then
      write(unit,'(26x,a10,i4,/)') '  Cycle # ',ncytot
   else
      write(unit,'(16x,a10,i4,a24,i4,a1,i4/)') '  Cycle # ',ncytot,        &
      '       Step refinement: ',kstager,'/',kstagemax
   endif
!
   if (refcond%algo == NL2SOL) then
       write(unit,70)
       write(unit,'(2(2x,a13,2f12.5))')(par_string(i),xpar(i),xpar(i)-xparold(i),i=1,Nact)
   else
!!!!       if (kesd == 1) then
       if (index(refcond%sprint,'E') /= 0) then
!
!          Calcola le deviazioni standard sui parametri
           !esdd = chisquarednow/(refcond%lim%ncu+nrestraints(resvf)-Nact)
           esdd = chisquarednow/(dataset(1)%nc2+nrestraints(resvf)-Nact)
           write(unit,70)
           do i=1,Nact
              write(stresd,'(f12.5,a1)')sqrt(matinv(i,i)*esdd),')'
              stresd = '('//adjustl(stresd)
              write(unit,'(2x,a13,f12.5,a14,f12.5)')par_string(i),xpar(i),stresd,xpar(i)-xparold(i)
           enddo
       else
           write(unit,70)
           write(unit,'(2(2x,a13,2f12.5))')(par_string(i),xpar(i),xpar(i)-xparold(i),i=1,Nact)
       endif
!
!      Constraints su x,y,z
       nconstr = nconstraints(constrv)
       if (nconstr > 0) write(unit,50)
       do i=1,nconstr
          if (constrv(i)%ref > 0) then
              do kat=1,constrv(i)%npar
                 iat = constrv(i)%vat(kat)
                 ipar = constrv(i)%vpar(kat)
                 write(strat,'(i3,a)')iat,' ('//trim(aLab(iat))//')'
                 if (ipar == 4) then
                     write(unit,'(8x,a,f12.5)')strat,atm(iat)%biso
                 else
                     write(unit,'(8x,a,f12.5)')strat,atm(iat)%xc(ipar)
                 endif
              enddo
          endif
       enddo
   endif
!
!  Constraints su x,y,z
   if (nconstraints(constrv) > 0) then
       call print_constraints(constrv,atm,lo)
   endif
!
   if (refcond%algo == GAUNEW) then
       write(unit,'(/,2x,a12,es18.5,10x,a13,f12.5)') 'Chisquared =',chisquarednow,'Step lenght =',step_length
   else
       write(unit, '(/,2x,a12,es18.5)')  'Chisquared =',chisquarednow
   endif
   if (knw == 0) then
       write(6,'(2x,a,f8.3)') 'R(obs-calc) =',errefs
   else
       write(6,'(2x,a13,f8.3,2(3x,a14,f8.3) )')      &
       'R(obs-calc) =',errefs,'R(true-calc) =',errefsv,'R(true-obs) =',errefsv1
       if (npunti > 0) then
           write(6,'(2x,"Rw(obs-calc)=",f8.4,3x,"RF(singoli)  =",f8.4,4x,"Rwp =",f8.4)')    &
           errefsw,errefsing,errepw
       else
           write(6,'(2x,"Rw(obs-calc)=",f8.4,3x,"RF(singoli)  =",f8.4,4x)')    &
           errefsw,errefsing
       endif
   endif
!corr   if (rinfo%refine_structure) call to_coord(0)
   if (cryst(1)%at_refined) call to_coord(0)
   call print_restraints_all(unit,resvf,atm,set_cell_type(cell),.false.)
!
!10 format(2x,4hRp =,f8.3,8h   Rwp =,f8.3,7h   Re =,f8.3,8h   GoF =,f8.3,15h (Conventional))
!20 format(2x,4hRp'=,f8.3,8h   Rwp'=,f8.3,7h   Re'=,f8.3,8h   GoF'=,f8.3,17h (Back. subtrac.))
!30 format(2x'R-structure factor =',f8.3,'   R-Bragg factor     =',f8.3,/)
!40 format(/,4x,'Parameters submitted by constraints',/)
50 format(/,4x,'List of  constraints')
!60 format(2x,'R (true-obs)       =',f8.3)
70 format('                  Parameter      Shift                   Parameter      Shift',/,       &
          '  -------------------------------------  -------------------------------------')
!!!!!80 format(2x,'Rw(obs-calc)=',f8.4,3x,'RF(singoli)  =',f8.4,4x,'Rwp =',f8.4)
!
   end subroutine stampa_all_parameters

 !-------------------------------------------------------------------
   subroutine fillref2()
   USE General  , only : nrefl,dtor,alambda
   USE Riflessi, only : Mult,IndHKL,WHM,SetFob,TThet
   USE xdataMod, only : clp
   USE variables, only : ref
   !!!!USE RefinecomRef, only : lambda
!
   implicit none
   integer :: i
!
   do i=1,nrefl
      ref(i)%hkl = IndHKL(i,1:3)                           ! indici h,k,l
      ref(i)%m   = Mult(i)                                 ! molteplicit�
      ref(i)%tthd(1) = TThet(i)                            ! 2-theta in gradi
      ref(i)%slaq = (sin(0.5*TThet(i)*dtor)/alambda)**2  ! (sen(theta)/lambda)**2
      ref(i)%fo  = sqrt(SetFob(i,4))                    ! fattori di struttura osservati
      ref(i)%fwhm(1) = WHM(i)                              ! FWHM
      ref(i)%lp(1) = clp(i)                                ! LP
   enddo
!
   end subroutine fillref2
 !-------------------------------------------------------------------
      subroutine minimizza_distanze()
      USE General
      USE Atomi
!
      implicit none
      integer                       :: i,j,jj,l,ll
      integer                       :: kAction,iprinCode,nicon 
      integer                       :: ix,iy,nsel_atom,nvolte
      real                          :: d,ang_lim,angcal
      real                          :: d_dist1,d_dist2,d_dist1_perc,d_dist2_perc
      real                          :: ang_dif1,ang_dif1_perc,sum_dmin 
      integer, dimension(500)       :: num_leg,isel_atom,ip_pos
      integer, dimension(500,500)   :: iatom_leg
      real, dimension(50)           :: d_calc,dist_att
      real, dimension(50,50)        :: ang_calc,ang_att
      real, dimension(3)            :: x1(3),x2(3),x3(3),sh(3)
      real, dimension(3,nats)       :: xyzs_new(3,500),xyzs_sav(3,500)
      real, dimension(2)            :: yf(2)
      real                          :: ang
      real                          :: sum_d
      real                          :: d1,d2
      real                          :: p,q
      integer                       :: j_sav

!!!FIXME-ggmat is undefined here!
      common/Gmatrix/ggMat(3,3)
      real :: ggMat
      common/avvis/mosso(2500),mosso2(2500),kpsfra(2500),numpsfr(2500) &
       ,tabdst(6,2500),numcop0,numcop1,numcop2,numang,tabang(10,5000) &
       ,angolomn,angolomx
      integer :: mosso,mosso2,kpsfra,numpsfr
      integer :: numcop0,numcop1,numcop2,numang
      real    :: tabdst,tabang
      real    :: angolomn,angolomx
      real    :: yfl
      
!
!--num_leg=num. di legami per ogni atomo.
!--atom_leg=atomi con il quale e' legato.
!--isel_atom=atomi da sottoporre alla procedura
!
!--azzeramenti
      iy=67543
      ix=iy
      nvolte=1000
      num_leg(:)=0
      iatom_leg(:,:)=0

      d_calc(:)=0.0

!     ang_lim=0.001
      ang_lim=0.01
      ang_calc(:,:)=0.0
      ang_att(:,:)=0.0

      nsel_atom=0
      isel_atom(:)=0
      xyzs_new(1:3,1:nats)=0.0

      j_sav=0
!--
      call Fillg
!--
      call xspinb         ! riempie aaa()
!--
      write(6,*)'SONO IN MINIMIZZA_DISTANZE'
      write(6,*) 'COORD. MODELLO INIZIALE'
      do i=1,nats
        write(6,*) 'X    Y   Z   =',i,(xyzs(j,i),j=1,3)
      end do

      kblock(1:nats)=0
      kAction = 4; iprinCode = 0     
      call maincl(kAction, iprinCode)
      kblock(1:nats)=1
      call avvisolati(5,0,3)         ! per modificare la connettivita'

      nicon = iconn(1) * 3 + 1

      write(6,*) 'COORD. MODELLO DOPO AVVISOLATI'
      do i=1,nats
        do j=1,3
           xyzs_sav(j,i)=xyzs(j,i)
        end do
        write(6,*) 'X    Y   Z   =',i,(xyzs(j,i),j=1,3)
      end do

!--calcolo il num. di legami per ogni atomo
      do i=1,nats
        jj=2
        do j=2,nicon
          if(i.eq.iconn(jj).or.i.eq.iconn(jj+1)) then
             num_leg(i)=num_leg(i)+1
             if(i.eq.iconn(jj)) then
                iatom_leg(i,num_leg(i))=iconn(jj+1) 
             else
                iatom_leg(i,num_leg(i))=iconn(jj) 
             endif
          endif
          jj=jj+3
        end do
        do j=1,num_leg(i)
         write(6,*)'NUM. LEGAMI PER ATOMO',i,num_leg(i),j,iatom_leg(i,j)
        end do
      end do

!--calcolo la distanza tra due atomi
      do i=1,nats
        ip_pos(i)=0
        x1(1:3)=xyzs(1:3,i)
        do j=1,num_leg(i)
           x2(1:3)=xyzs(1:3,iatom_leg(i,j))
           call calcdist(x1,x2,d)
           d_calc(j)=d
           write(6,'(a,2i4,f8.4)')'DISTANZA CALCOLATE= ',i,iatom_leg(i,j),d_calc(j)
!--calcolo angolo tra tre atomi
           if(num_leg(i)>=2) then   
            do l=j+1,num_leg(i)
               x3(1:3)=xyzs(1:3,iatom_leg(i,l))
               call angolo(ggMat,x2,x1,x3,angcal)
               ang_calc(j,l)=angcal*rtod
               write(6,*) ' '
               write(6,'(a,2x,3i4,2x,f8.4)')'ANGOLI CALCOLATI= ',iatom_leg(i,j),i,iatom_leg(i,l),ang_calc(j,l)
               write(6,*) ' '
            end do
           endif
        end do     ! fine do su j

!           VALORI ATTESI
!--recupero la distanza attesa tra due atomi
        do_ll: do ll=1,iconn(1)
          do j=1,num_leg(i)

            if(i.eq.tabdst(1,ll).and.iatom_leg(i,j).eq.tabdst(2,ll)) then
!           if(i.eq.tabdst(1,ll).and.iatom_leg(i,j).eq.tabdst(2,ll).or. &
!           (i.eq.tabdst(2,ll).and.iatom_leg(i,j).eq.tabdst(1,ll))) then
              dist_att(j)=tabdst(3,ll)
              write(6,'(a,3x,i4,f8.4)')'DISTANZA ATTESE= ',i,dist_att(j)
            endif
          end do    ! fine do su j
        end do do_ll
!--recupero angolo atteso tra tre atomi
!       if(num_leg(i)>=2) then   
!         do_ll1: do ll1=1,numang
!           if(i.eq.tabang(3,ll1)) then
!            do j=1,num_leg(i)
!              do jj=j+1,num_leg(i)
!               if(iatom_leg(i,j).eq.tabang(1,ll1).and.iatom_leg(i,jj).eq.tabang(5,ll1).or. &
!                  iatom_leg(i,j).eq.tabang(5,ll1).and.iatom_leg(i,jj).eq.tabang(1,ll1)) then
!                  ang_att(j,jj)=tabang(6,ll1)
!                  write(6,*) ' '
!                  write(6,'(a,5x,3i4,2x,f8.4)'),'ANGOLI ATTESI= ',iatom_leg(i,j),i,&
!                            iatom_leg(i,jj),ang_att(j,jj)
!                  write(6,*) ' '
!               endif
!              end do
!            end do
!           endif
!         end do do_ll1
!       endif
!----------------------
!--occhio da qui in poi gestione solo su atomi con 2 legami
       if(num_leg(i)==2) then    ! tratto solo atomi con 2 legami
!----------------------

!--confronto, per ogni atomo, le distanze calcolate con quelle attese
           d_dist1=d_calc(1)-dist_att(1)
           d_dist2=d_calc(2)-dist_att(2)

           d_dist1_perc=0.10*dist_att(1)
           d_dist2_perc=0.10*dist_att(2)
           if(d_dist1.lt.0.0.and.d_dist2.gt.0.0) ip_pos(i)=1

           write(6,'(a,i3,2x,a,2i3,2f8.3)')'CONFRONTO DISTANZE. Atomo= ',i,'con= ',&
                     iatom_leg(i,1),iatom_leg(i,2),d_dist1,d_dist2

!--confronto, per ogni atomo, gli angoli calcolati con quelli attesi
!          ang_dif1=ang_calc(1,2)-ang_att(1,2)
!          ang_dif1_perc=0.10*ang_att(1,2)
           ang_dif1=ang_calc(1,2)-120.0
           ang_dif1_perc=0.10*120.0

!--scelgo l'atomo o gli atomi che possiedono contemporaneamente una dist. corta ed una lunga
        if((d_dist1.lt.0.0.and.d_dist2.gt.0.0).or.(d_dist1.gt.0.0.and.d_dist2.lt.0.0)) then
          if(abs(d_dist1).gt.d_dist1_perc.and.abs(d_dist2).gt.d_dist2_perc) then
             isel_atom(i)=i 
             nsel_atom=nsel_atom+1
             write(6,*)'**************************'
             write(6,*) 'TROVATO ATOMO DA MODIFICARE',i,d_dist1,d_dist2
             write(6,*)'**************************'
          endif
        endif
       endif
      end do            ! fine do su nats
      write(6,*) '******************'
!
!--calcolo le correzioni lungo x,y,z in modo random
      if(nsel_atom.gt.0) then
        do i=1,nats
         if(isel_atom(i).eq.i) then
          sum_dmin=99999.0
          do j=1,nvolte
            call SirRandom(ix,iy,yfl)  ! genero num. random e riempio p e q
            ix=iy
            yf(1)=yfl

            call SirRandom(ix,iy,yfl)
            ix=iy
            yf(2)=yfl
            if(ip_pos(i).eq.1) then
               p=yf(1)
               q=-yf(2)
            else
               p=-yf(1)
               q=yf(2)
            endif
!--calcolo dello shift da applicare alle coordinate
            write(6,*) 'P E Q',p,q
            sh(1)=p*(xyzs(1,i)-xyzs(1,iatom_leg(i,1)))+q*(xyzs(1,iatom_leg(i,2))-xyzs(1,i))
            sh(2)=p*(xyzs(2,i)-xyzs(2,iatom_leg(i,1)))+q*(xyzs(2,iatom_leg(i,2))-xyzs(2,i))
            sh(3)=p*(xyzs(3,i)-xyzs(3,iatom_leg(i,1)))+q*(xyzs(3,iatom_leg(i,2))-xyzs(3,i))
            write(6,'(a,i0,3x,a,i0,3x,a,3f7.3)')'CICLO N.= ',j,'ATOMO N.= ',i, &
                  'SHIFT APPLICATO= ',sh(1),sh(2),sh(3)
!--calcolo le nuove coordinate dell'atomo
            xyzs_new(1,i)=xyzs(1,i)+sh(1)
            xyzs_new(2,i)=xyzs(2,i)+sh(2)
            xyzs_new(3,i)=xyzs(3,i)+sh(3)
            write(6,'(a,3f8.4)')'NUOVE COORD=',xyzs_new(1,i),xyzs_new(2,i),xyzs_new(3,i)
!--calcolo le nuove distanze
            x1(1)=xyzs_new(1,i)
            x1(2)=xyzs_new(2,i)
            x1(3)=xyzs_new(3,i)
  
            x2(1)=xyzs(1,iatom_leg(i,1))
            x2(2)=xyzs(2,iatom_leg(i,1))
            x2(3)=xyzs(3,iatom_leg(i,1))
            call calcdist(x1,x2,d)
            d1=d

            x3(1)=xyzs(1,iatom_leg(i,2))
            x3(2)=xyzs(2,iatom_leg(i,2))
            x3(3)=xyzs(3,iatom_leg(i,2))
            call calcdist(x1,x3,d)
            d2=d
            sum_d=d1+d2
            write(6,'(a,i3,2x,a,2i3,a,3f8.4)')'NUOVE DIST. TRA',i,'E',&
                      iatom_leg(i,1),iatom_leg(i,2),'=',d1,d2,sum_d
!--calcolo nuovo angolo
            call angolo(ggMat,x2,x1,x3,angcal)
            angcal=angcal*rtod
!           ang=abs(angcal-ang_att(1,2))
            ang=abs(angcal-120.0)
            write(6,'(a,i3,2x,a,2i3,a,2f8.4)')'NUOVO ANGOLO. TRA',i,'E',&
                      iatom_leg(i,1),iatom_leg(i,2),'=',angcal,ang

!           if(sum_d.lt.sum_dmin.and.ang.lt.ang_lim) then
            if(sum_d.lt.sum_dmin) then
              xyzs_sav(1:3,i)= xyzs_new(1:3,i)
              sum_dmin=sum_d
              j_sav=j
            endif
          end do  ! do su nvolte

          write(6,'(a,2x,i3,2x,f9.4)') 'CICLO SALVATO',j_sav,sum_dmin
          write(6,'(a,2x,i3,2x,3f8.4)') 'COORDINATA FINALE',i,(xyzs_sav(j,i),j=1,3)
         endif
        end do    ! do su nats
      endif       ! fine if su nsel_atom

      write(6,*) 'MODELLO FINALE'
      do i=1,nats
         write(6,*) i,(xyzs_sav(j,i),j=1,3)
      end do
      xyzs(1:3,1:nats)=xyzs_sav(1:3,1:nats)
!
      return
      end
!-----------------------------------------------------------------------------------
