! ----------------------------------------------------------------------
      MODULE MappaPatterson
             USE ParametriMappa
             real, allocatable :: Patt(:,:,:)
             real, allocatable :: SMF(:,:,:)
             real, allocatable :: xmapShi(:,:,:)
             real, allocatable :: xmapSav(:,:,:)
      END MODULE MappaPatterson
! ----------------------------------------------------------------------
      MODULE MappaCont
             USE ParametriMappa
             real, allocatable :: RhoNew(:,:,:)
      END MODULE MappaCont
! ----------------------------------------------------------------------
      MODULE Seminvariants
!
*     common /choi/ mm,iimax,jmax,nsj,jtable(8,16),invet(48)
*     common /pro/  jvarma(3,3),kx(3),idoub,kkk,sump(2),icros,
*    * jhkl(3),e,scr2(2),ns,sr2(2),  hklt(3,3),nsemc,nsemg
*     common /Seminvariants/ nSemi, kSemi(8000)
*     common /inv/  invma(96,3,3),idivv(48)
*     common/multi/ntrials,ntrialsatt,npeaktrial(500)
      integer  ::  mm, iimax, jmax, nsj, jtable(8,16), invet(48)
      integer  :: jvarma(3,3), kx(3), idoub, kkk,icros
      integer  :: jhklSem(3), ns, nsemc, nsemg
      real     :: sump(2), e, scr2(2), sr2(2), hklt(3,3)
      integer  :: nSemi, kSemi(8000)
      integer  :: invma(96,3,3), idivv(48)
!
      END MODULE Seminvariants
! ----------------------------------------------------------------------
c===============================REM===============================
c   Se trovo una struttura con F222 (ncentr=3) rivedere le routines
c   RompiCentroSimmetria, RompiSimmetria3d, RestoreSymmetry
c   per inserire la cancellazione degli equivalenti dei picchi
c   centrati (in questo caso la centratura e' presente anche
c   nella SMF. 
c===============================History===============================
c--Gennaio 2004
c  introduzione del riciclo a bassa risoluzione
c  aggiornamento delle chiamate al Cluster Finder, correzione di NsymTot
c--06/05/04
c  versione modificata (Atomi allocati dinamicamente)
c--01/06/04
c  estensine ai gruppi centrosimmetrici
c--01/09/04
c  adattamento alla grafica della release sir2004
c--20/10/05
c  velocizzazione e miglioramento
c--9/11/05
c  ImproveRiciclo e introduzione della sigmaa nel riciclo. Nuovo Peak search
c--31/01/06
c  Introduzione della struttura a blocchi e nuova organizzazione in subroutines
c=====================================================================
c--------------------------------------------------
      subroutine Patterson(inizTrial, ifinTrial, ierr)
!
!--sfrutto il metodo alternativo: trasformo la mappa Patterson in una Fourier
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE PhaseStuff       !patterson FOM SIR97
      USE Molcom       !p
      USE PhaseModule     !p
      USE fourier_mod, only: AllocaMappa
      USE cgeom
      USE unit_cell
      USE elements
      USE atom_type_util, only: natom_cell
c_ULTIM
      include 'param.fi'        !p
c_ULTIM

      character*9 cara
      character*80 line

!pgMAD150206
      character*10 reje
!pgMAD150206
!
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
!
      common /tables/ stable(500)           !patterson FOM SIR97
      equivalence (stable(91),ctable(1))
      dimension ctable(500)
      
      dimension xor(3),xnew(3),s(3)
      dimension ccffmm(302), ipos(302), figmer(11)   !!!corr,shi(4)

      common /tempo/ nSecs,nSecsTot
      real, dimension(3,3) :: gm
!

      call CPUTime0('Patterson')
      kverbo = 1

      call write_inte_routine('Patterson Deconvolution')
!corr      write(lo,1110) itle
!corr 1110 format(///,1h ,78('+'),//,
!corr     1 ' expo2007  : Patterson Deconvolution Procedure',//,
!corr     2 20x,20a4,/,1h ,78('+'),//)

!corr      if (knw == 1) call AllocaTestStuff(1)
      call xspinb
      gm = matrice_metrica(cell)
    
      nfl = 1
      jBlock = 1            !p
      Msg = 'Starting Patterson procedure'
      call PrintMess(Msg)
      if(jBlock==1) then
         write(Msg,1)
      else
         write(Msg,2) jBlock
      endif
    1 format('Compute starting phases by means of Patterson procedure')
    2 format('Compute starting phases by means of Patterson procedure',
     *        ' for Block #',i2)
      call RunToolBar(1,Msg)
!
! inizializzazioni
!
      call InitFour
      call InitFour_Patt   
      ilist=15
      call cancella(ilist)

c -----
c     call sub. per lettura lista 2 : simmetria
c -----
      call yfl02
c -----
c     call sub. per lettura preambolo lista 7
c -----
      call ysfl07(iy)

      call sw14

      call dirpatt(ier)
  
      call AllocaRiflessi(2)
      call AllocaRiflessi(1)

      call Store_Reflexions
      
      
      do i=1,nrefl                !patterson FOM SIR97 
          e1(i) = evet(i)
      end do

c
c--clear xmap
c
      call AllocaMappa(2)
      call AllocaMappa(1)
c
c--aumenta lo spazio disponibile per i vettori del peak search
c
!     if(jBlock==1) then         ! 07/09/2006 
!p        natsSav = 2 * MaxAtoms
!corr        natsSav = 4 * nat        !p
        natsSav = 4 * nint(natom_cell(celem,neutro==0))
        MaxAtoms = 4 * natsSav   !p
        
!p        call AllocaAtomi(2)
        nats = natsSav
!p        call AllocaAtomi(-1)
!     endif
c
c--clear Patt map
c
      call AllocaMappaPatterson(2)
      call AllocaMappaPatterson(1)
c
c--applica il metodo di deconvoluzione Patterson
c
      call DoSingleIteration()
      call Deconvolution(ksezold,iswitch_3D,ierr)
      if(ierr<0) return

c
c--procedura multi-soluzione
c
!p      npunti = sum(jBlocksPh(1,:))
!p      call AllocaGrafici(1, npunti)
!     iAction = -1
!     call DataForGraph(iAction, npunti)
!
      call scrper('Compute phases            ',0,0)
c
c--loop sui picchi della Patterson
c
!p      if (jBlock == 1) then
          kats15 = nats15
!p      else
!p          kats15 = nats15 - sum(jBlocksPh(1,1:jBlock-1))
!p      endif
!p      if (kats15 < jBlocksPh(1,jBlock)) then
!p          jBlocksPh(1,jBlock) = kats15
!p      endif
      if (kats15 <= 0) then
          ierr = -2
          write(lo,6)
          return
      endif
      write(lo,5)
    5 format(' ',78('-'),/,
     *       ' List of the Patterson peaks used as pivot',//,
     *       ' Serial   Height      ','X',9x,'Y',9x,'Z')
    6 format(' ',78('-'),/,
     *       ' *** No more Patterson peaks available. Program stops ***'
     *       ,/)
!      MaxRun = jBlocksPh(1,jBlock)
      
      if (nset > 0) then
         MaxRun = nset
         MaxToStore = MaxRun
      else
         MaxRun = 30        !p
         MaxToStore = 30     !p
         nsxx = MaxRun             !pgMad150508
      end if
      
      jBlock = 1            !p
      
      j302 = 302
!      call nfrm16(MaxRun,j302)               !p
!      call nfrm16(nstr,j302)               !p
      call nfrm16(nrefl,j302)               !pgMAD050208
      call ysfl16(ccffmm,ipos,idum)     !p
      
      MaxToStoreSav = MaxToStore
      MaxToStore = MaxRun
      
!corr      sigm = s3s2                !patterson FOM SIR97
      sigm = s3s2_value(celem,neutro,spacegr%ncoper) !patterson FOM SIR97
      nsacc = 0
      call rialfnew(icent,sigm)

      do ntrbl=1, MaxRun
         if (nset > 0) then
             numbrun = iset(ntrbl)
         else
             numbrun = ntrbl
         endif
         
!p         if (jBlock > 1) then
!p             numbrun = numbRun + sum(jBlocksPh(1,1:jBlock-1))
!p         endif
!p         if (MaxRun .gt.1) then
!p             if (jBlock == 1) then
!p                 kOffSet = 0
!p             else
!p                 kOffSet = sum(jBlocksPh(1,1:jBlock-1))
!p             endif
!p             write(cara,10) ntrbl+kOffSet,MaxRun+kOffSet
!p         else
             write(cara,15) numbrun
!p         endif
         call NoBlanks(cara,icara)
         write(line,20) nstr,cara(1:icara)
         call scrper(line,ntrbl,MaxRun)
   10 format(i3,'/',i3)
   15 format(i3)
   20 format('Compute starting phases for',i5,
     *       ' reflections in Patterson trial ',a)
c
        if (ntrbl == 1) then
            inizTrial = numbrun
        endif
        if (ntrbl == MaxRun) then
            ifinTrial = numbrun
        endif
        if (numbrun > nats15 .and. knw == 1) then
            write(lo,*) 'peak ',numbrun,' not found within',
     &                                   nats15,' peaks' 
            exit
        endif

        x1=side(xyzo(1,numbrun))
        y1=side(xyzo(2,numbrun))
        z1=side(xyzo(3,numbrun))
        h1=xyzo(4,numbrun)

       itria=numbrun
       write(6,'(a,i4,3f10.4,f15.1)') 'PEAK',numbrun,x1,y1,z1,h1

        xnew(1:3)=0.0
        xor(1:3)=xyzo(1:3,numbrun)
        !call xdist(xnew,xor,dist,s)
        call xdisteqs(xnew,xor,gm,dist,s)
        if (knw == 0) then
            write(lo,'(i5,f11.1,3f10.4,f10.4)') 
     *          numbrun,h1,x1,y1,z1
        else
            write(lo,'(i5,f11.1,3f10.4,f10.4)') 
     *          numbrun,h1,x1,y1,z1,dist
        endif


c
c--procedura per creare la mappa Fourier
c
        call DoSingleIteration()
        call DoFourier(x1,y1,z1,ksezold,iswitch_3D)
        
!       if (ntrbl == 11) stop
        
c
c
c--procedura di riciclo Patterson
c

        kmadsave = kmad     !pgMAD280907
        
        call Riciclo3d(foma)
        
        kmad = kmadsave     !pgMAD280907

        call DoSingleIteration()
c
        if(knw==1) then
          izero = 0
          ifmin = 1
          call examin(numbrun,khl,ipub,iphaz,nstr,izero,wt,ifmin)
        endif
        
!        stop      ! per fare solo il primo picco
!

!pgMAD150206
!p        if (kmad /= 0) then

        ifFOM97 = 1        !patterson FOM SIR97
        if (ifFOM97 == 1) then
           do 1480  i=1,450
              stable(i)=sin(dtor * float(i-1))
 1480      continue

           do i=1, nstr        
              if (iphaz(i) == 0) iphaz(i) = 360
           end do
           call absnew(numbrun,sigm)
           error = erore
           errpes = erorepes
           mxsac = MaxToStore
!           call fomsp(numbrun,ns1mx,sogs2,
!     *                sigm,icent,mxsac,mxsaco,nsacc,aminco,nena)
           call fomsp(ntrbl,ns1mx,sogs2,
     *                sigm,icent,mxsac,mxsaco,nsacc,aminco,nena)
        else
           call Calcola_FOM_Early(corre)
           fomrt(ntrbl,1:)= 1.0-(ntrbl-1)/float(MaxRun)
          
           fomrt(ntrbl,5)= FOMs(1,4)
           fomrt(ntrbl,6)= 0.0
           fomrt(ntrbl,7)= erore
           fomrt(ntrbl,8)= erorepes
           fomrt(ntrbl,10)= numbrun
!
           figMer(1:10) = fomrt(ntrbl,1:10)
           call snw16(ntrbl,figMer,wt,iphaz)   
           SetsStored = SetsStored + 1
        end if

!p        else
!pc_ULTIM
!p           call FomTrip_Patt()
!P           foma=Fom_TripM
!p           if (no(nk) >= 20 .and. jsys > 1) then
!p                 jpatt = 0
!p                 fcoef(:) = evet(:)
!p                 call MakeMap(nrefl,jpatt)
!P                 call maxmin(np(1),np(2),np(3),xmap)
!p                 fomastd=stden/5000.0
!p                 foma=Fom_TripM*fomastd
!p           endif
!p           if (jsys > 1) then
!p               if (no(nk) < 20) then
!P                   if (ksize > 4) then
!p                       if (iwei > 0) then
!p                           foma=(foma+2.0)*1000./
!p     *                          (900.+float(min(numbrun,75)))
!p                       endif
!P*                      RfacMatrix(2,i,jBlock) = foma
!p                   endif
!p               else
!p                   if (iwei > 0) then
!p                       foma=(foma+2.0)*1000./
!p     *                      (900.+float(min(numbrun,75)))
!P                   endif
!p*                  RfacMatrix(2,i,jBlock) = foma
!p               endif
!p           endif
!p           FOMs(1,4) = foma
!P           absfom = 0.0
!p           coms   = 0.0
!p           nundet = 0
!p           call fomsp(reje)
!P!          write(6,*) 'numbrun,foma',numbrun,foma
!p        endif
!p        corre = 0.0
!p        call ManageEarlyFom(FOMs(1,4), corre, erore)
      enddo  ! fine loop su ntrbl

!
      MaxToStore = MaxToStoreSav
!p
      write(lo,'(///,a)') ' Risultati della Patterson'
	do i=1,numbTrials
         write(lo,'(10f10.5)') (fomrt(i,j),j=1,10)
      end do

!      write(6,1111) (ipub(i),i=1,nstr)
!1111  format(20i5)

!      call prtfom_Patt(numbTrials,ier)
!      call prtfom_Patt(MaxRun,ier)
      MaxNumbOfSets = min0(nats15, MaxRun)
      call prtfom_Patt(MaxNumbOfSets,ier)
!p
c
c--deallocate Patt map
c
      call AllocaMappaPatterson(2)
c
!corr      if (knw == 1) call AllocaTestStuff(2)

      call CPUTime('Patterson')
      iss = mod(nSecs,3600)
      ihou = ( nSecs - iss ) / 3600
      is =  mod(iss,60)
      im  = ( iss - is ) / 60
      write(lo,1900) ihou,im,is
 1900 format(/,' CPU Time for Patterson Deconv. ',i6,'h',i3,'m',i3,'s')

      return
   50 format(' FOMs',4f7.3,1x,2f6.2,4f7.3,2x,a)
      end
c-----------------------------------------------------------------------
      subroutine Deconvolution(ksezold,iswitch_3D,ierr)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE ParametriMappa
      USE MappaPatterson
      USE Seminvariants
      USE Molcom      !p
      USE PhaseModule    !p

      integer h(3,3)
      dimension h1(3,3)
      character*3 xyzc
      character*9 Procedura     !p
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common /ori/ ntra,taboTC(8,3)          !p
c
      if(kverbo>0) then
        write(6,*) 'Grid sampling:',np
        do i=1,nOrigRoxi
          write(6,'(a,i4,3f8.3)') 'origini permesse',i,taboTC(i,1:3)
        enddo
        xyzc = 'xyz'
      endif
c
c-- inizializzazioni
c
c     if(numbGen>0) then
c       numbMax = nrefl
c       write(6,*) 'Sto usando i riflessi estrapolati',
c    &                    numbLSQ,nrefl,nreflTot
c     else

!p        numbLSQ = 0.7 * nrefl          !p
        numbLSQ =  nrefl               !p
        numbTrials = 30              !p
        numbTrialsAtt = numbTrials    !p
        
        numbMax = numbLSQ
        
        
        
c     endif
c
c--- azzeramenti
c
      ksezold=0
      iwork1(:) = 0       !p
      iwork2(:) = 0       !p
      work1(:) = 0.0      !p
      
      iswitch_3D=0
      xmap(:,:,:)=0.0
      icont1=0 
      Hvet(:,:,:)=0
      Tvet(:,:)=0
      Htype(:,:)=0
      NsezHarker=0
c
c-- calcolo della jtable 
c
      call seminv(ier)
!
!-- create the Patterson Map
!
      fcoef(:)=0.0
      wt(:)=0.0
      do i=1,numbMax
         wt(i) = 1
         fcoef(i) = evet(i) * evet(i)
      enddo
      
!      call assegna_pesi_riflessi

!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
!corr      nsymTot=nsym*(icent+1)*pts
c
c--faccio la mappa patterson con il gruppo Patterson
c
      jpatt = 1
      call MakeMap_Patt(numbMax,jpatt)       !p

c
c--solo per debug  
c     call CercaPicchi3d(90)  
!      do ih = 0, np(1)-1
!c      do ik = np(2)/2, np(2)/2
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!c          smf(ih,ik,il) = xmap(ih,ik,il)
!         write(64,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo
c--debb
c--solo per debug
!
!-- restore the original Space Group
!
      call yfl02
      nfl = 1
!corr      nsymTot=nsym*(icent+1)*pts
      if(icent==1) then  
        do k=1,nsym
          do i=1,3
            do j=1,3
              kmat(k+nsym,i,j)=-kmat(k,i,j)
            enddo
          enddo
        enddo
        do k=1,nsym
          do i=1,3
            tmat(k+nsym,i)=-tmat(k,i)
          enddo
        enddo
      endif
c
c--riduco l'altezza dei picchi nell'intorno dell'origine della Patterson
c
      call RiduciOrigine_Patt()  ! da non fare se uso la Patterson con E*E-1  
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(65,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo
!
!-- save the Patterson Map in Patt
!
      Patt(:,:,:) = xmap(:,:,:)
     
!
!-- loop on different Harker Sections:
!--    by means of the working table ( jtable ) consider
!--    only indipendent symmetry operators.
c attenzione: le sezioni indipendenti si trovano solo sul primo
c indice, per i2=1, mentre per gli altri i2=2,..,iimax si trovano
c le sezioni non indipendenti
!
      nsemtot = 0
      vi = 1.0
      ns1 = 0
      do j2=1,jmax
         kkk = jtable(1,j2)
c
         if (kkk.gt.0) then
!
!-- compute the matrix  h = ( i - rs )  where  s = jtable(i,j)
!-- calcola traccia e determinante della matrice  rs   dove  s = jtable(i,j)
!
           ntraccia=0
           do i1=1,3
             do j1=1,3
               h(i1,j1) = -kmat(kkk,j1,i1)
               h1(i1,j1) = kmat(kkk,j1,i1)
             enddo
             h(i1,i1) = h(i1,i1) + 1
             ntraccia=ntraccia+h1(i1,i1)
           enddo
           call deter3(h1,deter)
!pbapg
!pbapg           if (deter*ntraccia /= -1 .and. jsys /= 1) cycle
!!           if (deter*ntraccia /= -1 .and. jsys > 3) cycle
           
           if (icent==1 .and. deter*ntraccia/=3 .and. jsys>3) cycle !prende solo lo spazio per g.s. centro

! elimino le matrici relative ad elementi centrosimmetrici in gruppi ad alta simmetria
!!           if (deter < 0 .and. jsys > 3) then
!!              if (kverbo > 0) write(6,*) 'Matrice dovuta ad elementi cen
!!     *trosimmetrici eliminata'           
!!              cycle
!!           end if   
c--deb
           if(kverbo>0) then
             write(6,*) 'kkk',kkk
             write(6,'(a,3(3i8))') 'h1',kmat(kkk,1:3,1:3)
             write(6,'(a,3(3i4))') 'h',h(1:3,1:3)
           endif
c--deb
           if(j2==jmax.and.ntraccia==-3.and.jsys/=1) then   !pba
                if(kverbo>0) write(6,*) 'Matrice eliminata'
                cycle  ! elimino la matrice -1 in piu'
           endif
c
c--calcolo inum = numero di righe nulle di H 
c
           inum1=0
           inum=0
           do i=1,3
             if (h(i,i).eq.0) then
               inum1=0
               do j=1,3
                 if(i==j) cycle
                 if (h(j,i).eq.0) inum1=inum1+1
               enddo
               if(inum1==2) inum=inum+1
             endif
           enddo
c
c--single out the current section
c
c-------    REM:
c  sezioni perpendicolari
c  ksez=3: z costante /   ksez=1: x costante /   ksez=2: y costante /   
c  linee   perpendicolari
c  ksez=13: z costante /  ksez=11: x costante /  ksez=12: y costante /   
c-------    REM:
c
           if(inum==3) then
c--Matrice nulla 
             if (kverbo > 0) then
               write(6,*) 'Null H, not processed'
             endif
             cycle
           elseif(inum==2) then
c--Linea di Harker perpendicolare
             ksez=0
             do i=1,3
               if (h(i,i).ne.0) then
                 ksez = 10 + i
               else
               endif
             enddo
c
             if (kverbo > 0) then
               write(6,*) 'Perpendicular Harker Line, not processed'
             endif
             cycle
           elseif(inum==1) then
c--Sezione di Harker perpendicolare
             alim=0
             ksez=0
             do i=1,3
               if (h(i,i).eq.0) then
                 alim = -tmat(kkk,i)
                 if (alim.lt.0.0) then
                   alim = alim + 1
                 endif
                 ksez = i
                 lsez = nint( alim * np(i) )
               endif
             enddo
             if (kverbo > 0) then
                write(lo,10) xyzc(ksez:ksez),alim,lsez,ksez
             endif
           else
c--Spazio di Harker, oppure Sezione o Linea di Harker non perpendicolare
             ksez=0
           endif
           if(kverbo>0) then
             write(6,'(a,i4,f8.2,2i4)') 'traccia,det,ksez,inum'
     &                          ,ntraccia,deter,ksez,inum
           endif
c
c--conto le sezioni di Harker indipendenti e memorizzo il loro puntatore
c
           NsezHarker=NsezHarker+1
           do i1=1,3
             Tvet(NsezHarker,i1)=side(-tmat(kkk,i1))
             do j1=1,3
              Hvet(NsezHarker,i1,j1)=h(i1,j1)
             enddo
           enddo
           Htype(NsezHarker,1)=ksez
           Htype(NsezHarker,2)=ntraccia
           Htype(NsezHarker,3)=deter
           if(iswitch_3D==0) then
             if(NsezHarker==1) then
               ksezold=ksez
               if(ksez==0) iswitch_3D=1
             else
               if(ksez<10) then
                 if(ksez/=ksezold) then
                    iswitch_3D=1
                 endif
               else
                 kksez=mod(ksez,10)
                 if(kksez==ksezold) then
                    iswitch_3D=1
                 endif
               endif
             endif
           endif
c
c-- per il momento filtro solo le sezioni di Harker perpendicolari
c
           if(ksez==0) cycle
           if(ksez>10) cycle
!
!-- restore in xmap the copy of the patterson map;
!
           xmap(:,:,:) = Patt(:,:,:)
!
!-- clear the map and retain only Harker sections
!
!pba           call ZeroHarkermio(ksez,alim,1)  
           call ZeroHarkermio(ksez,alim,0)  
c
c-- eseguo il taglio della sezione di Harker
c
           if(ksez==1) then
             denom=np(2)*np(3)
           elseif(ksez==2) then
             denom=np(1)*np(3)
           elseif(ksez==3) then
             denom=np(1)*np(2)
           endif
           invflag = 31   
           call maxminnew(denmin,denmax,avden,stden,npunt,ksez)
           call changesectionnew(stden,nmod,denmin,ksez)
           if (kverbo > 0) then
               write(6,'(a,3f15.2,f8.3,a)') 'change section ',
     &      denmax,avden,stden,100*((denom-float(nmod))/denom),'%'
           endif
c
           icont1=icont1+1
c
c--rimetto in Patt la sezione modificata
c
           call ZeroHarkertuo(ksez,alim)
c
         endif
      enddo   ! enddo sulle possibili sezioni di Harker
c
      if(kverbo>0) then
        do i=1,NsezHarker
          write(6,'(a,i4)') 'SEZ',i
          write(6,'(a,3(3f8.2))') 'Hvet',Hvet(i,1:3,1:3)
          write(6,'(a,3f8.2)') 'Tvet',Tvet(i,1:3)
        enddo
      endif
      
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(69,'(3i4,f12.2)') ih,ik,il,Patt(ih,ik,il)   !<<<<<<
!      enddo
!      enddo
!      enddo



!p!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      mxsac = numbTrials      
      numbTrialsAtt = numbTrials      

      jBlock = 1
      nBlocksPh = 1
      write(lo,210) nBlocksPh
      Procedura = 'Patterson'
      write(lo,220) nBlocksPh,numbTrials,numbTrialsAtt,Procedura
      write(lo,*) ' '
  210 format(' Number of blocks to be used:',i3,/,
     *       15x,' Block     Trials    to explore    Procedure')
  220 format(15x,i3,2i12,8x,a)
!p!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
c--procedura per creare la mappa SMF
c
      call DoSingleIteration()
      if(jsys==1) then  
c--triclino 
        if (icent==0) then
           if(kverbo>0) write(6,*) 'DoSMF_tricl'
           call DoSMF_tricl(ksezold,ierr)     !-1
        end if
        if (icent==1) then
           if(kverbo>0) write(6,*) 'DoSMF_3D'
           call DoSMF_3D(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)   ! 0
        end if
      else
       if(iswitch_3D==0) then
c--Sezioni di Harker in una sola direzione
         if(kverbo>0) write(6,*) 'DoSMF_1D'
         call DoSMF_1D(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
       else
c--Sezioni di Harker in piu' di una direzione
         if(kverbo>0) write(6,*) 'DoSMF_3D'
         call DoSMF_3D(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
       endif
      endif
      call DoSingleIteration()
c
      return
  10  format(' Harker section ',a1,' = ',f6.3,'  Layer = ',i3,
     &                             ' ksez=',i3)
c
      end
c-----------------------------------------------------------------------
      subroutine DoSMF_3D(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
c
c--Patterson method for Harker in 3 dimensions
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom      !p
      USE PhaseModule    !p
      USE fourier_mod, only: maxmin3d
      integer sideppp
      dimension iuvw(3)
      dimension Harkerheight(50)
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
c
c--per la costruzione della SMF elimino del tutto il picco all'origine nella
c  Patterson
c
      enve(:,:,:) = Patt(:,:,:)
      call DropZeroPeak()
      SMF(:,:,:) = 0.0
      
c
c--regola la molteplicitï¿½della sezione di Harker
c  vale solo per l'asse 4 o 6. Sono sempre le ultime sezioni di Harker!!
c
      HarkerMult=1.0
!--se non ho componenti traslazionali.....
      if(sum(Tvet(NsezHarker,1:3))<=0.01)  then
!--e ho asse 4 o 6
        if(jsys>3.and.Hvet(NsezHarker,2,2)<=2.0.and.ifRhombAx==0) then
           HarkerMult=0.5
           write(6,*) 'Harker Multiplicity set on...'
        endif
      endif

c
c--costruisco la SMF
c
      iassepari=0
      do iz = 0, np(3)-1
        do iy = 0, np(2)-1
          do ix = 0, np(1)-1
            do k=1,NsezHarker
              do i1=1,3
                ntermm=Hvet(k,1,i1)*ix+Hvet(k,2,i1)*iy+Hvet(k,3,i1)*iz
                ntermm=ntermm+nint(Tvet(k,i1)*np(i1))
                iuvw(i1)=sideppp(ntermm,np(i1))
              enddo
!--elimino le sezioni di Harker nel Riciclo
              call CancSpread(iuvw(1),iuvw(2),iuvw(3))
              if(jsys==3.and.ksize>3) then
                Harkerheight(k)=enve(iuvw(1),iuvw(2),iuvw(3))
              else
                ksez    = Htype(k,1)
                ntraccia= Htype(k,2)
                kdet    = Htype(k,3)
                if(ntraccia*kdet==2) then
c--asse 6
                  Harkerheight(k)=HarkerMult*
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  iassepari=1
                elseif(ntraccia*kdet==1) then
c--asse 4
                  if(kdet>0) then 
                    Harkerheight(k)=HarkerMult*
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  else
                    Harkerheight(k)=HarkerMult*
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  endif
                  iassepari=1
                elseif(ntraccia*kdet==0) then
c--asse 3
                  if(ksez==0) then
c         diagonale
                    Harkerheight(k)=
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  else
c         perpendicolare
                    Harkerheight(k)=
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  endif
                elseif(ntraccia*kdet==-1) then
c--asse 2
                  if(ksez==0) then
c         diagonale
                    Harkerheight(k)=
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  elseif(ksez>10) then
c         linea di Harker
                    Harkerheight(k)=
     &               spreadpeak_linea(enve,iuvw(1),iuvw(2),iuvw(3),ksez)
                  else
c         perpendicolare
                    Harkerheight(k)=
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  endif
                elseif(ntraccia*kdet==3) then
c--centro di inversione
                    Harkerheight(k)=enve(iuvw(1),iuvw(2),iuvw(3))
                endif
              endif
            enddo
c
            Nstart=1+iassepari
            xx=minval(Harkerheight(Nstart:NsezHarker)) 
c           if(abs(ix-50)<3.and.abs(iy-41)<3.and.abs(iz-1)<3) then
c              write(6,*) ix,iy,iz,Harkerheight(1:NsezHarker),xx  ! deb
c           endif
            if(xx<0.0) xx=0.0
            xmap(ix,iy,iz)=xx
          enddo
        enddo
      enddo
c
c--conserva la SMF finale per la procedura multi-soluzione
c
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(70,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo
      xmapSav(:,:,:) = xmap(:,:,:)
c
c--ricerca i picchi da considerare
c
      call CercaPicchi(0,ierr)
      if(ierr<0) return

c
c--faccio il tagli alla Patterson
c
      xmap(:,:,:) = Patt(:,:,:)
      invflag = 10
      call maxmin3d(denmin,denmax,avden,stden,npunt,1)
!      sog=avden+0.8*stden    !rocco
      sog=avden+1.0*stden    !rocco
      call changesection3d(sog,nmod,denmin)
      denom=np(1)*np(2)*np(3)
      if (kverbo > 0) then
            write(6,'(a,4f15.2,f8.3,a)') 'change Patterson ',
     &      denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
      endif
c       
c--anticipo del calcolo di FOM e ImproveRiciclo
c       
      call CercaPicchiPatt()  
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(72,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo 

      Patt(:,:,:) = xmap(:,:,:)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine DoSMF_1D(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
c
c--Patterson method for Harker in 1 dimension
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom     !p
      USE PhaseModule   !p
      USE fourier_mod, only: maxmin3d

      dimension iuvw(3)
      dimension Harkerheight(50)
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
      integer sideppp
c
c--per la costruzione della SMF elimino del tutto il picco all'origine nella
c  Patterson
c
      enve=Patt
      call DropZeroPeak()
      SMF=0.0
c
c  costruisco la SMF per colonne e la memorizzo 
c                 per la procedura multisoluzione
c
c
c--regola la molteplicitï¿½della sezione di Harker
c  vale solo per l'asse 4 o 6. Sono sempre le ultime sezioni di Harker!!
c
      HarkerMult=1.0
!--se non ho componenti traslazionali.....
      if(sum(Tvet(NsezHarker,1:3))<=0.01)  then
!--e ho asse 4 o 6
        if(jsys>3.and.Hvet(NsezHarker,2,2)<=2.0.and.latt/=7) then
           HarkerMult=0.5
           write(6,*) 'Harker Multiplicity set on...'
        endif
      endif

      iassepari=0
      do iz = 0, np(3)-1
        do iy = 0, np(2)-1
          do ix = 0, np(1)-1
            do k=1,NsezHarker
              do i1=1,3
                ntermm=Hvet(k,1,i1)*ix+Hvet(k,2,i1)*iy+Hvet(k,3,i1)*iz
                ntermm=ntermm+nint(Tvet(k,i1)*np(i1))
                iuvw(i1)=sideppp(ntermm,np(i1))
              enddo
!--elimino le sezioni di Harker nel Riciclo
              call CancSpread(iuvw(1),iuvw(2),iuvw(3))
c
              ksez    = Htype(k,1)
              ntraccia= Htype(k,2)
              kdet    = Htype(k,3)
              if(ntraccia*kdet==2) then
c--asse 6
                Harkerheight(k)=HarkerMult*
     &           enve(iuvw(1),iuvw(2),iuvw(3))
                iassepari=1
              elseif(ntraccia*kdet==1) then
c--asse 4
                Harkerheight(k)=HarkerMult*
     &           enve(iuvw(1),iuvw(2),iuvw(3))
                iassepari=1
              elseif(ntraccia*kdet==0) then
c--asse 3
!--elimino le sezioni di Harker nella SMF
                Patt(iuvw(1),iuvw(2),iuvw(3))=0.0  
                Harkerheight(k)=HarkerMult*
     &             spreadpeak_asse3(enve,iuvw(1),iuvw(2),iuvw(3),ksez)
              elseif(ntraccia*kdet==-1) then
c--asse 2
!--elimino le sezioni di Harker nella SMF
                Patt(iuvw(1),iuvw(2),iuvw(3))=0.0  
                if(ksez>10) then
c         linea di Harker
                  Harkerheight(k)=
     &             spreadpeak_linea(enve,iuvw(1),iuvw(2),iuvw(3),ksez)
                else
!pba                  Harkerheight(k)=
!pba     &              spreadpeak_asse2(enve,iuvw(1),iuvw(2),iuvw(3),ksez)
                  ksezpg = ksez + 10
                  Harkerheight(k)=
     &             spreadpeak_linea(enve,iuvw(1),iuvw(2),iuvw(3),ksezpg)
                endif
              endif
            enddo
c--elimino eventualmente l'asse 2 parallelo a quello 4 o 6
            Nstart=1+iassepari
            xx=minval(Harkerheight(Nstart:NsezHarker))
c           if(abs(ix-72)<2.and.abs(iy-1)<2.and.abs(iz-0)<2) then
c              write(6,*) ix,iy,iz,Harkerheight(1:NsezHarker),xx  ! deb
c           endif
            if(xx<0.0) xx=0.0
            xmap(ix,iy,iz)=xx
          enddo
        enddo
      enddo
c
c--conserva la SMF finale per la procedura multi-soluzione
c
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(70,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo 
      xmapSav(:,:,:) = xmap(:,:,:)
c
c--ricerca i picchi sulla mappa bidimensionale (non lo posso fare sulla mappa
c   per colonne)   
c
      n1=0
      if(ksezold==1) then
        xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1)=0.0
      elseif(ksezold==2) then
        xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1)=0.0
      elseif(ksezold==3) then
        xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1)=0.0
      elseif(ksezold==11) then  
        ikc=sideppp(nint(Tvet(1,2)*np(2)),np(2))
        ilc=sideppp(nint(Tvet(1,3)*np(3)),np(3))
        do il=0,np(3)-1
         do ik=0,np(2)-1
           do ih=0,np(1)-1
            if(ik==ikc) then
              if(il==ilc) cycle
            endif
            xmap(ih,ik,il)=0.0
          enddo
         enddo
        enddo
      elseif(ksezold==12) then  
        ihc=sideppp(nint(Tvet(1,1)*np(1)),np(1))
        ilc=sideppp(nint(Tvet(1,3)*np(3)),np(3))
        do il=0,np(3)-1
         do ik=0,np(2)-1
          do ih=0,np(1)-1
            if(ih==ihc) then
              if(il==ilc) cycle
            endif
            xmap(ih,ik,il)=0.0
          enddo
         enddo
        enddo
      elseif(ksezold==13) then  
        ihc=sideppp(nint(Tvet(1,1)*np(1)),np(1))
        ikc=sideppp(nint(Tvet(1,2)*np(2)),np(2))
        do il=0,np(3)-1
         do ik=0,np(2)-1
           do ih=0,np(1)-1
            if(ih==ihc) then
              if(ik==ikc) cycle
            endif
            xmap(ih,ik,il)=0.0
          enddo
         enddo
        enddo
      endif
c
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(71,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo 
      
      call CercaPicchi(ksezold,ierr)
      if(ierr<0) return

c
c--anticipo del calcolo della ImproveRiciclo
c
      xmap(:,:,:) = Patt(:,:,:)
      call CercaPicchiPatt()  
c
c--faccio il taglio alla Patterson
c
      invflag = 10
      call maxmin3d(denmin,denmax,avden,stden,npunt,1)
      sog=avden+1.5*stden 
      call changesection3d(sog,nmod,denmin)
      if (kverbo > 0) then
          denom=np(1)*np(2)*np(3)
          write(6,'(a,4f15.2,f8.3,a)') 'change Patterson ',
     &      denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
      endif
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(72,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo 


!!!!      call CercaPicchiPatt()  


      Patt(:,:,:) = xmap(:,:,:)
c
      return
      end 
c-----------------------------------------------------------------------
      subroutine DoSMF_tricl(ksezold,ierr)
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom     !p
      USE PhaseModule   !p
      USE fourier_mod, only: maxmin3d
c
c--per la ricerca dei picchi elimino del tutto il picco all'origine nella
c  Patterson
c
      enve(:,:,:) = Patt(:,:,:)
      call DropZeroPeak()  
      SMF(:,:,:) = 0.0
c
c--la SMF coincide con la Patterson
c
      xmap(:,:,:) = enve(:,:,:)
c
c--conserva la SMF finale per la procedura multi-soluzione
c
!!!   xmapSav=xmap
      xmapSav(:,:,:) = Patt(:,:,:)
c
c--ricerca i picchi da considerare
c
      call CercaPicchi(-1,ierr)
      if(ierr<0) return

c
c--faccio il tagli alla Patterson
c
      xmap(:,:,:) = Patt(:,:,:)
      invflag = 10
      call maxmin3d(denmin,denmax,avden,stden,npunt,1)
      sog=avden+1.5*stden  
      call changesection3d(sog,nmod,denmin)
      if (kverbo > 0) then
          denom=np(1)*np(2)*np(3)
          write(6,'(a,4f15.2,f8.2,a)') 'change Patterson ',
     &    denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
      endif
c
c--anticipo del calcolo della ImproveRiciclo
c
      call CercaPicchiPatt()  
      Patt(:,:,:) = xmap(:,:,:)
c
      return
      end 
c------------------------------------------------------------------
      subroutine DoFourier(x1,y1,z1,ksezold,iswitch_3D)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom      !p
      USE PhaseModule    !p
      USE fourier_mod, only: maxmin3d
      integer sideppp

c
      io1=sideppp(nint(x1*np(1)),np(1))
      io2=sideppp(nint(y1*np(2)),np(2))
      io3=sideppp(nint(z1*np(3)),np(3))
c
      xmap(:,:,:) = xmapSav(:,:,:)
c
      if(iswitch_3D>0) then
        if(jsys==3) then  
c--ortorombico
c         call RompiCentroSimmetria(x1,y1,z1)
c-ULTIM
c         if(iwei==0) call RompiCentroSimmetria(x1,y1,z1)
c-ULTIM
          call RompiSimmetria3d(x1,y1,z1)
        else
c--da chiamare negli altri casi
          call RestoreSymmetry()      
        endif
      endif
c
c--sposto la Patterson originale del vettore (x1,y1,z1)
c     P0 = Patt  ---> P0 spostata = enve
c
      enve(:,:,:)=0.0
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
            if(abs(Patt(ih,ik,il))>0.0) then
              ih1=ih+io1
              if(ih1.ge.np(1)) ih1=ih1-np(1)
              ik1=ik+io2
              if(ik1.ge.np(2)) ik1=ik1-np(2)
              il1=il+io3
              if(il1.ge.np(3)) il1=il1-np(3)
              enve(ih1,ik1,il1)=Patt(ih,ik,il)
            endif
          enddo
        enddo
      enddo
      
      
!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(73,'(3i4,f12.2)') ih,ik,il,enve(ih,ik,il)
!      enddo
!      enddo
!      enddo 
!      close(73)
c
c--calcola la mappa min(P0 spostata * F0) = min(enve * xmapSav)
c
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
             xx1=xmap(ih,ik,il)
             xx2=enve(ih,ik,il)
             xmap(ih,ik,il)=min( xx1, xx2 )
             
 !!!!!!!!!!!!!!!!!!            xmap(ih,ik,il)= xx1              !per avere la sola smf

             if(xmap(ih,ik,il)<0.0) xmap(ih,ik,il)=0.0
          enddo
        enddo
      enddo

!      do ih = 0, np(1)-1
!      do ik = 0, np(2)-1
!      do il = 0, np(3)-1
!         write(74,'(3i4,f12.2)') ih,ik,il,xmap(ih,ik,il)
!      enddo
!      enddo
!      enddo 
!      close(74)

c
c-- cerco di ristabilire la simmetria del gruppo spaziale nella nuova
c   Fourier, cancellando la rimanente simmetria Patterson
c
      if(jsys==2.and.iswitch_3D==0) then
        call RestoreSymmetry_mono(x1,y1,z1,ksezold)
      else
        if(jsys/=1) call RestoreSymmetry()  
      endif
c
      esponent=1.3
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
            if (xmap(ih,ik,il).lt.0.0) then
                 xmap(ih,ik,il) = 0.0
            else
                 xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
            endif
          enddo
        enddo
      enddo
      esalta=esponent
c
c--modifico nuovamente la mappa
c
      invflag = 10
      call maxmin3d(denmin,denmax,avden,stden,npunt,1)
      sog=0.666*stden
      call changesection3d(sog,nmod,denmin)
      denom=np(1)*np(2)*np(3)
      if (kverbo > 0 ) then
          write(6,'(a,3f15.2,f8.3,a)') 'change section ',
     &      denmax,avden,stden,100*((denom-float(nmod))/denom),'%'
      endif
c
c-- stimo gli h  generici e gli H  di secondo rango
c
      invflag = 0
c     if(numbGen>0) then
c       numbMax=nreflTot
c     else
        numbMax=nrefl
        
!        numbMax=nrefl        !p
        
        
c     endif
      call InvMap_Patt(khl,mkang,iphaz,fcvet,numbMax,ier)     !p
      fcvet=sqrt(fcvet)
c
c     if(numbGen>0) then
c       nreflDimSav=nreflDim
c       nreflDim=nrefl
c       do i=1, nrefl
c        if (fcvet(i) > 0.00001) wt(i) = 1.
c       end do
c     endif
c
!p      if(ksize>3) then
!p        call PresigmaA(-2)
!p        wt=pesMod
!p      else
        work2(:) = 0.0
        do i=1,numbMax
          wt(i)=1.
          work2(i) = 100.0*evet(i)*fcvet(i)
        enddo
        call ScaleWeights(numbMax,wt,work2)
!p      endif
c
c     if(numbGen>0) then
c       nreflDim=nreflDimSav
c       chope=2.0
c       call Calcola_WT_Sigmaa_Patt(chope)
c     endif
c
c
      if(kverbo>0.and.knw==1) then
        do i=1,numbMax
          if(jsys==1) then
            iwork1(i)=0
          else
            jhklSem(1) = khl(1,i)
            jhklSem(2) = khl(2,i)
            jhklSem(3) = khl(3,i)
            ks = modulo_sir(jhklSem)
            if (ks.eq.0) then
             iwork1(i)=1
            else
             iwork1(i)=0
            endif
          endif
        enddo
        call CalcolaStatisticheH3d(numbMax)
      endif
c
      return
      end 
c------------------------------------------------------------------
      subroutine ZeroHarkermio(ksez,alim,id)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
!g    include 'atoms.inc'      !p
!g    include 'sircom.inc'     !p
!g    include 'symcom.inc'     !p
      USE PhaseModule    !p
c
c--id==1: faccio la pulizia vedendo le sezioni vicine
c
      n11=0
      n1 = nint(np(ksez) * alim)
      if(n1==0) then
        n1m=np(ksez)-1-1
        n2m=np(ksez)-1-2
       else
        n1m=n1-1
        n2m=n1-2
      endif
c
c--modifico la sezione di Harker vedendo quelle vicine
c
      icont=0
      avden=0
      denmax=0
      if(ksez==1) then
        if(id==1) then
          denom=np(2)*np(3)
          do ik = 0, np(2)-1
            do il = 0, np(3)-1
              if(xmap(n1,ik,il)>0.0) then  
                if(xmap(n1m,ik,il)>xmap(n1,ik,il)) then
                   icont=icont+1
                   avden=avden+xmap(n1,ik,il)
                   if(xmap(n1,ik,il)>denmax) then
                      denmax=xmap(n1,ik,il)
                      denwrong=xmap(n1m,ik,il)
                   endif
                   xmap(n1,ik,il) = 0.0 
                endif
              endif
            enddo
          enddo
        endif
c
c--isolo  la sezione di Harker dalla mappa Patterson
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(ih.lt.n1.or.ih.gt.n1) then
                xmap(ih,ik,il) = 0.0
              endif
            enddo
          enddo
        enddo
c
c-- sposto la sezione di Harker nella prima posizione della mappa
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
              xmap(n11,ik,il) = xmap(n1,ik,il)
          enddo
        enddo
      elseif(ksez==2) then
        if(id==1) then
          denom=np(1)*np(3)
          do il = 0, np(3)-1
            do ih = 0, np(1)-1
              if(xmap(ih,n1,il)>0.0) then  
                if(xmap(ih,n1m,il)>xmap(ih,n1,il)) then
                   icont=icont+1
                   avden=avden+xmap(ih,n1,il)
                   if(xmap(ih,n1,il)>denmax) then
                      denmax=xmap(ih,n1,il)
                      denwrong=xmap(ih,n1m,il)
                   endif
                   xmap(ih,n1,il) = 0.0 
                endif
              endif
            enddo
          enddo
        endif
c
c--isolo  la sezione di Harker dalla mappa Patterson
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(ik.lt.n1.or.ik.gt.n1) then
                xmap(ih,ik,il) = 0.0
              endif
            enddo
          enddo
        enddo
c
c-- sposto la sezione di Harker nella prima posizione della mappa
c
        do il = 0, np(3)-1
          do ih = 0, np(1)-1
              xmap(ih,n11,il) = xmap(ih,n1,il)
          enddo
        enddo
      elseif(ksez==3) then
        if(id==1) then
          denom=np(1)*np(2)
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(xmap(ih,ik,n1)>0.0) then  
                if(xmap(ih,ik,n1m)>xmap(ih,ik,n1)) then
                   icont=icont+1
                   avden=avden+xmap(ih,ik,n1)
                   if(xmap(ih,ik,n1)>denmax) then
                      denmax=xmap(ih,ik,n1)
                      denwrong=xmap(ih,ik,n1m)
                   endif
                   xmap(ih,ik,n1) = 0.0 
                endif
              endif
            enddo
          enddo
        endif
c
c--isolo  la sezione di Harker dalla mappa Patterson
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(il.lt.n1.or.il.gt.n1) then
                xmap(ih,ik,il) = 0.0
              endif
            enddo
          enddo
        enddo
c
c-- sposto la sezione di Harker nella prima posizione della mappa
c
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
              xmap(ih,ik,n11) = xmap(ih,ik,n1)
          enddo
        enddo
      endif
c       
      if(kverbo>0) then
        if(id==1) then
          if(icont>0) then
           write(6,'(a,i8,f8.2,a,3f10.2)') 'azzeramenti',icont,
     &          (100.*float(icont))/(denom),'% ',
     &           avden/icont,denmax,denwrong
          else
           write(6,*) 'no azzeramenti '
          endif
        endif
      endif
!
      return
      end
c-----------------------------------------------------------------------
      subroutine ZeroHarkertuo(ksez,alim)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
!g    include 'atoms.inc'      !p
!g    include 'sircom.inc'     !p
!g    include 'symcom.inc'     !p
      USE PhaseModule    !p

c
      n11=0
      n1 = nint(np(ksez) * alim)
c
c-- inserisco la sezione di Harker modificata al suo posto
c
      if(ksez==1) then
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
              Patt(n1,ik,il) = xmap(n11,ik,il)
!              write(66,'(3i4,f12.4)') n11,ik,il,xmap(n11,ik,il)
          enddo
        enddo
      elseif(ksez==2) then
        do il = 0, np(3)-1
          do ih = 0, np(1)-1
              Patt(ih,n1,il) = xmap(ih,n11,il)
!              write(67,'(3i4,f12.4)') ih,n11,il,xmap(ih,n11,il)
          enddo
        enddo
      elseif(ksez==3) then
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
              Patt(ih,ik,n1) = xmap(ih,ik,n11)
!              write(68,'(3i4,f12.4)') ih,ik,n11,xmap(ih,ik,n11)
          enddo
        enddo
      endif
!
      return
      end
c---------------------------------------------------------------
      subroutine maxminnew(denmin,denmax,avden,stden,npunt,ksez)
      USE Mappa
      USE ParametriMappa

!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      npunt=0
c
      n1=0
c
      if(ksez==1) then
       do iz = 0, np(3)-1
        do iy = 0, np(2)-1
          do ix = n1, n1
            if(iy<=2.and.iz<=2) cycle  ! non considero l'origine
            if(iy<=2.and.iz>=np(3)-3) cycle  ! non considero l'origine
            if(iy>=np(2)-3.and.iz<=2) cycle  ! non considero l'origine
            if(iy>=np(2)-3.and.iz>=np(3)-3) cycle  ! non considero l'origin
            xx=xmap(ix,iy,iz)
            if(xx.ne.0) then   
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
            endif
            npunt=npunt+1
           enddo
         enddo
       enddo
      elseif(ksez==2) then
       do iz = 0, np(3)-1
         do iy = n1, n1
           do ix = 0, np(1)-1
            if(ix<=3.and.iz<=3) cycle  ! non considero l'origine
            if(ix<=3.and.iz>=np(3)-3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iz<=3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iz>=np(3)-3) cycle  ! non considero l'origi
            xx=xmap(ix,iy,iz)
            if(xx.ne.0) then   
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
            endif
            npunt=npunt+1
           enddo
         enddo
       enddo
      elseif(ksez==3) then
       do iz = n1, n1
         do iy = 0, np(2)-1
           do ix = 0, np(1)-1
            if(ix<=3.and.iy<=3) cycle  ! non considero l'origine
            if(ix<=3.and.iy>=np(2)-3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iy<=3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iy>=np(2)-3) cycle  ! non considero l'origine
            xx=xmap(ix,iy,iz)
            if(xx.ne.0) then   
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
            endif
            npunt=npunt+1
           enddo
         enddo
       enddo
      endif
c
      avden=avden/float(npunt)
      stden=stden/float(npunt) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
c
      return
      end
*----------------------------------------------------------------------------*
      subroutine changesectionnew(sog,nmod,denmin,ksez)
      USE Mappa
      USE PhaseModule        !p

*---- invflag=1 taglia la mappa > sog (solo parte positiva)
*---- invflag=2 azzera la mappa > sog (solo parte positiva)
*---- invflag=3 taglia la mappa > sog 
*---- invflag=4 azzera la mappa > sog 
*---- invflag=10 azzera la mappa < sog (solo parte positiva)
*---- invflag=20 azzera la mappa < sog 
*---- invflag=30 azzera la mappa > sog partendo dal basso 
*---- invflag=31 taglio combinato
*---- invflag=32 taglio combinato ridotto
*---- invflag=40 azzera la parte negativa 

      nmod=0
c
      n1=0
c
      if(ksez==1) then
        nu=n1
        nv=np(2)-1
        nww=np(3)-1
      elseif(ksez==2) then
        nu=np(1)-1
        nv=n1
        nww=np(3)-1
      elseif(ksez==3) then
        nu=np(1)-1
        nv=np(2)-1
        nww=n1
      endif
c
      do 150 k=0,nww
         do 100 j=0,nv
            do 50 i=0,nu
               xx=xmap(i,j,k)
c
c--applico la soglia
c
               if (sog.gt.0.0.and.abs(xx)>0.) then
                 if (invflag==1) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==2) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==3) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==4) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==10) then
                   if(xmap(i,j,k).lt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==20) then
                   if(abs(xmap(i,j,k)).lt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==30) then
                   sog1=denmin+sog
                   if(xmap(i,j,k).lt.sog1) then
c                     xmap(i,j,k)=sog1
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                      nmod=nmod+1
                   endif
                 elseif (invflag==31) then
!pba                   sog1=0.6666*sog
                   sog1=0.5*sog
                   if(abs(xmap(i,j,k)).lt.sog1) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==32) then
                   sog1=0.3333*sog
                   if(abs(xmap(i,j,k)).lt.sog1) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                   sog1=denmin+2*sog
                   if(xmap(i,j,k).lt.sog1) then
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                   endif
                 elseif (invflag==40) then
                   if(xmap(i,j,k).lt.0.0) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 endif
               endif
c
  50        continue
 100     continue
 150  continue

!      do k=0,nww
!         do j=0,nv
!            do i=0,nu
!               if ( xmap(i,j,k) > 500) xmap(i,j,k) = 500
!               write(78,200) i,j,k,xmap(i,j,k)
! 200           format(3i4,f12.2)
!            end do
!         end do
!      end do



      return
      end
c---------------------------------------------------------
      subroutine CercaPicchi(ksezold, ierr)
c
c--compila la lista dei picchi da considerare nella multisoluzione
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom          !p
      USE PhaseModule        !p
      USE cgeom
      USE unit_cell
      dimension xor(3),xnew(3),s(3)
      
      dimension axyz(5)
      real, dimension(3,3) :: gm
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      ierr=0
c      nnn=max(jBlocksPh(1,jBlock),30)  ! ricontrollare
c     nnn=max(sum(jBlocksPh(1,1:jBlock)),30)
!p      if(numbTrials>0) then
!p        nnn=TrialVett(numbTrials)
!p      else
!p        nnn=sum(jBlocksPh(1,1:jBlock))
!p      endif
      nnn = 10        !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      aperc(1)=nnn * nOrigRoxi * 10.
      call pksrch_big_RocPat(1,ier) ! non funziona la ricerca in Fourier!!
c
      if (kverbo > 0) then
          gm = matrice_metrica(cell)
          do i=1,nats
              write(6,'(a,i5,3f10.4,f20.3,f10.0)')
     &            'peak found',i,xyzs(1:5,i)
          enddo

          xnew(1:3)=0.0
          do j=1,nats
             xor(1:3)=xyzs(1:3,j)
             !call xdist(xnew,xor,dist,s)
             call xdisteqs(xnew,xor,gm,dist,s)
!              write(6,11) j,xyzs(1:5,j),dist
          enddo

      endif
  11  format ('peak dist',i6,1h),3f10.4,f15.4,2f10.4)

!      STOP 222
c
c--provo a clusterizzare i picchi
c
c     goto 11
c     xyzs_dev(1,1:nats)=xyzs(4,1:nats)
c     do i=1,nats-1
c       if(xyzs(4,i)<0.01) cycle
c       xnew(1:3)=xyzs(1:3,i)
c       icont=0
c       do k=1,3
c        xweight(k)=xyzs(k,i)*xyzs(4,i)
c       enddo
c       weight=xyzs(4,i)
c       do j=i+1,nats
c         if(xyzs(4,j)<0.01) cycle
c         xor(1:3)=xyzs(1:3,j)
c         call xdist(xnew,xor,dist,s)
c         if(dist<2.0) then
c           write(6,*) 'clust',i,xyzs(1:4,i),j,xyzs(1:4,j),dist
c           icont=icont+1
c           weight=weight+xyzs(4,j)
c           do k=1,3
c             xweight(k)=xweight(k)+xyzs(k,j)*xyzs(4,j)
c           enddo
c           xyzs(4,j)=0.0
c         endif
c       enddo
!       xyzs(1:3,i)=xweight(1:3)/weight
c       write(6,'(a,i5,3f10.4,f20.3,i10)') 'dopo',i,xyzs(1:4,i),icont
c     enddo
c     xyzs(4,1:nats)=xyzs_dev(1,1:nats) ! non clusterizzo in effetti
c  11 continue
c
c--selezione dei picchi da considerare per lo shift
c
      npiktot=0
      goodmax=-999.
      heigh=xyzs(4,1)
      do_1: do i=1,nats
        h1=xyzs(4,i)
        if(h1<=1.0) cycle do_1
        if(abs(h1-heigh)>0.1) then
          goodmax=-999.
          heigh=h1
          npiktot=npiktot+1
          do j=1,5
            xyzs(j,npiktot)=xyzs(j,igoodmin)
          enddo
          if (kverbo > 0) then
          write(6,'(a,i5,3f10.4,2f10.1)') 
     &            'peak sel',npiktot,xyzs(1:5,npiktot)
          endif
        endif
        if(xyzs(5,i)>goodmax) then
           goodmax=xyzs(5,i)
           igoodmin=i
        endif
      enddo do_1
c
c--metto anche l'ultimo
c
      npiktot=npiktot+1
      do j=1,5
        xyzs(j,npiktot)=xyzs(j,igoodmin)
      enddo
      if (kverbo > 0) then
        write(6,'(a,i5,3f10.4,2f10.1)') 
     &            'peak sel',npiktot,xyzs(1:5,npiktot)
      endif
      
!pba     istruzioni per portare un picco dal n-esimp posto al primo posto della lista       
      
!        nhg = 11
!        do j=1, 5
!           axyz(j) = xyzs(j,nhg)
!           xyzs(j,nhg) = xyzs(j,1)
!           xyzs(j,1) = axyz(j)
!        end do    
    
c
c--controllo sul totale dei picchi utili per la multi-soluzione
c
      if (npiktot <= 0) then
        write(lo,10) 
        ierr=-1
      endif
   10 format(' Patterson Procedure unable to provide trials.',/,
     *       ' The program skips the first Block.',/)
c
c--uso la variabile xyzo per memorizzare i picchi della SMF per la
c  procedura multi-soluzione
c
      xyzo(:,:) = xyzs(:,:) 
      nats15=npiktot
c
      call to_coord_Patt(ksezold)

      return
      end
c---------------------------------------------------------
      subroutine RompiCentroSimmetria(x1,y1,z1)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom         !p
      USE PhaseModule       !p
      USE cgeom
      USE unit_cell
      dimension pik(3,200)
      dimension xs(3),xs1(3),s(3)
      integer sideppp
      common /ori/ ntra,taboTC(8,3)          !p
      real, dimension(3,3) :: gm
c
c--genero i suoi equivalenti per simmetria
c
      pik(:,:)=0.0
      ndrop=3
      npiktot=0
      gm = matrice_metrica(cell)
      do k=1,spacegr%nsymop !!!!nsymTot
        call oper(k,xs,x1,y1,z1)
c
c--rimetto la posizione del picco equivalente nella cella
c  e genero gli 8 picchi della simmetria residua dei seminvarianti
c
        do k1=1,nOrigRoxi
          npiktot=npiktot+1
          do j=1,3
            termm=xs(j)+taboTC(k1,j)
            pik(j,npiktot)=side(termm)
          enddo
        enddo
      enddo
c
c--cancello nella mappa tutti i picchi equivalenti al piu' alto che sono
c       centrosimmetrici 
c
      do_1: do i=1,npiktot
c
c--genero il picco centrosimmetrico a quello i-esimo
c
        do j=1,3
          termm=-pik(j,i)
          xs(j)=side(termm)
        enddo
c
c--controllo che il picco centrosimmetrico non coincida con 
c  alcuno degli equivalenti secondo il gruppo spaziale
c
        do k=1,spacegr%nsymop !!!!corr nsymTot
         call oper(k,xs1,x1,y1,z1)
         !call xdist(xs,xs1,dist,s)
         call xdisteqs(xs,xs1,gm,dist,s)
         if(dist<1.2) then
           if(kverbo>0) then
             write(6,'(a,3f8.2)') 'picco non cancellato',xs
           endif
           cycle do_1
         endif
        enddo
c
        io1=nint(xs(1)*np(1))
        io2=nint(xs(2)*np(2))
        io3=nint(xs(3)*np(3))
c 
        do il = -ndrop, ndrop
          do ik = -ndrop, ndrop
            do ih = -ndrop, ndrop 
               ih1=sideppp(io1+ih,np(1))
               ik1=sideppp(io2+ik,np(2))
               il1=sideppp(io3+il,np(3))
               xmap(ih1,ik1,il1) = 0.0
            enddo
          enddo
        enddo
c
      enddo  do_1
!
      return
      end
c---------------------------------------------------------
      subroutine CercaPicchi3d(id)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom         !p
      USE PhaseModule       !p
      dimension xs(3),xs1(3)
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      aperc(1)=1000
      call pksrch_big_RocPat(1,ier)
c
c--solo per debug
      write(id,'(a)') '-------- 3d --------'
      heigh=0.
      do i=1,nats
        h1=xyzs(4,i)
        if(h1.gt.0.01) then
          heigh=h1
          write(id,'(a,30x,f10.1)') 'uf',xyzs(4,i)  ! deb
          do ii=1,3
            xs(ii)=side(xyzs(ii,i))
          enddo
          do kk1=1,spacegr%ncoper
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
            call xequi(xs,kk3,coef,xs1,kk1)
            do j=1,3
              xs(j)=side(xs(j))
            enddo
            write(id,'(a,3f10.4,f10.1)') ' ',(xs1(j),j=1,3)  ! deb
          enddo
          enddo
          enddo
        endif
      enddo
c--solo per debug
!
      return
      end
c--------------------------------------------------
      subroutine CercaPicchiPatt()  
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom       !p
      USE PhaseModule     !p
      USE cgeom
      USE unit_cell
      dimension xor(3),xnew(3),s(3),xs(3)
      real, dimension(3,3) :: gm
      gm = matrice_metrica(cell)
c
c     do ix=0,np(1)-1
c     do iy=0,np(2)-1
c     do iz=0,np(3)-1
c       write(79,*) ix,iy,iz,SMF(ix,iy,iz)
c     enddo
c     enddo
c     enddo
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
!corr      nsymTot=nsym*(icent+1)*pts
!
!-ricerca dei picchi piu' alti  ( e lontani dall'origine)
!
!corr      aperc(1)=min(500.,float(maxAtoms)/float(nsymTot))
      aperc(1)=min(500.,float(maxAtoms)/float(spacegr%nsymop))
      call pksrch_big_RocPat(1,ier)
c
      hold=0.0
      nats30=0
      do i=1,nats
        xnew(1:3)=xyzs(1:3,i)
        hnew=xyzs(4,i)
c
        if(abs(hnew-hold)<0.001) cycle 
!
!-elimino quelli vicini all'origine
!
        distmin=999.
        xs(:)=0.0
        do kk1=1,spacegr%ncoper
          coef=1.0
          kk3=1
          call xequi(xs,kk3,coef,xor,kk1)
          !call xdist(xnew,xor,dist,s)
          call xdisteqs(xnew,xor,gm,dist,s)
          if(dist<distmin) distmin=dist
        enddo
        if(distmin>1.0) then    
!
!-genero i picchi equivalenti 
!
          hold=hnew
          do kk1=1,spacegr%ncoper
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
            call xequi(xnew,kk3,coef,xs,kk1)
            nats30=nats30+1
            xyz30(1,nats30)=side(xs(1))
            xyz30(2,nats30)=side(xs(2))
            xyz30(3,nats30)=side(xs(3))
c           write(6,*) 'picchi Patterson',nats30,i
c    &                      ,xyz30(1:3,nats30),xyzs(4,i)
          enddo
          enddo
          enddo
        endif
      enddo 
!
!-- restore the original Space Group
!
      call yfl02
!corr      nsymTot=nsym*(icent+1)*pts
      if(icent==1) then  
        do k=1,nsym
          do i=1,3
            do j=1,3
              kmat(k+nsym,i,j)=-kmat(k,i,j)
            enddo
          enddo
        enddo
        do k=1,nsym
          do i=1,3
            tmat(k+nsym,i)=-tmat(k,i)
          enddo
        enddo
      endif
!
c     call CheckPatt()
!
      return
      end
c--------------------------------------------------
      subroutine Riciclo3d(foma)
c
c--affina le fasi dei seminvarianti (2h,2k,2l) usando  i riflessi del tipo
c           (h,k,l) mediante un riciclo
c
c--ora nSemi e kSemi denotano solo i seminvarianti! 
c     iwork1 distingue  H    (1)  da h         (0)
c
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Seminvariants
      USE Molcom        !p
      USE PhaseModule      !p
      USE elements, only: Ca_at,numelem

      common /pesante/pesaggio,valpesante

      character tirang*11
!!!corr      dimension shi(4)
      character pesaggio*8
      dimension prM(40)
!cr.sing.      data prM /1.5, 2.5, 3.6, 5.0, 1.5, 2.5, 1.5, 5.0, 5.0, 7.5,
!cr.sing.     *          30 * 2.5/
      data prM /1.5, 2.5, 3.6, 5.0, 1.5, 2.5, 1.5, 3.0, 3.0, 4,
     *          30 * 2.5/
      integer, dimension(1) :: maxel

c

      kmad = 0                        !pgMad150508

      LowRes = 0                      !p
      
!corr      if(no(nk)>20.and.LowRes==0) then
      if(maxval(celem%z) > Ca_at .and.LowRes==0) then
        ncicli=10
      else
        ncicli=8
      endif
      if(iwei==0) ncicli=40
      if (kmad==1) ncicli = 12   !pgMAD070206
      if (kmad==2) ncicli = 8   !pgMAD070206
c     if (kmad==2) ncicli = 4   !dritan

      nchange=2
      iciclochmax=(ncicli-1)/nchange
c
      foma=0.0
c     if(numbGen>0) then
c       numbMax=nreflTot
c     else
        numbMax=nrefl

c     endif
c
      if (icent /= 1) call Mappa_Su(sufom)   !p
      sufom0=sufom
c     write(6,*) 'Sufom',sufom,sufom0/sufom
c
c--fa i cicli di inversione
c
!      percMap = 0.025
!      write(lo,'(a,f8.5)') ' percMap =',percMap


C calcolo indice " struttura pesante"

!corr      nomax = no(1)
!corr      jmax = 1
!corr      do j=2,nk
!corr         if ( no(j) > nomax) then
!corr            nomax = no(j)
!corr            jmax = j
!corr         end if
!corr      end do
      maxel = maxloc(celem%z)
      jmax = maxel(1)
      nomax = celem(jmax)%z
!corr
      numer = 0
      denom = 0
!corr      do j=1,nk
      do j=1,numelem(celem)
!corr         if (j.ne.jmax .and. no(j)>1) then
!corr            numer = numer + no(j) * nw(j)
!corr            denom = denom + nw(j)
         if (j.ne.jmax .and. celem(j)%z>1) then
            numer = numer + celem(j)%z * celem(j)%nw
            denom = denom + celem(j)%nw
         end if
      end do
      amedleggeri = numer / denom 
      valpesante = nomax / amedleggeri
      if (neutro == 1) then
         valpesante = 1.0
      end if
      write(lo,67856) valpesante
67856 format(/,' indice pesantezza della struttura: ',f6.3,/)

      do iciclo=0,ncicli-1
c
!                             iciclo   ! 0 1 2 3 4 5 6 7
        iciclomod=mod(iciclo,nchange)  ! 0 1 0 1 0 1 0 1 
        icicloch=iciclo/nchange        ! 0 0 1 1 2 2 3 3
c
        if(kverbo > 0) then
           write(6,'(a,i5,a)') '============  Riciclo n. ',
     &            (iciclo+1),' ============'
        endif
c
c--faccio la mappa Fourier con gli H + h
c
        fcoef(1:nrefl) = evet(1:nrefl)
c       if(numbGen>0) then
c          fcoef(nrefl+1:nreflTot) = fcvet(nrefl+1:nreflTot)
c       endif
        jpatt = 0
        if (kmad /= 0) then            !pgMAD090206
            call MakeMap_Patt(numbLSQ,jpatt)
        else
            call MakeMap_Patt(numbMax,jpatt)
        endif
c
c--modifico la mappa
c
        if (kmad /= 0) then            !pgMAD100206
            call ModificaMap3d_MAD(iciclo,ncicli,esponent)
        else
            call ModificaMap3d(icicloch,iciclomod,esponent)
        endif
!p        if (ksize == 7 .and. LowRes == 0) then
!p            kprint = 1  !0
!p            call Modifica_Mappa_NEW(iciclo)
!p        endif

!       kWriMap  = 1
!       MapNumber = iciclo + 10
!       iesMap = 0
!       jphas = 0
!       call Visualizza_Mappa(nrefl,MapNumber,iesMap,jphas)


!       write(6,*) ' MAXMIN Dopo RiduciRipples in Riciclo3d',iciclo
!       call maxmin_dedi(np(1),np(2),np(3),xmap)
c
c--inverto la mappa modificata
c
        invflag = 1
c-ULTIM
c       percMap=0.015
c-ULTIM
!  procedure per variare la percentuale di mappa nei due casi
!  percvar2 = per strutture leggere + DADA + LAMO
!  percvar  = per strutture pesanti tranne DADA e LAMO

!        pesaggio = 'percvar '           !<<<<<<   ATTENZIONE !!!!!
!        pesaggio = 'percvar2'           !<<<<<<   ATTENZIONE !!!!!
!        pesaggio = '20AB'               !<<<<<<   ATTENZIONE !!!!!
!        pesaggio = '20A3B'              !<<<<<<   ATTENZIONE !!!!!
!        pesaggio = '20BA'               !<<<<<<   ATTENZIONE !!!!!
!        pesaggio = '21'               !<<<<<<   ATTENZIONE !!!!!
!        pesaggio = '22'               !<<<<<<   ATTENZIONE !!!!!

        if (valpesante >= 3.0) then
           pesaggio = 'percvar '
        else
           pesaggio = 'percvar2'
        end if
        
        if (pesaggio(1:2) == '22') then
           if (iciclo <10) then
              percMap = prM(iciclo+1)/100.
           else
              ich = iciclo / 5
              if(ich == 5) then
                  percMAP = 0.075       
                  percMAP = 0.050      
              else
                  percMAP = 0.025       
                  percMAP = 0.015       
              end if
           end if
        elseif (pesaggio(1:2) == '21') then
           if (iciclo <10) then
              percMap = prM(iciclo+1)/100.
           else
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.05       
              else
                  percMAP = 0.015       
              end if
           end if
        elseif (pesaggio(1:4) == '20AB') then
           if (iciclo <10) then
              percMap = prM(iciclo+1)/100.
           else
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.075       !20A
              else
                  percMAP = 0.025       !20A
              end if
           end if
        elseif (pesaggio(1:5) == '20A3B') then
           ncicli = 40
           if (iciclo <10) then
              percMap = prM(iciclo+1)/100.
           elseif (iciclo < 20) then
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.075       !20A
              else
                  percMAP = 0.025       !20A
              end if
           else
              if ( iciclo > 19 .and. iciclo < 25 )then 
                 x=iciclo                                   
                 x1 = 20                                    
                 x2=ncicli-16                                  
                 y1 = 0.015                                    
                 y2 = 0.020                                      
              else if ( iciclo > 24 .and. iciclo < 30 )then 
                 x=iciclo                                   
                 x1 = 25                                    
                 x2=ncicli-11                                  
                 y1 = 0.01                                    
                 y2=0.075                                      
              else if ( iciclo > 29 .and. iciclo < 35 )then 
                 x=iciclo                                   
                 x1 = 30                                    
                 x2=ncicli-6                                 
                 y1 = 0.01                                    
                 y2=0.075                                      
              else if (iciclo > 34 ) then                      
                 x=iciclo                                   
                 x1 = 35                                    
                 x2=ncicli-1                                
                 y1 = 0.01                                 
                 y2=0.075                                      
              end if                                        
              call varlinear(x,x1,x2,y,y1,y2)
              percMAP = y
           end if
        elseif (pesaggio(1:4) == '20BA') then
           if (iciclo <10) then
              percMap = prM(iciclo+1)/100.
           else
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.025       !20B
              else
                  percMAP = 0.075       !20B
              end if
           end if
        elseif (pesaggio(1:8) == 'percvar ') then
        
           if (iciclo <10) then
              percMap = 0.015
           else
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.075       !20A
              else
                  percMAP = 0.025       !20A
              end if
           end if        
        
        
        
        
        
        
        
        
!           percMap=0.015                                        !percvar!
!           if ((iciclo > 9 .and. iciclo<20) .or. iciclo>29)then !percvar
!              if (iciclo > 9 .and. iciclo <20) then             !percvar
!                 x=iciclo                                       !percvar
!                 x1 = 10                                        !percvar
!                 x2=ncicli-21                                   !percvar
!              else if (iciclo > 29 ) then                       !percvar
!                 x=iciclo                                       !percvar
!                 x1 = 30                                        !percvar
!                 x2=ncicli-1                                    !percvar
!              end if                                            !percvar
!              y1=0.015                                          !percvar
!              y2 = 0.025                                        !percvar
!              call varlinear(x,x1,x2,y,y1,y2)
!              percMap = y
!           end if




        elseif (pesaggio(1:8) == 'percvar2') then
        
           if (iciclo <10) then
              percMap = 0.025
           else
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.075       !20A
!                  percMAP = 0.1       !20A
              else
                  percMAP = 0.025       !20A
!                  percMAP = 0.06       !20A
              end if
           end if        
        
        
        
        
        
!           percMap=0.025                                    !percvar2
!           if ( iciclo > 9 ) then                           !percvar2 
!              if ( iciclo > 9 .and. iciclo < 20 )then       !percvar2
!                 x=iciclo                                   !percvar2 
!                 x1 = 10                                    !percvar2
!                 x2=ncicli-21                               !percvar2
!                 y1 = 0.025                                 !percvar2
!              else if ( iciclo > 19 .and. iciclo < 30 )then !percvar2
!                 x=iciclo                                   !percvar2
!                 x1 = 20                                    !percvar2
!                 x2=ncicli-11                               !percvar2   
!                 y1 = 0.015                                 !percvar2   
!              else if (iciclo > 29 ) then                   !percvar2   
!                 x=iciclo                                   !percvar2
!                 x1 = 30                                    !percvar2
!                 x2=ncicli-1                                !percvar2
!                 y1 = 0.015                                 !percvar2
!              end if                                        !percvar2
!              y2=0.075                                      !percvar2
!              call varlinear(x,x1,x2,y,y1,y2)
!              percMap = y
!           end if    
        end if
        write(lo,'(a,i5,a,f8.5)') ' iciclo+1',(iciclo+1),
     *                            ' percMap =',percMap


        call InvMap_Patt(khl,mkang,iphaz,fcvet,numbMax,ier)

c
c      if(numbGen>0) then
c        nreflDimSav=nreflDim
c        nreflDim=nrefl
c        do i=1, nrefl
c         if (fcvet(i) > 0.00001) wt(i) = 1.
c        end do
c      endif
c
!p        if(ksize>3) then
!p          call PresigmaA(-2)
!p          wt=pesMod
!p        else
          work2(:)=0.
          do i=1,numbMax
            wt(i)=1.
            work2(i) = 100. * evet(i) * fcvet(i)
          enddo
          call ScaleWeights(numbMax,wt,work2)
!p        endif
c
c     if(numbGen>0) then
c       nreflDim=nreflDimSav
c       x  = iciclo
c       x1 = 0
c       x2 = ncicli-1
c       y1 = 1.0
c       y2 = 2.0
c       call varlinear(x,x1,x2,y,y1,y2)
c       chope = y
c       call Calcola_WT_Sigmaa_Patt(chope)
c     endif
c
c--calcolo delle FOMs
c
        dphi = 0
        if(iciclo==0) then
          fom1=dphi                ! x Piero: dphi non e' definito
        elseif(iciclo==6) then
          fom7=dphi
        elseif(iciclo==ncicli-1) then
          if(abs(esponent-1.0)>0.15) then
            foma=(fom1-fom7)*abs(fom7-dphi)/100.
          else
            foma=(fom1-fom7)/100.
          endif
        endif
c
        if(iciclomod==1 .and. icent /=1) call Mappa_Su(sufom)   !p
c       write(6,*) 'Sufom',sufom,sufom0/sufom
c
c--faccio le statistiche sulle fasi ottenute
c
 
 
        if(knw==1 .and. kverbo > 0) then
           call CalcolaStatisticheH3d(numbMax)
        endif
c

!        if (iciclo == 4) then
!          PercMap = 0.03 
!          write(lo,'(a,f8.5)') ' percMap =',percMap
!        else if (iciclo == 9) then
!           PercMap = 0.04 
!           write(lo,'(a,f8.5)') ' percMap =',percMap
!        else if (iciclo == 14) then
!           PercMap = 0.05 
!           write(lo,'(a,f8.5)') ' percMap =',percMap
!        end if
 
!         nm = 8
!         if (mod(iciclo+1,nm) == 0) then
!             percMap = 0.025
!         else
!             percMap = 1.1 * percMap
!         end if
         
      enddo  ! fine ciclo
!rocco  
        do i=1,numbMax
          faze=iphaz(i)
          if (mkang(i).ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
          endif
          iphaz(i)=mod(faze+3600.,360.)
        end do
 
 
     
!      kmad = 0                        !pgMad150508
      
c--ufi
c     if(numbGen>0) then
c       do i=nrefl+1,nreflTot
c          if(fcvet(i)>10.) fcvet(i)=10.
c          wt(i)=wt(i)*fcvet(i)*0.1
c       enddo
c     endif
c--ufi
c
c--scrivo la mappa per XtalView
c
c     call Trasla_Origine(nrefl)
c     do i=1,nrefl
c      write(79,'(3i4,2f8.3,i5)') khl(1:3,i),evet(i),wt(i),iphaz(i)
c     enddo
c     fcoef(1:nrefl)=evet(1:nrefl)
c     call MakeMap(nrefl,0)
c     call ScriviMappa("FourierFinale")
!
      return
      end
c-----------------------------------------------------------------------
      subroutine ModificaMap3d(icicloch,iciclomod,esponent)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom          !p
      USE PhaseModule        !p
      include 'param.fi'           !p
c       ciclo      ! 1 2 3 4 5 6 7 8
c       iciclomod  ! 0 1 0 1 0 1 0 1 
c       icicloch   ! 0 0 1 1 2 2 3 3
c

      common /pesante/pesaggio,valpesante

      character pesaggio*8

      kmad = 0
      resm = 11.
      ResSogLow = 1.
      
      iciclo = 2*icicloch + iciclomod
      ich = iciclo / 5
      
      esponent=1.0
      
!      pesaggio = 'percvar'      !<<<<<<   ATTENZIONE !!!!!
!      pesaggio = '20AB'         !<<<<<<   ATTENZIONE !!!!!
!      pesaggio = '20A3B'         !<<<<<<   ATTENZIONE !!!!!
!      pesaggio = '20BA'         !<<<<<<   ATTENZIONE !!!!!
!       pesaggio = '21'          !<<<<<<   ATTENZIONE !!!!!
!      pesaggio = '22'          !<<<<<<   ATTENZIONE !!!!!
        
        if (pesaggio(1:2) == '22') then
           if (iciclo <10) then
              esponent = 0.8
           else
              ich = iciclo / 5
              if(ich == 5) then
                 esponent = 0.8       
              else
                 esponent = 1.2       
              end if
           end if
      elseif (pesaggio(1:2) == '21') then
!         if (iciclo < 10) then
            esponent = 0.8
!         else
!            ich = iciclo / 5
!            if(ich == 2 .or. ich == 5) then
!               esponent = 0.8       
!            else
!               esponent = 1.2       
!            end if
!         end if
      elseif (pesaggio(1:4) == '20AB') then
         if (iciclo < 10) then
            esponent = 0.8
         else
!            esponent = 1.2
            esponent = 0.8

!            if(mod(ich,2) == 1) then
!               esponent = 0.8       !20xB
!            else
!               esponent = 1.2       !20xB
!            end if

         end if
      elseif (pesaggio(1:5) == '20A3B') then
         if (iciclo <10) then
            esponent = 0.8
            esponent = 1.0    !  I prova
         else
            if(mod(ich,2) == 1) then
               esponent = 0.8       !20B
            else
               esponent = 1.2       !20B
            end if
         end if
      elseif (pesaggio(1:4) == '20BA') then
         if (iciclo <10) then
            esponent = 0.8
         else
            if(mod(ich,2) == 1) then
               esponent = 1.2       !20xA
            else
               esponent = 0.8       !20xA
            end if
         end if
      elseif (pesaggio(1:8) == 'percvar ') then
         esponent=1.2
!         if (iciclo <10) then
!            esponent = 0.8
!         else
!            esponent=1.2
!         end if
      elseif (pesaggio(1:8) == 'percvar2') then
         if (valpesante >= 2.20) then
            esponent = 1.2
         else
            esponent = 0.8
         end if
      end if   
      
! procedura per variare il valore di esponent

!      if (iciclomod == 0) then
!          esponent = 0.8
!      else
!          esponent = 1.2
!      end if

!      if (iciclo >30) then
!         x=iciclo
!         x1=31
!         x2=40  
!         y1=0.8   
!         y2=1.0   
!         call varlinear(x,x1,x2,y,y1,y2)
!         esponent = y
!      end if     
!--------------------------------
!      esponent=0.7
!      if (iciclo >7 ) esponent = 0.8
!      if (iciclo >12 ) esponent = 0.9
!      if (iciclo >16 ) esponent = 1.
!--------------------------------
!      espStart = 0.7
!      esponent = espStart
!      if (iciclo > 2) then
!         esponent = espStart + (iciclo - 2) * 0.025
!         if (esponent > 1.0) then
!            esponent = 1.0
!         end if
!      end if
!--------------------------------
      
      if (iciclomod==0) then
c
c--opera la trasformazione dei picchi
c
        if(icicloch==0) call ImproveRicicloPat()   !pgMAD080206
!rocco        if (kmad /= 0) then         !pgMAD070206
            if (icicloch == 1) call ImproveRiciclo()
!rocco        else
!rocco            if (icicloch==1.or.jsys==4.or.
!rocco     *          v_p>0.98) call ImproveRiciclo()
!rocco        endif
  !  per forzare l'elevamento a esponent nei cicli pari      
        if (iciclo > 3) then
!          esponent = 1.0
          if(kverbo>0) write(6,'(a,f8.2)') 'esponent',esponent

           do il = 0, np(3)-1
             do ik = 0, np(2)-1
               do ih = 0, np(1)-1
                 if (xmap(ih,ik,il).lt.0.0) then
                   xmap(ih,ik,il) = 0.0
                 else
                   xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
                 endif
               enddo
             enddo
           enddo
        end if
           
      else
!        if (kmad == 0) then      !pgMAD090206!
!
!            if (resm < ResSogLow) then
!                if (no(nk)>20) then
!                    esponent=0.8
!                else
!                    esponent=1.0
!                    if (ksize>4.and.v_p<0.6) esponent = 0.8
!                    if (is3s2>2500) esponent = 1.1
!                    if (jsys==4) esponent=1.2
!                endif
!                if (iwei==0) esponent = 1.1
!            else
!                esponent=1.4
!!                if(ksize>5.and.no(nk)>20.and.v_p>0.59)  esponent=1.2
!                if (jsys==4.or.jsys==6) esponent=1.0
!            endif

c          if(numbGen>0) then
c              if (no(nk)>20) then
c                 if(ksize==4) then
c                    esponent=1.0
c                 else
c                    esponent=1.3
c                 endif
c              else
c                 if(ksize==4) then
c                    esponent=1.3
c                 else
c                    esponent=1.4
c                 endif
c              endif
c           endif
!        else
!            esponent = 1.0
!        endif
       
        if(kverbo>0) write(6,'(a,f8.2)') 'esponent',esponent

        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if (xmap(ih,ik,il).lt.0.0) then
                xmap(ih,ik,il) = 0.0
              else
                xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
             endif
            enddo
          enddo
        enddo

      endif ! su iciclomod
      esalta=esponent
c
      return
      end
c-----------------------------------------------------------------------
!corr      subroutine maxmin3d(denmin,denmax,avden,stden,npunt,id)
!corr      USE Mappa
!corr      USE ParametriMappa
!corr
!corr      denmin =  1.0e25
!corr      denmax = -1.0e25
!corr      avden  =  0.0
!corr      stden  =  0.0
!corr      npunt=0
!corrc
!corr       if(id==0) then
!corr         do iz = 0, np(3)-1
!corr           do iy = 0, np(2)-1
!corr             do ix = 0, np(1)-1
!corr               xx=xmap(ix,iy,iz)
!corr               denmax=amax1(denmax,xx)
!corr               denmin=amin1(denmin,xx)
!corr               avden=avden + xx
!corr               stden=stden + xx * xx
!corr               npunt=npunt+1
!corr             enddo
!corr           enddo
!corr         enddo
!corr      else
!corr         do iz = 0, np(3)-1
!corr           do iy = 0, np(2)-1
!corr             do ix = 0, np(1)-1
!corr               xx=xmap(ix,iy,iz)
!corr               if(xx>0) then   
!corr                 denmax=amax1(denmax,xx)
!corr                 denmin=amin1(denmin,xx)
!corr                 avden=avden + xx
!corr                 stden=stden + xx * xx
!corr                 npunt=npunt+1
!corr               endif
!corr             enddo
!corr           enddo
!corr         enddo
!corr      endif
!corrc
!corr      avden=avden/float(npunt)
!corr      stden=stden/float(npunt) - avden*avden
!corr      if (stden.gt.0.0) then
!corr          stden=sqrt(stden)
!corr      else
!corr          stden=0.0
!corr      endif
!corrc
!corr      return
!corr      end
*----------------------------------------------------------------------------*
      subroutine changesection3d(sog,nmod,denmin)
      USE Mappa
      USE PhaseModule       !p
*---- invflag=1 taglia la mappa > sog (solo parte positiva)
*---- invflag=2 azzera la mappa > sog (solo parte positiva)
*---- invflag=3 taglia la mappa > sog 
*---- invflag=4 azzera la mappa > sog 
*---- invflag=10 azzera la mappa < sog (solo parte positiva)
*---- invflag=20 azzera la mappa < sog 
*---- invflag=30 azzera la mappa > sog partendo dal basso 
*---- invflag=31 taglio combinato
*---- invflag=40 azzera la parte negativa 

      nmod=0
c
      do 150 k=0,np(3)-1
         do 100 j=0,np(2)-1
            do 50 i=0,np(1)-1
               xx=xmap(i,j,k)
               if(xx==0.0) cycle
c
c--applico la soglia
c
               if (sog.gt.0.0.and.abs(xx)>=0.0) then
                 if (invflag==1) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==2) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==3) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==4) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==10) then
                   if(xmap(i,j,k).lt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==20) then
                   if(abs(xmap(i,j,k)).lt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==30) then
                   sog1=denmin+sog
                   if(xmap(i,j,k).lt.sog1) then
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                      nmod=nmod+1
                   endif
                 elseif (invflag==31) then
                   sog1=0.6666*sog
                   if(abs(xmap(i,j,k)).lt.sog1) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                   sog1=denmin+2*sog
                   if(xmap(i,j,k).lt.sog1) then
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                   endif
                 elseif (invflag==40) then
                   if(xmap(i,j,k).lt.0.0) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 endif
               endif
c
  50        continue
 100     continue
 150  continue

      return
      end
c-----------------------------------------------------------------------
      subroutine DrawMap3d(id,tar,isez)
c
      USE Mappa
      USE PhaseModule        !p
c
      tar=side(tar)
c
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
             if(isez==1) then
               if(ih==nint(tar*np(1))) then
                 write(id+0,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ih==nint((1.-tar)*np(1))) then
                 write(id+1,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ih==nint((0.5+tar)*np(1))) then
                 write(id+2,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               endif
             elseif(isez==2) then
               io1=nint(tar*np(2))
               io2=nint((0.5+tar)*np(2))
               io3=nint((1.-tar)*np(2))
               tar1=side(0.5-tar)
               io4=nint(tar1*np(2))
               if(io1>=np(2)) then
                   io1=io1-np(2)
               elseif(io1<0) then
                   io1=io1+np(2)
               endif
               if(io2>=np(2)) then
                   io2=io2-np(2)
               elseif(io2<0) then
                   io2=io2+np(2)
               endif
               if(io3>=np(2)) then
                   io3=io3-np(2)
               elseif(io3<0) then
                   io3=io3+np(2)
               endif
               if(io4>=np(2)) then
                   io4=io4-np(2)
               elseif(io4<0) then
                   io4=io4+np(2)
               endif
               if(ik==io1) then  
                 write(id+0,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ik==io2) then
                 write(id+1,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ik==io3) then
                 write(id+2,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ik==io4) then
                 write(id+3,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               endif
             elseif(isez==3) then
               io1=nint(tar*np(3))
               io2=nint((0.5+tar)*np(3))
               io3=nint(tar*np(2)+2)
               io4=nint(tar*np(2)-2)
               if(io1>=np(3)) then
                   io1=io1-np(3)
               elseif(io1<0) then
                   io1=io1+np(3)
               endif
               if(io2>=np(3)) then
                   io2=io2-np(3)
               elseif(io2<0) then
                   io2=io2+np(3)
               endif
               if(io3>=np(3)) then
                   io3=io3-np(3)
               elseif(io3<0) then
                   io3=io3+np(3)
               endif
               if(io4>=np(3)) then
                   io4=io4-np(3)
               elseif(io4<0) then
                   io4=io4+np(3)
               endif
               if(il==io1) then  
                 write(id+0,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(il==io2) then
                 write(id+1,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(il==io3) then
                 write(id+2,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(il==io4) then
                 write(id+3,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               endif
             endif
          enddo
        enddo
      enddo
!
      return
      end
c-----------------------------------------------------------------------
      subroutine CalcolaStatisticheH3d(numbMax)
c
c--id=1: statistiche di H e h
c
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Seminvariants
!g    include 'atoms.inc'        !p
!g    include 'sircom.inc'       !p
!g    include 'symcom.inc'       !p
      USE PhaseModule      !p
!g    include 'seminvar.inc'     !p
!!!corr      dimension shi(4)
      real, allocatable :: wt_serv(:)
c
      IF (.NOT. ALLOCATED(wt_serv))
     *    ALLOCATE (wt_serv(1:numbMax),    stat = ierr)
c
      wt_serv(:)=0.
      write(6,*) ' special reflections'
      icont=0
      do i=1,numbMax
        if(iwork1(i).eq.1) then
          wt_serv(i)=wt(i)
          icont=1
        endif
      enddo
      if(icont>0) then
        nbru = +31
        izero = 0
        ifmin = 1
        call examin(nbru,khl,ipub,iphaz,numbMax,izero,wt_serv,ifmin)
        nbru = +21
        izero = 0
        ifmin = 1
        call examin(nbru,khl,ipub,iphaz,nstr,izero,wt_serv,ifmin)
      endif
c
      wt_serv(:)=0.
      write(6,*) ' general reflections'
      do i=1,numbMax
        if(iwork1(i).eq.0) then
          wt_serv(i)=wt(i)
        endif
      enddo
      nbru = +51
      izero = 0
      ifmin = 1
      call examin(nbru,khl,ipub,iphaz,numbMax,izero,wt_serv,ifmin)
      nbru = +41
      izero = 0
      ifmin = 1
      call examin(nbru,khl,ipub,iphaz,nstr,izero,wt_serv,ifmin)
c
      IF (ALLOCATED(wt_serv))
     *        DEALLOCATE (wt_serv, stat = ierr)
!
      return
      end
c-----------------------------------------------------------------------
      subroutine RompiSimmetria3d(x1,y1,z1)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom      !p
      USE PhaseModule    !p
      USE cgeom
      USE unit_cell
      dimension pik(3,200)
      dimension xs(3),xs1(3),s(3)
      integer sideppp
      common /ori/ ntra,taboTC(8,3)          !p
      real, dimension(3,3) :: gm
c
c--genero i suoi equivalenti per simmetria
c
      gm = matrice_metrica(cell)
      pik(:,:)=0.0
      npiktot=0
      ndrop=3
      do k=1,spacegr%nsymop !!!!nsymTot
        call oper(k,xs,x1,y1,z1)
c
c--rimetto la posizione del picco equivalente nella cella
c  e genero gli 8 picchi della simmetria residua dei seminvarianti
c
        do k1=2,nOrigRoxi
          npiktot=npiktot+1
          do j=1,3
            termm=xs(j)+taboTC(k1,j)
            pik(j,npiktot)=side(termm)
          enddo
        enddo
      enddo
c
c--cancello nella mappa tutti i 28 picchi equivalenti al primo, traslati
c     di 1/2 (quelli centrosimmetrici sono stati gia' cancellati)
c
      do_1: do i=1,npiktot
c
        do j=1,3
          termm=pik(j,i)
          xs(j)=side(termm)
        enddo
c
c--controllo che il picco da modificare non coincida con alcuno
c  degli equivalenti secondo il gruppo spaziale
c
        do k=1,spacegr%nsymop !!!!nsymTot
          call oper(k,xs1,x1,y1,z1)
          !call xdist(xs1,xs,dist,s)
          call xdisteqs(xs1,xs,gm,dist,s)
          if(dist<1.2) then
            if(kverbo>0) then
              write(6,'(a,3f8.2)') 'picco non modificato',xs
             endif
             cycle do_1
          endif
        enddo
c
        io1=nint(xs(1)*np(1))
        io2=nint(xs(2)*np(2))
        io3=nint(xs(3)*np(3))
c
        do il = -ndrop, ndrop
          do ik = -ndrop, ndrop
            do ih = -ndrop, ndrop 
               ih1=sideppp(io1+ih,np(1))
               ik1=sideppp(io2+ik,np(2))
               il1=sideppp(io3+il,np(3))
               xmap(ih1,ik1,il1) = 0.0
            enddo
          enddo
        enddo
      enddo do_1
!
      return
      end
c----------------------------------------------------------------------
      function side(term0)
c
      termm = term0
      termm=termm-int(termm)
      if(termm<0.0) termm=termm+1.0
      if(termm>=1.0) termm=termm-1.0
      side=termm
c
      return 
      end
c-----------------------------------------------------------------------
      function spreadpeak_clever(ih,ik,il)
c
c--fa lo spread  su tutti i 19 punti 
c
      USE Mappa
      USE ParametriMappa
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
      dimension b(19)
      integer sideppp
c
      do i=1,19
        ih1=sideppp(ih+ishift(1,i),np(1))
        ik1=sideppp(ik+ishift(2,i),np(2))
        il1=sideppp(il+ishift(3,i),np(3))
        b(i)=enve(ih1,ik1,il1)
      enddo
      spreadpeak_clever=b(10)
      b1 = b(3) + b(7) + b(9) + b(11) + b(13) + b(17)
      b2 = b(1) + b(2) + b(4) + b(5) + b(6) + b(8) +
     &     b(12) + b(14) +  b(15) + b(16) + b(18) + b(19)
      f = (30.0 * b(10) + 11.0 * b1 - 8.0 * b2) / 63.0
      if(abs(f)>=0.001) then
        c = (b(5)+b(12)+b(13)+b(14)+b(19)
     &      -b(1)-b(6)-b(7)-b(8)-b(15))/10.0
        deltaxf = c / f
        if(abs(deltaxf)<1.0) then
          d = (b(4)+b(8)+b(11)+b(14)+b(18)
     &        -b(2)-b(6)-b(9)-b(12)-b(16))/10.0
          deltay = d / f
          if(abs(deltay)<1.0) then
            e = (b(15)+b(16)+b(17)+b(18)+b(19)
     &          -b(1)-b(2)-b(3)-b(4)-b(5))/10.0
            deltaz = e / f
            if(abs(deltaz)<1.0) then
               ih2=sideppp(nint(ih+deltaxf),np(1))
               ik2=sideppp(nint(ik+deltay),np(2))
               il2=sideppp(nint(il+deltaz),np(3))
c              write(6,*) 'uf ',deltaxf,deltay,deltaz,
c    &                  ih,ik,il,ih2,ik2,il2,enve(ih2,ik2,il2)
               spreadpeak_clever=enve(ih2,ik2,il2)
            endif
          endif
        endif
      endif
c
      return 
      end
c-----------------------------------------------------------------------
      function spreadpeak_asse4(xmapmod,ih,ik,il,ksez)
c
c
c--fa lo spread    +      che va bene per l'asse 4 
c                + * +
c                  +
c
c  ksez=0 serve per l'eventuale spread sulla Patterson per la mappa S
c
      USE ParametriMappa
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      integer sideppp
c
      spreadpeak_asse4=0.0
      if(ksez==0) then
c--spread nello spazio  (serve per la Patterson)
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il)
        xx3=xmapmod(ih2,ik,il)
        xx4=xmapmod(ih,ik1,il)
        xx5=xmapmod(ih,ik2,il)
        xx6=xmapmod(ih,ik,il1)
        xx7=xmapmod(ih,ik,il2)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5,xx6,xx7)
      elseif(ksez==1) then
c--spread nella sezione yz
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il)
        xx3=xmapmod(ih,ik2,il)
        xx4=xmapmod(ih,ik,il1)
        xx5=xmapmod(ih,ik,il2)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==2) then
c--spread nella sezione xz
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il)
        xx3=xmapmod(ih2,ik,il)
        xx4=xmapmod(ih,ik,il1)
        xx5=xmapmod(ih,ik,il2)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==3) then
c--spread nella sezione xy
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il)
        xx3=xmapmod(ih2,ik,il)
        xx4=xmapmod(ih,ik1,il)
        xx5=xmapmod(ih,ik2,il)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5)
      endif
c
      return 
      end
c-------------------------------------------------------
      function spreadpeak_asse2(xmapmod,ih,ik,il,ksez)
c
c--fa lo spread +   + che va bene per l'asse 2 perpendicolare
c                 *
c               +   +
c
      USE ParametriMappa
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      integer sideppp
c
      spreadpeak_asse2=0.0
      if(ksez==1) then
c--spread nella sezione yz
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il1)
        xx3=xmapmod(ih,ik2,il2)
        xx4=xmapmod(ih,ik2,il1)
        xx5=xmapmod(ih,ik1,il2)
        spreadpeak_asse2=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==2) then
c--spread nella sezione xz
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il1)
        xx3=xmapmod(ih2,ik,il2)
        xx4=xmapmod(ih1,ik,il2)
        xx5=xmapmod(ih2,ik,il1)
        spreadpeak_asse2=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==3) then
c--spread nella sezione xy
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik1,il)
        xx3=xmapmod(ih2,ik2,il)
        xx4=xmapmod(ih1,ik2,il)
        xx5=xmapmod(ih2,ik1,il)
        spreadpeak_asse2=max(xx1,xx2,xx3,xx4,xx5)
      endif
c
      return 
      end
c-------------------------------------------------------
      function spreadpeak_linea(xmapmod,ih,ik,il,ksez)
c
c--fa lo spread + + + che va bene per la linea di Harker
c               + * +
c               + + +
c  nella sezione perpendicolare alla linea
c
      USE ParametriMappa
!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      integer sideppp
c
      spreadpeak_linea=0.0
      if(ksez==11) then
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il1)
        xx3=xmapmod(ih,ik2,il2)
        xx4=xmapmod(ih,ik2,il1)
        xx5=xmapmod(ih,ik1,il2)
        xx6=xmapmod(ih,ik1,il)
        xx7=xmapmod(ih,ik2,il)
        xx8=xmapmod(ih,ik,il1)
        xx9=xmapmod(ih,ik,il2)
      elseif(ksez==12) then
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih2,ik,il1)
        xx3=xmapmod(ih1,ik,il2)
        xx4=xmapmod(ih1,ik,il1)
        xx5=xmapmod(ih2,ik,il2)
        xx6=xmapmod(ih2,ik,il)
        xx7=xmapmod(ih1,ik,il)
        xx8=xmapmod(ih,ik,il1)
        xx9=xmapmod(ih,ik,il2)
      elseif(ksez==13) then
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik1,il)
        xx3=xmapmod(ih2,ik2,il)
        xx4=xmapmod(ih1,ik2,il)
        xx5=xmapmod(ih2,ik1,il)
        xx6=xmapmod(ih,ik1,il)
        xx7=xmapmod(ih,ik2,il)
        xx8=xmapmod(ih1,ik,il)
        xx9=xmapmod(ih2,ik,il)
      endif
      spreadpeak_linea=max(xx1,xx2,xx3,xx4,xx5,xx6,xx7,xx8,xx9)
c
      return 
      end
c-------------------------------------------------------
      function spreadpeak_asse3(xmapmod,ih,ik,il,ksez)
c
c--fa lo spread    + che va bene per l'asse 3 perpendicolare
c                *
c              +
c
      USE ParametriMappa

!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)

      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      integer sideppp
c
      spreadpeak_asse3=0.0
      if(ksez==1) then
c--spread nella sezione yz
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il1)
        xx3=xmapmod(ih,ik2,il2)
        spreadpeak_asse3=max(xx1,xx2,xx3)
      elseif(ksez==2) then
c--spread nella sezione xz
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        il1=sideppp(il-1,np(3))
        il2=sideppp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il1)
        xx3=xmapmod(ih2,ik,il2)
        spreadpeak_asse3=max(xx1,xx2,xx3)
      elseif(ksez==3) then
c--spread nella sezione xy
        ih1=sideppp(ih-1,np(1))
        ih2=sideppp(ih+1,np(1))
        ik1=sideppp(ik-1,np(2))
        ik2=sideppp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik1,il)
        xx3=xmapmod(ih2,ik2,il)
        spreadpeak_asse3=max(xx1,xx2,xx3)
      endif
c
      return 
      end
c-------------------------------------------------------
      integer function sidep(nterm0,isez)
c
      USE ParametriMappa
      USE PhaseModule        !p
c
      ntermm = nterm0
      if(ntermm<0) ntermm=ntermm+np(isez)
      if(ntermm>=np(isez)) ntermm=ntermm-np(isez)
      sidep=ntermm
c
      return 
      end
c-----------------------------------------------------------------------
      integer function sideppp(nterm0,nbin)
c
      ntermm = nterm0
      do while(ntermm<0)
          ntermm=ntermm+nbin
      enddo
      do while(ntermm>=nbin)
          ntermm=ntermm-nbin
      enddo
      sideppp=ntermm
c
      return 
      end
c---------------------------------------------------------
      subroutine RestoreSymmetry()
c
c--Rompe la simmetria Patterson, ristabilendo quella del gruppo spaziale
c    originario
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom      !p
      USE PhaseModule    !p
      dimension xs(3)
      dimension alimit(3,2)
      integer ipixeq(200,3)
      integer sideppp
c
c
c--determino l'unita' asimmetrica 
c
      do i=1,3
        alimit(i,1)=xyzfou(i,1)/xyzfou(i,4)
        alimit(i,2)=xyzfou(i,2)/xyzfou(i,4)
      enddo
c     write(6,*) 'asymmetric unit X:',alimit(1,1),alimit(1,2)
c     write(6,*) 'asymmetric unit Y:',alimit(2,1),alimit(2,2)
c     write(6,*) 'asymmetric unit Z:',alimit(3,1),alimit(3,2)
c
c--esploro l'unita' asimmetrica
c
      dx = 1.0/float(np(1))
      dy = 1.0/float(np(2))
      dz = 1.0/float(np(3))
c
      xx=alimit(1,1)
      do while (xx<=alimit(1,2))
        xx=xx+dx
        yy=alimit(2,1)
        do while (yy<=alimit(2,2))
          yy=yy+dy
          zz=alimit(3,1)
          do while (zz<=alimit(3,2))
            zz=zz+dz
c
c--considero le posizioni equivalenti
c
            fact=1.0
            pixsum=0.0
            do k=1,spacegr%nsymop !!!!!nsymTot
              call oper(k,xs,xx,yy,zz)
c
c--considero tutti i pixels equivalenti
c
              do j=1,3
                ipixeq(k,j)=sideppp(nint(xs(j)*np(j)),np(j))
              enddo
c
c--considero i corrispondenti valori della mappa e la loro media
c
              pixval=xmap(ipixeq(k,1),ipixeq(k,2),ipixeq(k,3))
              if(pixval==0.0) fact=0.7
              pixsum=pixsum+pixval
            enddo
!corr            avpix=pixsum/float(nsymTot)
            avpix=pixsum/float(spacegr%nsymop)
c
c--cambio i valori della mappa
c
            do k=1,spacegr%nsymop !!!!nsymTot
                xmap(ipixeq(k,1),ipixeq(k,2),ipixeq(k,3))=avpix*fact
            enddo
c
          enddo
        enddo
      enddo
c
      return
      end
c---------------------------------------------------------
      subroutine RestoreSymmetry_mono(x1,y1,z1,isez)
c
c--Rompe la simmetria Patterson, ristabilendo quella del gruppo spaziale
c    originario
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom      !p
      USE PhaseModule    !p

      dimension xs1(3)
      dimension xs2(3)
      integer sideppp
c
c--genero i suoi equivalenti per simmetria
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
      k=2  ! considero solo la seconda matrice di rotazione del monoclino
      call oper(k,xs2,x1,y1,z1)
      do j=1,3
        termm=xs2(j)
        xs2(j)=side(termm)
      enddo
c
      isect1=sideppp(nint(xs1(isez)*np(isez)),np(isez))
      isect2=sideppp(nint(xs2(isez)*np(isez)),np(isez))
      if(isect2==isect1) isect2=isect1+np(isez)
c
      if(isez==1) then
        do ih1 = isect1, isect2-1
          ih2=sideppp(ih1+isect2,np(1))
          do il1 = 0, np(3)-1
            do ik1 = 0, np(2)-1
               ik2=np(2)-ik1
               ik2=sideppp(np(2)-ik1,np(2))
               il2=np(3)-il1
               il2=sideppp(np(3)-il1,np(3))
               xx1=xmap(ih1,ik1,il1)
               xx2=xmap(ih2,ik2,il2)
               xxt=(xx1+xx2)/2.  
               if(xx1==0.0.or.xx2==0.0) then
                 xxt=xxt*0.3
               endif
               xmap(ih1,ik1,il1)=xxt
               xmap(ih2,ik2,il2)=xxt
            enddo
          enddo
        enddo
      elseif(isez==2) then
        do ik1 = isect1, isect2-1
          ik2=ik1+isect2
          ik2=sideppp(ik1+isect2,np(2))
          do il1 = 0, np(3)-1
            do ih1 = 0, np(1)-1
               ih2=np(1)-ih1
               ih2=sideppp(np(1)-ih1,np(1))
               il2=np(3)-il1
               il2=sideppp(np(3)-il1,np(3))
               xx1=xmap(ih1,ik1,il1)
               xx2=xmap(ih2,ik2,il2)
               xxt=(xx1+xx2)/2.  
               if(xx1==0.0.or.xx2==0.0) then
                 xxt=xxt*0.3
               endif
               xmap(ih1,ik1,il1)=xxt
               xmap(ih2,ik2,il2)=xxt
            enddo
          enddo
        enddo
      elseif(isez==3) then
        do il1 = isect1, isect2-1
          il2=il1+isect2
          il2=sideppp(il1+isect2,np(3))
          do ik1 = 0, np(2)-1
            do ih1 = 0, np(1)-1
               ih2=np(1)-ih1
               ih2=sideppp(np(1)-ih1,np(1))
               ik2=np(2)-ik1
               ik2=sideppp(np(2)-ik1,np(2))
               xx1=xmap(ih1,ik1,il1)
               xx2=xmap(ih2,ik2,il2)
               xxt=(xx1+xx2)/2.  
               if(xx1==0.0.or.xx2==0.0) then
                 xxt=xxt*0.3
               endif
               xmap(ih1,ik1,il1)=xxt
               xmap(ih2,ik2,il2)=xxt
            enddo
          enddo
        enddo
      endif
!
      return
      end
c---------------------------------------------------------
      subroutine RiduciOrigine_Patt()
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom         !p
      USE PhaseModule       !p
      dimension xs(3),xs1(3)
      integer sideppp
c
c--considero picchi diversi da quello nell'origine in gruppi centrati
c
c
      nnp=min(np(1),np(2),np(3))
!pba      alim=15.0    !originale per proteine
      alim=5.0
      nnp=nnp/2.
      if(alim>=nnp) then
        alim=nnp
        if (kverbo > 0 ) then
          write(6,*) 'limite raggiunto',nnp,alim
        endif
      endif
      ndrop=alim
      fact=1./alim
c
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
      xs1(:)=0.0
      do kk1=1,spacegr%ncoper
        coef=1.0
        kk3=1
        call xequi(xs1,kk3,coef,xs,kk1)
        if (kverbo > 0) 
     &      write(6,*) 'equivalenti di origine',kk1,xs(1:3)
        ih0=nint(xs(1)*np(1))
        ik0=nint(xs(2)*np(2))
        il0=nint(xs(3)*np(3))
c
        do iz = -ndrop, ndrop
          do iy = -ndrop, ndrop
            do ix = -ndrop, ndrop
c
              ray=ix**2+iy**2+iz**2+
     &            2.*ix*iy*cg + 2.*ix*iz*cb + 2.*iy*iz*ca
              ray=sqrt(ray)
c
              if(ray>1.0.and.ray<alim) then
                ih=sideppp(ih0+ix,np(1))
                ik=sideppp(ik0+iy,np(2))
                il=sideppp(il0+iz,np(3))
                xx=xmap(ih,ik,il)
                if(xx>0.0) then
                  factt=ray*fact
!                  factt=0.5*ray*fact   !pbapg
                  xmap(ih,ik,il) = factt*xx
                endif
              endif
c
            enddo
          enddo
        enddo
c
      enddo  ! fine loop sulla centratura
c
      return
      end
c---------------------------------------------------------
      subroutine RiduciRipple1(x1,y1,z1)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom         !p
      USE PhaseModule       !p
      dimension xs(3),xs1(3)
      integer sideppp
c
c
 
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
      alimd=0.5
      alimu=1.8
      factt=0.0
c     factt=0.5
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
      do kk1=1,spacegr%ncoper
        coef=1.0
        kk3=1
        call xequi(xs1,kk3,coef,xs,kk1)
        if (kverbo > 0) 
     &      write(6,*) 'equivalenti di origine',kk1,xs(1:3)
        xs(1)=side(xs(1))
        xs(2)=side(xs(2))
        xs(3)=side(xs(3))
        iszu=int(xs(3)*np(3)+alimu*deltx)
        iszl=int(xs(3)*np(3)-alimu*deltx)
        isyu=int(xs(2)*np(2)+alimu*delty)
        isyl=int(xs(2)*np(2)-alimu*delty)
        isxu=int(xs(1)*np(1)+alimu*deltz)
        isxl=int(xs(1)*np(1)-alimu*deltz)
c
        do iz = iszl, iszu
          do iy = isyl, isyu
            do ix = isxl, isxu
              a1=ix/deltx-xs(1)*cell(1)
              a2=iy/delty-xs(2)*cell(2)
              a3=iz/deltz-xs(3)*cell(3)
              ray2=a1**2 + a2**2 + a3**2 + 
     &             2.*a1*a2*cg + 2.*a1*a3*cb +
     &             2.*a2*a3*ca
              ray=sqrt(ray2)
c
              if(ray>alimd.and.ray<alimu) then
                ih=sideppp(ix,np(1))
                ik=sideppp(iy,np(2))
                il=sideppp(iz,np(3))
                xx=xmap(ih,ik,il)
                if(xx>0.0) then
                  xmap(ih,ik,il) = factt*xx
c                 write(6,*) 'ecco',ih,ik,il,ray,factt,xx
                endif
              endif
c
            enddo
          enddo
        enddo
c
      enddo  ! fine loop sulla centratura
c
      return
      end
c---------------------------------------------------------
      subroutine DropZeroPeakNew()
c
c--elimina il picco all'origine dalla Patterson 
c  (solo per fare l'SMF)
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom       !p
      USE PhaseModule     !p
      dimension xs(3),xs1(3)
      integer sideppp
c
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
c--posizione del primo minimo della funzione che descrive l'origine
c
      ap1minx=3.0/(2.0*(2.0*ihmx(1)+1.0))
      ap1miny=3.0/(2.0*(2.0*ihmx(2)+1.0))
      ap1minz=3.0/(2.0*(2.0*ihmx(3)+1.0))
c
      alimx=0.5*ap1minx*np(1) ! in pixels
      alimy=0.5*ap1miny*np(2)
      alimz=0.5*ap1minz*np(3)
      alim=amin1(alimx/deltx,alimy/delty,alimz/deltz) ! in Amstrong
      alim2=alim*alim
      write(6,*) 'uff',ihmx,alimx,alimy,alimz,alim
c
      xs1(:)=0.0
      do kk1=1,spacegr%ncoper
        coef=1.0
        kk3=1
        call xequi(xs1,kk3,coef,xs,kk1)
        if (kverbo > 0) 
     &      write(6,*) 'equivalenti di origine',kk1,xs(1:3)
        xs(1)=side(xs(1))
        xs(2)=side(xs(2))
        xs(3)=side(xs(3))
        iszu=int(xs(3)*np(3)+alimz)
        iszl=int(xs(3)*np(3)-alimz)
        isyu=int(xs(2)*np(2)+alimy)
        isyl=int(xs(2)*np(2)-alimy)
        isxu=int(xs(1)*np(1)+alimx)
        isxl=int(xs(1)*np(1)-alimx)
c       write(6,*) 'ufi',isxl,isxu,isyl,isyu,iszl,iszu
c
        do iz = iszl, iszu
          do iy = isyl, isyu
            do ix = isxl, isxu
              a1=ix/deltx-xs(1)*cell(1)
              a2=iy/delty-xs(2)*cell(2)
              a3=iz/deltz-xs(3)*cell(3)
              ray2=a1**2 + a2**2 + a3**2 + 
     &             2.*a1*a2*cg + 2.*a1*a3*cb +
     &             2.*a2*a3*ca
              if(ray2<alim2) then
                ih=sideppp(ix,np(1))
                ik=sideppp(iy,np(2))
                il=sideppp(iz,np(3))
c               write(6,*) 'ecco',ih,ik,il,sqrt(ray2),enve(ih,ik,il)
                enve(ih,ik,il) = 0.0
              endif
c
            enddo
          enddo
        enddo
c
      enddo  ! fine loop sulla centratura
c
      return
      end
c---------------------------------------------------------
      subroutine DropZeroPeak()
c
c--elimina brutalmente il picco all'origine
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom       !p
      USE PhaseModule     !p
      dimension xs(3),xs1(3)
      integer sideppp
c
      ndrop=2
      factt=0
      xs1(:)=0.0
c
      do kk1=1,spacegr%ncoper
        coef=1.0
        kk3=1
        call xequi(xs1,kk3,coef,xs,kk1)
        if (kverbo > 0) then
          write(6,*) 'equivalenti di origine',kk1,xs(1:3)
        endif
        ih0=nint(xs(1)*np(1))
        ik0=nint(xs(2)*np(2))
        il0=nint(xs(3)*np(3))
c
        do iz = -ndrop, ndrop
          do iy = -ndrop, ndrop
            do ix = -ndrop, ndrop
c
              ih=ih0+ix
              ik=ik0+iy
              il=il0+iz
c
              ray=(ih-ih0)**2+(ik-ik0)**2+(il-il0)**2
              ray=sqrt(ray)
c
              if(ray<=1.5) then
                ih1=sideppp(ih,np(1))
                ik1=sideppp(ik,np(2))
                il1=sideppp(il,np(3))
                enve(ih1,ik1,il1) = factt*enve(ih1,ik1,il1)
              endif
c
            enddo
          enddo
        enddo
c
      enddo  ! fine loop sulla centratura 
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ImproveRicicloPat()
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom          !p
      USE PhaseModule        !p
      USE cgeom
      USE unit_cell

      dimension xs(3),xs1(3),s(3)
      dimension xs2(3,200),xs3(3)
      integer kvetmax(1)
      dimension rhovet(200)
      integer sideppp
      real, dimension(3,3) :: gm
      gm = matrice_metrica(cell)
    
      jmin = 0
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      eps=0.01
      aperc(1)=10  
      call pksrch_big_RocPat(0,ier)
c
c--seleziono il picco piu' alto (nell'intorno del PIVOT)
c
      ipeak=1
c     goto 12
      xs(1:3)=xyzo(1:3,itria)  ! picco PIVOT
      do_peak: do i=1,nats
       xs1(1:3)=xyzs(1:3,i)
       do kk1=1,spacegr%ncoper
       do kk2=1,icent+1
       coef=1.0
       if(kk2==2) coef=-1.0
       do kk3=1,nsym
          call xequi(xs1,kk3,coef,xs3,kk1)
          !call xdist(xs,xs3,dist,s)
          call xdisteqs(xs,xs3,gm,dist,s)
          if(dist<1.2) then
            ipeak=i
!            write(6,*) 'picco preso',i,dist
            exit do_peak
           else
!            write(6,*) 'picco scartato',xyzs(1:4,i),dist
          endif
       enddo
       enddo
       enddo
      enddo do_peak
c 12  continue
      x0=xyzs(1,ipeak)
      y0=xyzs(2,ipeak)
      z0=xyzs(3,ipeak)
      h0=xyzs(4,ipeak)
      xs1(1:3)=xyzs(1:3,ipeak)
c
      if(kverbo>0) write(6,*) 'Fourier peak 1',x0,y0,z0,h0
c
c--faccio la sovrapposizione tra FF e Patt per modificare la mappa
c
      if (icent /= 1) call SovrapponiSuPatt(x0,y0,z0)   !p
c
c--seleziono il secondo picco piu' alto
c
      nsymPat=nsym*(1+1)*pts
      distmin=999.
      contmax=0.0
      do_1: do j=1,nats30
        jj=mod(j,nsymPat)
        if(jj==0) jj=nsymPat
c
c--elimino qui i picchi Harker
c
        if(jj==1) ino=0
        if(jsys/=1.and.ksize>3) then  
          ix=sideppp(nint(xyz30(1,j)*np(1)),np(1))
          iy=sideppp(nint(xyz30(2,j)*np(2)),np(2))
          iz=sideppp(nint(xyz30(3,j)*np(3)),np(3))
          if(SMF(ix,iy,iz)>0.0) ino=1
        endif
c
        xs2(1,jj)=side(xyz30(1,j)+x0)  ! picco nella Patterson 1 shiftata
        xs2(2,jj)=side(xyz30(2,j)+y0)
        xs2(3,jj)=side(xyz30(3,j)+z0)
        rhovet(jj)=PattFou(xs2(1,jj),xs2(2,jj),xs2(3,jj))
c       write(6,*) '               ',xs2(1:3,jj),jj,rhovet(jj),ino
        if(jj==nsymPat) then
          if(ino==1) cycle 
          kvetmax=maxloc(rhovet(1:nsymPat))
!--considero il picco vincente
          xs(1)=side(xs2(1,kvetmax(1)))
          xs(2)=side(xs2(2,kvetmax(1)))
          xs(3)=side(xs2(3,kvetmax(1)))
c         write(6,*) ' scelto  ',xs(1:3),rhovet(kvetmax(1))
c
c--elimino il picco se e' troppo vicino all'origine (0,0,0) nel triclino
c
          if (jsys == 1) then
              xs3 = 0.0
              !call xdist(xs,xs3,dist,s)
              call xdisteqs(xs,xs3,gm,dist,s)
              if (dist < 0.5) cycle do_1
          endif
c
c--elimino il picco se e' troppo vicino a quello PIVOT
c    (o ai suoi equivalenti)
c
          distmin=9999.
          do kk1=1,spacegr%ncoper
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
             call xequi(xs1,kk3,coef,xs3,kk1)
             !call xdist(xs,xs3,dist,s)
             call xdisteqs(xs,xs3,gm,dist,s)
             if(dist<distmin) distmin=dist
             if(abs(xs(1)-xs3(1))<0.001) cycle do_1
             if(abs(xs(2)-xs3(2))<0.001) cycle do_1
             if(abs(xs(3)-xs3(3))<0.001) cycle do_1
          enddo
          enddo
          enddo
c         write(6,*) 'distmin',distmin
          if(distmin<1.5) cycle do_1
c
          cont=rhovet(kvetmax(1))
          if(cont>contmax) then
            contmax=cont
            x1=xs(1)
            y1=xs(2)
            z1=xs(3)
            jmin=j
          endif
        endif
      enddo do_1
c
      if(jmin==0) then
         write(6,*) 'Second peak not found'
         return
      endif
      if(kverbo>0) then
        write(6,*) 'Fourier peak 2',x1,y1,z1,jmin,xyz30(1:3,jmin)
     &                               ,contmax
      endif
      if(contmax<=0.001) return
c
!--azzero  la maschera
      enve(:,:,:)=0.0
c
c--premio i picchi scelti
c
      call SetMask(x0,y0,z0,-1.2)
      call SetMask(x1,y1,z1,-1.2)
c
c--nats30, xyz30(1:3,i)  picchi Patterson nella cella della Patterson   
c
      do j1=1,nats30
        xs(1)=side(xyz30(1,j1)+x0)  ! picco nella Patterson 1 shiftata
        xs(2)=side(xyz30(2,j1)+y0)
        xs(3)=side(xyz30(3,j1)+z0)
        distmin=999. 
        do j2=1,nats30
          xs1(1)=side(xyz30(1,j2)+x1)  ! picco nella Patterson 2 shiftata
          xs1(2)=side(xyz30(2,j2)+y1)
          xs1(3)=side(xyz30(3,j2)+z1)
          !call xdist(xs,xs1,dist,s)
          call xdisteqs(xs,xs1,gm,dist,s)
c
c--premio i picchi in sovrapposizione
c
          if(dist<distmin) then
            distmin=dist
            jmin=j2
            x2=xs1(1)
            y2=xs1(2)
            z2=xs1(3)
          endif
        enddo
c       write(6,*) 'distmin',j1,jmin,distmin
        if(distmin<0.5) then
          call SetMask(xs(1),xs(2),xs(3),-1.2)
          call SetMask(x2,y2,z2,-1.2)
c         write(6,*) 'vince ',j1,j2,xs,xs1,dist
        endif
      enddo
c
c--deprimo tutti gli altri picchi
c
      do j1=1,nats30
        xs(1)=side(xyz30(1,j1)+x0)  ! picco nella Patterson 1 shiftata
        xs(2)=side(xyz30(2,j1)+y0)
        xs(3)=side(xyz30(3,j1)+z0)
        xs1(1)=side(xyz30(1,j1)+x1)  ! picco nella Patterson 2 shiftata
        xs1(2)=side(xyz30(2,j1)+y1)
        xs1(3)=side(xyz30(3,j1)+z1)
c--deb
c       prova=PattFou(xs(1),xs(2),xs(3))  ! deb
c       write(6,*) 'perde ',xs(1:3),prova
c       prova=PattFou(xs1(1),xs1(2),xs1(3))  ! deb
c       write(6,*) 'perde ',xs1(1:3),prova
c--deb
        call SetMask(xs(1),xs(2),xs(3),0.0)
        call SetMask(xs1(1),xs1(2),xs1(3),0.0)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ImproveRiciclo() 
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom          !p
      USE PhaseModule        !p
      USE cgeom
      USE unit_cell
      dimension xs(3),xs1(3,200),xs2(3),xs3(3),s(3)
      integer kvetmax(1)
      dimension rhovet(200)
      integer sideppp
      real, dimension(3,3) :: gm
      gm = matrice_metrica(cell)
c
c         x=icicloch
c         x1=0
c         x2=9  
c         y1=1.2   
c         y2=1.0   
c         call varlinear(x,x1,x2,y,y1,y2)
c         fact=y
c
!--azzero la maschera
      enve(:,:,:)=0.0
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      eps=0.01
      aperc(1)=10  
      call pksrch_big_RocPat(0,ier)
c
c--seleziono il picco piu' alto 
c
      ipeak=1
c     goto 12
      xs(1:3)=xyzo(1:3,itria)  ! picco PIVOT
      write(6,*) 'pivot',xs
      do_peak: do i=1,nats
       xs2(1:3)=xyzs(1:3,i)
       do kk1=1,spacegr%ncoper
       do kk2=1,icent+1
       coef=1.0
       if(kk2==2) coef=-1.0
       do kk3=1,nsym
          call xequi(xs2,kk3,coef,xs3,kk1)
          !call xdist(xs,xs3,dist,s)
          call xdisteqs(xs,xs3,gm,dist,s)
          if(dist<1.2) then
            ipeak=i
!            write(6,*) 'picco preso',i,dist
            exit do_peak
           else
!            write(6,*) 'picco scartato',xyzs(1:4,i),dist
          endif
       enddo
       enddo
       enddo
      enddo do_peak
c 12  continue
      x0=xyzs(1,ipeak)
      y0=xyzs(2,ipeak)
      z0=xyzs(3,ipeak)
      h0=xyzs(4,ipeak)
c
      if(kverbo>0) write(6,*) 'Fourier peak',x0,y0,z0
c
c--faccio la sovrapposizione tra FF e Patt per modificare la mappa
c
      if (icent /= 1) call SovrapponiSuPatt(x0,y0,z0)    !p 
c
c--nats30, xyz30(1:3,i)  picchi Patterson nella cella della Patterson   
c
      nsymPat=nsym*(1+1)*pts
c--deb
c     nsymFou=nsym*(icent+1)*pts
c     write(6,*) 'nsymPat',nsymPat,nsymFou
c--deb
      do j=1,nats30
c--deb
c       xp=xyz30(1,j)   ! picco Patterson
c       yp=xyz30(2,j)
c       zp=xyz30(3,j)
c       write(6,*) 'picco Patterson',xp,yp,zp
c--deb
c
        jj=mod(j,nsymPat)
        if(jj==0) jj=nsymPat
c
c--elimino qui i picchi Harker
c
        if(jj==1) ino=0
        if(jsys/=1.and.ksize>3) then  
          ix=sideppp(nint(xyz30(1,j)*np(1)),np(1))
          iy=sideppp(nint(xyz30(2,j)*np(2)),np(2))
          iz=sideppp(nint(xyz30(3,j)*np(3)),np(3))
          if(SMF(ix,iy,iz)>0.0) ino=1
        endif
c
        xs1(1,jj)=side(xyz30(1,j)+x0)  ! picco nella Patterson shiftata
        xs1(2,jj)=side(xyz30(2,j)+y0)
        xs1(3,jj)=side(xyz30(3,j)+z0)
        rhovet(jj)=PattFou(xs1(1,jj),xs1(2,jj),xs1(3,jj))
c       write(6,*) '               ',xs1(1:3,jj),jj,rhovet(jj)
c
c--scelgo un solo picco da premiare, gli altri li deprimo 
c
        if(jj==nsymPat) then
          if(ino==1) cycle 
          kvetmax=maxloc(rhovet(1:nsymPat))
c         ufi=maxval(rhovet(1:nsymPat),mask=rhovet/=rhovet(kvetmax(1)))
          iok=0
          do k=1,nsymPat
             if(k==kvetmax(1)) cycle
             if((rhovet(kvetmax(1))-rhovet(k))<0.0001) cycle
             iok=1
          enddo
          if(rhovet(kvetmax(1))<=0.0) cycle 
          if(iok==0) cycle 
!--considero prima il picco vincente
          xs(1)=side(xs1(1,kvetmax(1)))
          xs(2)=side(xs1(2,kvetmax(1)))
          xs(3)=side(xs1(3,kvetmax(1)))
          call SetMask(xs(1),xs(2),xs(3),-1.2) 
c         write(6,*) 'vince ',xs(1:3),rhovet(kvetmax(1))
c--deb
c         prova=PattFou(xs(1),xs(2),xs(3))  ! deb
c         write(6,*) 'vince ',xs(1:3),rhovet(kvetmax(1)),prova
c--deb
!--  ....poi quelli perdenti
          do i=1,nsymPat
            if(i==kvetmax(1)) cycle
            xs(1)=side(xs1(1,i))
            xs(2)=side(xs1(2,i))
            xs(3)=side(xs1(3,i))
            call SetMask(xs(1),xs(2),xs(3),0.0)
c           write(6,*) 'perde ',xs(1:3),rhovet(i)
c--deb
c           prova=PattFou(xs(1),xs(2),xs(3))  ! deb
c           write(6,*) 'perde ',xs(1:3),rhovet(i),prova
c--deb
          enddo
        endif
      enddo
c
      return
      end
c---------------------------------------------------------
      subroutine SetMask(x1,y1,z1,flag)
c
      USE Symmetry
      USE Mappa
      USE MappaPatterson
      USE PhaseModule        !p
      USE General, only: spacegr
      integer sideppp
      dimension xs(3),xs1(3)
c
      ndrop=2
c
c--genero gli equivalenti per simmetria
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
      do kk1=1,spacegr%ncoper
      do kk2=1,icent+1
      coef=1.0
      if(kk2==2) coef=-1.0
      do kk3=1,nsym
        call xequi(xs1,kk3,coef,xs,kk1)
        io1=sideppp(nint(xs(1)*np(1)),np(1))
        io2=sideppp(nint(xs(2)*np(2)),np(2))
        io3=sideppp(nint(xs(3)*np(3)),np(3))
c
        if(flag>=0.0) then
          do il1 = io3-ndrop, io3+ndrop
            do ik1 = io2-ndrop, io2+ndrop
              do ih1 = io1-ndrop, io1+ndrop 
                ih=sideppp(ih1,np(1))
                ik=sideppp(ik1,np(2))
                il=sideppp(il1,np(3))
                xx=xmap(ih,ik,il)
                if(enve(ih,ik,il)>-0.5) then
                   if(xx>0.0) then
                     xmap(ih,ik,il) = xx*flag
                   endif
                endif
              enddo
            enddo
          enddo
        else
          do il1 = io3-ndrop, io3+ndrop
            do ik1 = io2-ndrop, io2+ndrop
              do ih1 = io1-ndrop, io1+ndrop 
                ih=sideppp(ih1,np(1))
                ik=sideppp(ik1,np(2))
                il=sideppp(il1,np(3))
                xx=xmap(ih,ik,il)
                if(enve(ih,ik,il)>-0.5) then
                  enve(ih,ik,il)=-1.0
                  if(xx>0.0) xmap(ih,ik,il) = xx*abs(flag)
                endif
              enddo
            enddo
          enddo
        endif
c
      enddo
      enddo
      enddo
!
      return
      end
c-------------------------------------------------------
      real function  PattFou(x1,y1,z1)
      USE Mappa
      USE MappaPatterson
      USE PhaseModule        !p
      integer sideppp
c
        ndrop=1
c
        io1=nint(x1*np(1))
        io2=nint(y1*np(2))
        io3=nint(z1*np(3))
c
        sum=0.0
        icont=0
        do il1 = io3-ndrop, io3+ndrop
          do ik1 = io2-ndrop, io2+ndrop
            do ih1 = io1-ndrop, io1+ndrop 
              ih=sideppp(ih1,np(1))
              ik=sideppp(ik1,np(2))
              il=sideppp(il1,np(3))
              xx1=xmap(ih,ik,il)
              sum=sum+xx1 
              icont=icont+1
            enddo
          enddo
        enddo
c
      PattFou=sum/float(icont)
!
      return
      end
c---------------------------------------------------------------
      subroutine DrawHarker(ksez,id)
      USE Mappa
      USE PhaseModule        !p
c
c--100+id sez x    200+id sez y   300+id  sez z
c
c
c--scritta per visualizzare la sezione di Harker
c
      n1=0
c
c--scrivi la mappa fourier dopo la esaltazione 
c
c     idd=id+100*ksez
      idd=id
      if(ksez==1) then
       do il = 0, np(3)-1
         do ik = 0, np(2)-1
           do ih = n1, n1
             write(idd,'(3i6,2x,f15.3)') ih,ik,il,xmap(ih,ik,il)
           enddo
         enddo
       enddo
      elseif(ksez==2) then
       do il = 0, np(3)-1
         do ik = n1, n1
           do ih = 0, np(1)-1
             write(idd,'(3i6,2x,f15.3)') ih,ik,il,xmap(ih,ik,il)
           enddo
         enddo
       enddo
      elseif(ksez==3) then
       do il = n1, n1
         do ik = 0, np(2)-1
           do ih = 0, np(1)-1
             write(idd,'(3i6,2x,f15.3)') ih,ik,il,xmap(ih,ik,il)
           enddo
         enddo
       enddo
      endif
c
      return
      end
c---------------------------------------------------------------------
      subroutine varlinear(x,x1,x2,y,y1,y2)
c
c--faccio variare linearmente la variabile y tra y1 e y2 
c  in funzione della variabile c  x nei limiti  x1 e x2
c
      if(x<=x1) then
        delta=0.0
      else
        delta=(y2-y1)/(x2-x1)
      endif
      y=delta*(x-x1)+y1
      if(y1==y2) then
        y=y1
      elseif(y1<y2) then
        if(y<y1) then
          y=y1
        elseif(y>y2) then
          y=y2
        endif
      elseif(y1>y2) then
        if(y>y1) then
          y=y1
        elseif(y<y2) then
          y=y2
        endif
      endif
c
      return
      end
!======================================================================
!
!  ------------------------ S E M I N V A R -------------------------
!
!======================================================================
      subroutine seminv(ier)
      USE Symmetry
      USE General
      USE Riflessi
      USE Seminvariants
!g    include 'sircom.inc'          !p
!g    include 'symcom.inc'          !p
!g    include 'seminvar.inc'        !p
c---- reading of normal file
      common/sym2/msym,nsym2,icents
!g    dimension ivet(12),vet(12)
!g    equivalence (vet(1),ivet(1))
c
      ier=0
      iprin = 0
      nsem=0
      nlis=0
*     iphiv=0    ! gianluca 29/5/2008
!-- check if the space group is ' p 1 '
      icents = icent + 1
      msym=nsym*icents
      nsym2=(3-icents)*msym
      if (msym.eq.1) then
          write(lo,1040)
          ier = 1
          return
      endif
 1040 format(//5x,'* Warning *  No seminvariants are estimated'
     *        ,5x,'                when the space group is P 1',/)
      do k=1,nsym
         do i=1,3
            do j=1,3
               kmat(k+nsym,i,j)=-kmat(k,i,j)
            enddo
         enddo
      enddo
      do k=1,nsym
         do i=1,3
            tmat(k+nsym,i)=-tmat(k,i)
         enddo
      enddo
c-- calculation of inverse matricies
      call invers
c-- calculation of generalized inverse matricies
      call geninv
c-- set up the working table
      call choice
c
      return
      end
c----------------------------------------------------------------------
      subroutine invers
      USE Symmetry
      USE General
      USE Seminvariants
!g    include 'sircom.inc'          !p
!g    include 'symcom.inc'          !p
!g    include 'seminvar.inc'        !p
c
      common/sym2/msym,nsym2,icents
c
      integer v(3,3)
c
      invet(1)=1
      do 30 i=2,msym
         call invs(i,v)
         do 20 j=1,msym
            do k=1,3
               do l=1,3
                  if (kmat(j,k,l).ne.v(k,l)) go to 20
               enddo
            enddo
            invet(i)=j
            go to 30
   20    continue
   30 continue
      return
      end
c---------------------------------------------------------------------
      subroutine invs(j,v)
      USE Symmetry
      USE General
!g    include 'sircom.inc'          !p
!g    include 'symcom.inc'          !p
!
      common/sym2/msym,nsym2,icents
c
      integer v(3,3),a(3,3)
c
      do i1=1,3
         do j1=1,3
            a(i1,j1)=kmat(j,i1,j1)
         enddo
      enddo
c
c---- calcola v, la inversa di a
c
      call inv3(a,idet,v)
      if (idet.eq.0) then
                       write(lo,100) j
                       write(lo,*) '****  programming  error  ****'
                       write(lo,*) ' sir ends in error'
!p                       call cstop('1234')
                       stop 1234       !p
                      endif
  100 format(1x,'error computing invers no.',i2,' - det.=0  ')
      return
      end
c-----------------------------------------------------------------------
      subroutine geninv
      USE Symmetry
      USE General
      USE Seminvariants
!g    include 'sircom.inc'          !p
!g    include 'symcom.inc'          !p
!g    include 'seminvar.inc'        !p
c
c-- calcola le generalizzate inverse
c-- memorizzandole in 'invma' ed in 'idivv'
c
c
      common/sym2/msym,nsym2,icents
c
      integer a(3,3),v(3,3),va(3,3)
c
      lo=6
      do k=1,nsym2
c
c---- calcola la inversa generalizzata   v  della matrice  a
c---- dove  a  e' uguale alla matrice unita' meno la
c---- trasposta della k-esima matrice di rotazione
c
         if (k == 1) cycle
         do i=1,3
            do j=1,3
               a(i,j)=-kmat(k,j,i)
            enddo
            a(i,i)=1+a(i,i)
         enddo
         call g12sp(a,v,idiv)
c
c---- calcola  va = v * a
c
         do i=1,3
            do j=1,3
               va(i,j)=0
               do l=1,3
                  va(i,j)=va(i,j)+v(i,l)*a(l,j)
               enddo
            enddo
         enddo
c
c---- memorizza  v  ed  va  in invma
c
         do i=1,3
            do j=1,3
               invma(k+48,i,j)=va(i,j)
               invma(k   ,i,j)= v(i,j)
            enddo
         enddo
         idivv(k)=idiv
c
      enddo
!
      return
      end
c-----------------------------------------------------------------------
      subroutine g12sp(a,v,idiv)
      integer s(3,3),com(3,3),v(3,3),hold(3,3)
      integer a(3,3),p(3,3),q(3,3)
      do i=1,3
         do j=1,3
            p(i,j)=0
            q(i,j)=0
            s(i,j)=0
            hold(i,j)=a(i,j)
         enddo
         p(i,i)=1
         q(i,i)=1
      enddo
      do ir=1,3
         irr=ir
c
c---- trova il minimo elemento diverso da zero
c
         ip=0
         jp=0
         imin=999
         do i=ir,3
            do j=ir,3
               int=iabs(hold(i,j))
               if (int.eq.0.or.int.ge.imin) cycle
               imin=int
               ip=i
               jp=j
            enddo
         enddo
         if (ir < ip) then
c
c---- scambia le righe
c
             call rowop(hold,ip,ir,ih,p,1)
         endif
         if (ir < jp) then
c
c---- scambia le colonne
c
             call colop(hold,jp,ir,ih,q,1)
         endif
         iflo=hold(ir,ir)
         if (iflo == 0) cycle
c
c---- azzera la colonna
c
         ip=ir+1
         if (ip <= 3) then
             do i=ip,3
                if (hold(i,ir).eq.0) cycle
                ih=-1*hold(i,ir)/iflo
                call rowop(hold,i,ir,ih,p,2)
             enddo
         endif
c
c---- azzera la riga
c
         jp=ir+1
         if (jp <= 3) then
             do j=jp,3
                if (hold(ir,j).eq.0) cycle
                ih=-1*hold(ir,j)/iflo
                call colop(hold,j,ir,ih,q,2)
             enddo
         endif
      enddo
      ir=irr
      ia=hold(irr,irr)
      if (ia /= 0) then
          irr1=irr-1
          ib=hold(irr1,irr1)
          iflo=mod(ia,ib)
          if (iflo /= 0) then
              call colop(hold,irr,irr,ib,q,2)
          endif
      endif
   22 idiv=hold(ir,ir)
      if (idiv == 0) then
          ir=ir-1
          if (ir) 22,23,22
      endif
      i=ir
   15 i=i-1
      if (i /= 0) then
          s(i,i)=idiv/hold(i,i)
          go to 15
      endif
      s(ir,ir)=1
      do i=1,3
         do j=1,3
            com(i,j)=0
            do l=1,3
               com(i,j)=com(i,j)+q(i,l)*s(l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            v(i,j)=0
            do l=1,3
               v(i,j)=v(i,j)+com(i,l)*p(l,j)
            enddo
         enddo
      enddo
   23 continue
!
      return
      end
c-----------------------------------------------------------------------
      subroutine colop(a,il,ir,ii,q,ind)
      integer a(3,3),q(3,3),r(3,3),com(3,3),temp(3,3)
      do i=1,3
         do j=1,3
            r(i,j)=0
         enddo
      enddo
      if (ind <= 1) then
          i=6-1*(il+ir)
          r(i,i)=1
          r(il,ir)=1
          r(ir,il)=1
      else
          do i=1,3
             r(i,i)=1
          enddo
          r(ir,il)=ii
      endif
      do i=1,3
         do j=1,3
            com(i,j)=0
            temp(i,j)=0
            do l=1,3
               temp(i,j)=temp(i,j)+q(i,l)*r(l,j)
               com(i,j)=com(i,j)+a(i,l)*r(l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            q(i,j)=temp(i,j)
            a(i,j)=com(i,j)
         enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine rowop(a,il,ir,ii,p,ind)
      integer a(3,3),p(3,3),r(3,3),com(3,3),temp(3,3)
      do i=1,3
         do j=1,3
            r(i,j)=0
         enddo
      enddo
      if (ind <= 1) then
          i=6-1*(ir+il)
          r(i,i)=1
          r(il,ir)=1
          r(ir,il)=1
      else
          do i=1,3
             r(i,i)=1
          enddo
          r(il,ir)=ii
      endif
      do i=1,3
         do j=1,3
            com(i,j)=0
            temp(i,j)=0
            do l=1,3
               temp(i,j)=temp(i,j)+r(i,l)*p(l,j)
               com(i,j)=com(i,j)+r(i,l)*a(l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            p(i,j)=temp(i,j)
            a(i,j)=com(i,j)
         enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine choice
      USE General
      USE Symmetry
      USE Seminvariants
      USE Liste
!g    include 'sircom.inc'          !p
!g    include 'symcom.inc'          !p
!g    include 'listcom.inc'         !p
!g    include 'seminvar.inc'        !p
c
c-- calcola la 'working table' memorizzandola in 'jtable'
c
      common/sym2/msym,nsym2,icents
c
      integer v(3,3),vscar(48),mscar(48,3),jrot(48,48)
      data vscar/48*-1/
      data mscar/144*-1/
c
      nsy = 0
      jrot(:,:)=0
      maxi=1
      ima=1
      jmax=0
      if (ngen.eq.1.and.iprin.gt.2) write(lo,3000)
      if (icents.eq.1.and.iprin.gt.2) write(lo,9002)
      if (icents.eq.2.and.iprin.gt.2) write(lo,9000)
c
c---- elimina la matrice unita
c
      do i=2,msym
         vscar(i)=i
         mscar(i,1)=i
      enddo
      if (iprin.gt.2) write(lo,113)
      vscar(1)=-1
c
c---- stiamo trattando un gruppo spaziale fino a ortorombico ?
c
      if (jsys.le.3) go to 500
c
c---- poiche' e' un gruppo spaziale con simmetria superiore
c---- all'ortorombico ci chiediamo se e' abeliano
c
      if (ngen.eq.1) go to 700
c
c---- non essendo abeliano isoliamo la matrice  -i (se esiste)
c---- memorizzando la sua posizione (*-1) in  nsy
c
      if (icents.eq.1) go to 61
      nsy=msym/2+1
      if (iprin.gt.2) write(lo,9001) nsy
      vscar(nsy)=0
      nsy=-nsy
   61 continue
c
c---- eliminiamo le matrici inverse e le matrici  rj (?)
c----
c----              -1
c----             rj * ri * rj     (k=j+1,m)
c----
      m1m=msym-1
      do 99 i=2,msym
      iflag=0
      do 100 j=2,msym
      if (i.eq.j) go to 100
      iflag=0
c
c---- controlla che la matrice   ri  sia
c---- diversa dalla inversa di  rj .
c
      call invs(j,v)
      do k=1,3
         do l=1,3
         if (kmat(i,k,l).ne.v(k,l)) iflag=1
         enddo
      enddo
      if (iflag.ne.0) go to 100
      mscar(i,2)=j
      if (iprin.gt.2) write(lo,112) j,i
      go to 99
  100 continue
   99 continue
      do 854 i=2,msym
      do 853 j=2  ,msym
      if (i.eq.j) go to 853
      call invs(j,v)
c
c---- elimina le matrici equivalenti
c
      call prodms(i,j,v)
      j1p=j+1
      do 852 jj=2  ,msym
      if (jj.eq.i.or.jj.eq.j) go to 852
      do k=1,3
         do l=1,3
            if (kmat(jj,k,l).ne.v(k,l)) go to 852
         enddo
      enddo
      if (iprin.gt.2) write(lo,204) jj,i,j
      jrot(j,jj)=i
  852 continue
  853 continue
  854 continue
      do 860 j=2,msym
      jrot(1,j)=j
  860 continue
      do 855 j=2,msym
      do 856 i=1,msym
      jj=jrot(i,j)
      if (jj.eq.0) go to 856
      if (jj.eq.j) go to 856
      iflag=0
      jrot(1,jj)=0
      do 857 k=2,msym
      if (jrot(k,jj).eq.0) go to 857
      iflag=1
      jrot(k,jj)=0
  857 continue
      if (iflag.eq.0) jrot(i,j)=0
  856 continue
  855 continue
      jmax=0
      ima =0
      do 861 j=2,msym
      iflag=0
      do 862 i=1,msym
      jj=jrot(i,j)
      if (jj.eq.0) go to 862
      if (mscar(jj,1).eq.0) go to 862
      if (iflag.eq.1) go to 863
      iflag=1
      jmax=jmax+1
      ima =0
  863 continue
      ima=ima+1
      if (ima.gt.maxi) maxi=ima
      jtable(ima,jmax)=jj
      jj=mscar(jj,2)
      if (jj.lt.0) go to 862
      mscar(jj,1)=0
  862 continue
  861 continue
      go to 600
  700 continue
c
c---- essendo un gruppo abeliano deve solo eliminare le inverse
c
      if (iprin.gt.2) write(lo,4000)
      m1m=msym-1
      do 50 i=1,m1m
      if (vscar(i).le.0) go to 50
      iflag=0
      i1p=i+1
      do 45 j=i1p,msym
      if (vscar(j).le.0) go to 45
      call invs(j,v)
      do k=1,3
         do l=1,3
         if (kmat(i,k,l).ne.v(k,l)) iflag=1
         enddo
      enddo
      if (iflag.eq.0) go to 44
      iflag=0
      go to 45
   44 continue
      vscar(j)=0
      if (iprin.gt.2) write(lo,112) j,i
      go to 50
   45 continue
   50 continue
  500 continue
      do 505 i=1,msym
      if (vscar(i).le.0) go to 505
      jmax=jmax+1
      jtable(1,jmax)=vscar(i)
  505 continue
      go to 605
  600 continue
      if (icents.eq.1) go to 605
      if (ngen.gt.1.and.jsys.gt.3) go to 605
      jmax=jmax+1
      jtable(1,jmax)=iabs(nsy)
      nsy=0
  605 continue
      mmSem=jmax
      if (iprin.lt.2) go to 225
      write(lo,221)
      do i=1,maxi
         write(lo,223) (jtable(i,jj),jj=1,jmax)
      enddo
      write(lo,224)
      write(lo,9004) mmSem
  225 continue
      if (nsy.lt.0) nsy=0
c &&&&&&&&&&&&&&&&&&&&&&&
c &&&&&&&&&   questa istruzione serve ad evitare l'errore
c &&&&&&&&&   in compilazione - il 2000 non e' riferito
c &&&&&&&&&&&&&&&&&&&&&&&
      ihdgtd=0
      if(ihdgtd.eq.2323) goto 2000
      go to 9900
 2000 continue
      mmSem=-1
 9900 continue
      iimax=maxi
      ns=nsy
      return
  221 format(///,  5x,'  kk     w o r k i n g     t a b l e',/,
     *           5x,'==kk===========================================',/
     *            ,5x,'  kk')
  223 format(5x,'  kk     ',16i3)
  224 format(5x,'  kk',
     *     /,5x,    '==kk===========================================',/
     *        ,5x,'  kk',//)
  204 format(1x,'matrix # ',i2,' has been eliminated being equivalent to
     * matrix # ',i2,'  j=',i2)
  112 format(1x,'matrix # ',i2,' has been eliminated being the inverse o
     *f matrix # ',i2)
  113 format(1x,'matrix # 1 has been eliminated being the unitary one')
 3000 format(1x,'this is an abelian space group      ')
 4000 format(1x,'space group above orthorombic')
 9000 format(1x,'centrosimmetric space group')
 9002 format(1x,'non-centrosimmetric space group')
 9001 format(1x,'matrix number ',i2,'  is equal to  -i   ')
 9004 format(1x,'..... therefore we get ',i2,' different classes',//)
      end
c-----------------------------------------------------------------------
      subroutine prodms(ind1,ind2,v)
      USE Symmetry
      USE General
!g    include 'sircom.inc'          !p
!g    include 'symcom.inc'          !p
c
      common/sym2/msym,nsym2,icents
c
      integer v(3,3),com1(3,3),com2(3,3)
c
      do i=1,3
         do j=1,3
            com1(i,j)=0
            do l=1,3
               com1(i,j)=com1(i,j)+v(i,l)*kmat(ind1,l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            com2(i,j)=0
            do l=1,3
               com2(i,j)=com2(i,j)+com1(i,l)*kmat(ind2,l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            v(i,j)=com2(i,j)
         enddo
      enddo

      return
      end
c---------------------------------------------------------------------
!      subroutine CheckPatt()
!!
!      USE Atomi
!      USE Mappa
!      USE MappaPatterson
!      USE MolDyn
!      include 'sircom.fi'
!      USE Molcom
!      include 'symcom.fi'
!      USE PhaseModule
!      dimension xs(3),xsp(3),s(3),xs1(3)
!
!c
!      nsymPat=nsym*(1+1)*pts
!c     ncheck=nats30
!      ncheck=min(50*nsymPat,nats30)
!      do_1: do i=1,nats30
!        ii=mod(i,nsymPat)
!        if(ii==0) ii=nsymPat
!        if(ii/=nsymPat) cycle
!        xsp(1)=side(xyz30(1,i))  
!        xsp(2)=side(xyz30(2,i))
!        xsp(3)=side(xyz30(3,i))
!        icont=0
!        avdist=0.0
!        pafom=0.0
!        do_2: do j=1,ncheck-1
!          xs(1:3)=xyz30(1:3,j)+xsp(1:3)  
!!--calcolo il numero di sovrapposizioni
!          do_3: do k=j+1,ncheck
!            xs1(1:3)=xyz30(1:3,k)  
!            call xdist(xs,xs1,dist,s)
!            if(dist<1.0) then
!              icont=icont+1
!              avdist=avdist+dist
!            endif
!          enddo do_3
!        enddo do_2
!        if(icont>0) then
!         avdist=avdist/float(icont)
!         pafom=icont/avdist
!        endif
!        write(6,*) 'analizz',xsp,i,icont,avdist,pafom
!        xyz30(4,i)=avdist
!      enddo do_1
!c
!      return
!      end
c------------------------------------------------------------------
      subroutine CancSpread(ih,ik,il)
c
      USE Mappa
      USE MappaPatterson
      USE ParametriMappa
      USE PhaseModule        !p
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
      integer sideppp
c
      do i=1,19
        ih1=sideppp(ih+ishift(1,i),np(1))
        ik1=sideppp(ik+ishift(2,i),np(2))
        il1=sideppp(il+ishift(3,i),np(3))
        SMF(ih1,ik1,il1)=1.0
      enddo
c
      return
      end
c------------------------------------------------------------------
      subroutine Mappa_Su(sufom)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaCont
      USE MappaPatterson  ! solo per xmapShi
      USE fourier_mod, only: maxmin3d
!g    include 'atoms.inc'         !p
!g    include 'sircom.inc'        !p
!g    include 'symcom.inc'        !p
      USE PhaseModule       !p
      include 'param.fi'          !p
!--
                do i=1,nstr
                   worko(i) = wt(i)
                   iphazo(i) = iphaz(i)
                   wt(i) = 1.0
                   if (mkang(i) /= 1) wt(i) = 0.0
                   fcoef(i)  = evet(i)*evet(i)
                   iphaz(i)  = 2.0 * iphaz(i)
                enddo
!
!-- switch to P2 Space Group
!
c              icent=0
c              tmat(:,:)=0.
c              call musym()
c              nsymTot=nsym*(icent+1)*pts

               jpatt = 0
               call MakeMap_Patt_mod(nstr,jpatt) ! twopi * 2
c
c              aperc(1)=10
c              call pksrch_big_Roc(1, ier, nsr)
c              aver=0.0
c              do i = 1,nats
c                  write(6,99) i,xyzs(1:4,i)
c                  if(i>1) aver=aver+xyzs(4,i)
c              enddo
c99     format(i5,1h),4f15.3)
c              aver=aver/float(nats)
c              sufom=xyzs(4,1)/aver
c              write(6,*) 'Mappa FF',xyzs(4,1),aver,sufom
               call maxmin3d(xdenmin,xdenmax,xavden,xstden,npunt,1)
               sufom=(denmax-avden)/stden
c              write(6,*) 'Mappa FF 1',denmax,avden,stden,sufom
     &              
!
!-- restore the original Space Group
!
c              call yfl02
c              nsymTot=nsym*(icent+1)*pts
c              if(icent==1) then
c                do k=1,nsym
c                  do i=1,3
c                    do j=1,3
c                      kmat(k+nsym,i,j)=-kmat(k,i,j)
c                    enddo
c                  enddo
c                enddo
c                do k=1,nsym
c                  do i=1,3
c                    tmat(k+nsym,i)=-tmat(k,i)
c                  enddo
c                enddo
c              endif
c
!--rimetto a posto
c
      do i=1,nstr
        iphaz(i)  =  iphazo(i)
        wt(i) = worko(i)
      enddo
      xmapShi(:,:,:) = xmap(:,:,:)
!--
      return
      end
c---------------------------------------------------------------------
      subroutine SovrapponiSuPatt(x1,y1,z1)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaPatterson  
      USE MappaCont
!g    include 'atoms.inc'         !p
!g    include 'sircom.inc'        !p
!g    include 'symcom.inc'        !p
      USE PhaseModule       !p
      include 'param.fi'          !p
      real, allocatable :: xmapmod2(:,:,:)
      integer sideppp

      ALLOCATE (xmapmod2(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierr)

!--
        io1=sideppp(nint(x1*np(1)),np(1))
        io2=sideppp(nint(y1*np(2)),np(2))
        io3=sideppp(nint(z1*np(3)),np(3))

        enve(:,:,:)=0.0
        xmapmod2(:,:,:)=0.0
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
c
              ih1=ih+io1
              if(ih1.ge.np(1)) ih1=ih1-np(1)
              ik1=ik+io2
              if(ik1.ge.np(2)) ik1=ik1-np(2)
              il1=il+io3
              if(il1.ge.np(3)) il1=il1-np(3)
              enve(ih1,ik1,il1)=Patt(ih,ik,il)
c
              ih2=sideppp(ih-io1,np(1))
              ik2=sideppp(ik-io2,np(2))
              il2=sideppp(il-io3,np(3))
              xmapmod2(ih2,ik2,il2)=xmapShi(ih,ik,il)
            enddo
          enddo
        enddo
c
        if(kverbo>0) write(6,*) 'Patt+FF map'
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              xx1=enve(ih,ik,il)
              xx2=xmapmod2(ih,ik,il)
              xx3=min(xx1,xx2)
              if(xx3>=10.0) xmap(ih,ik,il)=1.5*xmap(ih,ik,il)
            enddo
          enddo
        enddo
!--
      IF (ALLOCATED(xmapmod2)) DEALLOCATE (xmapmod2,stat=ierr)
!--
      return
      end
c---------------------------------------------------------------------
!p      subroutine ScriviMappa(filename_map)
!p      USE Riflessi
!p      include 'sircom.inc'        !p
!p      include 'phasecom.inc'      !p
!p!p      USE PhaseModule     
!p      character*80 filename_map
!pc
!pc     filename_map="XtalMap"
!p      itype=0
!p      iform=2
!p      if (jopen(jhost,filename_map,itype,iform,ios).lt.0)
!p     *          go to 9500
!pc
!pc-- analizza e normalizza la mappa
!pc
!p      call Analizza_Mappa_Xtal(xmap_coef)
!pc
!pc-- scrive l'header
!pc
!p      nByte = 4
!p      call scrivi_header_Xtal(nByte,jhost,filename_map,ierr)
!pc
!pc-- scrive la mappa
!pc
!p      call ScriviMappaXtal(nByte,jhost,xmap_coef,xmap_div,ierr)
!pc
!p      close(jhost)
!p 9410 format(' Open  error, code =',i5,' file is ',a)
!p      ierr = -1
!p      return
!pc
!p 9500 write(Msg,9410) ios,filename_map(1:Lung(filename_map))
!p      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
!p      ierr = -1
!p!--
!p      return
!p      end
c---------------------------------------------------------
      subroutine ModificaMap3d_MAD(iciclo,ncicli,esponent)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom          !p
      USE PhaseModule       !p
      include 'param.fi'          !p

c       ciclo      ! 1 2 3 4 5 6 7 8
c
      if(iciclo == 0) then
c
c--opera la trasformazione dei picchi
c
      call ImproveRicicloPat()  !pgMAD1402
      
      elseif (iciclo == 2) then
        call ImproveRiciclo()
      else 

!        if (mod((iciclo+1),2) == 0) then       !pgMAD1402
         if (mod((iciclo+1),2) /= 0) then       !pgMAD170206

!        nStepcicli = 4
!        delta = (1.2-0.8) / (ncicli/nStepcicli -1)
!        delta = (1.2-1.0) / (ncicli/nStepcicli -1)
!        esponent = 0.8+ (iciclo/nStepcicli) * delta
!        esponent = 1.0+ (iciclo/nStepcicli) * delta

!        esponent = 1.0       !pgMAD1402

            esponent = 1.2
        

        if(kverbo>0) write(6,'(a,f8.2)') 'esponent',esponent

        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if (xmap(ih,ik,il).lt.0.0) then
                xmap(ih,ik,il) = 0.0
              else
                xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
             endif
            enddo
          enddo
        enddo

        end if               !pgMAD170206
!       endif       !pgMAD1402

      endif ! su iciclo
!
      return
      end
c---------------------------------------------------------
      subroutine maxmin_dedi(nx,ny,nz,x)
      USE General
!g    include 'sircom.inc'        !p
      include 'param.fi'          !p
c
      real x(0:nx-1,0:ny-1,0:nz-1)

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      do 30 iz = 0, nz-1
       do 20 iy = 0, ny-1
        do 10 ix = 0, nx-1
            xx=x(ix,iy,iz)
            if (xx > denmax) then
                denmax=xx
                ixmx = ix
                iymx = iy
                izmx = iz
            endif
            if (xx < denmin) then
                denmin=xx
                ixmn = ix
                iymn = iy
                izmn = iz
            endif
!           write(55,*) ix,iy,iz,xx
            avden=avden + xx
            stden=stden + xx * xx
 10     continue
 20    continue
 30   continue

      avden=avden/float(nx*ny*nz)
      stden=stden/float(nx*ny*nz) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
      rapden = denmax/stden

!     write(6,*) 'DenMax =',denmax,ixmx,iymx,izmx
!     write(6,*) 'DenMin =',denmin,ixmn,iymn,izmn
!     write(6,*) 'Average, Stand_dev, Rapden =',avden,stden,rapden
!     write(6,110) denmax, denmin,  stden,   rapden

  110 format ('Denmax, Denmin, St_dev, Rapden =',4f10.2)
      return
      end
!-----------------------------------------------------------------------
      subroutine ScaleWeights(nref,wt,g)

      dimension wt(nref),wtsort(nref),g(nref)
      dimension peso(100),sogg(100),iorde(nref)

      ic=0
      do i=1,nref
        if(wt(i).lt.0.000001) then
          wt(i)=0.0
          g(i)=0.0
        else
          ic=ic+1
          iorde(ic)=i
          wtsort(ic)=g(i)
        endif
      enddo
      nsort=ic
      if(nsort==0) return
      call sortall3(-1,wtsort,1,nsort,iorde)
c
      nstep=20
      rstep2=1.0/nstep
      rstep1=0.1/nstep
c
      nalfa1=-1
      term=1.0/(nstep*3.0)
      perc1=term
      do while(nalfa1<=0)
        nalfa1=nint(perc1*nsort)
        perc1=perc1+term/10.
      enddo
c
      sogg(1)=wtsort(nalfa1)
      peso(1)=1.0
c
      do i=2,nstep
        peso(i)=peso(i-1)-rstep2
        peso(i)=max(peso(i),0.01)
        perc1=perc1 + rstep1*i
        perc1=min(perc1,1.0)
        nalfa1=nint(perc1*nsort)
        sogg(i)=wtsort(nalfa1)
      enddo
c
      sogg(nstep)=wtsort(nsort)
c
      n=1
      do i=1,nsort
         k=iorde(i)
   17   if (wtsort(i).ge.sogg(n)) then
            wt(k)=peso(n)
        else
            n=n+1
            if (n.gt.nstep) n=nstep
            goto 17
        endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine MakeMap_Patt(numbMax,jpatt)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Molcom 
!g    include 'sircom.inc'
!g    include 'symcom.inc'
      USE PhaseModule 

!      include 'param.fi' 
c      
*
*  jpatt = 0   -> Fourier
*  jpatt = 1   -> Patterson
*  X(nx,ny,nz)

      dimension i1(3),i2(3)
!
      complex fh,fm,phasec
      integer lmod
      external lmod
c
      nu=np(1)
      nv=np(2)
      nww=np(3)
      f000 = 0.0

      xmap(:,:,:) = 0.0

      do i=1,numbMax
         fourcoef = fcoef(i)*wt(i)

         call DoSingleIteration()

	   if (jpatt.eq.0) then
             phase = dtor * float(iphaz(i))
         else
             phase = 0.0
         endif
         work2(i) = fourcoef * sin(phase)
         work1(i) = fourcoef * cos(phase)
      enddo
c
c     generate one complete hemisphere of reflexions
c

      nex = 0
      do jn=1,numbMax
         i1(1) = khl(1,jn)
         i1(2) = khl(2,jn)
         i1(3) = khl(3,jn)
         eep = work2(jn)
         ee  = work1(jn)

         do j=1,nsym

            do l=1,3
               i2(l)=0
               do k=1,3
                  i2(l)=i2(l)+i1(k)*kmat(j,k,l)
               enddo
            enddo

            fh = cmplx(ee,eep)
            fm = fh * phasec(-twopi*(i1(1)*tsmat(1,j) +
     +                               i1(2)*tsmat(2,j) +
     +                               i1(3)*tsmat(3,j)) )

            if (i2(3).ge.0) then
                ih=  lmod(i2(1),nu)
                ik=  lmod(i2(2),nv)
                il=2*lmod(i2(3),nww)
                xmap(ih,ik,il)  =real(fm)
                xmap(ih,ik,il+1)= aimag(fm)
            endif

            if (-i2(3).ge.0) then   
                ih=  lmod(-i2(1),nu)
                ik=  lmod(-i2(2),nv)
                il=2*lmod(-i2(3),nww)
                xmap(ih,ik,il)  =real(fm)
                xmap(ih,ik,il+1)= -aimag(fm)
            endif
         enddo
      enddo

      xmap(0,0,0)=f000

      call fft3hr(xmap,nu,nv,nww)

      return
      end
c-----------------------------------------------------------------------
      subroutine MakeMap_Patt_mod(numbMax,jpatt)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Molcom       
!g    include 'sircom.inc'
!g    include 'symcom.inc'
      USE PhaseModule 
!      include 'param.fi' 
c      
*
*  jpatt = 0   -> Fourier
*  jpatt = 1   -> Patterson
*  X(nx,ny,nz)

      dimension i1(3),i2(3)
!
      complex fh,fm,phasec
      integer lmod
      external lmod
c
      nu=np(1)
      nv=np(2)
      nww=np(3)
      f000 = 0.0

      xmap(:,:,:) = 0.0

      do i=1,numbMax
         fourcoef = fcoef(i)*wt(i)

         call DoSingleIteration()

	   if (jpatt.eq.0) then
             phase = dtor * float(iphaz(i))
         else
             phase = 0.0
         endif
         work2(i) = fourcoef * sin(phase)
         work1(i) = fourcoef * cos(phase)
      enddo
c
c     generate one complete hemisphere of reflexions
c

      nex = 0
      do jn=1,numbMax
         i1(1) = khl(1,jn)
         i1(2) = khl(2,jn)
         i1(3) = khl(3,jn)
         eep = work2(jn)
         ee  = work1(jn)

         do j=1,nsym

            do l=1,3
               i2(l)=0
               do k=1,3
                  i2(l)=i2(l)+i1(k)*kmat(j,k,l)
               enddo
            enddo

            fh = cmplx(ee,eep)
!p            fm = fh * phasec(-twopi*(i1(1)*tsmat(1,j) +
!p     +                               i1(2)*tsmat(2,j) +
!p     +                               i1(3)*tsmat(3,j)) )
            fm = fh * phasec(-2.*twopi*(i1(1)*tsmat(1,j) +
     +                                  i1(2)*tsmat(2,j) +
     +                                  i1(3)*tsmat(3,j)) )

            if (i2(3).ge.0) then
                ih=  lmod(i2(1),nu)
                ik=  lmod(i2(2),nv)
                il=2*lmod(i2(3),nww)
                xmap(ih,ik,il)  =real(fm)
                xmap(ih,ik,il+1)= aimag(fm)
            endif

            if (-i2(3).ge.0) then   
                ih=  lmod(-i2(1),nu)
                ik=  lmod(-i2(2),nv)
                il=2*lmod(-i2(3),nww)
                xmap(ih,ik,il)  =real(fm)
                xmap(ih,ik,il+1)= -aimag(fm)
            endif
         enddo
      enddo

      xmap(0,0,0)=f000

      call fft3hr(xmap,nu,nv,nww)

      return
      end
! ----------------------------------------------------------------------
#if 0
      subroutine AllocaMappa(iAction)
      USE General
      USE Mappa
      USE PhaseModule 
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      dimension ierv(3)
!
      ifPatt = 1

      do i=1,3
         ierv(i) = 0
      enddo

      nr3dSize = 3 * ( np(1) + 2 ) * ( np(3) + 2 )

      ierr = 0
      if (iAction == 1) then
        IF (.NOT. ALLOCATED(xmap))
     *    ALLOCATE (xmap(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierv(1))
!     *    ALLOCATE (xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(1))
          IF (.NOT. ALLOCATED(nr3d)) 
     *    ALLOCATE (nr3d (nr3dSize), stat = ierv(3))
          if (ifPatt > 0) then 
            IF (.NOT. ALLOCATED(enve))
     *    ALLOCATE (enve(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierv(2))
        endif
!
        if (ierv(1).ne.0.or.ierv(2).ne.0.or.ierv(3).ne.0) then
              write(0,*) 'Map Allocation Error'
              stop
        endif
        xmap(:,:,:) = 0.0
        nr3d(:) = 0
        if (ifPatt > 0) then 
           enve(:,:,:) = 0.0
        end if
      else
          IF (ALLOCATED(xmap)) DEALLOCATE (xmap,nr3d,  stat = ierr)
          IF (ALLOCATED(enve)) DEALLOCATE (enve,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'Mappa DeAllocation Error'
              stop
          endif
      endif
!
      return
      end
#endif
! ----------------------------------------------------------------------
      subroutine AllocaMappaPatterson(iAction)
      USE MappaPatterson
      USE PhaseModule       !p
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(3)
!
      do i=1,3
         ierv(i) = 0
      enddo
!
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(Patt))
     *    ALLOCATE (Patt(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierv(1))

          IF (.NOT. ALLOCATED(SMF))
     *    ALLOCATE (SMF(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierv(2))

          IF (.NOT. ALLOCATED(xmapShi))
     *    ALLOCATE (xmapShi(0:np(1)-1,0:np(2)-1,0:np(3)+1), 
     *                                                  stat = ierv(3))
          IF (.NOT. ALLOCATED(xmapSav))
     *    ALLOCATE (xmapSav(0:np(1)-1,0:np(2)-1,0:np(3)+1),
     *                                                  stat = ierv(3))

!
          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(0,*) 'MapPatterson Allocation Error'
              stop    !p
          endif
          SMF = 0.0
          xmapShi = 0.0
          xmapSav = 0.0
      else
          IF (ALLOCATED(Patt))
     *        DEALLOCATE (Patt,SMF,xmapShi,xmapSav,  stat = ierr)
          if (ierr.ne.0) then
              write(0,*) 'MapPatterson DeAllocation Error'
              stop       !p
          endif
      endif
!
      return
      end
c--------------------------------------------------------------------------
      subroutine pksrch_big_RocPat(iflagPKS, ier)
c
c-- find positions of peaks by fitting quadratic function to 19 points
c   da usare solo per il metodo Patterson
c   non usa gli operatori di simmetria, ne' il dm
c   iflagPKS=0: unita' asimmetrica Fourier
c   iflagPKS=1: unita' asimmetrica Patterson
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE ParametriMappa
      USE Molcom          !p
      USE PhaseModule        !p
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
      real xs(3)
      real b(19)
      integer sideppp,inRegion
      integer np1(3),np2(3)
c
      nats=aperc(1)
      nats = min0(MaxAtoms-20, nats)
!     if (ksize > 2) then
!         if (nats < 20) nats = 20
!     else
!         if (nats < 5) nats = 5
!     endif
      npic = nint(nats * 1.3)
      npic = min0(MaxAtoms-20, npic)
!
!-- micro structures
!
!     if (ksize == 1) then
!         if (npic < 10) then
!             npic = 10
!         endif
!         if (nats < 10) then
!             nats = 10
!         endif
!     endif
!--initialise constants
      dx = 1.0/float(np(1))
      dy = 1.0/float(np(2))
      dz = 1.0/float(np(3))
      limit = min0(MaxAtoms, npic)
      alevel = 0.1
      NumPeaks = 0
!
!--eventualmente limito la ricerca
      do i=1,3
        np1(i)=0
        np2(i)=np(i)-1
        if(iflagPKS==0) then
          alimd=xyzfou(i,1)/xyzfou(i,4)
          alimu=xyzfou(i,2)/xyzfou(i,4)
        elseif(iflagPKS==1) then
          alimd=xyzpat(i,1)/xyzpat(i,4)
          alimu=xyzpat(i,2)/xyzpat(i,4)
        endif
        if(alimd>=0.0) then
           ndown=max0(np1(i),floor(alimd*np(i)))
           nup=min(np2(i),ceiling(alimu*np(i)))
           np1(i)=ndown
           np2(i)=nup
        endif
      enddo
!
!--initialise variables
      do iz=np1(3),np2(3)
       do iy=np1(2),np2(2)
        do_ix: do ix=np1(1),np2(1)
            b(10)=xmap(ix,iy,iz)
            if (b(10) < alevel) cycle
!--locate grid point with maximum density
c           icont=0 ! deb
            do i=1,19
              if(i==10) cycle
              jx = sideppp(ix+ishift(1,i),np(1))
              jy = sideppp(iy+ishift(2,i),np(2))  
              jz = sideppp(iz+ishift(3,i),np(3))
              b(i)=xmap(jx,jy,jz)
c             if(b(i)>0.0) icont=icont+1 ! deb
              if (b(10) <  b(i)) then
                  cycle do_ix
              elseif (b(10) == b(i)) then
!--scarto il picco solo se ho gia' preso uno vicino 
                do j=1,NumPeaks
                   if(jx==nint(xyzs(1,j)*np(1)).and.
     &                jy==nint(xyzs(2,j)*np(2)).and.
     &                jz==nint(xyzs(3,j)*np(3))) then
                      cycle do_ix
                   endif
                enddo
              endif
            enddo
c--check if the peak is inside the asymmetric unit
            xs(1) = float(ix) * dx
            xs(2) = float(iy) * dy
            xs(3) = float(iz) * dz
            if(inRegion(xs,iflagPKS)==0) cycle
c-- fit quadratic function to 19 points
c-- dens = a + c*x + d*y + e*z - 0.5*f*(x*x + y*y + z*z)
            b1 = b(3) + b(7) + b(9) + b(11) + b(13) + b(17)
            b2 = b(1) + b(2) + b(4) + b(5) + b(6) + b(8) + 
     &           b(12) + b(14) +  b(15) + b(16) + b(18) + b(19)
            f = (30.0 * b(10) + 11.0 * b1 - 8.0 * b2) / 63.0
            if(abs(f)>=0.001) then
              c = (b(5)+b(12)+b(13)+b(14)+b(19)
     &            -b(1)-b(6)-b(7)-b(8)-b(15))/10.0
              deltaxf = c / f
              if(abs(deltaxf)<1.0) then
                d = (b(4)+b(8)+b(11)+b(14)+b(18)
     &              -b(2)-b(6)-b(9)-b(12)-b(16))/10.0
                deltay = d / f
                if(abs(deltay)<1.0) then
                  e = (b(15)+b(16)+b(17)+b(18)+b(19)
     &                -b(1)-b(2)-b(3)-b(4)-b(5))/10.0
                  deltaz = e / f
                  if(abs(deltaz)<1.0) then
                    xs(1) = xs(1) + deltaxf * dx
                    xs(2) = xs(2) + deltay * dy
                    xs(3) = xs(3) + deltaz * dz
c                   icont=-icont ! deb
                  endif
                endif
              endif
            endif
c-- peak height interpolation - not suitable if peak shape is poor
c-- a = (9.0 * b(10) + 4.0 * b1 - b2) / 21.0
c-- b(10) = amax1(a+0.5*(c*deltaxf+d*deltay+e*deltaz), b(10))
            NumPeaks = NumPeaks+1
            xyzs(1,NumPeaks) = side(xs(1))
            xyzs(2,NumPeaks) = side(xs(2))
            xyzs(3,NumPeaks) = side(xs(3))
            xyzs(4,NumPeaks) = b(10)
c           xyzs(5,NumPeaks) = icont ! deb
            xyzs(5,NumPeaks) = f 
            if (NumPeaks .ge. limit) then
              call sortf_Patt(NumPeaks,4)
              NumPeaks = npic
              alevel = xyzs(4,npic) + 0.5
              limit = min0(MaxAtoms, 2*nats)
c             write(6,*) 'limit Roc',NumPeaks,limit,alevel  ! deb
            endif
          enddo do_ix ! fine loop su ix
        enddo ! fine loop su iy
      enddo ! fine loop su iz
c-- sort peaks in order of peak height
      call sortf_Patt(NumPeaks,4)
      nats = min0(NumPeaks, nats)
      nats = min0(MaxAtoms, nats)
!
!-- check for intensities <= 0
!
      jj = 0
      do i=nats,1,-1
         if (xyzs(4,i) > 0.0) then
             jj = i
             exit
         endif
      enddo
      nats = jj
      if (nats == 0) then
         ier = -1234
      end if
      nz(1:nats) = 0
!
      if (kverbo.gt.0) then
          npic=NumPeaks
          write(lo,22) npic,nats
c         do i=1,nats
c           write(lo,*) 'picco ',i,xyzs(1:5,i)
c         enddo
      endif
 22   format ('PKS npic =',i8,' nats =',i8)
!
      call DoSingleIteration()
!
      return
      end
c--------------------------------------------------------------------------
      subroutine InitFour_Patt
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
!
!--shifts per peak search
!
      ishift(1:3,1) =(/ -1,  0, -1/)
      ishift(1:3,2) =(/  0, -1, -1/)
      ishift(1:3,3) =(/  0,  0, -1/)
      ishift(1:3,4) =(/  0,  1, -1/)
      ishift(1:3,5) =(/  1,  0, -1/)
      ishift(1:3,6) =(/ -1, -1,  0/)
      ishift(1:3,7) =(/ -1,  0,  0/)
      ishift(1:3,8) =(/ -1,  1,  0/)
      ishift(1:3,9) =(/  0, -1,  0/)
      ishift(1:3,10)=(/  0,  0,  0/)
      ishift(1:3,11)=(/  0,  1,  0/)
      ishift(1:3,12)=(/  1, -1,  0/)
      ishift(1:3,13)=(/  1,  0,  0/)
      ishift(1:3,14)=(/  1,  1,  0/)
      ishift(1:3,15)=(/ -1,  0, +1/)
      ishift(1:3,16)=(/  0, -1, +1/)
      ishift(1:3,17)=(/  0,  0, +1/)
      ishift(1:3,18)=(/  0,  1, +1/)
      ishift(1:3,19)=(/  1,  0, +1/)
c
      return
      end     
c-----------------------------------------------------------------------
      subroutine ModificaMappa()
      USE General
      USE Symmetry
!      USE Atomi_Patt
      USE Mappa

!g    include 'atoms.inc'
!g    include 'sircom.inc'
!g    include 'symcom.inc'
      USE PhaseModule 

!      include 'param.fi' 
      common/dsog/den_p, den_s, n_p, n_s, perc, den_m, den_n, perc_n,
     *              denmin, denmax,
     *              CoefSigma_p, CoefSigma_n, SogSigma_p, SogSigma_n 

      common /estmap/ avden, stden, dumm(102)

      common/histogramC/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist,
     +                   rangeP(501),hisp(501),dip(501),nrange,
     +                   range1(501),hisp1(501),dip1(501)

c
c
cdedi

*---- Parametri per la subr. changemap  ----*
*---- invflag=0 Non modifica la densita'  ----*
*---- invflag=1 Modifica la densita': troncare a " den_p "  ----*
*---- invflag=2 Modifica la densita': troncare solo la parte negativa--*
*---- invflag=3 Modifica la densita': troncare a " den_p " e a " den_n "----*
*---- invflag=4 Modifica la densita': troncare a " den_p " + tutta la parte negativa ----*
*---- invflag=5 Modifica la densita': troncare a " den_p " e a " den_n " secondo sigma

      if (invflag.eq.0) then
          return
      endif
      npts   =  np(1)*np(2)*np(3)
      npts_p =  0
      npts_n =  0

      if (invflag.ne.5) then
          if (invflag.ne.2) then
              if (percMap.gt.0.0001) then
!                  perc_p   = percMap
!                  npts_p = npts * perc_p
                  npts_p = npts * percMap
              else
                  stop 'Error wrong value for PercMap'
              endif
          endif
    
          if (invflag.eq.3) then
              if (percMap_n.gt.0.0001) then
!                   perc_n   = percMap_n
!                   npts_n = npts * perc_n
                   npts_n = npts * percMap_n
              else
                   stop 'Error wrong value for PercMap_Neg'
              endif
          else
!              perc_n = 0
              npts_n = 0
          endif
      else
         perc_p = 0.1
         npts_p = npts * perc_p
!         perc_n = -1.0
         npts_n =  0
      endif

      call denhist_Patt(xmap,npts_p,npts_n)

      aCheServe = 1
	if (aCheServe < 0) then

      npupos = 0
      npuneg = 0
      npudenp =0
      npudenn = 0
      do i = 0, np(1)-1
         do j = 0,np(2)-1
            do k = 0,np(3)-1
               if (xmap(i,j,k).gt.0.0) then
                  npupos = npupos + 1
               end if
               if (xmap(i,j,k).lt.0.0) then
                  npuneg = npuneg + 1
               end if
               if (xmap(i,j,k).ge.den_p) then
                  npudenp = npudenp + 1
               end if
               if (xmap(i,j,k).le.den_n) then
                  npudenn = npudenn + 1
               end if
            end do
         end do
      end do
!      write(6,67299) np,npupos,npuneg,
!     *                den_p,den_n
!67299 format('  BBBBB ',7i10,/,2f10.4)
!      write(lo,67298) np,npupos,npuneg,npudenp,npudenn,
!     *                den_p,den_n
!67298 format('  BBBBB ',7i10,/,2f10.4)
      
      endif

      sog=0.0
      npunti=np(1)*np(2)*np(3)

      call changemap_Patt (xmap,sog,invflag,npu1,n_pos,n_neg)

      return
      end
c-----------------------------------------------------------------------
      subroutine changemap_Patt (x,sog,jflag,npu1,n_pos,n_neg)

      USE General
      USE ParametriMappa

!g    include 'sircom.inc'

!      include 'param.fi' 
      common/dsog/den_p,den_s,n_pp,n_ss,perc,den_m,den_n,perc_n,
     *              denmin, denmax,
     *              CoefSigma_p, CoefSigma_n, SogSigma_p, SogSigma_n 

      common /estmap/ avden, stden, dumm(102)

      common/histogramC/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist,
     +                   rangeP(501),hisp(501),dip(501),nrange,
     +                   range1(501),hisp1(501),dip1(501)


!corr      common /const/ nex,numset,npic,nats,jall,nset,iset(20)
c
      real x(1:np(1),1:np(2),1:np(3))
 
*---- jflag=0 Non modifica la densita'  ----*
*---- jflag=1 Modifica la densita': troncare a " den_p "  ----*
*---- jflag=2 Modifica la densita': troncare la parte negativa--*
*---- jflag=3 Modifica la densita': troncare a " den_p " e a " den_n "----*
*---- jflag=4 Modifica la densita': troncare a " den_p " + tutta la parte neg.
*---- jflag=5 Modifica la densita': troncare a " den_p " e a " den_n " secondo sigma


!     SOGmin=0.32*volume
!     SOGmax=2.0*volume
      nx=np(1)
      ny=np(2)
      nz=np(3)
      n_p=0
      n_s=0
      npu1=0
      n_pos=0
      n_neg=0
      if (jflag == 5) then
          write(lo,20) CoefSigma_p,CoefSigma_n, stden
   20 format(' Coefficienti per +(%) & -(%) per StD ',2f6.2,
     *       ' StD =',f10.4)
          SogSigma_p = CoefSigma_p*stden
          SogSigma_n = CoefSigma_n*stden
      endif
      do 150 k=1,nz
         do 100 j=1,ny
            do 50 i=1,nx
               xx=x(i,j,k)
               if (sog.gt.0.0.and.x(i,j,k).gt.sog) then
                    x(i,j,k)=sog
                    npu1=npu1+1
               endif

               if (jflag.eq.0) then
                  n_p=n_p+1
               elseif (jflag.eq.1) then
                  if (xx.lt.den_p.or.xx.le.0.0) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     n_pos=n_pos+1
                  endif
               elseif (jflag.eq.2) then
                  if ( xx.le.0.0 ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                  endif
               elseif (jflag.eq.3) then
                  if (xx.ge.den_p.or.xx.le.den_n) then
                     n_p=n_p+1
                     if (xx.ge.den_p) then
                         n_pos=n_pos+1
                     elseif (xx.le.den_n) then
                         x(i,j,k) = x(i,j,k) * 0.75
                         n_neg=n_neg+1
                     endif
                  else
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  endif
               elseif (jflag.eq.4) then
                  if (xx.ge.den_p.or.xx.lt.0.0) then
                     n_p=n_p+1
                     if (xx.ge.den_p) then
                         n_pos=n_pos+1
                     elseif (xx.lt.0.0) then
                         n_neg=n_neg+1
                     endif
                  else
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  endif
               elseif (jflag.eq.5) then
                  if (xx.gt.0.0) then
                     if (xx.ge.SogSigma_p) then
                        n_pos = n_pos+1
                     else
                        x(i,j,k)=0.0
                     end if
                  end if
                  if (xx.lt.0.0) then
                     if (abs(xx).ge.SogSigma_n) then
                        n_neg = n_neg+1
                     else
                        x(i,j,k)=0.0
                     end if
                  endif
               endif
  50        continue
 100     continue
 150  continue

      if (jflag.eq.5) then
         nputot = nx*ny*nz
         p1= float(n_pos)/nputot
         percMap= float(n_pos)/nputot
         p2= float(n_neg)/nputot
         percMap_n= float(n_neg)/nputot
!         write(lo,6789) n_pos,p1,n_neg,p2
! 6789 format(' nnnnnnn ',i10,f8.4,i10,f8.4)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine InvMap_Patt(khl,mkang,iphi,fcv,numbMax,ier)

      USE General
      USE Mappa
      USE PhaseModule 
c
      dimension khl(3,nrefl),mkang(nrefl),iphi(nrefl),fcv(nrefl)
cdedi
      if (invflag.ne.0) then
          call ModificaMappa()
      endif

      call NewInv(xmap,khl,mkang,iphi,fcv,nrefl,np(1),np(2),np(3))
cdedi
      return
      end
c------------------------------------------------------------------
      subroutine denhist_Patt(x,npts_p,npts_n)
      USE General
      USE Symmetry
      USE ParametriMappa
!g    include 'sircom.inc'
!g    include 'symcom.inc'
      USE PhaseModule 
!      include 'param.fi' 
      common/dsog/den_p, den_s, n_p, n_s, perc, den_m, den_n, perc_n,
     *              denmin, denmax,
     *              CoefSigma_p, CoefSigma_n, SogSigma_p, SogSigma_n 
      common /estmap/ avden, stden, dumm(102)
      common/histogramC/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist,
     +                   rangeP(501),hisp(501),dip(501),nrange,
     +                   range1(501),hisp1(501),dip1(501)
c
      real x(1:np(1),1:np(2),1:np(3))
c     call scrper(' Density Histogram ',0,0)


      nx=np(1)
      ny=np(2)
      nz=np(3)
      npunti=nx*ny*nz

      call maxmin_Patt(nx,ny,nz,x)

      nrange=500
      rang=(denmax - denmin)/nrange
      do 10 i=1,nrange+1
         hisp(i)=0.0
         rangeP(i)=denmin + rang*(i-1)
 10   continue
      nrange=nrange+1

      do 150 kz=1,nz
         do 100 ky=1,ny
           do 50 kx=1,nx
               xx=x(kx,ky,kz)
               n=int((xx-denmin)/rang) + 1
               if (n.gt.nrange) n=nrange
               if (n.le.1) n=1
               hisp(n)=hisp(n)+1.0

 50         continue
 100     continue
 150  continue

      jflag=1
      npts1=npts_p                       ! % di punti della mappa positva
      call findsog_Patt(den_p,npts1,jflag)
      if (invflag.eq.3) then
          jflag=2
          npts1=npts_n                   ! % di punti della mappa negativa
          call findsog_Patt(den_n,npts1,jflag)
      endif

c!!!!!    ----  STAMPA  HISTOGRAM MAP  -----
      idenh = 0
!!    idenh = 1

      if (idenh.eq.1) then
      volume = 1.    !!!!!!!!!
      write(lo,*)
      write(lo,*)'  ***************************************'
      write(lo,*)'  *           HISTOGRAM MAP             *'
      write(lo,*)'  ***************************************'
      write(lo,*)
      write(lo,2000) denmax/volume,denmin/volume,avden/volume,
     +             stden/volume,den_p/volume
 2000 format('   Maximum density ............ ',f8.3,/,
     +       '   Minimum density ............ ',f8.3,/,
     +       '   Average density ............ ',f8.3,/,
     +       '   Standar deviation .......... ',f8.3,/,
     +       '   Level protein ...... ........',f8.3,/)
      endif
      idenh = 0
      
      return
      end
*----------------------------------------------------------------------------*
      subroutine maxmin_Patt(nx,ny,nz,x)
      USE General
!g    include 'sircom.inc'
!      include 'param.fi' 
      common/dsog/den_p, den_s, n_p, n_s, perc, den_m, den_n, perc_n,
     *              denmin, denmax,
     *              CoefSigma_p, CoefSigma_n, SogSigma_p, SogSigma_n 
      common /estmap/ avden, stden, dumm(102)
c
      real x(1:nx,1:ny,1:nz)

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
!     denmax=maxval(x(1:nx,1:ny,1:nz))   ! ci mette 3 volte in piu'
!     denmin=minval(x(1:nx,1:ny,1:nz))   ! utilizzando maxval, minval, sum !!!!
!     avden =sum(x(1:nx,1:ny,1:nz))
!     stden =sum(x(1:nx,1:ny,1:nz)**2)
!     goto 31
      do 30 iz = 1, nz
       do 20 iy = 1, ny
        do 10 ix = 1, nx
	     xx=x(ix,iy,iz)
           denmax=amax1(denmax,xx)
           denmin=amin1(denmin,xx)
           avden=avden + xx
           stden=stden + xx * xx
 10     continue
 20    continue
 30   continue
!31   continue

      avden=avden/float(nx*ny*nz)
      stden=stden/float(nx*ny*nz) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine findsog_Patt(sogden,npts1,jflag)
      USE General
!g    include 'sircom.inc'
!      include 'param.fi' 
      common/dsog/den_p, den_s, n_p, n_s, perc, den_m, den_n, perc_n,
     *              denmin, denmax,
     *              CoefSigma_p, CoefSigma_n, SogSigma_p, SogSigma_n 
      common/histogramC/ vresl(50),vrmin(50),vrmax(50),vrave(50),
     +                   vrstd(50),hdata(200,50),nresl,nhist,
     +                   rangeP(501),hisp(501),dip(501),nrange,
     +                   range1(501),hisp1(501),dip1(501)
c
      rang=(denmax - denmin)/nrange

      if (jflag.eq.1) then
         ires=0
         do i=nrange+1,2,-1
            ires=ires+hisp(i-1)
            if (ires.ge.npts1) then
               sogden = denmin + (rang*(i-2) + rang/2)
               exit
            endif
         enddo
      elseif (jflag.eq.2) then
         ires=0
         do i=2,nrange+1
            ires=ires+hisp(i-1)
            if (ires.ge.npts1) then
               sogden = denmin + (rang*(i-2) + rang/2)
               exit
            endif
         enddo
      elseif (jflag.lt.0) then                ! uso una soglia predefinita (sogden)
         ires=0
         res=0.0
         do i=nrange+1,2,-1
            res=rangeP(i-1)
            ies=ires + hisp(i-1)
            if (res.le.sogden) then
               npts=ires
               exit
            endif
         enddo
      endif
!     write(6,40) npts1,jflag,nrange,perc,denmin,denmax,sogden
! 40  format('BBBB findsog',i15,2i4,4f12.3)
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FOM_Early(corre)
      USE General
      USE Symmetry
      USE Riflessi
!      USE Atomi_Patt
!g    include 'atoms.inc'
!g    include 'sircom.inc'
!g    include 'symcom.inc'     
      USE PhaseModule      

!g    include 'Patt_Pow.fi'

c
c-- fomBuff(1) = fomrtN(trial,1) = Fom sui tripletti
c-- fomBuff(2) = fomrtN(trial,2) = RES su numbLSQ
c-- fomBuff(3) = fomrtN(trial,3) = RES su weak
c-- fomBuff(4) = fomrtN(trial,4) = numeratore di WEFom
c-- fomBuff(5) = fomrtN(trial,5) = denominatore di WEFom
c-- fomBuff(6) = fomrtN(trial,6) = RAT

      Fom_TripM = 0.0

!      if (ksize.le.3.and.kmad.eq.0) then

      call Calcola_FOM_Small(corre)
      FOMs(1,4) = FOMs(2,4)
      return

!      endif
      end
c-----------------------------------------------------------------------
      subroutine Calcola_FOM_Small(corre)
      USE General
      USE Riflessi
!g    include 'sircom.inc'
      USE PhaseModule  

!g    include 'Patt_Pow.fi'

c
c-dedi  -- per girare in continuo con la strategia per il singolo trial
c
      fcoef(1:nstr) = evet(1:nstr)
      tmpwt(1:nstr) =   wt(1:nstr)

      invflag = 1
      percMap = 0.035
      jpatt = 0
      call MakeMap_Patt(nstr,jpatt)
c
c --  iwork2 = nuova fase dopo inversione (per non sporcare iphaz)
c
      call InvMap_Patt(khl,mkang,iwork2,fcvet,nrefl,ier)
c
      chope = 2.0
      iAll  = -1 ! pesi di tangente
      iAll  =  1 
      call CalcolaPesi_Old(nrefl,nrefl,chope,iAll)
c
c--- fcvet = Ecal, wt = nuovo peso , iwork2 = nuova fase

      do j = 1,2
         iflg = j
         call Fom_CC_Lib(numbLSQ,CC,iflg)
         FOMs(2,j) = CC
      enddo

      call Fom_EC2_Lib(numbLSQ,EC2,sgmin)
      FOMs(2,3) = EC2
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif
c_LIB
!      if (knw /= 0) then
!          kstp = 1
!          call Calcola_CC_Mappa(nstr,corre,kstp,2,ier)
!          write(lo,9) numbrun,CC,EC2,FOMs(2,4),corre
!      endif
!  9   format(' Trial #',i6,'   RAT-FOMs',3f7.3,
!     *       '  Initial CC_Map = ',f6.3)
 
      wt(1:nstr)  = tmpwt(1:nstr)

      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaPesi_Old(numb,numbMax,chope,iAll)
      USE General
      USE Riflessi
!g    include 'sircom.inc'
      USE PhaseModule 

!
      e2medNew = 0.0
      e2med = 1.0  ! impongo <E**2> = 1
      do i=1,numbMax
         e2medNew = e2medNew + fcvet(i) ** 2
      enddo
      e2medNew  = e2medNew / float(numbMax)
      scalae2med = e2med / e2medNew
      scalamed = sqrt( scalae2med )
      do i=1,numbMax
         fcvet(i) = scalamed * fcvet(i)
         if (fcvet(i).gt.4.5) fcvet(i)=4.5
      enddo
!
      scalan = 1.0
      sumfo = 0.0
      sumfc = 0.0
      do i=1,numbMax
         sumfc=sumfc+fcvet(i)
         sumfo=sumfo+evet(i)
      enddo    
      scalan=sumfc/sumfo
      do i=1,numbMax
         fcvet(i) = fcvet(i)/scalan
         EObs = evet(i)
         ECal = fcvet(i)
!        SimW = 0.5 * EObs * ECal
         SimW = chope * EObs * ECal      ! LIBERATO
         gSim =  bes( SimW )
         work1(i) = gSim
         work2(i) = gSim
      enddo
!
      if (iAll.lt.0) then
          return
      elseif (iAll.eq.0) then
          call sortall(-1,work1,numbMax)

! solo per compilazione senza warning!!!!!
          nit = 1
          iDelta = 0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          ncond1 = numb + nit * iDelta
          sog = work1(ncond1)
          if (ncond1.gt.numbMax) sog=0.0
! 
          do i=1,numbMax
             if (work2(i).lt.sog) then
                 wt(i) = 0.0
             else
                 wt(i) = work2(i)
             endif
          enddo
      else
          do i=1,numbMax
             wt(i) = work2(i)
          enddo
      endif
!
      if (numbMax.lt.nrefl) then
          wt(numbMax+1:) = 0.0
      endif
!
      return
      end
c-----------------------------------------------------------------------
      subroutine Fom_CC_Lib(numbLSQ,CC,iflg)
      USE General
      USE Riflessi
!g    include 'sircom.inc'

!
!---- calcola il CC tra Eo**2 e wt**2 
!     iflg = 0  uso tutti gli Eo (nrefl) 
!     iflg = 1  uso solo il 70% degli Eo sino alla risoluzione voluta
!     iflg = 2  uso solo gli Eo con modulo compreso tra sgmin sgmax

      resol = 0.5/sqrt(rhomax)

      rhosog = (0.5 / resol) **2

      sumWT2     = 0.0
      sumEo2     = 0.0
      sumWT2Eo2  = 0.0
      sumWT4     = 0.0
      sumEo4     = 0.0

      ncont  = 0
 
      sgmin = 0.1
      sgmax = 100.
      do i=1,nrefl
         icc = 1
         if(iflg.eq.0) then
             if(rhov(i).gt.rhosog) then
                 icc = 0
             endif
         elseif (iflg.eq.1) then
             if(rhov(i).gt.rhosog.
     *         or.i.gt.numbLSQ) then
                 icc = 0
             endif
         elseif(iflg.eq.2) then
             if(evet(i).lt.sgmin.or.evet(i).gt.sgmax.
     *          or.rhov(i).gt.rhosog.
     *          or.i.gt.numbLSQ) then
                 icc = 0
             endif
         endif
         if (wt(i) < 0.00001) then
             icc = 0
         endif
c
         if (icc.eq.1) then
             ncont = ncont + 1

             Eo2 = evet(i)**2
             Eo4 = evet(i)**4
             WT2 = wt(i)**2
             WT4 = wt(i)**4
 
             sumWT2Eo2 = sumWT2Eo2 + WT2 * Eo2
             sumWT2    = sumWT2    + WT2
             sumEo2    = sumEo2    +       Eo2
             sumWT4    = sumWT4    + WT4
             sumEo4    = sumEo4    +       Eo4

         endif
 
      enddo

      if (ncont.gt.0) then
          sumWT2Eo2 = sumWT2Eo2 / ncont
          sumWT2    = sumWT2    / ncont
          sumEo2    = sumEo2    / ncont
          sumWT4    = sumWT4    / ncont
          sumEo4    = sumEo4    / ncont
   
          arg  = sumWT2Eo2 - (sumWT2 * sumEo2)
          den1 = sumWT4 - (sumWT2**2)
          den2 = sumEo4 - (sumEo2**2)
          if (den1.gt.0.00001.and.den2.gt.0.00001) then
              den  = sqrt(den1) * sqrt(den2)
          else
              den = 0.0
          endif
      else
          den = 0.0
      endif
c
      if (abs(den).gt.0.00001) then
          rap = arg / den
      else
          rap = -99.9 !0.0
      endif

          CC = rap

      return
      end

c_LIB
c-----------------------------------------------------------------------
      subroutine Fom_EC2_Lib(numbLSQ,EC2,sgmin)

      USE General
      USE Riflessi
!g    include 'sircom.inc'

!
!---- calcola il valormedio per Ec**2 (per il 30% dei riflessi piu' deboli)
!
      sumEc2   = 0.0
      ncont = 0
      sgmin = 0.1
!
      do i=numbLSQ+1,nrefl
         if (evet(i).gt.sgmin) then
             ncont = ncont + 1
             Ec2   = fcvet(i)**2
             sumEc2   = sumEc2   + Ec2
         endif
      enddo
!
      if (ncont.gt.0) then
          EC2    = sumEc2   / ncont
      else
          EC2 = 0.0
      endif
      if( EC2 > 1.0 ) EC2 =  0.5

      return
      end
c-----------------------------------------------------------------------
      subroutine prtfom_Patt(noset,ier)
      USE General
      USE Symmetry
      USE Riflessi
!g    include 'sircom.inc'
!g    include 'symcom.inc'
      USE PhaseModule 
!g    include 'Patt_Pow.fi'
!g    include 'xdata.inc'
!
      character cbuff*93

c
      dimension iprvet(60000),prvet(60000),ccffmm(302),ipos(302),zero(6)
      dimension fig(11)
*     equivalence (prvet(1),store(1))
      equivalence (prvet(1),iprvet(1))

c
      if (knw > 0) then
          write(lo,'(/,a,f6.2,a,f8.0,/)') ' Errore minimo=',erm1min,
     *                                    '   nel trial ',setmin
      endif


      do i=1,noset

         absfom = fomrt(i,1)
         alcom  = fomrt(i,2)
         psicom = fomrt(i,3)
         crel   = fomrt(i,4)
!pgMAD280907
         if (f1mx-f1mn > 0) then
            fomabs = (absfom-f1mn)/(f1mx-f1mn)
         else
            fomabs = 0.0
         end if
         if (f15mx-f15mn > 0) then
            comal = (alcom-f15mn)/(f15mx-f15mn)
         else
            comal = 0.0
         end if
         if (f16mx-f16mn > 0) then
            compsi = (psicom-f16mn)/(f16mx-f16mn)
         else
            compsi = 0.0
         end if
         if (f17mx-f17mn > 0) then
            relc = (crel-f17mn)/(f17mx-f17mn)
         else
            relc = 0.0
         end if   
!pgMAD280907
         swwn = 1.0/(4.0)
         coms = swwn*(relc + comal + fomabs + compsi)

         swwn = 1.0/(3.0)
         coms = swwn*(relc + comal + fomabs )
         
         if (kmad == 1) then
            coms = fomabs                            !pgMad150508
         end if

         fomrt(i,5) = coms

      end do

      do 10 i=1,6
   10 zero(i)=0.0
      nwro=0
      iploe=0
      inund=0
c-- transfer fom's values in prtvet to sort them
      k=0
      do 200 i=1,noset
         do 100 j=1,10
            k=k+1
  100    prvet(k)=fomrt(i,j)
         k=k+1
  200 iprvet(k)=i
      LenStore = k
      jump=-5
      iniz=1
      lungs=noset
      istep=11
      if (kverbo /= 0) then
          write(6,*) 'XXXXXXXXXXXXXX'
          iniz = 1
          ifin = istep
          do i=1,lungs
             write(6,'(10f8.3,i5)') 
     *            (prvet(j),j=iniz,ifin-1),iprvet(ifin)
             iniz = iniz + istep
             ifin = ifin + istep
          enddo
      endif
      
!patterson FOM SIR97      
!      iniz = 1
!      call sortz(iniz,lungs,istep,jump)

      idim = 60000
      call sortz_dyn(prvet,idim,1,lungs,istep,jump)

      if (kverbo /= 0) then
          write(6,*) 'XXXXXXXXXXXXXX'
          iniz = 1
          ifin = istep
          do i=1,lungs
             write(6,'(10f8.3,i5)') 
     *            (prvet(j),j=iniz,ifin-1),iprvet(ifin)
             iniz = iniz + istep
             ifin = ifin + istep
          enddo
      endif
      k=0
      l=0
      do 300 i=1,noset
         l=l+1
         k=k+5
         ccffmm(l)=prvet(k)
         k=k+6
         ipos(l)=iprvet(k)
  300 continue
      if (knw.eq.0) then
          write(lo,620)
          write(lo,6351)
      else
          write(lo,636)
      endif
      k=0
      do i=1,noset
         jj=i
         if (knw == 1) then
             cbuff = ' '
         else
             if (mod(jj,2) == 1) then 
                 cbuff = ' '
             endif
         endif
         inuk=0
         if (prvet(k+6).ge.nstr/2) then
            inund=inund+1
            inuk=1
            do kk=k+1,k+5
               prvet(kk)=zero(1)
            end do
            prvet(k+7)=zero(1)
            prvet(k+8)=zero(1)
            prvet(k+11)=zero(1)
         endif
         nund=int(prvet(k+6))
         iitrial=nint(prvet(k+10))
         if (knw.eq.0) then
            if (mod(jj,2) == 1) then
                write(cbuff(1:28),650) jj,iitrial,prvet(k+5),nund
            else
                write(cbuff(45:72),650) jj,iitrial,prvet(k+5),nund
            endif
         else
            write(cbuff,655) jj,iitrial,
     *                     prvet(k+1),
     *                     (prvet(kk),kk=k+3,k+5),nund,
     *                     (prvet(kk),kk=k+7,k+8)
         endif
         if (inuk.eq.1) then
             nwro=nwro+1
             if (knw.eq.1) then
                 cbuff(64:67)='(**)'
             else
                 if (mod(jj,2) == 1) then
                     cbuff(31:34)='(**)'
                 else 
                     cbuff(75:78)='(**)'
                 endif 
             endif
         endif
         if (knw.eq.1) then
             lb = Lung(cbuff)
             write(lo,'(a)') cbuff(1:lb)
         else
            if (mod(jj,2) == 0 .or.
     *               (mod(noset,2) == 1 .and. jj == noset)) then
                lb = Lung(cbuff)
                write(lo,'(a)') cbuff(1:lb)
            endif
         endif
         k=k+istep
      end do
      if (inund.ge.lungs) then
          write(lo,710)
          write(Msg,720)
          call MsgWinErr('Warning', Msg, WARN_WINDOW, nExitCode)
      endif
  620 format(/,10x,'+++++++++++++  Figures  of  merit  ++++++++++++')
  629 format(/,10x,'+++++++++++++  Figures  of  merit  ++++++++++++'
     * ,//14x,'  mabs  R(x,y) eFom  cFom      '
     * ,/10x,'min',
     * 4f7.3,/,10x,'max',4f7.3)
  630 format(/,10x,'+++++++++++++  Figures  of  merit  ++++++++++++'
     * ,//14x,'  mabs  alcomb pscomb R(x,y) cphase  cfom      '
     * ,/10x,'min',
     * 6f7.3,/,10x,'max',6f7.3)
  635 format(///1h ,'Set  (Trial)',1x,'  eFom',2x,'undetermined',
     *          11x,'Set  (Trial)',1x,'  eFom',2x,'undetermined',/)
 6351 format(///1h ,'Set  (Trial)',1x,'  cFom',2x,'undetermined',
     *          11x,'Set  (Trial)',1x,'  cFom',2x,'undetermined',/)
  636 format(///1h ,'Set  (Trial)',1x,'  mabs  R(x,y)  eFom   cFom',
     *       2x,'nund',2x,'error  w-err',/)
  638 format(f4.1,' (*)')
  650 format(1h ,i3,'  (',i5,')',f7.3,i8)
  655 format(1h ,i3,'  (',i5,')',4f7.3,i5,1x,2f7.2)
  710 format(//,2x,'(**)  ***  warning  ***   the number of',
     *   ' undetermined phases is too hight',//)
  720 format('The number of undetermined phases is too hight ',
     *       'for this block. Program skips to the next one.')
      nsetttt=lungs
      call ysup16(ccffmm,ipos,nsetttt)
!      if (ier.eq.-1) then
!          call Cancella(15)
!          call Cancella(16)
!      endif
      return
      end
c-----------------------------------------------------------------------
      subroutine deter3(g,d)
c--calcola determinante matrice(3,3)
c
      dimension g(3,3)
c
      d = g(1,1)*g(2,2)*g(3,3) + g(1,2)*g(2,3)*g(3,1) +
     2	  g(1,3)*g(2,1)*g(3,2) - g(1,3)*g(2,2)*g(3,1) -
     3	  g(1,1)*g(2,3)*g(3,2) - g(1,2)*g(2,1)*g(3,3)
      return
      end
! ----------------------------------------------------------------------
      function inRegion(delta,iflagPKS)

!
!  iflagPKS=0 unita' asimmetrica del gruppo spaziale originale
!  iflagPKS=1 unita' asimmetrica della Patterson
!  iflagPKS=2 unita' asimmetrica del gruppo Cheshire
!
      USE PhaseModule        !p
      dimension delta(3)
      integer inAsymmUnit, inAsymmUnitPatt
!
      if (iflagPKS == 0) then
!--per uso generale
          inRegion=inAsymmUnit(delta)
      elseif (iflagPKS == 1) then
!--per Patterson
          inRegion=inAsymmUnitPatt(delta)
c     elseif(iflagPKS==2) then
!--per Remo
c       inRegion=inCheShire(delta)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      function inAsymmUnit(delta)
      USE General
      USE Symmetry
!g    include 'sircom.inc'       !p
!g    include 'symcom.inc'       !p
!
      dimension delta(3), valoriMM(3,2)
!
      valoriMM(1:3,1) = (/ -9999.9, -9999.9, -9999.9 /)
      valoriMM(1:3,2) = (/  9999.9,  9999.9,  9999.9 /)
      eps=0.005

      do i=1,3
         do j=1,2
            nCond = ncondfou(i,j)
            if (nCond > 0) then
!
!--limiti piu' complessi
!
                if (j == 1) then
                    do m=1, nCond
                       a = ( xcondfou(i,j,m,1) * delta(1) +
     *                       xcondfou(i,j,m,2) * delta(2) +
     *                       xcondfou(i,j,m,3) * delta(3) +
     *                       xcondfou(i,j,m,4) ) * xcondfou(i,j,m,5)
                       if (a > valoriMM(i,j)) valoriMM(i,j) = a
                    enddo
!--per maneggiare limiti negativi
                    if (valoriMM(i,j) < 0.0) then
                        if (delta(i) > 0.5)  delta(i)=delta(i)-1.0
                    endif
!
                    valoriMM(i,j)=valoriMM(i,j)-eps
                    if (delta(i) < valoriMM(i,j)) then
                        inAsymmUnit = 0
                        return
                    endif
                else
                    do m=1, nCond
                       a = ( xcondfou(i,j,m,1) * delta(1) +
     *                       xcondfou(i,j,m,2) * delta(2) +
     *                       xcondfou(i,j,m,3) * delta(3) +
     *                       xcondfou(i,j,m,4) ) * xcondfou(i,j,m,5)
                       if (a < valoriMM(i,j)) valoriMM(i,j) = a
                    enddo
                    valoriMM(i,j)=valoriMM(i,j)+eps
                    if (delta(i) > valoriMM(i,j)) then
                        inAsymmUnit = 0
                        return
                    endif
                endif
            else
!
!--limiti semplici
!
                if (j == 1) then
                    valoriMM(i,j)=xyzfou(i,1)/xyzfou(i,4)
!--per maneggiare limiti negativi
                    if (valoriMM(i,j) < 0.0) then
                        if(delta(i) > 0.5)  delta(i)=delta(i)-1.0
                    endif
!
                    valoriMM(i,j)=valoriMM(i,j)-eps
                    if (delta(i) < valoriMM(i,j)) then
                        inAsymmUnit = 0
                        return
                    endif
                else
                    valoriMM(i,j)=xyzfou(i,2)/xyzfou(i,4)
                    valoriMM(i,j)=valoriMM(i,j)+eps
                    if (delta(i)>valoriMM(i,j)) then
                        inAsymmUnit = 0
                        return
                    endif
                endif
            endif
         enddo
      enddo
!
      inAsymmUnit = 1
!
      return
      end
! ----------------------------------------------------------------------
      function inAsymmUnitPatt(delta)
      USE General
      USE Symmetry
!g    include 'sircom.inc'       !p
!g    include 'symcom.inc'       !p
!
      dimension delta(3), valoriMM(3,2)
!
      valoriMM(1:3,1) = (/ -9999.9, -9999.9, -9999.9 /)
      valoriMM(1:3,2) = (/  9999.9,  9999.9,  9999.9 /)
      eps=0.005

      do i=1,3
         do j=1,2
            nCond = ncondpat(i,j)
            if (nCond > 0) then
!
!--limiti piu' complessi
!
                if (j == 1) then
                    do m=1, nCond
                       a = ( xcondpat(i,j,m,1) * delta(1) +
     *                       xcondpat(i,j,m,2) * delta(2) +
     *                       xcondpat(i,j,m,3) * delta(3) +
     *                       xcondpat(i,j,m,4) ) * xcondpat(i,j,m,5)
                       if (a > valoriMM(i,j)) valoriMM(i,j) = a
                    enddo
!--per maneggiare limiti negativi
                    if (valoriMM(i,j) < 0.0) then
                        if (delta(i) > 0.5)  delta(i)=delta(i)-1.0
                    endif
!
                    valoriMM(i,j)=valoriMM(i,j)-eps
                    if (delta(i) < valoriMM(i,j)) then
                        inAsymmUnitPatt = 0
                        return
                    endif
                else
                    do m=1, nCond
                       a = ( xcondpat(i,j,m,1) * delta(1) +
     *                       xcondpat(i,j,m,2) * delta(2) +
     *                       xcondpat(i,j,m,3) * delta(3) +
     *                       xcondpat(i,j,m,4) ) * xcondpat(i,j,m,5)
                       if (a < valoriMM(i,j)) valoriMM(i,j) = a
                    enddo
                    valoriMM(i,j)=valoriMM(i,j)+eps
                    if (delta(i) > valoriMM(i,j)) then
                        inAsymmUnitPatt = 0
                        return
                    endif
                endif
            else
!
!--limiti semplici
!
                if (j == 1) then
                    valoriMM(i,j)=xyzpat(i,1)/xyzpat(i,4)
!--per maneggiare limiti negativi
                    if (valoriMM(i,j) < 0.0) then
                        if (delta(i) > 0.5)  delta(i)=delta(i)-1.0
                    endif
!
                    valoriMM(i,j)=valoriMM(i,j)-eps
                    if (delta(i) < valoriMM(i,j)) then
                        inAsymmUnitPatt = 0
                        return
                    endif
                else
                    valoriMM(i,j)=xyzpat(i,2)/xyzpat(i,4)
                    valoriMM(i,j)=valoriMM(i,j)+eps
                    if (delta(i) > valoriMM(i,j)) then
                        inAsymmUnitPatt = 0
                        return
                    endif
                endif
            endif
         enddo
      enddo
!
      inAsymmUnitPatt = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine NoBlanks(String,ls) ! substitute xcmprp
      USE General
!g    include 'sircom.inc'        !p
!
!-- Delete all blanks in String
!
      character*(*) String
!g    character *300 Buffer1    !p
      call shift(string,ls)
      ls = Lung(String)
      k = 9999
      do while (k > 0)
         k = index(String(1:ls), ' ')
         if (k > 0) then
             Buffer1 = ' '
             Buffer1(1:k-1) = String(1:k-1)
             Buffer1(k:) = String(k+1:)
             String = ' '
             ls = ls - 1
             String(1:ls) = Buffer1(1:ls)
         endif
      enddo
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRiflessi_old(iAction)

      USE General
      USE Riflessi

!g    include 'sircom.inc'

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(30)
!
      ierv(:) = 0
      ierr = 0
      
      kmad = 0      !p
!corr      ifTwin = 0    !p
      
      nreflDim = nrefl    !p
      
!
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(khl)) 
     *     ALLOCATE (khl(1:3,1:nreflDim) ,stat = ierv( 1))
          IF (.NOT. ALLOCATED(evet)) 
     *     ALLOCATE (evet(1:nreflDim)    ,stat = ierv( 2))
          IF (.NOT. ALLOCATED(fovet)) 
     *     ALLOCATE (fovet(1:nreflDim)   ,stat = ierv( 3))
          IF (.NOT. ALLOCATED(mkang)) 
     *     ALLOCATE (mkang(1:nreflDim)   ,stat = ierv( 4))
          IF (.NOT. ALLOCATED(sigmav)) 
     *     ALLOCATE (sigmav(1:nreflDim)  ,stat = ierv( 5))
          IF (.NOT. ALLOCATED(ipub)) 
     *     ALLOCATE (ipub(1:nreflDim)    ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(rhov)) 
     *     ALLOCATE (rhov(1:nreflDim)    ,stat = ierv( 7))
          IF (.NOT. ALLOCATED(iwork1)) 
     *     ALLOCATE (iwork1(1:nreflDim)  ,stat = ierv( 8))
          IF (.NOT. ALLOCATED(iwork2)) 
     *     ALLOCATE (iwork2(1:nreflDim)  ,stat = ierv( 9))
          IF (.NOT. ALLOCATED(iphaz)) 
     *     ALLOCATE (iphaz(1:nreflDim)   ,stat = ierv(10))
          IF (.NOT. ALLOCATED(fcvet)) 
     *     ALLOCATE (fcvet(1:nreflDim)   ,stat = ierv(11))
          IF (.NOT. ALLOCATED(work1)) 
     *     ALLOCATE (work1(1:nreflDim)   ,stat = ierv(12))
          IF (.NOT. ALLOCATED(work2)) 
     *     ALLOCATE (work2(1:nreflDim)   ,stat = ierv(13))
          IF (.NOT. ALLOCATED(epsv)) 
     *     ALLOCATE (epsv(1:nreflDim)    ,stat = ierv(14))
          IF (.NOT. ALLOCATED(wt)) 
     *     ALLOCATE (wt(1:nreflDim)      ,stat = ierv(15))
          IF (.NOT. ALLOCATED(fcoef)) 
     *     ALLOCATE (fcoef(1:nreflDim)   ,stat = ierv(16))
          IF (.NOT. ALLOCATED(tmpwt)) 
     *     ALLOCATE (tmpwt(1:nreflDim)   ,stat = ierv(17))
          IF (.NOT. ALLOCATED(mult)) 
     *     ALLOCATE (mult(1:nreflDim)    ,stat = ierv(18))
          IF (.NOT. ALLOCATED(iphazo))
     *     ALLOCATE (iphazo(1:nreflDim)  ,stat = ierv(19))
          IF (.NOT. ALLOCATED(worko))
     *     ALLOCATE (worko(1:nreflDim)   ,stat = ierv(20))
          ierr = 0
          ierr = sum(iabs( ierv(:) ))
          if (ierr.ne.0) then
              write(lo,*) 'Riflessi Allocation error'
              stop      !p
          endif
          khl(:,:)  = 0
          evet(:)   = 0
          fovet(:)  = 0
          mkang(:)  = 0
          sigmav(:) = 0
          ipub(:)   = 0
          rhov(:)   = 0
          iwork1(:) = 0
          iwork2(:) = 0
          iphaz(:)  = 0
          iphazo(:) = 0
          fcvet(:)  = 0
          work1(:)  = 0
          work2(:)  = 0
          worko(:)  = 0
          epsv(:)   = 0
          wt(:)     = 0
          fcoef(:)  = 0
          tmpwt(:)  = 0
!
!p          ListaOK(6) = 2
!
      else
          IF (ALLOCATED(khl))
     *        DEALLOCATE (epsv, evet, fcoef, fcvet, fovet, iphaz,
     *                    ipub, iwork1, iwork2, khl, mkang, mult, rhov,
     *                    sigmav, tmpwt, work1, work2, wt,
     *                    iphazo, worko, 
     *                    stat = ierr)
!p          ListaOK(6) = 0
          if (ierr.ne.0) then
              write(0,*) 'Riflessi DeAllocation Error'
              stop           !p
          endif
      endif
!
      return
      end
c-----------------------------------------------------------------
c      subroutine  lettura  dei  riflessi
      subroutine Store_Reflexions

      USE General
      USE Riflessi
      USE xdataMod
      use reflection_type_util, only: rhof

c
!g    include 'sircom.inc'      !p
!
!g    dimension vet(12),ivet(12)
!g    equivalence (ivet(1),vet(1))
c
!      i=0
!      do 50 j=1,nrefl
!         call snr07(vet)
!         i=i+1
!         khl(1,i) = ivet(1)
!         khl(2,i) = ivet(2)
!         khl(3,i) = ivet(3)
!         evet(i) = vet(4)
!         fovet(i) = vet(5)
!         iphi8 = mod(ivet(8),2**15)
!         ipub(i) = iphi8/32
!         mkang(i) = mod(iphi8,32)
!         rho=rhof(pp,ivet(1),ivet(2),ivet(3))
!         rhov(i)=rho*rho
!   50 continue

!#!   call xfl06
      call LeggiRiflessiOrdinati
      i = 0
      do j=1,nrefl
         i = i + 1
         evet(i) = ex(i)
         fovet(i) = fx(i)
*        ipub(i) = iphiv(i)    ! gianluca 29/5/2008
         rho=rhof(pp,khl(1,i),khl(2,i),khl(3,i))
         rhov(i)=rho*rho
      enddo

      return
      end
c     ------------------------------------------------------------------
c     sort peaks in order of peak height or in order of plotting
      subroutine sortf_Patt(natomi,n)
      USE Atomi
!g    include 'atoms.inc'        !p
      USE PhaseModule      !p
c
      dimension t(5)
c
c-PEZZA
c
      if (natomi.le.1) return
c
      int=2
 1000 int=int+int
      if (int.lt.natomi) go to 1000
      int=min0(natomi,(3*int)/4-1)
 1020 int=int/2
      ifin=natomi-int
      do 1200 ii=1,ifin
      i=ii
      j=i+int
      if (xyzs(n,i).ge.xyzs(n,j)) go to 1200
      do 1060 k=1,5
      t(k)=xyzs(k,j)
 1060 continue
 1080 do 1100 k=1,5
      xyzs(k,j)=xyzs(k,i)
 1100 continue
      j=i
      i=i-int
      if (i) 1140,1140,1120
 1120 if (xyzs(n,i).lt.t(n)) go to 1080
 1140 do 1160 k=1,5
      xyzs(k,j)=t(k)
 1160 continue
 1200 continue
      if (int.ne.1) go to 1020
      return
      end
c------------------------------------------------------------------
      subroutine to_coord_Patt(ksezold)

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule  !p     
      USE cgeom
      USE unit_cell
!
      common /ori/ ntra,taboTC(8,3)
!
      dimension xcoo(3,100)
      dimension vet(40),ivet(40)
      character tipo*2,line*80,dire*80
      character a
      character patom*256
      dimension xn(3),xo(3),xeq(3),xeq1(3),s(3)
c
      real, allocatable :: distv(:)
      integer, allocatable :: npunt(:)
      real, dimension(3,3) :: gm
c      
c      
C--  Individua l'atomo del frammento con distanza minima dal picco Patterson
c
      if (knw <= 0) then
          return
      endif
      IF (.NOT.ALLOCATED(distv)) ALLOCATE (distv(1:nats15),stat = ierr)
      IF (.NOT.ALLOCATED(npunt)) ALLOCATE (npunt(1:nats15),stat = ierr)


!
!--definisco il numero di equivalenti presenti nella SMF caso per caso
!
!--cerco l'eventuale componente translazionale sull'asse 6,4,3
!
        itrasla=0
        do i=1,nsym
          do j=1,3
             if(tmat(i,j)>0.0.and.tmat(i,j)<0.5) itrasla=1
          enddo
        enddo
        nOrigRoxiRoc=nOrigRoxi
!corr: FIXME
!corr-chiedere a Rocco cosa voleva fare        nsymTotRoc=nsymTot ! non includo i centrosimmetrici
        nsymTotRoc=spacegr%nsymop ! non includo i centrosimmetrici
        if(ksezold<0) then
!--caso del triclino
        elseif(ksezold>0) then
!--caso unidimensionale
          if(jsys==5) then
!--trigonale senza componente traslazionale
!corr            if(itrasla==0) nsymTotRoc=2*nsymTot  ! includo anche i centrosimmetrici nella SMF  !FIXME
            if(itrasla==0) nsymTotRoc=2*spacegr%nsymop  ! includo anche i centrosimmetrici nella SMF
            if(latt==7) then
!--per produrre gli equivalenti nel R3 esagonale
!  (trucco per simulare la simmetria Patterson nella sezione SMF)
!  dato che OriginiRoxi da erroneamente 3 shift di origine permessi
!  nel caso R3 esagonale
              nOrigRoxiRoc=1 
!corr-FIXME              nsymTotRoc=2*nsymTot
              nsymTotRoc=2*spacegr%nsymop
            endif
          endif
        else
!--caso tridimensionale
! eventualmente includo anche i centrosimmetrici nella SMF
!corr-FIXME           if(itrasla==0 .and. icent==0) nsymTotRoc=2*nsymTot !pgMAD280907 
           if(itrasla==0 .and. icent==0) nsymTotRoc=2*spacegr%nsymop !pgMAD280907 
        endif

      nats_Save = nats
!
! --- legge il file .fra
!
!       FraFilePath = '/server/public/proteins/frag/'
!       kpath = Lung(FraFilePath)

!!!       k=index(fname(1),'.')
!!!!       patom = FraFilePath(1:kpath)//fname(1)(1:k)//'fra'
!!!       patom='c:\EXPO2006\strutture\'//fname(1)(1:k)//'fra'
 
       k=index(fname(FC_FILE),'.')
       patom = fname(FC_FILE)(1:k)//'fra'

       open(unit=kform,file=patom,status='old',err=8000)

       natcoo=0
1      read(kform,'(a)',end=2) line
          call shift(line,ls)
            iasc = ichar(line(1:1))
            if (iasc .eq. 26) then
                goto 2
            end if
            a = line(1:1)
            if (a == '!' .or. a == '>') then
               goto 1
            end if
            natcoo=natcoo+1
            call cutst(line,lenp,dire,lend)
            aLabOld(natcoo) = dire(1:lend)
            iopt=0
            call getnum(line,vet,ivet,iv,iopt)
            do i=1,3
               xcoo(i,natcoo)=side(vet(i))
            enddo
            if (natcoo < 100) then
                goto 1
            else
               kpatom = Lung(patom)
              write(6,*) 'WARNING : max. 100 atoms in ',patom(1:kpatom)
                goto 2
            endif
2       continue
        close(kform)

      nats = nats15
!
! --- applica lo shift alle coordinate SIR
!
      npunt(:) = 0
c     dddmin = 0.6    !0.99
      dddmin = 0.99
      gm = matrice_metrica(cell)
!
! --- calcola le distanze minime
!
      do i=1,nats
         x1 = side(xyzs(1,i))
         y1 = side(xyzs(2,i))
         z1 = side(xyzs(3,i))
         distm=9999
         jpunt = 0
         if (npunt(i).eq.0) then
             do j=1,natcoo
                do k=1,3
                   xo(k) = xcoo(k,j)
                   if(k==ksezold) xo(k)=0.0
                enddo
                do k=1,nsymTotRoc
                  call oper(k,xeq1,x1,y1,z1)
                  do k1=1,nOrigRoxiRoc
                    do j1=1,3
                      termm=xeq1(j1)+taboTC(k1,j1)
                      xeq(j1)=side(termm)
                      if(j1==ksezold) xeq(j1)=0.0
                    enddo
                    !call xdist(xo,xeq,d,s)
                    call xdisteqs(xo,xeq,gm,d,s)
                    if(d.lt.distm.and.d.lt.dddmin) then
                       distm=d
                       npunt(i) = j
                       distv(i) = distm
                    endif
                  enddo
                enddo
             enddo
         endif
      enddo

      kstampa = 1
      if (kstampa.ne.0) then
         write(lo,200)
         do j=1,nats
            if (npunt(j).ne.0) then
                l = npunt(j)
                write(lo,310) j,(xyzs(k,j),k=1,3),aLabOld(l),l,
     &                 (xcoo(k,l),k=1,3),distv(j)
            endif
         enddo
      endif
  200 format('  --- picco sir  ---------         ',
     *       '------ coord. pubbl. ------    distanza')
  310 format(i6,2x,3f6.3,7x,4x,a4,i3,2x,3f6.3,f10.5)
!
      DEALLOCATE(distv,npunt,stat =ierr)
!
      nats = nats_Save
!      call toflush()
      return
!
 8000 continue
      kpatom = Lung(patom)
      write(6,*) ' ERROR in file: ',patom(1:kpatom)
      stop 1122
      end
c------------------------------------------------------------------
      subroutine to_coord_Patt_POW()

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule  !p     
      USE cgeom
      USE unit_cell
      USE sinterface
!
      common /ori/ ntra,taboTC(8,3)
!
      dimension xcoo(3,3000)
      dimension vet(40),ivet(40)
      character tipo*2,line*80,dire*80
      character a
      character patom*256
      dimension xn(3),xo(3),xeq(3),xeq1(3),s(3)
      real, dimension(3,3) :: gm

C--  Calcola e stampa la distanza del picco Patterson dai tutti gli atomi del frammento

      if (knw <= 0) then
          return
      endif
!
! --- legge il file .fra
!
!       FraFilePath = '/server/public/proteins/frag/'
!       kpath = Lung(FraFilePath)

!!!       k=index(fname(1),'.')
!!!!       patom = FraFilePath(1:kpath)//fname(1)(1:k)//'fra'
!!!       patom='c:\EXPO2006\strutture\'//fname(1)(1:k)//'fra'

 
       k=index(fname(FC_FILE),'.')
       patom = fname(FC_FILE)(1:k)//'fra'

       open(unit=kform,file=patom,status='old',err=8000)
!
       natcoo=0
1      read(kform,'(a)',end=2) line
            call shift(line,ls)
            iasc = ichar(line(1:1))
            if (iasc .eq. 26) then
                goto 2
            end if
            a = line(1:1)
            if (a == '!' .or. a == '>') then
               goto 1
            end if
            natcoo=natcoo+1
            call cutst(line,lenp,dire,lend)
            aLabOld(natcoo) = dire(1:lend)
            iopt=0
            call getnum(line,vet,ivet,iv,iopt)
            do i=1,3
               xcoo(i,natcoo)=side(vet(i))
            enddo
            if (natcoo < 3000) then
                goto 1
            else
               kpatom = Lung(patom)
              write(6,*) 'WARNING : max. 3000 atoms in ',patom(1:kpatom)
                goto 2
            endif
2       continue
        close(kform)

      nats = nats15
      if (nats > 3000) then
          nats = 3000
          write(6,*) 'WARNING : max. 500 peaks in Patterson map '
      endif

!
! --- applica lo shift alle coordinate SIR
!
!
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      dddmin = 0.99
      gm = matrice_metrica(cell)
!
! --- calcola le distanze minime
!
      write(lo,200)
      do i=1,natcoo
         do k=1,3
            xo(k) = xcoo(k,i)
         enddo
         distm=9999
         jpunt = 0
         do j=1,nats
             do k=1,3
                xn(k) = side(xyzs(k,j))
             enddo
             do kt=1,spacegr%ncoper
                do ifi=1,ifin
                   coef=vet(ifi)
                   do k=1,nsym
                      call xequi(xn,k,coef,xeq1,kt)
                     do kr=1,nOrigRoxi
                       do jr=1,3
                         xeq(jr)=xeq1(jr)+taboTC(kr,jr)
                       enddo

                       kpol = get_kpol(spacegr)
                       if (kpol == 100) then
                            xo(1) = 0.0
                            xeq(1) = 0.0
                        elseif (kpol == 10) then
                            xo(2) = 0.0
                            xeq(2) = 0.0
                        elseif (kpol == 1) then
                            xo(3) = 0.0
                            xeq(3) = 0.0
                        endif

                        !call xdist(xo,xeq,d,s)
                        call xdisteqs(xo,xeq,gm,d,s)
                        if (d.lt.dddmin) then
                            write(lo,310) j,xn(1:3),
     *                                  aLabOld(i),i,xcoo(1:3,i),d
                        endif
                     enddo
                   enddo
                enddo
             enddo
         enddo
      enddo

  200 format('  --- picco sir  ---------         ',
     *       '------ coord. pubbl. ------    distanza')
  310 format(i6,2x,3f6.3,7x,a8,i3,2x,3f6.3,f10.5)
!
      return
!
 8000 continue
      kpatom = Lung(patom)
      write(6,*) ' ERROR in file: ',patom(1:kpatom)
      stop 1122

      end
c------------------------------------------------------------------
      subroutine assegna_pesi_riflessi()
      
!   assegna i pesi calcolati per i riflessiin ordine di sen_teta 
!   ai riflessi ordinati su E

      USE General
      USE Riflessi
      USE xdataMod

      common/fig_comb/movermax,fig_rit_old,fig_rwp_old,rap_rit_old
     *       ,rap_rwp_old,weilsq(3000)
!corr      common/anna1/inizc(3000),ifinc(3000),sumobs,sumobsnobac
      common /annamult/ Mult0(3000)
      dimension ipunta(3000),ih2(3,3000)
      dimension ipuntb(3000)
!
      call LeggiRiflessi
      do i=1,nrefl
         ih2(1:3,j) = IndHKL(i,1:3)
         Mult0(i) = Mult(i)
      enddo

c------------------------------
c---
      zero = 0.00000001
      do j=1, nrefl
         if (neutro.eq.0 .and. nsyn.eq.0) then
            alp = 1.0 + 0.8*(cos(TThet(j)*dtor))**2
         else
            alp = 1.0
         end if
         blp = sin(0.5*TThet(j)*dtor) * sin(TThet(j)*dtor)
         clp0(j) = 1.0
         if (abs(blp) .gt. zero) clp0(j) = alp / blp
         clp(j) = clp0(j)
      end do


      write(6,'(a)') '--------------'
      ipunta(:) = 0
      do 1020 i=1,nrefl
        do 1030 j=1,nrefl
          if(khl(1,i).eq.ih2(1,j).and.khl(2,i).eq.ih2(2,j).and.
     *       khl(3,i).eq.ih2(3,j))then
            ipunta(i) = j
!            fxsavapp(i)=fxsav(j)
            go to 1020
          end if
 1030   continue
        if (ipunta(i) == 0) then
           write(6,'(i4,1h),3i5,f10.3)') i,khl(:,i),evet(i)
        end if
 1020 continue
!      write(6,'(a)') '--------------'
!      ipuntb(:) = 0
!      do 2020 j=1,nrefl
!        do 2030 i=1,nrefl
!          if(khl(1,i).eq.ih2(1,j).and.khl(2,i).eq.ih2(2,j).and.
!     *       khl(3,i).eq.ih2(3,j))then
!            ipuntb(j) = i
!            go to 2020
!          end if
! 2030   continue
!        if (ipuntb(j) == 0) then
!           write(6,'(i4,1h),3i5,f10.3)') j,ih2(:,j)
!        end if
! 2020 continue
!      write(6,'(a)') '--------------'
      
      
!      write(66,'(i4,3i5)') (i,khl(:,i), i=1,nrefl)
!      write(67,'(i4,3i5)') (i,ih2(:,i),i=1,nrefl)
!      stop

      call setweilsq_Patt
      
      do i=1, nrefl
         wt(i) = weilsq(ipunta(i))
      end do

      return
      end
c------------------------------------------------------------------
      subroutine setweilsq_Patt()

      USE General
      USE Riflessi
      USE xdataMod
!g    include 'sircom.inc'

      common/fig_comb/movermax,fig_rit_old,fig_rwp_old,rap_rit_old
     *       ,rap_rwp_old,weilsq(3000)
      common/erreI/indov(3000),indovv(3000),fioss(3000),foss(3000),
     *             ficalc(3000),sumio,sumfo
      common/anticipo_chi/term_chi(3000),tfocc_chi(3000,500)
     *                    ,fcvo(3000,24),fazeo(3000,24)
      dimension bh(3000)

      call def_maxoverl_Patt
      
c
      call calc_int_vic_Patt(bh)                 !calcolo del numero di riflessi vicini a quello in esame
      
      nnulli = 0
      
      do i=1,nrefl
       if(indovv(i).le.movermax) then
        intego=sqrt(SetFob(i,4))*term_chi(i)
        intego2=SetFob(i,4)*term_chi(i)
        if(intego2>0) then
!!!!!!          ww1=1.0/(1.0+4.0*(intego**2))
          ww1=1.0
          ww2=exp(-0.5*SetFob(i,5)) ! sentetasulambda**2
          ww3=sqrt(intego2/bh(i)) ! moltepl*lorpol*fobs**2
          if(ww3.lt.0.2)ww3=0.2
          weilsq(i)=ww1*ww2*ww3
        else
          weilsq(i)=0.0
          nnulli = nnulli + 1
        endif
       endif
       aint=SetFob(i,4)
       termc= term_chi(i)
       write(6,'(i8,5f12.4)')  indovv(i),ww2,ww3,weilsq(i),aint,termc
      end do
      write(6,*)' su ',nrefl,' ho',nnulli,' riflessi peso nullo'
c
      return
      end
c------------------------------------------------------------
      subroutine calc_int_vic_Patt(antg)

      USE General
      USE Riflessi
      USE xdataMod
!g    include 'sircom.inc'

      common/fig_comb/movermax,fig_rit_old,fig_rwp_old,rap_rit_old
     *       ,rap_rwp_old,weilsq(3000)
      common/erreI/indov(3000),indovv(3000),fioss(3000),foss(3000),
     *             ficalc(3000),sumio,sumfo
      common/anticipo_chi/term_chi(3000),tfocc_chi(3000,500)
     *                    ,fcvo(3000,24),fazeo(3000,24)

!corr      common/anna1/inizc(3000),ifinc(3000),sumobs,sumobsnobac
      common/annamult/Mult0(3000)

      dimension antg(3000)
!      dimension indov(3000),indovv(3000)

      call defovlex_mod_patt(3,0.7,indov,indovv)  ! definisce i rifl in overlap  sog = 0.7
!      call defovlex_mod_patt(0,0.7,indov,indovv)  ! definisce i rifl in overlap  sog = 0.7
      
!      write(lo,*)' indov, indovv in calc_int_vic: movermax =',movermax 
!      do i=1,nrefl
!         write(lo,100) i,indov(i),indovv(i)
! 100     format(3i8)
!      end do
     
     
      do i=1,nrefl
       if(indovv(i).le.movermax) then
         term_chi(i)=Mult0(i)*clp0(i)
!         fioss(i)=SetFob(i,4)*term_chi(i)      !m*l*f**2
         foss(i)=sqrt(SetFob(i,4))
!         sumio=sumio+fioss(i)
!         sumfo=sumfo+foss(i)
       endif
      end do
      


      do i=1,nrefl
       if(indov(i) > 0)then
         inv=indov(i)-1
         do j=0,inv
           essee=0.0
           do k=0,inv
             qq=abs(tthet(i+k)-tthet(i+j))/(WHM(i+j))
             if(qq.gt.1.0) qq=1.0
             essee = essee + (1-qq**2)*term_chi(i+k)*(foss(i+k)**2)
           enddo
           antg(i+j)=essee
         enddo
       endif
      enddo
c
      return
      end
c----------------------------------------
      subroutine defovlex_mod_patt(itot,sogh,indov,indovv)

      USE General
      USE Riflessi
      USE xdataMod
!corr      common /profp/phkl(3000,6),dumpp,nprof,ipol
      dimension ies(3000)
      dimension indov(3000),indovv(3000)
c
c--indovv non contiene zeri
c--indov  riempito con zeri
c
C
C --- Construct of overlapping groups of reflections;
C
      THG    = sogh
      jr     = nrefl
      DO 229 JS=1,JR
      indov(JS) = 1
      indovv(JS) = 1
      ies(js)=1
 229  CONTINUE
      DO 230 JS=1,JR-1
         If(ies(JS).EQ.0) GO TO 225
         indov(JS) = 1
         indovv(JS) = 1
         DO 220 JG=JS+1,JR
            IFL = 0
            fwrif=WHM(JG-1)
            IF(ABS(Tthet(JG)-Tthet(JG-1)).LE.THG*fwrif) THEN
               indov(JS) = indov(JS)+1
               indovv(JS) = indovv(JS)+1
               do 260 jk=js+1,jg
                  indovv(jk)=indov(js)
                  indov(jk)=0
 260           continue
               if(itot.eq.3) then
                  if(indov(js)==7)exit
               endif
               ies(jg)=0
               IFL = 1
            END IF
            IF(IFL.EQ.0) GO TO 225
 220     CONTINUE
 225     CONTINUE
 230  CONTINUE
 295  continue

      return
      end
c--------------------------------------------------------------------
      subroutine def_maxoverl_Patt()
      USE General
      USE ParametriMappa
      USE xdataMod

      common/fig_comb/movermax,fig_rit_old,fig_rwp_old,rap_rit_old,
     *       rap_rwp_old,weilsq(3000)
      dimension indov(3000),indovv(3000)

      call defovlex_mod_patt(0,0.7,indov,indovv)
   
      movermax=2
      moverl=maxval(indovv(1:nrefl))
      do i=1,moverl
        num=0
        do j=1,nrefl
         if(indovv(j).le.i) num=num+1
        enddo
!pbapg        if(num.gt.nats*3*3)then
        if(num.gt.0)then
           movermax=i
!pbapg           go to 1
        endif
      enddo

  1   continue

      if(movermax.lt.2) movermax=2
!      if(movermax.gt.5) movermax=5    !pbapg

!      write(lo,*)  ' indov, indovv in def_maxoverl: movermax',movermax 
!      do i=1,nrefl
!         write(lo,100) i,indov(i),indovv(i)
! 100     format(3i8)
!      end do

      return
      end 
c--------------------------------------------------------------------
      subroutine pherrdisNEW(tirang,dij,khl,nrif,ic,
     *                       ia,ib,c,nrang1,rmax1,shiftexam,ipher)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher) 

      USE General
      USE Atomi
      USE Mappa
      USE Symmetry
      USE Seminvariants
      dimension khl(3,nrif)
      dimension ia(nrif),ib(nrif),c(nrif),dij(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
     
      dimension shiftexam(4)
      character tirang*11
      integer his, cumde, ierv(3)

      real,    allocatable :: dijs(:)
      integer, allocatable :: jorde(:), jorde1(:)
c--
      knwsav = knw
!!!!!!!!      knw =  99999
      nrefldim = nrif
      
      
!      if (ipher.eq.0) then
!          lll = -444
!          ifmin = 10
!          call examin(lll,khl,ia,ib,nrif,ic,c,shi,ifmin)
!      endif
      if (knw.eq.0) return
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(jorde))
     *    ALLOCATE (jorde(1:nreflDim), stat = ierv(2))
      IF (.NOT. ALLOCATED(jorde1))
     *    ALLOCATE (jorde1(1:nreflDim),stat = ierv(3))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'PherrDisNEW Allocation error'
!          call cstop(' ')
      endif
      do i=1,nrif
         jorde(i) = i
      enddo
      nrang = 10
      if (nrang1.gt.0)   nrang = nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do 5 i=1,nrif
       if (i.le.ic) goto 5
       kk=jorde(i)
       if (kk.eq.0.or.kk.gt.nrif) write(lo,*)kk
       if (c(kk).le.0.0) goto 5
       ii=ii+1
       dijs(ii)=dij(kk)
       jorde1(ii)=kk
       if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
       if (dij(kk).lt.rmin) rmin=dij(kk)
       if (dij(kk).gt.rmax) rmax=dij(kk)
    5 continue
      numsort=ii
      if (rmax.eq.rmin)then
        write(lo,*) ' rmax = rmin '
        return
      endif
      call sortall3(1,dijs,1,numsort,jorde1)
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
        rmax=rmax1
        if (rmin.lt.0.0)rmin=-1.0*rmax
      endif

c--
      dev=rmax-rmin
      iaa=nint(dev)
      rang=float(nrang)
      if (iaa.gt.0) then
          dev=float(iaa)/rang
      else
          dev=dev/rang
      end if
      if (rmin.ge.0.0) then
         range(1)=float(int(10.*rmin))/10.
         do 12 i=2,nrang
            range(i)=range(i-1)+dev
  12     continue
      else
         range(1)=float(nint(10.*rmin))/10.
         nrangi=nint(rang/2.0)
         nrang=2*nrangi
         dev=rmax-rabs
         dev=dev/float(nrangi)
         do 13 i=2,nrangi-1
            range(i)=range(i-1)+dev
  13     continue
         range(nrangi)=-rabs
         range(nrangi+1)=rabs
         do 14 i=nrangi+2,nrang
            range(i)=range(i-1)+dev
  14     continue
      endif
c     range(1)=rmin
      range(1)=rming
      nrang=nrang+1
      range(nrang)=rmax
      range(nrang+1)=rmaxg
      
      range(1) = 0.0
      do i=2,11
         range(i) = range(i-1) + 0.5
      end do
      range(12) = rmaxg
      
      
c--
      n=2
      do 15 i=1,numsort
        k=jorde1(i)
        jh = khl(1,k)
        jk = khl(2,k)
        jl = khl(3,k)
        shiftp=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
        shiftp=360.* shiftp + ia(k)
        dif1=shiftp - ib(k)
        dif2=shiftp + ib(k)
        dif1=abs(amod(dif1,360.))
        if (dif1.gt.180.)dif1=360.-dif1
        dif2=abs(amod(dif2,360.))
        if (dif2.gt.180.)dif2=360.-dif2

   17   if (dijs(i).le.range(n)) then
            his(n)=his(n)+1
        else
            n=n+1
            if (n.gt.nrang) n=nrang+1
            goto 17
        endif
       disa1(n)=disa1(n)+dif1
       disa2(n)=disa2(n)+dif2
       disb1(n)=disb1(n)+dif1*c(k)
       disb2(n)=disb2(n)+dif2*c(k)
       cmed(n)=cmed(n)+c(k)
   15 continue
*-----cumulative
      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
      cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
      cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
      ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do 20 i=1,nrang+1
         if (his(i).gt.0) then
            itot=itot+his(i)
            sumdif1=sumdif1+disa1(i)
            sumdif2=sumdif2+disa2(i)
            sumdisb1=sumdisb1+disb1(i)
            sumdisb2=sumdisb2+disb2(i)
            sumc=sumc+cmed(i)
            sumsegni=sumsegni+csegni(i)
            disa1(i)=disa1(i)/float(his(i))
            disa2(i)=disa2(i)/float(his(i))
            disb1(i)=disb1(i)/cmed(i)
            disb2(i)=disb2(i)/cmed(i)
            csegni(i)=csegni(i)/float(his(i))
            csegni(i)=100.*csegni(i)
         else
            disa1(i)=0.0
            disa2(i)=0.0
            disb1(i)=0.0
            disb2(i)=0.0
            csegni(i)=0.0
            cmed(i)=0.0
         endif
   20 continue
      if (itot.le.0) then
         write(lo,*) ' itot = 0'
         return
      endif
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do 25 i=1,nrang
      cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
      cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                   float(his(nrang+1-i))
      cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                   float(his(nrang+1-i))
      cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                   float(his(nrang+1-i))
   25 continue

      if (knw.eq.1) write(lo,200)tirang
      if (knw.eq.0) write(lo,250)tirang
      do 30 i=2,nrang+1
      if (his(i).eq.0) go to 30
      if (knw.gt.0 )then
         if(shiftexam(4).gt.0.) then
            write(lo,100) range(i-1),range(i),his(i),
     *              disa1(i),disb1(i),cumde(i),
     * cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
          else
            write(lo,100) range(i-1),range(i),his(i),
     *              disa2(i),disb2(i),cumde(i),
     * cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
         endif
      else
      write(lo,150) range(i-1),range(i),his(i),cumde(i)
      endif
   30 continue

      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
          if(shiftexam(4).gt.0.) then 
             write(lo,300)itot,dif1m,disb1m
         else
             write(lo,300)itot,dif2m,disb2m
          endif
      else
      write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i8,2f7.2,'  |',i8,2f7.2)
  150 format(f10.4,'  - ',f10.4,i8,'  |',i8)
  200 format(/,11x,a11,6x,' HIS',
     *      '  <err> <w-err>',' | ',
     *      '    CUM',
     *      '  <err> <w-err>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(34x,i8,2f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, jorde, jorde1, stat = ierr)
      if (ierr.ne.0) then
          write(0,*) 'PherrDisNEW DeAllocation Error'
!          call cstop(' ')
      endif
c

      knw = knwsav
      
      return
      end
c---------------------------------------------------------------
      subroutine dirpatt(ier) 
c--
      USE General
      USE Symmetry
      USE PhaseModule
c--
      common/ylimi/nfl,lfl,idummy(4),nfls
      character line*80,dire*80,diret*80
!g    character blank,digit*12,card(540)*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
!g    common /chara/ blank,digit,card
      common /partia/e(800),ep(800),iphp(800),
     *        imk,gminpa,aksca,ssims,cutpa
      common /mag/ sqp4,sq2pi,mi(15),ms(15),dx,iyyy!,lasts
      common/cris/numcri,jcran,maxtri,nstart,muset,nfixed,inumber,ifirst
      integer igin(3),icode(200),ifaz20(200),ipigin(3),inperm(12)
      dimension peso(200)
      dimension vet(40),ivet(40)
c -----
      ier = 0
c -----
      nset=0
      do 7 jcris=1,20
    7 iset(jcris)=0

      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000

      if (dire(1:4).eq.'tria') then
          if (iv.eq.0) go to 8000
          nset=min0(iv,20)
          do 140 i=1,nset
  140     iset(i)=ivet(i)
          go to 100
      endif
      write(Msg,6000) diret(1:Lung(diret))
      ier=-1
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
 6000 format(' wrong directive on following line: ',a)
      return

 8000 write(Msg,8001) diret(1:Lung(diret))
 8001 format(' Error in directive: ',a)
      ier=-1
      call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
      return

 9000 continue
      return
      end
 
